// required for old g++ to compile PRId64 macros, see
// https://github.com/pytorch/pytorch/issues/3571
// for context
#ifndef __STDC_FORMAT_MACROS
#define __STDC_FORMAT_MACROS
#endif

// NOTE: This condition is true for all PyTorch internal libraries, it
//       just excludes external projects such as torch_xla which
//       re-use some of the PyTorch codegen machinery.
#if defined(CAFFE2_BUILD_MAIN_LIB)        || \
    defined(TORCH_CUDA_BUILD_MAIN_LIB)    || \
    defined(TORCH_HIP_BUILD_MAIN_LIB)     || \
    defined(TORCH_CUDA_CU_BUILD_MAIN_LIB) || \
    defined(TORCH_CUDA_CPP_BUILD_MAIN_LIB)
#define TORCH_ASSERT_ONLY_METHOD_OPERATORS
#endif

// @generated by tools/codegen/gen.py from RegisterDispatchKey.cpp

#include <c10/core/TensorImpl.h>
#include <c10/core/Allocator.h>
#include <ATen/DeviceGuard.h>
#include <ATen/NamedTensorUtils.h>
#include <ATen/Utils.h>
#include <ATen/WrapDimUtils.h>
#include <ATen/Dispatch.h>
#include <c10/util/ExclusivelyOwned.h>
#include <c10/util/Half.h>
#include <c10/core/UndefinedTensorImpl.h>
#include <c10/util/Optional.h>
#include <ATen/Tensor.h>
#include <ATen/native/Resize.h>

#include <cstddef>
#include <functional>
#include <memory>
#include <utility>

#include <ATen/Config.h>
#include <ATen/core/op_registration/adaption.h>
#include <torch/library.h>
#include <c10/cuda/CUDAGuard.h>
#include <ATen/cuda/ATenCUDAGeneral.h>
#include <ATen/cuda/CUDADevice.h>
#include <ATen/cuda/CUDAContext.h>

#include <ATen/ops/as_strided_native.h>
#include <ATen/cuda/EmptyTensor.h>
#include <ATen/ops/_adaptive_avg_pool2d_backward_cuda_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool2d_backward_native.h>
#include <ATen/ops/_adaptive_avg_pool2d_cuda_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool2d_native.h>
#include <ATen/ops/_adaptive_avg_pool3d_backward_cuda_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool3d_backward_native.h>
#include <ATen/ops/_adaptive_avg_pool3d_cuda_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool3d_native.h>
#include <ATen/ops/_aminmax_cuda_dispatch.h>
#include <ATen/ops/_aminmax_native.h>
#include <ATen/ops/_amp_foreach_non_finite_check_and_unscale_cuda_dispatch.h>
#include <ATen/ops/_amp_foreach_non_finite_check_and_unscale_native.h>
#include <ATen/ops/_amp_update_scale_cuda_dispatch.h>
#include <ATen/ops/_amp_update_scale_native.h>
#include <ATen/ops/_assert_async_cuda_dispatch.h>
#include <ATen/ops/_assert_async_native.h>
#include <ATen/ops/_cat_cuda_dispatch.h>
#include <ATen/ops/_cat_native.h>
#include <ATen/ops/_cdist_backward_cuda_dispatch.h>
#include <ATen/ops/_cdist_backward_native.h>
#include <ATen/ops/_cdist_forward_cuda_dispatch.h>
#include <ATen/ops/_cdist_forward_native.h>
#include <ATen/ops/_cholesky_solve_helper_cuda_dispatch.h>
#include <ATen/ops/_cholesky_solve_helper_native.h>
#include <ATen/ops/_compute_linear_combination_cuda_dispatch.h>
#include <ATen/ops/_compute_linear_combination_native.h>
#include <ATen/ops/_conv_depthwise2d_cuda_dispatch.h>
#include <ATen/ops/_conv_depthwise2d_native.h>
#include <ATen/ops/_convert_indices_from_coo_to_csr_cuda_dispatch.h>
#include <ATen/ops/_convert_indices_from_coo_to_csr_native.h>
#include <ATen/ops/_convert_indices_from_csr_to_coo_cuda_dispatch.h>
#include <ATen/ops/_convert_indices_from_csr_to_coo_native.h>
#include <ATen/ops/_ctc_loss_backward_cuda_dispatch.h>
#include <ATen/ops/_ctc_loss_backward_native.h>
#include <ATen/ops/_ctc_loss_cuda_dispatch.h>
#include <ATen/ops/_ctc_loss_native.h>
#include <ATen/ops/_cudnn_ctc_loss_cuda_dispatch.h>
#include <ATen/ops/_cudnn_ctc_loss_native.h>
#include <ATen/ops/_cudnn_init_dropout_state_cuda_dispatch.h>
#include <ATen/ops/_cudnn_init_dropout_state_native.h>
#include <ATen/ops/_cudnn_rnn_backward_cuda_dispatch.h>
#include <ATen/ops/_cudnn_rnn_backward_native.h>
#include <ATen/ops/_cudnn_rnn_cuda_dispatch.h>
#include <ATen/ops/_cudnn_rnn_flatten_weight_cuda_dispatch.h>
#include <ATen/ops/_cudnn_rnn_flatten_weight_native.h>
#include <ATen/ops/_cudnn_rnn_native.h>
#include <ATen/ops/_cummax_helper_cuda_dispatch.h>
#include <ATen/ops/_cummax_helper_native.h>
#include <ATen/ops/_cummin_helper_cuda_dispatch.h>
#include <ATen/ops/_cummin_helper_native.h>
#include <ATen/ops/_det_lu_based_helper_backward_helper_cuda_dispatch.h>
#include <ATen/ops/_det_lu_based_helper_backward_helper_native.h>
#include <ATen/ops/_det_lu_based_helper_cuda_dispatch.h>
#include <ATen/ops/_det_lu_based_helper_native.h>
#include <ATen/ops/_dirichlet_grad_cuda_dispatch.h>
#include <ATen/ops/_dirichlet_grad_native.h>
#include <ATen/ops/_efficientzerotensor_cuda_dispatch.h>
#include <ATen/ops/_efficientzerotensor_native.h>
#include <ATen/ops/_embedding_bag_cuda_dispatch.h>
#include <ATen/ops/_embedding_bag_dense_backward_cuda_dispatch.h>
#include <ATen/ops/_embedding_bag_dense_backward_native.h>
#include <ATen/ops/_embedding_bag_forward_only_cuda_dispatch.h>
#include <ATen/ops/_embedding_bag_forward_only_native.h>
#include <ATen/ops/_embedding_bag_native.h>
#include <ATen/ops/_embedding_bag_per_sample_weights_backward_cuda_dispatch.h>
#include <ATen/ops/_embedding_bag_per_sample_weights_backward_native.h>
#include <ATen/ops/_fake_quantize_learnable_per_channel_affine_cuda_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_channel_affine_native.h>
#include <ATen/ops/_fake_quantize_learnable_per_tensor_affine_cuda_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_tensor_affine_native.h>
#include <ATen/ops/_fake_quantize_per_tensor_affine_cachemask_tensor_qparams_cuda_dispatch.h>
#include <ATen/ops/_fake_quantize_per_tensor_affine_cachemask_tensor_qparams_native.h>
#include <ATen/ops/_fft_c2c_cuda_dispatch.h>
#include <ATen/ops/_fft_c2c_native.h>
#include <ATen/ops/_fft_c2r_cuda_dispatch.h>
#include <ATen/ops/_fft_c2r_native.h>
#include <ATen/ops/_fft_r2c_cuda_dispatch.h>
#include <ATen/ops/_fft_r2c_native.h>
#include <ATen/ops/_foreach_abs_cuda_dispatch.h>
#include <ATen/ops/_foreach_abs_native.h>
#include <ATen/ops/_foreach_acos_cuda_dispatch.h>
#include <ATen/ops/_foreach_acos_native.h>
#include <ATen/ops/_foreach_add_cuda_dispatch.h>
#include <ATen/ops/_foreach_add_native.h>
#include <ATen/ops/_foreach_addcdiv_cuda_dispatch.h>
#include <ATen/ops/_foreach_addcdiv_native.h>
#include <ATen/ops/_foreach_addcmul_cuda_dispatch.h>
#include <ATen/ops/_foreach_addcmul_native.h>
#include <ATen/ops/_foreach_asin_cuda_dispatch.h>
#include <ATen/ops/_foreach_asin_native.h>
#include <ATen/ops/_foreach_atan_cuda_dispatch.h>
#include <ATen/ops/_foreach_atan_native.h>
#include <ATen/ops/_foreach_ceil_cuda_dispatch.h>
#include <ATen/ops/_foreach_ceil_native.h>
#include <ATen/ops/_foreach_cos_cuda_dispatch.h>
#include <ATen/ops/_foreach_cos_native.h>
#include <ATen/ops/_foreach_cosh_cuda_dispatch.h>
#include <ATen/ops/_foreach_cosh_native.h>
#include <ATen/ops/_foreach_div_cuda_dispatch.h>
#include <ATen/ops/_foreach_div_native.h>
#include <ATen/ops/_foreach_erf_cuda_dispatch.h>
#include <ATen/ops/_foreach_erf_native.h>
#include <ATen/ops/_foreach_erfc_cuda_dispatch.h>
#include <ATen/ops/_foreach_erfc_native.h>
#include <ATen/ops/_foreach_exp_cuda_dispatch.h>
#include <ATen/ops/_foreach_exp_native.h>
#include <ATen/ops/_foreach_expm1_cuda_dispatch.h>
#include <ATen/ops/_foreach_expm1_native.h>
#include <ATen/ops/_foreach_floor_cuda_dispatch.h>
#include <ATen/ops/_foreach_floor_native.h>
#include <ATen/ops/_foreach_frac_cuda_dispatch.h>
#include <ATen/ops/_foreach_frac_native.h>
#include <ATen/ops/_foreach_lgamma_cuda_dispatch.h>
#include <ATen/ops/_foreach_lgamma_native.h>
#include <ATen/ops/_foreach_log10_cuda_dispatch.h>
#include <ATen/ops/_foreach_log10_native.h>
#include <ATen/ops/_foreach_log1p_cuda_dispatch.h>
#include <ATen/ops/_foreach_log1p_native.h>
#include <ATen/ops/_foreach_log2_cuda_dispatch.h>
#include <ATen/ops/_foreach_log2_native.h>
#include <ATen/ops/_foreach_log_cuda_dispatch.h>
#include <ATen/ops/_foreach_log_native.h>
#include <ATen/ops/_foreach_maximum_cuda_dispatch.h>
#include <ATen/ops/_foreach_maximum_native.h>
#include <ATen/ops/_foreach_minimum_cuda_dispatch.h>
#include <ATen/ops/_foreach_minimum_native.h>
#include <ATen/ops/_foreach_mul_cuda_dispatch.h>
#include <ATen/ops/_foreach_mul_native.h>
#include <ATen/ops/_foreach_neg_cuda_dispatch.h>
#include <ATen/ops/_foreach_neg_native.h>
#include <ATen/ops/_foreach_norm_cuda_dispatch.h>
#include <ATen/ops/_foreach_norm_native.h>
#include <ATen/ops/_foreach_reciprocal_cuda_dispatch.h>
#include <ATen/ops/_foreach_reciprocal_native.h>
#include <ATen/ops/_foreach_round_cuda_dispatch.h>
#include <ATen/ops/_foreach_round_native.h>
#include <ATen/ops/_foreach_sigmoid_cuda_dispatch.h>
#include <ATen/ops/_foreach_sigmoid_native.h>
#include <ATen/ops/_foreach_sin_cuda_dispatch.h>
#include <ATen/ops/_foreach_sin_native.h>
#include <ATen/ops/_foreach_sinh_cuda_dispatch.h>
#include <ATen/ops/_foreach_sinh_native.h>
#include <ATen/ops/_foreach_sqrt_cuda_dispatch.h>
#include <ATen/ops/_foreach_sqrt_native.h>
#include <ATen/ops/_foreach_sub_cuda_dispatch.h>
#include <ATen/ops/_foreach_sub_native.h>
#include <ATen/ops/_foreach_tan_cuda_dispatch.h>
#include <ATen/ops/_foreach_tan_native.h>
#include <ATen/ops/_foreach_tanh_cuda_dispatch.h>
#include <ATen/ops/_foreach_tanh_native.h>
#include <ATen/ops/_foreach_trunc_cuda_dispatch.h>
#include <ATen/ops/_foreach_trunc_native.h>
#include <ATen/ops/_foreach_zero_cuda_dispatch.h>
#include <ATen/ops/_foreach_zero_native.h>
#include <ATen/ops/_fused_dropout_cuda_dispatch.h>
#include <ATen/ops/_fused_dropout_native.h>
#include <ATen/ops/_fused_moving_avg_obs_fq_helper_cuda_dispatch.h>
#include <ATen/ops/_fused_moving_avg_obs_fq_helper_native.h>
#include <ATen/ops/_index_put_impl_cuda_dispatch.h>
#include <ATen/ops/_index_put_impl_native.h>
#include <ATen/ops/_linalg_inv_out_helper_cuda_dispatch.h>
#include <ATen/ops/_linalg_inv_out_helper_native.h>
#include <ATen/ops/_linalg_qr_helper_cuda_dispatch.h>
#include <ATen/ops/_linalg_qr_helper_native.h>
#include <ATen/ops/_linalg_svd_cuda_dispatch.h>
#include <ATen/ops/_linalg_svd_native.h>
#include <ATen/ops/_local_scalar_dense_cuda_dispatch.h>
#include <ATen/ops/_local_scalar_dense_native.h>
#include <ATen/ops/_log_softmax_backward_data_cuda_dispatch.h>
#include <ATen/ops/_log_softmax_backward_data_native.h>
#include <ATen/ops/_log_softmax_cuda_dispatch.h>
#include <ATen/ops/_log_softmax_native.h>
#include <ATen/ops/_logcumsumexp_cuda_dispatch.h>
#include <ATen/ops/_logcumsumexp_native.h>
#include <ATen/ops/_make_per_channel_quantized_tensor_cuda_dispatch.h>
#include <ATen/ops/_make_per_channel_quantized_tensor_native.h>
#include <ATen/ops/_make_per_tensor_quantized_tensor_cuda_dispatch.h>
#include <ATen/ops/_make_per_tensor_quantized_tensor_native.h>
#include <ATen/ops/_masked_scale_cuda_dispatch.h>
#include <ATen/ops/_masked_scale_native.h>
#include <ATen/ops/_masked_softmax_cuda_dispatch.h>
#include <ATen/ops/_masked_softmax_native.h>
#include <ATen/ops/_native_multi_head_self_attention_cuda_dispatch.h>
#include <ATen/ops/_native_multi_head_self_attention_native.h>
#include <ATen/ops/_pdist_backward_cuda_dispatch.h>
#include <ATen/ops/_pdist_backward_native.h>
#include <ATen/ops/_pdist_forward_cuda_dispatch.h>
#include <ATen/ops/_pdist_forward_native.h>
#include <ATen/ops/_pin_memory_cuda_dispatch.h>
#include <ATen/ops/_pin_memory_native.h>
#include <ATen/ops/_reshape_alias_cuda_dispatch.h>
#include <ATen/ops/_reshape_alias_native.h>
#include <ATen/ops/_s_where_cuda_dispatch.h>
#include <ATen/ops/_s_where_native.h>
#include <ATen/ops/_sample_dirichlet_cuda_dispatch.h>
#include <ATen/ops/_sample_dirichlet_native.h>
#include <ATen/ops/_segment_reduce_backward_cuda_dispatch.h>
#include <ATen/ops/_segment_reduce_backward_native.h>
#include <ATen/ops/_slow_conv2d_backward_cuda_dispatch.h>
#include <ATen/ops/_slow_conv2d_backward_native.h>
#include <ATen/ops/_slow_conv2d_forward_cuda_dispatch.h>
#include <ATen/ops/_slow_conv2d_forward_native.h>
#include <ATen/ops/_softmax_backward_data_cuda_dispatch.h>
#include <ATen/ops/_softmax_backward_data_native.h>
#include <ATen/ops/_softmax_cuda_dispatch.h>
#include <ATen/ops/_softmax_native.h>
#include <ATen/ops/_solve_helper_cuda_dispatch.h>
#include <ATen/ops/_solve_helper_native.h>
#include <ATen/ops/_standard_gamma_cuda_dispatch.h>
#include <ATen/ops/_standard_gamma_grad_cuda_dispatch.h>
#include <ATen/ops/_standard_gamma_grad_native.h>
#include <ATen/ops/_standard_gamma_native.h>
#include <ATen/ops/_symeig_helper_cuda_dispatch.h>
#include <ATen/ops/_symeig_helper_native.h>
#include <ATen/ops/_thnn_fused_gru_cell_backward_cuda_dispatch.h>
#include <ATen/ops/_thnn_fused_gru_cell_backward_native.h>
#include <ATen/ops/_thnn_fused_gru_cell_cuda_dispatch.h>
#include <ATen/ops/_thnn_fused_gru_cell_native.h>
#include <ATen/ops/_thnn_fused_lstm_cell_backward_cuda_dispatch.h>
#include <ATen/ops/_thnn_fused_lstm_cell_backward_native.h>
#include <ATen/ops/_thnn_fused_lstm_cell_cuda_dispatch.h>
#include <ATen/ops/_thnn_fused_lstm_cell_native.h>
#include <ATen/ops/_torch_cuda_cu_linker_symbol_op_cuda_dispatch.h>
#include <ATen/ops/_torch_cuda_cu_linker_symbol_op_native.h>
#include <ATen/ops/_unique2_cuda_dispatch.h>
#include <ATen/ops/_unique2_native.h>
#include <ATen/ops/_unique_cuda_dispatch.h>
#include <ATen/ops/_unique_native.h>
#include <ATen/ops/_upsample_bicubic2d_aa_backward_cuda_dispatch.h>
#include <ATen/ops/_upsample_bicubic2d_aa_backward_native.h>
#include <ATen/ops/_upsample_bicubic2d_aa_cuda_dispatch.h>
#include <ATen/ops/_upsample_bicubic2d_aa_native.h>
#include <ATen/ops/_upsample_bilinear2d_aa_backward_cuda_dispatch.h>
#include <ATen/ops/_upsample_bilinear2d_aa_backward_native.h>
#include <ATen/ops/_upsample_bilinear2d_aa_cuda_dispatch.h>
#include <ATen/ops/_upsample_bilinear2d_aa_native.h>
#include <ATen/ops/_upsample_nearest_exact1d_backward_cuda_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact1d_backward_native.h>
#include <ATen/ops/_upsample_nearest_exact1d_cuda_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact1d_native.h>
#include <ATen/ops/_upsample_nearest_exact2d_backward_cuda_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact2d_backward_native.h>
#include <ATen/ops/_upsample_nearest_exact2d_cuda_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact2d_native.h>
#include <ATen/ops/_upsample_nearest_exact3d_backward_cuda_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact3d_backward_native.h>
#include <ATen/ops/_upsample_nearest_exact3d_cuda_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact3d_native.h>
#include <ATen/ops/_use_cudnn_ctc_loss_cuda_dispatch.h>
#include <ATen/ops/_use_cudnn_ctc_loss_native.h>
#include <ATen/ops/_weight_norm_cuda_interface_backward_cuda_dispatch.h>
#include <ATen/ops/_weight_norm_cuda_interface_backward_native.h>
#include <ATen/ops/_weight_norm_cuda_interface_cuda_dispatch.h>
#include <ATen/ops/_weight_norm_cuda_interface_native.h>
#include <ATen/ops/abs_cuda_dispatch.h>
#include <ATen/ops/abs_native.h>
#include <ATen/ops/acos_cuda_dispatch.h>
#include <ATen/ops/acos_native.h>
#include <ATen/ops/acosh_cuda_dispatch.h>
#include <ATen/ops/acosh_native.h>
#include <ATen/ops/adaptive_avg_pool2d_cuda_dispatch.h>
#include <ATen/ops/adaptive_avg_pool2d_native.h>
#include <ATen/ops/adaptive_avg_pool3d_backward_cuda_dispatch.h>
#include <ATen/ops/adaptive_avg_pool3d_backward_native.h>
#include <ATen/ops/adaptive_avg_pool3d_cuda_dispatch.h>
#include <ATen/ops/adaptive_avg_pool3d_native.h>
#include <ATen/ops/adaptive_max_pool2d_backward_cuda_dispatch.h>
#include <ATen/ops/adaptive_max_pool2d_backward_native.h>
#include <ATen/ops/adaptive_max_pool2d_cuda_dispatch.h>
#include <ATen/ops/adaptive_max_pool2d_native.h>
#include <ATen/ops/adaptive_max_pool3d_backward_cuda_dispatch.h>
#include <ATen/ops/adaptive_max_pool3d_backward_native.h>
#include <ATen/ops/adaptive_max_pool3d_cuda_dispatch.h>
#include <ATen/ops/adaptive_max_pool3d_native.h>
#include <ATen/ops/add_cuda_dispatch.h>
#include <ATen/ops/add_native.h>
#include <ATen/ops/addbmm_cuda_dispatch.h>
#include <ATen/ops/addbmm_native.h>
#include <ATen/ops/addcdiv_cuda_dispatch.h>
#include <ATen/ops/addcdiv_native.h>
#include <ATen/ops/addcmul_cuda_dispatch.h>
#include <ATen/ops/addcmul_native.h>
#include <ATen/ops/addmm_cuda_dispatch.h>
#include <ATen/ops/addmm_native.h>
#include <ATen/ops/addmv_cuda_dispatch.h>
#include <ATen/ops/addmv_native.h>
#include <ATen/ops/addr_cuda_dispatch.h>
#include <ATen/ops/addr_native.h>
#include <ATen/ops/all_cuda_dispatch.h>
#include <ATen/ops/all_native.h>
#include <ATen/ops/amax_cuda_dispatch.h>
#include <ATen/ops/amax_native.h>
#include <ATen/ops/amin_cuda_dispatch.h>
#include <ATen/ops/amin_native.h>
#include <ATen/ops/aminmax_cuda_dispatch.h>
#include <ATen/ops/aminmax_native.h>
#include <ATen/ops/angle_cuda_dispatch.h>
#include <ATen/ops/angle_native.h>
#include <ATen/ops/any_cuda_dispatch.h>
#include <ATen/ops/any_native.h>
#include <ATen/ops/arange_cuda_dispatch.h>
#include <ATen/ops/arange_native.h>
#include <ATen/ops/argmax_cuda_dispatch.h>
#include <ATen/ops/argmax_native.h>
#include <ATen/ops/argmin_cuda_dispatch.h>
#include <ATen/ops/argmin_native.h>
#include <ATen/ops/as_strided_cuda_dispatch.h>
#include <ATen/ops/as_strided_native.h>
#include <ATen/ops/asin_cuda_dispatch.h>
#include <ATen/ops/asin_native.h>
#include <ATen/ops/asinh_cuda_dispatch.h>
#include <ATen/ops/asinh_native.h>
#include <ATen/ops/atan2_cuda_dispatch.h>
#include <ATen/ops/atan2_native.h>
#include <ATen/ops/atan_cuda_dispatch.h>
#include <ATen/ops/atan_native.h>
#include <ATen/ops/atanh_cuda_dispatch.h>
#include <ATen/ops/atanh_native.h>
#include <ATen/ops/avg_pool2d_backward_cuda_dispatch.h>
#include <ATen/ops/avg_pool2d_backward_native.h>
#include <ATen/ops/avg_pool2d_cuda_dispatch.h>
#include <ATen/ops/avg_pool2d_native.h>
#include <ATen/ops/avg_pool3d_backward_cuda_dispatch.h>
#include <ATen/ops/avg_pool3d_backward_native.h>
#include <ATen/ops/avg_pool3d_cuda_dispatch.h>
#include <ATen/ops/avg_pool3d_native.h>
#include <ATen/ops/baddbmm_cuda_dispatch.h>
#include <ATen/ops/baddbmm_native.h>
#include <ATen/ops/batch_norm_backward_elemt_cuda_dispatch.h>
#include <ATen/ops/batch_norm_backward_elemt_native.h>
#include <ATen/ops/batch_norm_backward_reduce_cuda_dispatch.h>
#include <ATen/ops/batch_norm_backward_reduce_native.h>
#include <ATen/ops/batch_norm_elemt_cuda_dispatch.h>
#include <ATen/ops/batch_norm_elemt_native.h>
#include <ATen/ops/batch_norm_gather_stats_cuda_dispatch.h>
#include <ATen/ops/batch_norm_gather_stats_native.h>
#include <ATen/ops/batch_norm_gather_stats_with_counts_cuda_dispatch.h>
#include <ATen/ops/batch_norm_gather_stats_with_counts_native.h>
#include <ATen/ops/batch_norm_stats_cuda_dispatch.h>
#include <ATen/ops/batch_norm_stats_native.h>
#include <ATen/ops/batch_norm_update_stats_cuda_dispatch.h>
#include <ATen/ops/batch_norm_update_stats_native.h>
#include <ATen/ops/bernoulli_cuda_dispatch.h>
#include <ATen/ops/bernoulli_native.h>
#include <ATen/ops/binary_cross_entropy_backward_cuda_dispatch.h>
#include <ATen/ops/binary_cross_entropy_backward_native.h>
#include <ATen/ops/binary_cross_entropy_cuda_dispatch.h>
#include <ATen/ops/binary_cross_entropy_native.h>
#include <ATen/ops/bincount_cuda_dispatch.h>
#include <ATen/ops/bincount_native.h>
#include <ATen/ops/binomial_cuda_dispatch.h>
#include <ATen/ops/binomial_native.h>
#include <ATen/ops/bitwise_and_cuda_dispatch.h>
#include <ATen/ops/bitwise_and_native.h>
#include <ATen/ops/bitwise_left_shift_cuda_dispatch.h>
#include <ATen/ops/bitwise_left_shift_native.h>
#include <ATen/ops/bitwise_not_cuda_dispatch.h>
#include <ATen/ops/bitwise_not_native.h>
#include <ATen/ops/bitwise_or_cuda_dispatch.h>
#include <ATen/ops/bitwise_or_native.h>
#include <ATen/ops/bitwise_right_shift_cuda_dispatch.h>
#include <ATen/ops/bitwise_right_shift_native.h>
#include <ATen/ops/bitwise_xor_cuda_dispatch.h>
#include <ATen/ops/bitwise_xor_native.h>
#include <ATen/ops/bmm_cuda_dispatch.h>
#include <ATen/ops/bmm_native.h>
#include <ATen/ops/bucketize_cuda_dispatch.h>
#include <ATen/ops/bucketize_native.h>
#include <ATen/ops/cauchy_cuda_dispatch.h>
#include <ATen/ops/cauchy_native.h>
#include <ATen/ops/ceil_cuda_dispatch.h>
#include <ATen/ops/ceil_native.h>
#include <ATen/ops/cholesky_cuda_dispatch.h>
#include <ATen/ops/cholesky_inverse_cuda_dispatch.h>
#include <ATen/ops/cholesky_inverse_native.h>
#include <ATen/ops/cholesky_native.h>
#include <ATen/ops/clamp_cuda_dispatch.h>
#include <ATen/ops/clamp_max_cuda_dispatch.h>
#include <ATen/ops/clamp_max_native.h>
#include <ATen/ops/clamp_min_cuda_dispatch.h>
#include <ATen/ops/clamp_min_native.h>
#include <ATen/ops/clamp_native.h>
#include <ATen/ops/col2im_backward_cuda_dispatch.h>
#include <ATen/ops/col2im_backward_native.h>
#include <ATen/ops/col2im_cuda_dispatch.h>
#include <ATen/ops/col2im_native.h>
#include <ATen/ops/complex_cuda_dispatch.h>
#include <ATen/ops/complex_native.h>
#include <ATen/ops/conj_physical_cuda_dispatch.h>
#include <ATen/ops/conj_physical_native.h>
#include <ATen/ops/conv_depthwise3d_cuda_dispatch.h>
#include <ATen/ops/conv_depthwise3d_native.h>
#include <ATen/ops/convolution_backward_cuda_dispatch.h>
#include <ATen/ops/convolution_backward_native.h>
#include <ATen/ops/copysign_cuda_dispatch.h>
#include <ATen/ops/copysign_native.h>
#include <ATen/ops/cos_cuda_dispatch.h>
#include <ATen/ops/cos_native.h>
#include <ATen/ops/cosh_cuda_dispatch.h>
#include <ATen/ops/cosh_native.h>
#include <ATen/ops/count_nonzero_cuda_dispatch.h>
#include <ATen/ops/count_nonzero_native.h>
#include <ATen/ops/cudnn_affine_grid_generator_backward_cuda_dispatch.h>
#include <ATen/ops/cudnn_affine_grid_generator_backward_native.h>
#include <ATen/ops/cudnn_affine_grid_generator_cuda_dispatch.h>
#include <ATen/ops/cudnn_affine_grid_generator_native.h>
#include <ATen/ops/cudnn_batch_norm_backward_cuda_dispatch.h>
#include <ATen/ops/cudnn_batch_norm_backward_native.h>
#include <ATen/ops/cudnn_batch_norm_cuda_dispatch.h>
#include <ATen/ops/cudnn_batch_norm_native.h>
#include <ATen/ops/cudnn_convolution_add_relu_cuda_dispatch.h>
#include <ATen/ops/cudnn_convolution_add_relu_native.h>
#include <ATen/ops/cudnn_convolution_cuda_dispatch.h>
#include <ATen/ops/cudnn_convolution_native.h>
#include <ATen/ops/cudnn_convolution_relu_cuda_dispatch.h>
#include <ATen/ops/cudnn_convolution_relu_native.h>
#include <ATen/ops/cudnn_convolution_transpose_cuda_dispatch.h>
#include <ATen/ops/cudnn_convolution_transpose_native.h>
#include <ATen/ops/cudnn_grid_sampler_backward_cuda_dispatch.h>
#include <ATen/ops/cudnn_grid_sampler_backward_native.h>
#include <ATen/ops/cudnn_grid_sampler_cuda_dispatch.h>
#include <ATen/ops/cudnn_grid_sampler_native.h>
#include <ATen/ops/cumprod_cuda_dispatch.h>
#include <ATen/ops/cumprod_native.h>
#include <ATen/ops/cumsum_cuda_dispatch.h>
#include <ATen/ops/cumsum_native.h>
#include <ATen/ops/dequantize_cuda_dispatch.h>
#include <ATen/ops/dequantize_native.h>
#include <ATen/ops/diag_cuda_dispatch.h>
#include <ATen/ops/diag_native.h>
#include <ATen/ops/digamma_cuda_dispatch.h>
#include <ATen/ops/digamma_native.h>
#include <ATen/ops/div_cuda_dispatch.h>
#include <ATen/ops/div_native.h>
#include <ATen/ops/dot_cuda_dispatch.h>
#include <ATen/ops/dot_native.h>
#include <ATen/ops/elu_backward_cuda_dispatch.h>
#include <ATen/ops/elu_backward_native.h>
#include <ATen/ops/elu_cuda_dispatch.h>
#include <ATen/ops/elu_native.h>
#include <ATen/ops/embedding_dense_backward_cuda_dispatch.h>
#include <ATen/ops/embedding_dense_backward_native.h>
#include <ATen/ops/embedding_renorm_cuda_dispatch.h>
#include <ATen/ops/embedding_renorm_native.h>
#include <ATen/ops/empty_cuda_dispatch.h>
#include <ATen/ops/empty_native.h>
#include <ATen/ops/empty_strided_cuda_dispatch.h>
#include <ATen/ops/empty_strided_native.h>
#include <ATen/ops/eq_cuda_dispatch.h>
#include <ATen/ops/eq_native.h>
#include <ATen/ops/equal_cuda_dispatch.h>
#include <ATen/ops/equal_native.h>
#include <ATen/ops/erf_cuda_dispatch.h>
#include <ATen/ops/erf_native.h>
#include <ATen/ops/erfc_cuda_dispatch.h>
#include <ATen/ops/erfc_native.h>
#include <ATen/ops/erfinv_cuda_dispatch.h>
#include <ATen/ops/erfinv_native.h>
#include <ATen/ops/exp2_cuda_dispatch.h>
#include <ATen/ops/exp2_native.h>
#include <ATen/ops/exp_cuda_dispatch.h>
#include <ATen/ops/exp_native.h>
#include <ATen/ops/expm1_cuda_dispatch.h>
#include <ATen/ops/expm1_native.h>
#include <ATen/ops/exponential_cuda_dispatch.h>
#include <ATen/ops/exponential_native.h>
#include <ATen/ops/eye_cuda_dispatch.h>
#include <ATen/ops/eye_native.h>
#include <ATen/ops/fake_quantize_per_channel_affine_cachemask_cuda_dispatch.h>
#include <ATen/ops/fake_quantize_per_channel_affine_cachemask_native.h>
#include <ATen/ops/fake_quantize_per_tensor_affine_cachemask_cuda_dispatch.h>
#include <ATen/ops/fake_quantize_per_tensor_affine_cachemask_native.h>
#include <ATen/ops/fill_cuda_dispatch.h>
#include <ATen/ops/fill_native.h>
#include <ATen/ops/flip_cuda_dispatch.h>
#include <ATen/ops/flip_native.h>
#include <ATen/ops/floor_cuda_dispatch.h>
#include <ATen/ops/floor_divide_cuda_dispatch.h>
#include <ATen/ops/floor_divide_native.h>
#include <ATen/ops/floor_native.h>
#include <ATen/ops/fmax_cuda_dispatch.h>
#include <ATen/ops/fmax_native.h>
#include <ATen/ops/fmin_cuda_dispatch.h>
#include <ATen/ops/fmin_native.h>
#include <ATen/ops/fmod_cuda_dispatch.h>
#include <ATen/ops/fmod_native.h>
#include <ATen/ops/frac_cuda_dispatch.h>
#include <ATen/ops/frac_native.h>
#include <ATen/ops/fractional_max_pool2d_backward_cuda_dispatch.h>
#include <ATen/ops/fractional_max_pool2d_backward_native.h>
#include <ATen/ops/fractional_max_pool2d_cuda_dispatch.h>
#include <ATen/ops/fractional_max_pool2d_native.h>
#include <ATen/ops/fractional_max_pool3d_backward_cuda_dispatch.h>
#include <ATen/ops/fractional_max_pool3d_backward_native.h>
#include <ATen/ops/fractional_max_pool3d_cuda_dispatch.h>
#include <ATen/ops/fractional_max_pool3d_native.h>
#include <ATen/ops/frexp_cuda_dispatch.h>
#include <ATen/ops/frexp_native.h>
#include <ATen/ops/gather_cuda_dispatch.h>
#include <ATen/ops/gather_native.h>
#include <ATen/ops/gcd_cuda_dispatch.h>
#include <ATen/ops/gcd_native.h>
#include <ATen/ops/ge_cuda_dispatch.h>
#include <ATen/ops/ge_native.h>
#include <ATen/ops/gelu_backward_cuda_dispatch.h>
#include <ATen/ops/gelu_backward_native.h>
#include <ATen/ops/gelu_cuda_dispatch.h>
#include <ATen/ops/gelu_native.h>
#include <ATen/ops/geometric_cuda_dispatch.h>
#include <ATen/ops/geometric_native.h>
#include <ATen/ops/geqrf_cuda_dispatch.h>
#include <ATen/ops/geqrf_native.h>
#include <ATen/ops/glu_backward_cuda_dispatch.h>
#include <ATen/ops/glu_backward_native.h>
#include <ATen/ops/glu_cuda_dispatch.h>
#include <ATen/ops/glu_native.h>
#include <ATen/ops/grid_sampler_2d_backward_cuda_dispatch.h>
#include <ATen/ops/grid_sampler_2d_backward_native.h>
#include <ATen/ops/grid_sampler_2d_cuda_dispatch.h>
#include <ATen/ops/grid_sampler_2d_native.h>
#include <ATen/ops/grid_sampler_3d_backward_cuda_dispatch.h>
#include <ATen/ops/grid_sampler_3d_backward_native.h>
#include <ATen/ops/grid_sampler_3d_cuda_dispatch.h>
#include <ATen/ops/grid_sampler_3d_native.h>
#include <ATen/ops/gt_cuda_dispatch.h>
#include <ATen/ops/gt_native.h>
#include <ATen/ops/hardshrink_backward_cuda_dispatch.h>
#include <ATen/ops/hardshrink_backward_native.h>
#include <ATen/ops/hardshrink_cuda_dispatch.h>
#include <ATen/ops/hardshrink_native.h>
#include <ATen/ops/hardsigmoid_backward_cuda_dispatch.h>
#include <ATen/ops/hardsigmoid_backward_native.h>
#include <ATen/ops/hardsigmoid_cuda_dispatch.h>
#include <ATen/ops/hardsigmoid_native.h>
#include <ATen/ops/hardswish_backward_cuda_dispatch.h>
#include <ATen/ops/hardswish_backward_native.h>
#include <ATen/ops/hardswish_cuda_dispatch.h>
#include <ATen/ops/hardswish_native.h>
#include <ATen/ops/hardtanh_backward_cuda_dispatch.h>
#include <ATen/ops/hardtanh_backward_native.h>
#include <ATen/ops/hardtanh_cuda_dispatch.h>
#include <ATen/ops/hardtanh_native.h>
#include <ATen/ops/heaviside_cuda_dispatch.h>
#include <ATen/ops/heaviside_native.h>
#include <ATen/ops/histc_cuda_dispatch.h>
#include <ATen/ops/histc_native.h>
#include <ATen/ops/huber_loss_backward_cuda_dispatch.h>
#include <ATen/ops/huber_loss_backward_native.h>
#include <ATen/ops/huber_loss_cuda_dispatch.h>
#include <ATen/ops/huber_loss_native.h>
#include <ATen/ops/hypot_cuda_dispatch.h>
#include <ATen/ops/hypot_native.h>
#include <ATen/ops/i0_cuda_dispatch.h>
#include <ATen/ops/i0_native.h>
#include <ATen/ops/igamma_cuda_dispatch.h>
#include <ATen/ops/igamma_native.h>
#include <ATen/ops/igammac_cuda_dispatch.h>
#include <ATen/ops/igammac_native.h>
#include <ATen/ops/im2col_backward_cuda_dispatch.h>
#include <ATen/ops/im2col_backward_native.h>
#include <ATen/ops/im2col_cuda_dispatch.h>
#include <ATen/ops/im2col_native.h>
#include <ATen/ops/index_add_cuda_dispatch.h>
#include <ATen/ops/index_add_native.h>
#include <ATen/ops/index_copy_cuda_dispatch.h>
#include <ATen/ops/index_copy_native.h>
#include <ATen/ops/index_cuda_dispatch.h>
#include <ATen/ops/index_fill_cuda_dispatch.h>
#include <ATen/ops/index_fill_native.h>
#include <ATen/ops/index_native.h>
#include <ATen/ops/index_select_cuda_dispatch.h>
#include <ATen/ops/index_select_native.h>
#include <ATen/ops/is_pinned_cuda_dispatch.h>
#include <ATen/ops/is_pinned_native.h>
#include <ATen/ops/is_set_to_cuda_dispatch.h>
#include <ATen/ops/is_set_to_native.h>
#include <ATen/ops/isin_cuda_dispatch.h>
#include <ATen/ops/isin_native.h>
#include <ATen/ops/isnan_cuda_dispatch.h>
#include <ATen/ops/isnan_native.h>
#include <ATen/ops/isneginf_cuda_dispatch.h>
#include <ATen/ops/isneginf_native.h>
#include <ATen/ops/isposinf_cuda_dispatch.h>
#include <ATen/ops/isposinf_native.h>
#include <ATen/ops/kl_div_backward_cuda_dispatch.h>
#include <ATen/ops/kl_div_backward_native.h>
#include <ATen/ops/kthvalue_cuda_dispatch.h>
#include <ATen/ops/kthvalue_native.h>
#include <ATen/ops/l1_loss_backward_cuda_dispatch.h>
#include <ATen/ops/l1_loss_backward_native.h>
#include <ATen/ops/lcm_cuda_dispatch.h>
#include <ATen/ops/lcm_native.h>
#include <ATen/ops/le_cuda_dispatch.h>
#include <ATen/ops/le_native.h>
#include <ATen/ops/leaky_relu_backward_cuda_dispatch.h>
#include <ATen/ops/leaky_relu_backward_native.h>
#include <ATen/ops/leaky_relu_cuda_dispatch.h>
#include <ATen/ops/leaky_relu_native.h>
#include <ATen/ops/lerp_cuda_dispatch.h>
#include <ATen/ops/lerp_native.h>
#include <ATen/ops/lgamma_cuda_dispatch.h>
#include <ATen/ops/lgamma_native.h>
#include <ATen/ops/linalg_cholesky_ex_cuda_dispatch.h>
#include <ATen/ops/linalg_cholesky_ex_native.h>
#include <ATen/ops/linalg_cross_cuda_dispatch.h>
#include <ATen/ops/linalg_cross_native.h>
#include <ATen/ops/linalg_eig_cuda_dispatch.h>
#include <ATen/ops/linalg_eig_native.h>
#include <ATen/ops/linalg_eigh_cuda_dispatch.h>
#include <ATen/ops/linalg_eigh_native.h>
#include <ATen/ops/linalg_eigvalsh_cuda_dispatch.h>
#include <ATen/ops/linalg_eigvalsh_native.h>
#include <ATen/ops/linalg_householder_product_cuda_dispatch.h>
#include <ATen/ops/linalg_householder_product_native.h>
#include <ATen/ops/linalg_lstsq_cuda_dispatch.h>
#include <ATen/ops/linalg_lstsq_native.h>
#include <ATen/ops/linalg_lu_factor_ex_cuda_dispatch.h>
#include <ATen/ops/linalg_lu_factor_ex_native.h>
#include <ATen/ops/linalg_matrix_exp_cuda_dispatch.h>
#include <ATen/ops/linalg_matrix_exp_native.h>
#include <ATen/ops/linalg_slogdet_cuda_dispatch.h>
#include <ATen/ops/linalg_slogdet_native.h>
#include <ATen/ops/linalg_solve_cuda_dispatch.h>
#include <ATen/ops/linalg_solve_native.h>
#include <ATen/ops/linalg_solve_triangular_cuda_dispatch.h>
#include <ATen/ops/linalg_solve_triangular_native.h>
#include <ATen/ops/linalg_vector_norm_cuda_dispatch.h>
#include <ATen/ops/linalg_vector_norm_native.h>
#include <ATen/ops/linspace_cuda_dispatch.h>
#include <ATen/ops/linspace_native.h>
#include <ATen/ops/log10_cuda_dispatch.h>
#include <ATen/ops/log10_native.h>
#include <ATen/ops/log1p_cuda_dispatch.h>
#include <ATen/ops/log1p_native.h>
#include <ATen/ops/log2_cuda_dispatch.h>
#include <ATen/ops/log2_native.h>
#include <ATen/ops/log_cuda_dispatch.h>
#include <ATen/ops/log_native.h>
#include <ATen/ops/log_normal_cuda_dispatch.h>
#include <ATen/ops/log_normal_native.h>
#include <ATen/ops/log_sigmoid_backward_cuda_dispatch.h>
#include <ATen/ops/log_sigmoid_backward_native.h>
#include <ATen/ops/log_sigmoid_forward_cuda_dispatch.h>
#include <ATen/ops/log_sigmoid_forward_native.h>
#include <ATen/ops/logaddexp2_cuda_dispatch.h>
#include <ATen/ops/logaddexp2_native.h>
#include <ATen/ops/logaddexp_cuda_dispatch.h>
#include <ATen/ops/logaddexp_native.h>
#include <ATen/ops/logical_and_cuda_dispatch.h>
#include <ATen/ops/logical_and_native.h>
#include <ATen/ops/logical_not_cuda_dispatch.h>
#include <ATen/ops/logical_not_native.h>
#include <ATen/ops/logical_or_cuda_dispatch.h>
#include <ATen/ops/logical_or_native.h>
#include <ATen/ops/logical_xor_cuda_dispatch.h>
#include <ATen/ops/logical_xor_native.h>
#include <ATen/ops/logit_backward_cuda_dispatch.h>
#include <ATen/ops/logit_backward_native.h>
#include <ATen/ops/logit_cuda_dispatch.h>
#include <ATen/ops/logit_native.h>
#include <ATen/ops/logspace_cuda_dispatch.h>
#include <ATen/ops/logspace_native.h>
#include <ATen/ops/lshift_cuda_dispatch.h>
#include <ATen/ops/lshift_native.h>
#include <ATen/ops/lstsq_cuda_dispatch.h>
#include <ATen/ops/lstsq_native.h>
#include <ATen/ops/lt_cuda_dispatch.h>
#include <ATen/ops/lt_native.h>
#include <ATen/ops/lu_solve_cuda_dispatch.h>
#include <ATen/ops/lu_solve_native.h>
#include <ATen/ops/lu_unpack_cuda_dispatch.h>
#include <ATen/ops/lu_unpack_native.h>
#include <ATen/ops/masked_fill_cuda_dispatch.h>
#include <ATen/ops/masked_fill_native.h>
#include <ATen/ops/masked_scatter_cuda_dispatch.h>
#include <ATen/ops/masked_scatter_native.h>
#include <ATen/ops/masked_select_cuda_dispatch.h>
#include <ATen/ops/masked_select_native.h>
#include <ATen/ops/max_cuda_dispatch.h>
#include <ATen/ops/max_native.h>
#include <ATen/ops/max_pool2d_with_indices_backward_cuda_dispatch.h>
#include <ATen/ops/max_pool2d_with_indices_backward_native.h>
#include <ATen/ops/max_pool2d_with_indices_cuda_dispatch.h>
#include <ATen/ops/max_pool2d_with_indices_native.h>
#include <ATen/ops/max_pool3d_with_indices_backward_cuda_dispatch.h>
#include <ATen/ops/max_pool3d_with_indices_backward_native.h>
#include <ATen/ops/max_pool3d_with_indices_cuda_dispatch.h>
#include <ATen/ops/max_pool3d_with_indices_native.h>
#include <ATen/ops/max_unpool2d_backward_cuda_dispatch.h>
#include <ATen/ops/max_unpool2d_backward_native.h>
#include <ATen/ops/max_unpool2d_cuda_dispatch.h>
#include <ATen/ops/max_unpool2d_native.h>
#include <ATen/ops/max_unpool3d_backward_cuda_dispatch.h>
#include <ATen/ops/max_unpool3d_backward_native.h>
#include <ATen/ops/max_unpool3d_cuda_dispatch.h>
#include <ATen/ops/max_unpool3d_native.h>
#include <ATen/ops/maximum_cuda_dispatch.h>
#include <ATen/ops/maximum_native.h>
#include <ATen/ops/mean_cuda_dispatch.h>
#include <ATen/ops/mean_native.h>
#include <ATen/ops/median_cuda_dispatch.h>
#include <ATen/ops/median_native.h>
#include <ATen/ops/min_cuda_dispatch.h>
#include <ATen/ops/min_native.h>
#include <ATen/ops/minimum_cuda_dispatch.h>
#include <ATen/ops/minimum_native.h>
#include <ATen/ops/miopen_batch_norm_backward_cuda_dispatch.h>
#include <ATen/ops/miopen_batch_norm_backward_native.h>
#include <ATen/ops/miopen_batch_norm_cuda_dispatch.h>
#include <ATen/ops/miopen_batch_norm_native.h>
#include <ATen/ops/miopen_convolution_cuda_dispatch.h>
#include <ATen/ops/miopen_convolution_native.h>
#include <ATen/ops/miopen_convolution_transpose_cuda_dispatch.h>
#include <ATen/ops/miopen_convolution_transpose_native.h>
#include <ATen/ops/miopen_depthwise_convolution_cuda_dispatch.h>
#include <ATen/ops/miopen_depthwise_convolution_native.h>
#include <ATen/ops/miopen_rnn_backward_cuda_dispatch.h>
#include <ATen/ops/miopen_rnn_backward_native.h>
#include <ATen/ops/miopen_rnn_cuda_dispatch.h>
#include <ATen/ops/miopen_rnn_native.h>
#include <ATen/ops/mish_backward_cuda_dispatch.h>
#include <ATen/ops/mish_backward_native.h>
#include <ATen/ops/mish_cuda_dispatch.h>
#include <ATen/ops/mish_native.h>
#include <ATen/ops/mm_cuda_dispatch.h>
#include <ATen/ops/mm_native.h>
#include <ATen/ops/mode_cuda_dispatch.h>
#include <ATen/ops/mode_native.h>
#include <ATen/ops/mse_loss_backward_cuda_dispatch.h>
#include <ATen/ops/mse_loss_backward_native.h>
#include <ATen/ops/mse_loss_cuda_dispatch.h>
#include <ATen/ops/mse_loss_native.h>
#include <ATen/ops/mul_cuda_dispatch.h>
#include <ATen/ops/mul_native.h>
#include <ATen/ops/multi_margin_loss_backward_cuda_dispatch.h>
#include <ATen/ops/multi_margin_loss_backward_native.h>
#include <ATen/ops/multi_margin_loss_cuda_dispatch.h>
#include <ATen/ops/multi_margin_loss_native.h>
#include <ATen/ops/multilabel_margin_loss_backward_cuda_dispatch.h>
#include <ATen/ops/multilabel_margin_loss_backward_native.h>
#include <ATen/ops/multilabel_margin_loss_forward_cuda_dispatch.h>
#include <ATen/ops/multilabel_margin_loss_forward_native.h>
#include <ATen/ops/multinomial_cuda_dispatch.h>
#include <ATen/ops/multinomial_native.h>
#include <ATen/ops/mvlgamma_cuda_dispatch.h>
#include <ATen/ops/mvlgamma_native.h>
#include <ATen/ops/nan_to_num_cuda_dispatch.h>
#include <ATen/ops/nan_to_num_native.h>
#include <ATen/ops/nanmedian_cuda_dispatch.h>
#include <ATen/ops/nanmedian_native.h>
#include <ATen/ops/nansum_cuda_dispatch.h>
#include <ATen/ops/nansum_native.h>
#include <ATen/ops/native_batch_norm_backward_cuda_dispatch.h>
#include <ATen/ops/native_batch_norm_backward_native.h>
#include <ATen/ops/native_batch_norm_cuda_dispatch.h>
#include <ATen/ops/native_batch_norm_native.h>
#include <ATen/ops/native_dropout_backward_cuda_dispatch.h>
#include <ATen/ops/native_dropout_backward_native.h>
#include <ATen/ops/native_dropout_cuda_dispatch.h>
#include <ATen/ops/native_dropout_native.h>
#include <ATen/ops/native_group_norm_backward_cuda_dispatch.h>
#include <ATen/ops/native_group_norm_backward_native.h>
#include <ATen/ops/native_group_norm_cuda_dispatch.h>
#include <ATen/ops/native_group_norm_native.h>
#include <ATen/ops/native_layer_norm_backward_cuda_dispatch.h>
#include <ATen/ops/native_layer_norm_backward_native.h>
#include <ATen/ops/native_layer_norm_cuda_dispatch.h>
#include <ATen/ops/native_layer_norm_native.h>
#include <ATen/ops/ne_cuda_dispatch.h>
#include <ATen/ops/ne_native.h>
#include <ATen/ops/neg_cuda_dispatch.h>
#include <ATen/ops/neg_native.h>
#include <ATen/ops/nextafter_cuda_dispatch.h>
#include <ATen/ops/nextafter_native.h>
#include <ATen/ops/nll_loss2d_backward_cuda_dispatch.h>
#include <ATen/ops/nll_loss2d_backward_native.h>
#include <ATen/ops/nll_loss2d_forward_cuda_dispatch.h>
#include <ATen/ops/nll_loss2d_forward_native.h>
#include <ATen/ops/nll_loss_backward_cuda_dispatch.h>
#include <ATen/ops/nll_loss_backward_native.h>
#include <ATen/ops/nll_loss_forward_cuda_dispatch.h>
#include <ATen/ops/nll_loss_forward_native.h>
#include <ATen/ops/nonzero_cuda_dispatch.h>
#include <ATen/ops/nonzero_native.h>
#include <ATen/ops/norm_cuda_dispatch.h>
#include <ATen/ops/norm_native.h>
#include <ATen/ops/normal_cuda_dispatch.h>
#include <ATen/ops/normal_native.h>
#include <ATen/ops/ormqr_cuda_dispatch.h>
#include <ATen/ops/ormqr_native.h>
#include <ATen/ops/poisson_cuda_dispatch.h>
#include <ATen/ops/poisson_native.h>
#include <ATen/ops/polar_cuda_dispatch.h>
#include <ATen/ops/polar_native.h>
#include <ATen/ops/polygamma_cuda_dispatch.h>
#include <ATen/ops/polygamma_native.h>
#include <ATen/ops/pow_cuda_dispatch.h>
#include <ATen/ops/pow_native.h>
#include <ATen/ops/prelu_backward_cuda_dispatch.h>
#include <ATen/ops/prelu_backward_native.h>
#include <ATen/ops/prelu_cuda_dispatch.h>
#include <ATen/ops/prelu_native.h>
#include <ATen/ops/prod_cuda_dispatch.h>
#include <ATen/ops/prod_native.h>
#include <ATen/ops/put_cuda_dispatch.h>
#include <ATen/ops/put_native.h>
#include <ATen/ops/quantize_per_channel_cuda_dispatch.h>
#include <ATen/ops/quantize_per_channel_native.h>
#include <ATen/ops/quantize_per_tensor_cuda_dispatch.h>
#include <ATen/ops/quantize_per_tensor_dynamic_cuda_dispatch.h>
#include <ATen/ops/quantize_per_tensor_dynamic_native.h>
#include <ATen/ops/quantize_per_tensor_native.h>
#include <ATen/ops/random_cuda_dispatch.h>
#include <ATen/ops/random_native.h>
#include <ATen/ops/randperm_cuda_dispatch.h>
#include <ATen/ops/randperm_native.h>
#include <ATen/ops/range_cuda_dispatch.h>
#include <ATen/ops/range_native.h>
#include <ATen/ops/reciprocal_cuda_dispatch.h>
#include <ATen/ops/reciprocal_native.h>
#include <ATen/ops/record_stream_cuda_dispatch.h>
#include <ATen/ops/record_stream_native.h>
#include <ATen/ops/reflection_pad1d_backward_cuda_dispatch.h>
#include <ATen/ops/reflection_pad1d_backward_native.h>
#include <ATen/ops/reflection_pad1d_cuda_dispatch.h>
#include <ATen/ops/reflection_pad1d_native.h>
#include <ATen/ops/reflection_pad2d_backward_cuda_dispatch.h>
#include <ATen/ops/reflection_pad2d_backward_native.h>
#include <ATen/ops/reflection_pad2d_cuda_dispatch.h>
#include <ATen/ops/reflection_pad2d_native.h>
#include <ATen/ops/reflection_pad3d_backward_cuda_dispatch.h>
#include <ATen/ops/reflection_pad3d_backward_native.h>
#include <ATen/ops/reflection_pad3d_cuda_dispatch.h>
#include <ATen/ops/reflection_pad3d_native.h>
#include <ATen/ops/relu_cuda_dispatch.h>
#include <ATen/ops/relu_native.h>
#include <ATen/ops/remainder_cuda_dispatch.h>
#include <ATen/ops/remainder_native.h>
#include <ATen/ops/renorm_cuda_dispatch.h>
#include <ATen/ops/renorm_native.h>
#include <ATen/ops/repeat_interleave_cuda_dispatch.h>
#include <ATen/ops/repeat_interleave_native.h>
#include <ATen/ops/replication_pad1d_backward_cuda_dispatch.h>
#include <ATen/ops/replication_pad1d_backward_native.h>
#include <ATen/ops/replication_pad1d_cuda_dispatch.h>
#include <ATen/ops/replication_pad1d_native.h>
#include <ATen/ops/replication_pad2d_backward_cuda_dispatch.h>
#include <ATen/ops/replication_pad2d_backward_native.h>
#include <ATen/ops/replication_pad2d_cuda_dispatch.h>
#include <ATen/ops/replication_pad2d_native.h>
#include <ATen/ops/replication_pad3d_backward_cuda_dispatch.h>
#include <ATen/ops/replication_pad3d_backward_native.h>
#include <ATen/ops/replication_pad3d_cuda_dispatch.h>
#include <ATen/ops/replication_pad3d_native.h>
#include <ATen/ops/resize_cuda_dispatch.h>
#include <ATen/ops/resize_native.h>
#include <ATen/ops/roll_cuda_dispatch.h>
#include <ATen/ops/roll_native.h>
#include <ATen/ops/round_cuda_dispatch.h>
#include <ATen/ops/round_native.h>
#include <ATen/ops/rrelu_with_noise_cuda_dispatch.h>
#include <ATen/ops/rrelu_with_noise_native.h>
#include <ATen/ops/rshift_cuda_dispatch.h>
#include <ATen/ops/rshift_native.h>
#include <ATen/ops/rsqrt_cuda_dispatch.h>
#include <ATen/ops/rsqrt_native.h>
#include <ATen/ops/rsub_cuda_dispatch.h>
#include <ATen/ops/rsub_native.h>
#include <ATen/ops/scatter_add_cuda_dispatch.h>
#include <ATen/ops/scatter_add_native.h>
#include <ATen/ops/scatter_cuda_dispatch.h>
#include <ATen/ops/scatter_native.h>
#include <ATen/ops/searchsorted_cuda_dispatch.h>
#include <ATen/ops/searchsorted_native.h>
#include <ATen/ops/segment_reduce_cuda_dispatch.h>
#include <ATen/ops/segment_reduce_native.h>
#include <ATen/ops/set_cuda_dispatch.h>
#include <ATen/ops/set_native.h>
#include <ATen/ops/sgn_cuda_dispatch.h>
#include <ATen/ops/sgn_native.h>
#include <ATen/ops/sigmoid_backward_cuda_dispatch.h>
#include <ATen/ops/sigmoid_backward_native.h>
#include <ATen/ops/sigmoid_cuda_dispatch.h>
#include <ATen/ops/sigmoid_native.h>
#include <ATen/ops/sign_cuda_dispatch.h>
#include <ATen/ops/sign_native.h>
#include <ATen/ops/signbit_cuda_dispatch.h>
#include <ATen/ops/signbit_native.h>
#include <ATen/ops/silu_backward_cuda_dispatch.h>
#include <ATen/ops/silu_backward_native.h>
#include <ATen/ops/silu_cuda_dispatch.h>
#include <ATen/ops/silu_native.h>
#include <ATen/ops/sin_cuda_dispatch.h>
#include <ATen/ops/sin_native.h>
#include <ATen/ops/sinc_cuda_dispatch.h>
#include <ATen/ops/sinc_native.h>
#include <ATen/ops/sinh_cuda_dispatch.h>
#include <ATen/ops/sinh_native.h>
#include <ATen/ops/slow_conv_dilated2d_cuda_dispatch.h>
#include <ATen/ops/slow_conv_dilated2d_native.h>
#include <ATen/ops/slow_conv_dilated3d_cuda_dispatch.h>
#include <ATen/ops/slow_conv_dilated3d_native.h>
#include <ATen/ops/slow_conv_transpose2d_cuda_dispatch.h>
#include <ATen/ops/slow_conv_transpose2d_native.h>
#include <ATen/ops/slow_conv_transpose3d_cuda_dispatch.h>
#include <ATen/ops/slow_conv_transpose3d_native.h>
#include <ATen/ops/smooth_l1_loss_backward_cuda_dispatch.h>
#include <ATen/ops/smooth_l1_loss_backward_native.h>
#include <ATen/ops/smooth_l1_loss_cuda_dispatch.h>
#include <ATen/ops/smooth_l1_loss_native.h>
#include <ATen/ops/softplus_backward_cuda_dispatch.h>
#include <ATen/ops/softplus_backward_native.h>
#include <ATen/ops/softplus_cuda_dispatch.h>
#include <ATen/ops/softplus_native.h>
#include <ATen/ops/softshrink_backward_cuda_dispatch.h>
#include <ATen/ops/softshrink_backward_native.h>
#include <ATen/ops/softshrink_cuda_dispatch.h>
#include <ATen/ops/softshrink_native.h>
#include <ATen/ops/sort_cuda_dispatch.h>
#include <ATen/ops/sort_native.h>
#include <ATen/ops/special_entr_cuda_dispatch.h>
#include <ATen/ops/special_entr_native.h>
#include <ATen/ops/special_erfcx_cuda_dispatch.h>
#include <ATen/ops/special_erfcx_native.h>
#include <ATen/ops/special_i0e_cuda_dispatch.h>
#include <ATen/ops/special_i0e_native.h>
#include <ATen/ops/special_i1_cuda_dispatch.h>
#include <ATen/ops/special_i1_native.h>
#include <ATen/ops/special_i1e_cuda_dispatch.h>
#include <ATen/ops/special_i1e_native.h>
#include <ATen/ops/special_ndtri_cuda_dispatch.h>
#include <ATen/ops/special_ndtri_native.h>
#include <ATen/ops/special_xlog1py_cuda_dispatch.h>
#include <ATen/ops/special_xlog1py_native.h>
#include <ATen/ops/special_zeta_cuda_dispatch.h>
#include <ATen/ops/special_zeta_native.h>
#include <ATen/ops/sqrt_cuda_dispatch.h>
#include <ATen/ops/sqrt_native.h>
#include <ATen/ops/square_cuda_dispatch.h>
#include <ATen/ops/square_native.h>
#include <ATen/ops/squeeze_cuda_dispatch.h>
#include <ATen/ops/squeeze_native.h>
#include <ATen/ops/sspaddmm_cuda_dispatch.h>
#include <ATen/ops/sspaddmm_native.h>
#include <ATen/ops/std_cuda_dispatch.h>
#include <ATen/ops/std_mean_cuda_dispatch.h>
#include <ATen/ops/std_mean_native.h>
#include <ATen/ops/std_native.h>
#include <ATen/ops/sub_cuda_dispatch.h>
#include <ATen/ops/sub_native.h>
#include <ATen/ops/sum_cuda_dispatch.h>
#include <ATen/ops/sum_native.h>
#include <ATen/ops/take_cuda_dispatch.h>
#include <ATen/ops/take_native.h>
#include <ATen/ops/tan_cuda_dispatch.h>
#include <ATen/ops/tan_native.h>
#include <ATen/ops/tanh_backward_cuda_dispatch.h>
#include <ATen/ops/tanh_backward_native.h>
#include <ATen/ops/tanh_cuda_dispatch.h>
#include <ATen/ops/tanh_native.h>
#include <ATen/ops/tensordot_cuda_dispatch.h>
#include <ATen/ops/tensordot_native.h>
#include <ATen/ops/threshold_backward_cuda_dispatch.h>
#include <ATen/ops/threshold_backward_native.h>
#include <ATen/ops/threshold_cuda_dispatch.h>
#include <ATen/ops/threshold_native.h>
#include <ATen/ops/to_sparse_cuda_dispatch.h>
#include <ATen/ops/to_sparse_native.h>
#include <ATen/ops/topk_cuda_dispatch.h>
#include <ATen/ops/topk_native.h>
#include <ATen/ops/trace_cuda_dispatch.h>
#include <ATen/ops/trace_native.h>
#include <ATen/ops/triangular_solve_cuda_dispatch.h>
#include <ATen/ops/triangular_solve_native.h>
#include <ATen/ops/tril_cuda_dispatch.h>
#include <ATen/ops/tril_indices_cuda_dispatch.h>
#include <ATen/ops/tril_indices_native.h>
#include <ATen/ops/tril_native.h>
#include <ATen/ops/triu_cuda_dispatch.h>
#include <ATen/ops/triu_indices_cuda_dispatch.h>
#include <ATen/ops/triu_indices_native.h>
#include <ATen/ops/triu_native.h>
#include <ATen/ops/trunc_cuda_dispatch.h>
#include <ATen/ops/trunc_native.h>
#include <ATen/ops/unfold_backward_cuda_dispatch.h>
#include <ATen/ops/unfold_backward_native.h>
#include <ATen/ops/unfold_cuda_dispatch.h>
#include <ATen/ops/unfold_native.h>
#include <ATen/ops/uniform_cuda_dispatch.h>
#include <ATen/ops/uniform_native.h>
#include <ATen/ops/unique_consecutive_cuda_dispatch.h>
#include <ATen/ops/unique_consecutive_native.h>
#include <ATen/ops/unique_dim_consecutive_cuda_dispatch.h>
#include <ATen/ops/unique_dim_consecutive_native.h>
#include <ATen/ops/unique_dim_cuda_dispatch.h>
#include <ATen/ops/unique_dim_native.h>
#include <ATen/ops/unsqueeze_cuda_dispatch.h>
#include <ATen/ops/unsqueeze_native.h>
#include <ATen/ops/upsample_bicubic2d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_bicubic2d_backward_native.h>
#include <ATen/ops/upsample_bicubic2d_cuda_dispatch.h>
#include <ATen/ops/upsample_bicubic2d_native.h>
#include <ATen/ops/upsample_bilinear2d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_bilinear2d_backward_native.h>
#include <ATen/ops/upsample_bilinear2d_cuda_dispatch.h>
#include <ATen/ops/upsample_bilinear2d_native.h>
#include <ATen/ops/upsample_linear1d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_linear1d_backward_native.h>
#include <ATen/ops/upsample_linear1d_cuda_dispatch.h>
#include <ATen/ops/upsample_linear1d_native.h>
#include <ATen/ops/upsample_nearest1d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_nearest1d_backward_native.h>
#include <ATen/ops/upsample_nearest1d_cuda_dispatch.h>
#include <ATen/ops/upsample_nearest1d_native.h>
#include <ATen/ops/upsample_nearest2d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_nearest2d_backward_native.h>
#include <ATen/ops/upsample_nearest2d_cuda_dispatch.h>
#include <ATen/ops/upsample_nearest2d_native.h>
#include <ATen/ops/upsample_nearest3d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_nearest3d_backward_native.h>
#include <ATen/ops/upsample_nearest3d_cuda_dispatch.h>
#include <ATen/ops/upsample_nearest3d_native.h>
#include <ATen/ops/upsample_trilinear3d_backward_cuda_dispatch.h>
#include <ATen/ops/upsample_trilinear3d_backward_native.h>
#include <ATen/ops/upsample_trilinear3d_cuda_dispatch.h>
#include <ATen/ops/upsample_trilinear3d_native.h>
#include <ATen/ops/var_cuda_dispatch.h>
#include <ATen/ops/var_mean_cuda_dispatch.h>
#include <ATen/ops/var_mean_native.h>
#include <ATen/ops/var_native.h>
#include <ATen/ops/vdot_cuda_dispatch.h>
#include <ATen/ops/vdot_native.h>
#include <ATen/ops/view_as_complex_cuda_dispatch.h>
#include <ATen/ops/view_as_complex_native.h>
#include <ATen/ops/view_as_real_cuda_dispatch.h>
#include <ATen/ops/view_as_real_native.h>
#include <ATen/ops/view_cuda_dispatch.h>
#include <ATen/ops/view_native.h>
#include <ATen/ops/xlogy_cuda_dispatch.h>
#include <ATen/ops/xlogy_native.h>
#include <ATen/ops/zero_cuda_dispatch.h>
#include <ATen/ops/zero_native.h>


namespace at {

// NB: TORCH_LIBRARY_IMPL must be in an anonymous namespace to avoid
// ambiguity with conflicting identifiers that may have been defined in
// at namespace already.
namespace {


Tensor create_out(IntArrayRef sizes, IntArrayRef strides, const TensorOptions &options) {
  
  if (strides.empty()) {
      return at::detail::empty_cuda(sizes, options);
  } else {
      return at::detail::empty_strided_cuda(sizes, strides, options);
  }
}

void resize_out(const Tensor &out, IntArrayRef sizes, IntArrayRef strides, const TensorOptions &options) {
  TORCH_CHECK(options.dtype() == out.dtype(),
      "Expected out tensor to have dtype ", options.dtype(), ", but got ", out.dtype(), " instead");
  TORCH_CHECK(options.device() == out.device(),
      "Expected out tensor to have device ", options.device(), ", but got ", out.device(), " instead");
  const bool resized = at::native::resize_output(out, sizes);
  // Only restride if a resize occurred; otherwise we ignore the (advisory)
  // strides from the meta function and directly use the output tensor's
  // preexisting strides
  if (resized) {
    if (!strides.empty()) {
      TORCH_INTERNAL_ASSERT(!options.memory_format_opt().has_value());
      at::native::as_strided_(out, sizes, strides);
    } else if (options.memory_format_opt().has_value()) {
      out.unsafeGetTensorImpl()->empty_tensor_restride(*options.memory_format_opt());
    }
  }
}

void check_inplace(const Tensor &self, IntArrayRef sizes, const TensorOptions &options) {
  // These checks are needed on those operators that:
  //   1) don't use 'TensorIterator' (e.g. 'addmm' and 'baddbmm')
  //   2) have particular typing rules (e.g. 'cumsum' and 'cumprod')
  // For other operators (e.g. 'add'), 'TensorIterator' already checks
  // these things separately.
  TORCH_CHECK(options.dtype() == self.dtype(),
      "Bad in-place call: ",
      "input tensor dtype ", self.dtype(), " and output tensor dtype ", options.dtype(), " should match");
  TORCH_CHECK(options.device() == self.device(),
      "Bad in-place call: ",
      "input tensor device ", self.device(), " and output tensor device ", options.device(), " should match");
  TORCH_CHECK(sizes == self.sizes(),
      "Bad in-place call: ",
      "input tensor size ", self.sizes(), " and output tensor size ", sizes, " should match");
}

namespace {

void wrapper___assert_async(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___assert_async", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_assert_async_cuda(self);
}

} // anonymous namespace
namespace {

bool wrapper___use_cudnn_ctc_loss(const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, int64_t blank) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(log_probs));
  return at::native::_use_cudnn_ctc_loss(log_probs, targets, input_lengths, target_lengths, blank);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___cudnn_ctc_loss(const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, int64_t blank, bool deterministic, bool zero_infinity) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(log_probs));
  return at::native::_cudnn_ctc_loss(log_probs, targets, input_lengths, target_lengths, blank, deterministic, zero_infinity);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___cudnn_rnn_flatten_weight(at::TensorList weight_arr, int64_t weight_stride0, int64_t input_size, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, bool batch_first, bool bidirectional) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, weight_arr, "wrapper___cudnn_rnn_flatten_weight", "weight_arr");

  const OptionalDeviceGuard device_guard(device_of(weight_arr));
  return at::native::_cudnn_rnn_flatten_weight(weight_arr, weight_stride0, input_size, mode, hidden_size, proj_size, num_layers, batch_first, bidirectional);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper___cudnn_rnn(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const c10::optional<at::Tensor> & weight_buf, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::_cudnn_rnn(input, weight, weight_stride0, weight_buf, hx, cx, mode, hidden_size, proj_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,::std::vector<at::Tensor>> wrapper___cudnn_rnn_backward(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const at::Tensor & weight_buf, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, const at::Tensor & output, const c10::optional<at::Tensor> & grad_output, const c10::optional<at::Tensor> & grad_hy, const c10::optional<at::Tensor> & grad_cy, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state, const at::Tensor & reserve, ::std::array<bool,4> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper___cudnn_rnn_backward", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper___cudnn_rnn_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, weight_buf, "wrapper___cudnn_rnn_backward", "weight_buf");
  c10::impl::check_and_update_common_device(common_device, hx, "wrapper___cudnn_rnn_backward", "hx");
  c10::impl::check_and_update_common_device(common_device, cx, "wrapper___cudnn_rnn_backward", "cx");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper___cudnn_rnn_backward", "output");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper___cudnn_rnn_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, grad_hy, "wrapper___cudnn_rnn_backward", "grad_hy");
  c10::impl::check_and_update_common_device(common_device, grad_cy, "wrapper___cudnn_rnn_backward", "grad_cy");
  c10::impl::check_and_update_common_device(common_device, dropout_state, "wrapper___cudnn_rnn_backward", "dropout_state");
  c10::impl::check_and_update_common_device(common_device, reserve, "wrapper___cudnn_rnn_backward", "reserve");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::_cudnn_rnn_backward(input, weight, weight_stride0, weight_buf, hx, cx, output, grad_output, grad_hy, grad_cy, mode, hidden_size, proj_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state, reserve, output_mask);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___cudnn_init_dropout_state(double dropout, bool train, int64_t dropout_seed, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning


  globalContext().lazyInitCUDA();

  const DeviceGuard device_guard(device_or_default(device));
  return at::native::_cudnn_init_dropout_state(dropout, train, dropout_seed, dtype, layout, device, pin_memory);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___fused_dropout(const at::Tensor & self, double p, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fused_dropout", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fused_dropout_cuda(self, p, generator);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___masked_scale(const at::Tensor & self, const at::Tensor & mask, double scale) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___masked_scale", "self");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper___masked_scale", "mask");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_scale_cuda(self, mask, scale);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__native_dropout(const at::Tensor & input, double p, c10::optional<bool> train) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_dropout", "input");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::native_dropout_cuda(input, p, train);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__native_dropout_backward(const at::Tensor & grad_output, const at::Tensor & mask, double scale) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__native_dropout_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper__native_dropout_backward", "mask");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::native_dropout_backward_cuda(grad_output, mask, scale);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_abs_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::abs_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__angle(const at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::angle(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_angle_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::angle_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__view_as_real(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__view_as_real", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::view_as_real(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__view_as_complex(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__view_as_complex", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::view_as_complex(self);
}

} // anonymous namespace
struct structured_sgn_out_functional final : public at::native::structured_sgn_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sgn_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sgn(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sgn", "self");
structured_sgn_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sgn_out_out final : public at::native::structured_sgn_out {
    structured_sgn_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sgn_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sgn_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_sgn_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sgn_out_out", "self");
structured_sgn_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sgn_out_inplace final : public at::native::structured_sgn_out {
    structured_sgn_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sgn_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sgn_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sgn_", "self");
structured_sgn_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_conj_physical_out_out(const at::Tensor & self, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_conj_physical_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_conj_physical_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::conj_physical_out(self, out);
}

} // anonymous namespace
struct structured_acos_out_functional final : public at::native::structured_acos_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_acos_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_acos(const at::Tensor & self) {
  // No device check

structured_acos_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_acos_out_out final : public at::native::structured_acos_out {
    structured_acos_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_acos_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_acos_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_acos_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_acos_out_inplace final : public at::native::structured_acos_out {
    structured_acos_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_acos_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_acos_(at::Tensor & self) {
  // No device check

structured_acos_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_add_out_functional final : public at::native::structured_add_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_add_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_add_Tensor(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
  // No device check

structured_add_out_functional op;
op.meta(self, other, alpha);
op.impl(self, other, alpha, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_add_out_out final : public at::native::structured_add_out {
    structured_add_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_add_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_add_out_out(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
  // No device check

structured_add_out_out op(out);
op.meta(self, other, alpha);
op.impl(self, other, alpha, op.outputs_[0]);
return out;
}
struct structured_add_out_inplace final : public at::native::structured_add_out {
    structured_add_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_add_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_add__Tensor(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
  // No device check

structured_add_out_inplace op(self);
op.meta(self, other, alpha);
op.impl(self, other, alpha, op.outputs_[0]);
return self;
}
struct structured_addmv_out_cuda_functional final : public at::native::structured_addmv_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_addmv(const at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_addmv", "self");
  c10::impl::check_and_update_common_device(common_device, mat, "wrapper_addmv", "mat");
  c10::impl::check_and_update_common_device(common_device, vec, "wrapper_addmv", "vec");
structured_addmv_out_cuda_functional op;
op.meta(self, mat, vec, beta, alpha);
op.impl(self, mat, vec, beta, alpha, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_addmv_out_cuda_out final : public at::native::structured_addmv_out_cuda {
    structured_addmv_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addmv_out_out(const at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_addmv_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_addmv_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, mat, "wrapper_addmv_out_out", "mat");
  c10::impl::check_and_update_common_device(common_device, vec, "wrapper_addmv_out_out", "vec");
structured_addmv_out_cuda_out op(out);
op.meta(self, mat, vec, beta, alpha);
op.impl(self, mat, vec, beta, alpha, op.outputs_[0]);
return out;
}
struct structured_addmv_out_cuda_inplace final : public at::native::structured_addmv_out_cuda {
    structured_addmv_out_cuda_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addmv_(at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_addmv_", "self");
  c10::impl::check_and_update_common_device(common_device, mat, "wrapper_addmv_", "mat");
  c10::impl::check_and_update_common_device(common_device, vec, "wrapper_addmv_", "vec");
structured_addmv_out_cuda_inplace op(self);
op.meta(self, mat, vec, beta, alpha);
op.impl(self, mat, vec, beta, alpha, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__addr(const at::Tensor & self, const at::Tensor & vec1, const at::Tensor & vec2, const at::Scalar & beta, const at::Scalar & alpha) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__addr", "self");
  c10::impl::check_and_update_common_device(common_device, vec1, "wrapper__addr", "vec1");
  c10::impl::check_and_update_common_device(common_device, vec2, "wrapper__addr", "vec2");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::addr(self, vec1, vec2, beta, alpha);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_addr_out_out(const at::Tensor & self, const at::Tensor & vec1, const at::Tensor & vec2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_addr_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_addr_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, vec1, "wrapper_out_addr_out_out", "vec1");
  c10::impl::check_and_update_common_device(common_device, vec2, "wrapper_out_addr_out_out", "vec2");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::addr_out(self, vec1, vec2, beta, alpha, out);
}

} // anonymous namespace
struct structured_all_out_functional final : public at::native::structured_all_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_all_dim(const at::Tensor & self, int64_t dim, bool keepdim) {
  // No device check

structured_all_out_functional op;
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_all_out_out final : public at::native::structured_all_out {
    structured_all_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_all_out_out(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & out) {
  // No device check

structured_all_out_out op(out);
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, op.outputs_[0]);
return out;
}
struct structured_any_out_functional final : public at::native::structured_any_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_any_dim(const at::Tensor & self, int64_t dim, bool keepdim) {
  // No device check

structured_any_out_functional op;
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_any_out_out final : public at::native::structured_any_out {
    structured_any_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_any_out_out(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & out) {
  // No device check

structured_any_out_out op(out);
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, op.outputs_[0]);
return out;
}
namespace {

at::Tensor & wrapper_start_out_arange_out_start_out(const at::Scalar & start, const at::Scalar & end, const at::Scalar & step, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_start_out_arange_out_start_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::arange_cuda_out(start, end, step, out);
}

} // anonymous namespace
struct structured_argmax_out_functional final : public at::native::structured_argmax_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_argmax(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
  // No device check

structured_argmax_out_functional op;
op.meta(self, dim, keepdim);
op.impl(self, dim, keepdim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_argmax_out_out final : public at::native::structured_argmax_out {
    structured_argmax_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_argmax_out_out(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_argmax_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_argmax_out_out", "self");
structured_argmax_out_out op(out);
op.meta(self, dim, keepdim);
op.impl(self, dim, keepdim, op.outputs_[0]);
return out;
}
struct structured_argmin_out_functional final : public at::native::structured_argmin_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_argmin(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
  // No device check

structured_argmin_out_functional op;
op.meta(self, dim, keepdim);
op.impl(self, dim, keepdim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_argmin_out_out final : public at::native::structured_argmin_out {
    structured_argmin_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_argmin_out_out(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_argmin_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_argmin_out_out", "self");
structured_argmin_out_out op(out);
op.meta(self, dim, keepdim);
op.impl(self, dim, keepdim, op.outputs_[0]);
return out;
}
struct structured_acosh_out_functional final : public at::native::structured_acosh_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_acosh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_acosh(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_acosh", "self");
structured_acosh_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_acosh_out_out final : public at::native::structured_acosh_out {
    structured_acosh_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_acosh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_acosh_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_acosh_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_acosh_out_out", "self");
structured_acosh_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_acosh_out_inplace final : public at::native::structured_acosh_out {
    structured_acosh_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_acosh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_acosh_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_acosh_", "self");
structured_acosh_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_asinh_out_functional final : public at::native::structured_asinh_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_asinh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_asinh(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_asinh", "self");
structured_asinh_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_asinh_out_out final : public at::native::structured_asinh_out {
    structured_asinh_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_asinh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_asinh_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_asinh_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_asinh_out_out", "self");
structured_asinh_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_asinh_out_inplace final : public at::native::structured_asinh_out {
    structured_asinh_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_asinh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_asinh_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_asinh_", "self");
structured_asinh_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_atanh_out_functional final : public at::native::structured_atanh_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atanh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_atanh(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_atanh", "self");
structured_atanh_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_atanh_out_out final : public at::native::structured_atanh_out {
    structured_atanh_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atanh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_atanh_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_atanh_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_atanh_out_out", "self");
structured_atanh_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_atanh_out_inplace final : public at::native::structured_atanh_out {
    structured_atanh_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atanh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_atanh_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_atanh_", "self");
structured_atanh_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__as_strided(const at::Tensor & self, at::IntArrayRef size, at::IntArrayRef stride, c10::optional<int64_t> storage_offset) {
    // No device check


  // DeviceGuard omitted
  return at::native::as_strided_tensorimpl(self, size, stride, storage_offset);
}

} // anonymous namespace
struct structured_asin_out_functional final : public at::native::structured_asin_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_asin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_asin(const at::Tensor & self) {
  // No device check

structured_asin_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_asin_out_out final : public at::native::structured_asin_out {
    structured_asin_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_asin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_asin_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_asin_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_asin_out_inplace final : public at::native::structured_asin_out {
    structured_asin_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_asin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_asin_(at::Tensor & self) {
  // No device check

structured_asin_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_atan_out_functional final : public at::native::structured_atan_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atan_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_atan(const at::Tensor & self) {
  // No device check

structured_atan_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_atan_out_out final : public at::native::structured_atan_out {
    structured_atan_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atan_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_atan_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_atan_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_atan_out_inplace final : public at::native::structured_atan_out {
    structured_atan_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atan_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_atan_(at::Tensor & self) {
  // No device check

structured_atan_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_baddbmm_out_cuda_functional final : public at::native::structured_baddbmm_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_baddbmm(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_baddbmm", "self");
  c10::impl::check_and_update_common_device(common_device, batch1, "wrapper_baddbmm", "batch1");
  c10::impl::check_and_update_common_device(common_device, batch2, "wrapper_baddbmm", "batch2");
structured_baddbmm_out_cuda_functional op;
op.meta(self, batch1, batch2, beta, alpha);
op.impl(self, batch1, batch2, beta, alpha, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_baddbmm_out_cuda_out final : public at::native::structured_baddbmm_out_cuda {
    structured_baddbmm_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_baddbmm_out_out(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_baddbmm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_baddbmm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, batch1, "wrapper_baddbmm_out_out", "batch1");
  c10::impl::check_and_update_common_device(common_device, batch2, "wrapper_baddbmm_out_out", "batch2");
structured_baddbmm_out_cuda_out op(out);
op.meta(self, batch1, batch2, beta, alpha);
op.impl(self, batch1, batch2, beta, alpha, op.outputs_[0]);
return out;
}
struct structured_baddbmm_out_cuda_inplace final : public at::native::structured_baddbmm_out_cuda {
    structured_baddbmm_out_cuda_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_baddbmm_(at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_baddbmm_", "self");
  c10::impl::check_and_update_common_device(common_device, batch1, "wrapper_baddbmm_", "batch1");
  c10::impl::check_and_update_common_device(common_device, batch2, "wrapper_baddbmm_", "batch2");
structured_baddbmm_out_cuda_inplace op(self);
op.meta(self, batch1, batch2, beta, alpha);
op.impl(self, batch1, batch2, beta, alpha, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_bernoulli_out_out(const at::Tensor & self, c10::optional<at::Generator> generator, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bernoulli_out(self, generator, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_bernoulli__Tensor(at::Tensor & self, const at::Tensor & p, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bernoulli_(self, p, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_float_bernoulli__float(at::Tensor & self, double p, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bernoulli_(self, p, generator);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__binary_cross_entropy(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::binary_cross_entropy_cuda(self, target, weight, reduction);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_binary_cross_entropy_out_out(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::binary_cross_entropy_out_cuda(self, target, weight, reduction, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__binary_cross_entropy_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__binary_cross_entropy_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__binary_cross_entropy_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__binary_cross_entropy_backward", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__binary_cross_entropy_backward", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::binary_cross_entropy_backward_cuda(grad_output, self, target, weight, reduction);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_binary_cross_entropy_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_binary_cross_entropy_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_binary_cross_entropy_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_binary_cross_entropy_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_binary_cross_entropy_backward_out_grad_input", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_grad_input_binary_cross_entropy_backward_out_grad_input", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::binary_cross_entropy_backward_out_cuda(grad_output, self, target, weight, reduction, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__bincount(const at::Tensor & self, const c10::optional<at::Tensor> & weights, int64_t minlength) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__bincount", "self");
  c10::impl::check_and_update_common_device(common_device, weights, "wrapper__bincount", "weights");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_bincount_cuda(self, weights, minlength);
}

} // anonymous namespace
struct structured_bitwise_not_out_functional final : public at::native::structured_bitwise_not_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_not_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bitwise_not(const at::Tensor & self) {
  // No device check

structured_bitwise_not_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bitwise_not_out_out final : public at::native::structured_bitwise_not_out {
    structured_bitwise_not_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_not_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_not_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_bitwise_not_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_bitwise_not_out_inplace final : public at::native::structured_bitwise_not_out {
    structured_bitwise_not_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_not_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_not_(at::Tensor & self) {
  // No device check

structured_bitwise_not_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_copysign_out_functional final : public at::native::structured_copysign_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_copysign_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_copysign_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_copysign_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_copysign_out_out final : public at::native::structured_copysign_out {
    structured_copysign_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_copysign_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_copysign_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_copysign_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_copysign_out_inplace final : public at::native::structured_copysign_out {
    structured_copysign_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_copysign_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_copysign__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_copysign_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_logical_not_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logical_not_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_logical_xor_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logical_xor_out(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_logical_and_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logical_and_out(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_logical_or_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logical_or_out(self, other, out);
}

} // anonymous namespace
struct structured_bmm_out_cuda_functional final : public at::native::structured_bmm_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bmm(const at::Tensor & self, const at::Tensor & mat2) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_bmm", "self");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_bmm", "mat2");
structured_bmm_out_cuda_functional op;
op.meta(self, mat2);
op.impl(self, mat2, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bmm_out_cuda_out final : public at::native::structured_bmm_out_cuda {
    structured_bmm_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bmm_out_out(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_bmm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_bmm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_bmm_out_out", "mat2");
structured_bmm_out_cuda_out op(out);
op.meta(self, mat2);
op.impl(self, mat2, op.outputs_[0]);
return out;
}
struct structured_ceil_out_functional final : public at::native::structured_ceil_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ceil_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_ceil(const at::Tensor & self) {
  // No device check

structured_ceil_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_ceil_out_out final : public at::native::structured_ceil_out {
    structured_ceil_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ceil_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ceil_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_ceil_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_ceil_out_inplace final : public at::native::structured_ceil_out {
    structured_ceil_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ceil_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ceil_(at::Tensor & self) {
  // No device check

structured_ceil_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_clamp_out_functional final : public at::native::structured_clamp_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_clamp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_clamp(const at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max) {
  // No device check

structured_clamp_out_functional op;
op.meta(self, (min.has_value() ? at::OptionalScalarRef(&(min.value())) : at::OptionalScalarRef()), (max.has_value() ? at::OptionalScalarRef(&(max.value())) : at::OptionalScalarRef()));
op.impl(self, (min.has_value() ? at::OptionalScalarRef(&(min.value())) : at::OptionalScalarRef()), (max.has_value() ? at::OptionalScalarRef(&(max.value())) : at::OptionalScalarRef()), *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_clamp_out_out final : public at::native::structured_clamp_out {
    structured_clamp_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_clamp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_clamp_out_out(const at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max, at::Tensor & out) {
  // No device check

structured_clamp_out_out op(out);
op.meta(self, (min.has_value() ? at::OptionalScalarRef(&(min.value())) : at::OptionalScalarRef()), (max.has_value() ? at::OptionalScalarRef(&(max.value())) : at::OptionalScalarRef()));
op.impl(self, (min.has_value() ? at::OptionalScalarRef(&(min.value())) : at::OptionalScalarRef()), (max.has_value() ? at::OptionalScalarRef(&(max.value())) : at::OptionalScalarRef()), op.outputs_[0]);
return out;
}
struct structured_clamp_out_inplace final : public at::native::structured_clamp_out {
    structured_clamp_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_clamp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_clamp_(at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max) {
  // No device check

structured_clamp_out_inplace op(self);
op.meta(self, (min.has_value() ? at::OptionalScalarRef(&(min.value())) : at::OptionalScalarRef()), (max.has_value() ? at::OptionalScalarRef(&(max.value())) : at::OptionalScalarRef()));
op.impl(self, (min.has_value() ? at::OptionalScalarRef(&(min.value())) : at::OptionalScalarRef()), (max.has_value() ? at::OptionalScalarRef(&(max.value())) : at::OptionalScalarRef()), op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Tensor_clamp_Tensor(const at::Tensor & self, const c10::optional<at::Tensor> & min, const c10::optional<at::Tensor> & max) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_clamp_Tensor", "self");
  c10::impl::check_and_update_common_device(common_device, min, "wrapper_Tensor_clamp_Tensor", "min");
  c10::impl::check_and_update_common_device(common_device, max, "wrapper_Tensor_clamp_Tensor", "max");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::clamp(self, min, max);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_out_clamp_out_Tensor_out(const at::Tensor & self, const c10::optional<at::Tensor> & min, const c10::optional<at::Tensor> & max, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::clamp_out(self, min, max, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_clamp_max_out_out(const at::Tensor & self, const at::Scalar & max, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::clamp_max_out(self, max, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_out_clamp_max_out_Tensor_out(const at::Tensor & self, const at::Tensor & max, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_Tensor_out_clamp_max_out_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_out_clamp_max_out_Tensor_out", "self");
  c10::impl::check_and_update_common_device(common_device, max, "wrapper_Tensor_out_clamp_max_out_Tensor_out", "max");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::clamp_max_out(self, max, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_clamp_min_out_out(const at::Tensor & self, const at::Scalar & min, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::clamp_min_out(self, min, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_out_clamp_min_out_Tensor_out(const at::Tensor & self, const at::Tensor & min, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_Tensor_out_clamp_min_out_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_out_clamp_min_out_Tensor_out", "self");
  c10::impl::check_and_update_common_device(common_device, min, "wrapper_Tensor_out_clamp_min_out_Tensor_out", "min");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::clamp_min_out(self, min, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_complex_out_out(const at::Tensor & real, const at::Tensor & imag, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_complex_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, real, "wrapper_out_complex_out_out", "real");
  c10::impl::check_and_update_common_device(common_device, imag, "wrapper_out_complex_out_out", "imag");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::complex_out(real, imag, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_polar_out_out(const at::Tensor & abs, const at::Tensor & angle, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_polar_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, abs, "wrapper_out_polar_out_out", "abs");
  c10::impl::check_and_update_common_device(common_device, angle, "wrapper_out_polar_out_out", "angle");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::polar_out(abs, angle, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__convolution_backward(const at::Tensor & grad_output, const at::Tensor & input, const at::Tensor & weight, c10::optional<at::IntArrayRef> bias_sizes, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool transposed, at::IntArrayRef output_padding, int64_t groups, ::std::array<bool,3> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__convolution_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__convolution_backward", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__convolution_backward", "weight");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::convolution_backward(grad_output, input, weight, bias_sizes, stride, padding, dilation, transposed, output_padding, groups, output_mask);
}

} // anonymous namespace
struct structured_cos_out_functional final : public at::native::structured_cos_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_cos_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_cos(const at::Tensor & self) {
  // No device check

structured_cos_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_cos_out_out final : public at::native::structured_cos_out {
    structured_cos_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_cos_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cos_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_cos_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_cos_out_inplace final : public at::native::structured_cos_out {
    structured_cos_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_cos_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cos_(at::Tensor & self) {
  // No device check

structured_cos_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_cosh_out_functional final : public at::native::structured_cosh_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_cosh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_cosh(const at::Tensor & self) {
  // No device check

structured_cosh_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_cosh_out_out final : public at::native::structured_cosh_out {
    structured_cosh_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_cosh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cosh_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_cosh_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_cosh_out_inplace final : public at::native::structured_cosh_out {
    structured_cosh_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_cosh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cosh_(at::Tensor & self) {
  // No device check

structured_cosh_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_dim_IntList_count_nonzero_dim_IntList(const at::Tensor & self, at::IntArrayRef dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_dim_IntList_count_nonzero_dim_IntList", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::count_nonzero_cuda(self, dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_affine_grid_generator(const at::Tensor & theta, int64_t N, int64_t C, int64_t H, int64_t W) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, theta, "wrapper__cudnn_affine_grid_generator", "theta");

  const OptionalDeviceGuard device_guard(device_of(theta));
  return at::native::cudnn_affine_grid_generator_forward(theta, N, C, H, W);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_affine_grid_generator_backward(const at::Tensor & grad, int64_t N, int64_t C, int64_t H, int64_t W) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper__cudnn_affine_grid_generator_backward", "grad");

  const OptionalDeviceGuard device_guard(device_of(grad));
  return at::native::cudnn_affine_grid_generator_backward(grad, N, C, H, W);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper__cudnn_batch_norm(const at::Tensor & input, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double exponential_average_factor, double epsilon) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__cudnn_batch_norm", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__cudnn_batch_norm", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__cudnn_batch_norm", "bias");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__cudnn_batch_norm", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__cudnn_batch_norm", "running_var");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::cudnn_batch_norm(input, weight, bias, running_mean, running_var, training, exponential_average_factor, epsilon);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__cudnn_batch_norm_backward(const at::Tensor & input, const at::Tensor & grad_output, const at::Tensor & weight, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, const c10::optional<at::Tensor> & save_mean, const c10::optional<at::Tensor> & save_var, double epsilon, const at::Tensor & reserveSpace) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__cudnn_batch_norm_backward", "input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__cudnn_batch_norm_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__cudnn_batch_norm_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__cudnn_batch_norm_backward", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__cudnn_batch_norm_backward", "running_var");
  c10::impl::check_and_update_common_device(common_device, save_mean, "wrapper__cudnn_batch_norm_backward", "save_mean");
  c10::impl::check_and_update_common_device(common_device, save_var, "wrapper__cudnn_batch_norm_backward", "save_var");
  c10::impl::check_and_update_common_device(common_device, reserveSpace, "wrapper__cudnn_batch_norm_backward", "reserveSpace");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::cudnn_batch_norm_backward(input, grad_output, weight, running_mean, running_var, save_mean, save_var, epsilon, reserveSpace);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_convolution(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic, bool allow_tf32) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cudnn_convolution", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__cudnn_convolution", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cudnn_convolution(self, weight, padding, stride, dilation, groups, benchmark, deterministic, allow_tf32);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_convolution_transpose(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic, bool allow_tf32) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cudnn_convolution_transpose", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__cudnn_convolution_transpose", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cudnn_convolution_transpose(self, weight, padding, output_padding, stride, dilation, groups, benchmark, deterministic, allow_tf32);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_convolution_relu(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, int64_t groups) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cudnn_convolution_relu", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__cudnn_convolution_relu", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__cudnn_convolution_relu", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cudnn_convolution_relu(self, weight, bias, stride, padding, dilation, groups);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_convolution_add_relu(const at::Tensor & self, const at::Tensor & weight, const at::Tensor & z, const c10::optional<at::Scalar> & alpha, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, int64_t groups) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cudnn_convolution_add_relu", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__cudnn_convolution_add_relu", "weight");
  c10::impl::check_and_update_common_device(common_device, z, "wrapper__cudnn_convolution_add_relu", "z");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__cudnn_convolution_add_relu", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cudnn_convolution_add_relu(self, weight, z, alpha, bias, stride, padding, dilation, groups);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cudnn_grid_sampler(const at::Tensor & self, const at::Tensor & grid) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cudnn_grid_sampler", "self");
  c10::impl::check_and_update_common_device(common_device, grid, "wrapper__cudnn_grid_sampler", "grid");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cudnn_grid_sampler_forward(self, grid);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__cudnn_grid_sampler_backward(const at::Tensor & self, const at::Tensor & grid, const at::Tensor & grad_output) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cudnn_grid_sampler_backward", "self");
  c10::impl::check_and_update_common_device(common_device, grid, "wrapper__cudnn_grid_sampler_backward", "grid");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__cudnn_grid_sampler_backward", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cudnn_grid_sampler_backward(self, grid, grad_output);
}

} // anonymous namespace
namespace {

void wrapper___cummax_helper(const at::Tensor & self, at::Tensor & values, at::Tensor & indices, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___cummax_helper", "self");
  c10::impl::check_and_update_common_device(common_device, values, "wrapper___cummax_helper", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper___cummax_helper", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cummax_helper_cuda(self, values, indices, dim);
}

} // anonymous namespace
namespace {

void wrapper___cummin_helper(const at::Tensor & self, at::Tensor & values, at::Tensor & indices, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___cummin_helper", "self");
  c10::impl::check_and_update_common_device(common_device, values, "wrapper___cummin_helper", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper___cummin_helper", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cummin_helper_cuda(self, values, indices, dim);
}

} // anonymous namespace
struct structured_cumprod_out_functional final : public at::native::structured_cumprod_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_cumprod(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
  // No device check

structured_cumprod_out_functional op;
op.meta(self, dim, dtype);
op.impl(self, dim, dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_cumprod_out_out final : public at::native::structured_cumprod_out {
    structured_cumprod_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cumprod_out_out(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  // No device check

structured_cumprod_out_out op(out);
op.meta(self, dim, dtype);
op.impl(self, dim, dtype, op.outputs_[0]);
return out;
}
struct structured_cumprod_out_inplace final : public at::native::structured_cumprod_out {
    structured_cumprod_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cumprod_(at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_cumprod_", "self");
structured_cumprod_out_inplace op(self);
op.meta(self, dim, dtype);
op.impl(self, dim, dtype, op.outputs_[0]);
return self;
}
struct structured_cumsum_out_functional final : public at::native::structured_cumsum_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_cumsum(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
  // No device check

structured_cumsum_out_functional op;
op.meta(self, dim, dtype);
op.impl(self, dim, dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_cumsum_out_out final : public at::native::structured_cumsum_out {
    structured_cumsum_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cumsum_out_out(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  // No device check

structured_cumsum_out_out op(out);
op.meta(self, dim, dtype);
op.impl(self, dim, dtype, op.outputs_[0]);
return out;
}
struct structured_cumsum_out_inplace final : public at::native::structured_cumsum_out {
    structured_cumsum_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_cumsum_(at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_cumsum_", "self");
structured_cumsum_out_inplace op(self);
op.meta(self, dim, dtype);
op.impl(self, dim, dtype, op.outputs_[0]);
return self;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___ctc_loss(const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, int64_t blank, bool zero_infinity) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, log_probs, "wrapper___ctc_loss", "log_probs");
  c10::impl::check_and_update_common_device(common_device, targets, "wrapper___ctc_loss", "targets");

  const OptionalDeviceGuard device_guard(device_of(log_probs));
  return at::native::ctc_loss_gpu(log_probs, targets, input_lengths, target_lengths, blank, zero_infinity);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___ctc_loss_backward(const at::Tensor & grad, const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, const at::Tensor & neg_log_likelihood, const at::Tensor & log_alpha, int64_t blank, bool zero_infinity) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper___ctc_loss_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, log_probs, "wrapper___ctc_loss_backward", "log_probs");
  c10::impl::check_and_update_common_device(common_device, targets, "wrapper___ctc_loss_backward", "targets");
  c10::impl::check_and_update_common_device(common_device, neg_log_likelihood, "wrapper___ctc_loss_backward", "neg_log_likelihood");
  c10::impl::check_and_update_common_device(common_device, log_alpha, "wrapper___ctc_loss_backward", "log_alpha");

  const OptionalDeviceGuard device_guard(device_of(grad));
  return at::native::ctc_loss_backward_gpu(grad, log_probs, targets, input_lengths, target_lengths, neg_log_likelihood, log_alpha, blank, zero_infinity);
}

} // anonymous namespace
struct structured_div_out_functional final : public at::native::structured_div_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_div_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_div_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_div_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_div_out_out final : public at::native::structured_div_out {
    structured_div_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_div_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_div_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_div_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_div_out_inplace final : public at::native::structured_div_out {
    structured_div_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_div_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_div__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_div_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_div_out_mode_functional final : public at::native::structured_div_out_mode {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_div_out_mode::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_div_Tensor_mode(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
  // No device check

structured_div_out_mode_functional op;
op.meta(self, other, rounding_mode);
op.impl(self, other, rounding_mode, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_div_out_mode_out final : public at::native::structured_div_out_mode {
    structured_div_out_mode_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_div_out_mode::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_div_out_out_mode(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode, at::Tensor & out) {
  // No device check

structured_div_out_mode_out op(out);
op.meta(self, other, rounding_mode);
op.impl(self, other, rounding_mode, op.outputs_[0]);
return out;
}
struct structured_div_out_mode_inplace final : public at::native::structured_div_out_mode {
    structured_div_out_mode_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_div_out_mode::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_div__Tensor_mode(at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
  // No device check

structured_div_out_mode_inplace op(self);
op.meta(self, other, rounding_mode);
op.impl(self, other, rounding_mode, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__dot(const at::Tensor & self, const at::Tensor & tensor) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__dot", "self");
  c10::impl::check_and_update_common_device(common_device, tensor, "wrapper__dot", "tensor");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::dot_cuda(self, tensor);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__vdot(const at::Tensor & self, const at::Tensor & other) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__vdot", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper__vdot", "other");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::vdot_cuda(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__embedding_dense_backward(const at::Tensor & grad_output, const at::Tensor & indices, int64_t num_weights, int64_t padding_idx, bool scale_grad_by_freq) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__embedding_dense_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__embedding_dense_backward", "indices");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::embedding_dense_backward_cuda(grad_output, indices, num_weights, padding_idx, scale_grad_by_freq);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__embedding_renorm_(at::Tensor & self, const at::Tensor & indices, double max_norm, double norm_type) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__embedding_renorm_", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__embedding_renorm_", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::embedding_renorm_cuda_(self, indices, max_norm, norm_type);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper___embedding_bag_forward_only(const at::Tensor & weight, const at::Tensor & indices, const at::Tensor & offsets, bool scale_grad_by_freq, int64_t mode, bool sparse, const c10::optional<at::Tensor> & per_sample_weights, bool include_last_offset, int64_t padding_idx) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, weight, "wrapper___embedding_bag_forward_only", "weight");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper___embedding_bag_forward_only", "indices");
  c10::impl::check_and_update_common_device(common_device, offsets, "wrapper___embedding_bag_forward_only", "offsets");
  c10::impl::check_and_update_common_device(common_device, per_sample_weights, "wrapper___embedding_bag_forward_only", "per_sample_weights");

  const OptionalDeviceGuard device_guard(device_of(weight));
  return at::native::_embedding_bag_forward_only_cuda(weight, indices, offsets, scale_grad_by_freq, mode, sparse, per_sample_weights, include_last_offset, padding_idx);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper___embedding_bag(const at::Tensor & weight, const at::Tensor & indices, const at::Tensor & offsets, bool scale_grad_by_freq, int64_t mode, bool sparse, const c10::optional<at::Tensor> & per_sample_weights, bool include_last_offset, int64_t padding_idx) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, weight, "wrapper___embedding_bag", "weight");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper___embedding_bag", "indices");
  c10::impl::check_and_update_common_device(common_device, offsets, "wrapper___embedding_bag", "offsets");
  c10::impl::check_and_update_common_device(common_device, per_sample_weights, "wrapper___embedding_bag", "per_sample_weights");

  const OptionalDeviceGuard device_guard(device_of(weight));
  return at::native::_embedding_bag_cuda(weight, indices, offsets, scale_grad_by_freq, mode, sparse, per_sample_weights, include_last_offset, padding_idx);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___embedding_bag_dense_backward(const at::Tensor & grad, const at::Tensor & indices, const at::Tensor & offset2bag, const at::Tensor & bag_size, const at::Tensor & maximum_indices, int64_t num_weights, bool scale_grad_by_freq, int64_t mode, const c10::optional<at::Tensor> & per_sample_weights, int64_t padding_idx) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper___embedding_bag_dense_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper___embedding_bag_dense_backward", "indices");
  c10::impl::check_and_update_common_device(common_device, offset2bag, "wrapper___embedding_bag_dense_backward", "offset2bag");
  c10::impl::check_and_update_common_device(common_device, bag_size, "wrapper___embedding_bag_dense_backward", "bag_size");
  c10::impl::check_and_update_common_device(common_device, maximum_indices, "wrapper___embedding_bag_dense_backward", "maximum_indices");
  c10::impl::check_and_update_common_device(common_device, per_sample_weights, "wrapper___embedding_bag_dense_backward", "per_sample_weights");

  const OptionalDeviceGuard device_guard(device_of(grad));
  return at::native::_embedding_bag_dense_backward_cuda(grad, indices, offset2bag, bag_size, maximum_indices, num_weights, scale_grad_by_freq, mode, per_sample_weights, padding_idx);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___embedding_bag_per_sample_weights_backward(const at::Tensor & grad, const at::Tensor & weight, const at::Tensor & indices, const at::Tensor & offsets, const at::Tensor & offset2bag, int64_t mode, int64_t padding_idx) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper___embedding_bag_per_sample_weights_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper___embedding_bag_per_sample_weights_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper___embedding_bag_per_sample_weights_backward", "indices");
  c10::impl::check_and_update_common_device(common_device, offsets, "wrapper___embedding_bag_per_sample_weights_backward", "offsets");
  c10::impl::check_and_update_common_device(common_device, offset2bag, "wrapper___embedding_bag_per_sample_weights_backward", "offset2bag");

  const OptionalDeviceGuard device_guard(device_of(grad));
  return at::native::_embedding_bag_per_sample_weights_backward_cuda(grad, weight, indices, offsets, offset2bag, mode, padding_idx);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_memory_format_empty_memory_format(at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory, c10::optional<at::MemoryFormat> memory_format) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning


  globalContext().lazyInitCUDA();

  const DeviceGuard device_guard(device_or_default(device));
  return at::native::empty_cuda(size, dtype, layout, device, pin_memory, memory_format);
}

} // anonymous namespace
namespace {

const at::Tensor & wrapper__resize_(const at::Tensor & self, at::IntArrayRef size, c10::optional<at::MemoryFormat> memory_format) {
    // No device check


  // DeviceGuard omitted
  return at::native::resize_cuda_(self, size, memory_format);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__empty_strided(at::IntArrayRef size, at::IntArrayRef stride, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning


  globalContext().lazyInitCUDA();

  const DeviceGuard device_guard(device_or_default(device));
  return at::native::empty_strided_cuda(size, stride, dtype, layout, device, pin_memory);
}

} // anonymous namespace
struct structured_erf_out_functional final : public at::native::structured_erf_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_erf(const at::Tensor & self) {
  // No device check

structured_erf_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_erf_out_out final : public at::native::structured_erf_out {
    structured_erf_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_erf_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_erf_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_erf_out_inplace final : public at::native::structured_erf_out {
    structured_erf_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_erf_(at::Tensor & self) {
  // No device check

structured_erf_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_erfc_out_functional final : public at::native::structured_erfc_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erfc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_erfc(const at::Tensor & self) {
  // No device check

structured_erfc_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_erfc_out_out final : public at::native::structured_erfc_out {
    structured_erfc_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erfc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_erfc_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_erfc_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_erfc_out_inplace final : public at::native::structured_erfc_out {
    structured_erfc_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erfc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_erfc_(at::Tensor & self) {
  // No device check

structured_erfc_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_exp_out_functional final : public at::native::structured_exp_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_exp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_exp(const at::Tensor & self) {
  // No device check

structured_exp_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_exp_out_out final : public at::native::structured_exp_out {
    structured_exp_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_exp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_exp_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_exp_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_exp_out_inplace final : public at::native::structured_exp_out {
    structured_exp_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_exp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_exp_(at::Tensor & self) {
  // No device check

structured_exp_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_exp2_out_functional final : public at::native::structured_exp2_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_exp2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_exp2(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_exp2", "self");
structured_exp2_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_exp2_out_out final : public at::native::structured_exp2_out {
    structured_exp2_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_exp2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_exp2_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_exp2_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_exp2_out_out", "self");
structured_exp2_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_exp2_out_inplace final : public at::native::structured_exp2_out {
    structured_exp2_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_exp2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_exp2_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_exp2_", "self");
structured_exp2_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_expm1_out_functional final : public at::native::structured_expm1_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_expm1_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_expm1(const at::Tensor & self) {
  // No device check

structured_expm1_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_expm1_out_out final : public at::native::structured_expm1_out {
    structured_expm1_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_expm1_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_expm1_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_expm1_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_expm1_out_inplace final : public at::native::structured_expm1_out {
    structured_expm1_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_expm1_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_expm1_(at::Tensor & self) {
  // No device check

structured_expm1_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_eye_out_out(int64_t n, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_eye_out_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::eye_out_cuda(n, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_m_out_eye_out_m_out(int64_t n, int64_t m, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_m_out_eye_out_m_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::eye_out_cuda(n, m, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Scalar_fill__Scalar(at::Tensor & self, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fill_(self, value);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_fill__Tensor(at::Tensor & self, const at::Tensor & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fill_(self, value);
}

} // anonymous namespace
struct structured_floor_out_functional final : public at::native::structured_floor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_floor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_floor(const at::Tensor & self) {
  // No device check

structured_floor_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_floor_out_out final : public at::native::structured_floor_out {
    structured_floor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_floor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_floor_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_floor_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_floor_out_inplace final : public at::native::structured_floor_out {
    structured_floor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_floor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_floor_(at::Tensor & self) {
  // No device check

structured_floor_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__floor_divide(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::floor_divide(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_floor_divide_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::floor_divide_out(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_floor_divide__Tensor(at::Tensor & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::floor_divide_(self, other);
}

} // anonymous namespace
struct structured_frac_out_functional final : public at::native::structured_frac_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_frac_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_frac(const at::Tensor & self) {
  // No device check

structured_frac_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_frac_out_out final : public at::native::structured_frac_out {
    structured_frac_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_frac_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_frac_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_frac_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_frac_out_inplace final : public at::native::structured_frac_out {
    structured_frac_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_frac_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_frac_(at::Tensor & self) {
  // No device check

structured_frac_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_gcd_out_functional final : public at::native::structured_gcd_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gcd_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_gcd(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gcd", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_gcd", "other");
structured_gcd_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_gcd_out_out final : public at::native::structured_gcd_out {
    structured_gcd_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gcd_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gcd_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_gcd_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gcd_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_gcd_out_out", "other");
structured_gcd_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_gcd_out_inplace final : public at::native::structured_gcd_out {
    structured_gcd_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gcd_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gcd_(at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gcd_", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_gcd_", "other");
structured_gcd_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_lcm_out_functional final : public at::native::structured_lcm_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lcm_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_lcm(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_lcm", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_lcm", "other");
structured_lcm_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_lcm_out_out final : public at::native::structured_lcm_out {
    structured_lcm_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lcm_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lcm_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_lcm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_lcm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_lcm_out_out", "other");
structured_lcm_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_lcm_out_inplace final : public at::native::structured_lcm_out {
    structured_lcm_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lcm_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lcm_(at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_lcm_", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_lcm_", "other");
structured_lcm_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__grid_sampler_2d(const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__grid_sampler_2d", "input");
  c10::impl::check_and_update_common_device(common_device, grid, "wrapper__grid_sampler_2d", "grid");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::grid_sampler_2d_cuda(input, grid, interpolation_mode, padding_mode, align_corners);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__grid_sampler_2d_backward(const at::Tensor & grad_output, const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners, ::std::array<bool,2> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__grid_sampler_2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__grid_sampler_2d_backward", "input");
  c10::impl::check_and_update_common_device(common_device, grid, "wrapper__grid_sampler_2d_backward", "grid");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::grid_sampler_2d_backward_cuda(grad_output, input, grid, interpolation_mode, padding_mode, align_corners, output_mask);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__grid_sampler_3d(const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__grid_sampler_3d", "input");
  c10::impl::check_and_update_common_device(common_device, grid, "wrapper__grid_sampler_3d", "grid");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::grid_sampler_3d_cuda(input, grid, interpolation_mode, padding_mode, align_corners);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__grid_sampler_3d_backward(const at::Tensor & grad_output, const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__grid_sampler_3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__grid_sampler_3d_backward", "input");
  c10::impl::check_and_update_common_device(common_device, grid, "wrapper__grid_sampler_3d_backward", "grid");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::grid_sampler_3d_backward_cuda(grad_output, input, grid, interpolation_mode, padding_mode, align_corners);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__native_group_norm(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, int64_t N, int64_t C, int64_t HxW, int64_t group, double eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_group_norm", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__native_group_norm", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__native_group_norm", "bias");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::native_group_norm(input, weight, bias, N, C, HxW, group, eps);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__native_group_norm_backward(const at::Tensor & grad_out, const at::Tensor & input, const at::Tensor & mean, const at::Tensor & rstd, const c10::optional<at::Tensor> & weight, int64_t N, int64_t C, int64_t HxW, int64_t group, ::std::array<bool,3> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper__native_group_norm_backward", "grad_out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_group_norm_backward", "input");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__native_group_norm_backward", "mean");
  c10::impl::check_and_update_common_device(common_device, rstd, "wrapper__native_group_norm_backward", "rstd");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__native_group_norm_backward", "weight");

  const OptionalDeviceGuard device_guard(device_of(grad_out));
  return at::native::native_group_norm_backward(grad_out, input, mean, rstd, weight, N, C, HxW, group, output_mask);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___fft_r2c(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool onesided) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fft_r2c", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fft_r2c_cufft(self, dim, normalization, onesided);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out__fft_r2c_out_out(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool onesided, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__fft_r2c_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out__fft_r2c_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fft_r2c_cufft_out(self, dim, normalization, onesided, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___fft_c2r(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, int64_t last_dim_size) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fft_c2r", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fft_c2r_cufft(self, dim, normalization, last_dim_size);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out__fft_c2r_out_out(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, int64_t last_dim_size, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__fft_c2r_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out__fft_c2r_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fft_c2r_cufft_out(self, dim, normalization, last_dim_size, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___fft_c2c(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool forward) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fft_c2c", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fft_c2c_cufft(self, dim, normalization, forward);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out__fft_c2c_out_out(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool forward, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__fft_c2c_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out__fft_c2c_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fft_c2c_cufft_out(self, dim, normalization, forward, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_index_Tensor(const at::Tensor & self, const c10::List<c10::optional<at::Tensor>> & indices) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::index(self, indices);
}

} // anonymous namespace
struct structured_index_copy_out_functional final : public at::native::structured_index_copy_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_index_copy(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_index_copy", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_index_copy", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper_index_copy", "source");
structured_index_copy_out_functional op;
auto precompute = op.meta(self, dim, index, source);
(void)precompute;
op.impl(self, precompute.dim, index, source, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_index_copy_out_out final : public at::native::structured_index_copy_out {
    structured_index_copy_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_index_copy_out_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_index_copy_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_index_copy_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_index_copy_out_out", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper_index_copy_out_out", "source");
structured_index_copy_out_out op(out);
auto precompute = op.meta(self, dim, index, source);
(void)precompute;
op.impl(self, precompute.dim, index, source, op.outputs_[0]);
return out;
}
struct structured_index_copy_out_inplace final : public at::native::structured_index_copy_out {
    structured_index_copy_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_index_copy_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_index_copy_", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_index_copy_", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper_index_copy_", "source");
structured_index_copy_out_inplace op(self);
auto precompute = op.meta(self, dim, index, source);
(void)precompute;
op.impl(self, precompute.dim, index, source, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper___index_put_impl_(at::Tensor & self, const c10::List<c10::optional<at::Tensor>> & indices, const at::Tensor & values, bool accumulate, bool unsafe) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_index_put_impl_(self, indices, values, accumulate, unsafe);
}

} // anonymous namespace
struct structured_isin_Tensor_Tensor_out_functional final : public at::native::structured_isin_Tensor_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_isin_Tensor_Tensor(const at::Tensor & elements, const at::Tensor & test_elements, bool assume_unique, bool invert) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, elements, "wrapper_isin_Tensor_Tensor", "elements");
  c10::impl::check_and_update_common_device(common_device, test_elements, "wrapper_isin_Tensor_Tensor", "test_elements");
structured_isin_Tensor_Tensor_out_functional op;
op.meta(elements, test_elements, assume_unique, invert);
op.impl(elements, test_elements, assume_unique, invert, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_isin_Tensor_Tensor_out_out final : public at::native::structured_isin_Tensor_Tensor_out {
    structured_isin_Tensor_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_isin_out_Tensor_Tensor_out(const at::Tensor & elements, const at::Tensor & test_elements, bool assume_unique, bool invert, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_isin_out_Tensor_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, elements, "wrapper_isin_out_Tensor_Tensor_out", "elements");
  c10::impl::check_and_update_common_device(common_device, test_elements, "wrapper_isin_out_Tensor_Tensor_out", "test_elements");
structured_isin_Tensor_Tensor_out_out op(out);
op.meta(elements, test_elements, assume_unique, invert);
op.impl(elements, test_elements, assume_unique, invert, op.outputs_[0]);
return out;
}
struct structured_isin_Tensor_Scalar_out_functional final : public at::native::structured_isin_Tensor_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_isin_Tensor_Scalar(const at::Tensor & elements, const at::Scalar & test_element, bool assume_unique, bool invert) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, elements, "wrapper_isin_Tensor_Scalar", "elements");
structured_isin_Tensor_Scalar_out_functional op;
op.meta(elements, test_element, assume_unique, invert);
op.impl(elements, test_element, assume_unique, invert, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_isin_Tensor_Scalar_out_out final : public at::native::structured_isin_Tensor_Scalar_out {
    structured_isin_Tensor_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_isin_out_Tensor_Scalar_out(const at::Tensor & elements, const at::Scalar & test_element, bool assume_unique, bool invert, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_isin_out_Tensor_Scalar_out", "out");
  c10::impl::check_and_update_common_device(common_device, elements, "wrapper_isin_out_Tensor_Scalar_out", "elements");
structured_isin_Tensor_Scalar_out_out op(out);
op.meta(elements, test_element, assume_unique, invert);
op.impl(elements, test_element, assume_unique, invert, op.outputs_[0]);
return out;
}
struct structured_isin_Scalar_Tensor_out_functional final : public at::native::structured_isin_Scalar_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_isin_Scalar_Tensor(const at::Scalar & element, const at::Tensor & test_elements, bool assume_unique, bool invert) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, test_elements, "wrapper_isin_Scalar_Tensor", "test_elements");
structured_isin_Scalar_Tensor_out_functional op;
op.meta(element, test_elements, assume_unique, invert);
op.impl(element, test_elements, assume_unique, invert, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_isin_Scalar_Tensor_out_out final : public at::native::structured_isin_Scalar_Tensor_out {
    structured_isin_Scalar_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_isin_out_Scalar_Tensor_out(const at::Scalar & element, const at::Tensor & test_elements, bool assume_unique, bool invert, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_isin_out_Scalar_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, test_elements, "wrapper_isin_out_Scalar_Tensor_out", "test_elements");
structured_isin_Scalar_Tensor_out_out op(out);
op.meta(element, test_elements, assume_unique, invert);
op.impl(element, test_elements, assume_unique, invert, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__isnan(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::isnan(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__kl_div_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, bool log_target) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__kl_div_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__kl_div_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__kl_div_backward", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::kl_div_backward_cuda(grad_output, self, target, reduction, log_target);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_values_kthvalue_out_values(const at::Tensor & self, int64_t k, int64_t dim, bool keepdim, at::Tensor & values, at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, values, "wrapper_values_kthvalue_out_values", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_values_kthvalue_out_values", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_values_kthvalue_out_values", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::kthvalue_out_cuda(self, k, dim, keepdim, values, indices);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__native_layer_norm(const at::Tensor & input, at::IntArrayRef normalized_shape, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, double eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_layer_norm", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__native_layer_norm", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__native_layer_norm", "bias");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::layer_norm_cuda(input, normalized_shape, weight, bias, eps);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___native_multi_head_self_attention(const at::Tensor & query, const at::Tensor & qkv_weight, const at::Tensor & qkv_bias, const at::Tensor & proj_weight, const at::Tensor & proj_bias, int64_t num_head, const c10::optional<at::Tensor> & mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, query, "wrapper___native_multi_head_self_attention", "query");
  c10::impl::check_and_update_common_device(common_device, qkv_weight, "wrapper___native_multi_head_self_attention", "qkv_weight");
  c10::impl::check_and_update_common_device(common_device, qkv_bias, "wrapper___native_multi_head_self_attention", "qkv_bias");
  c10::impl::check_and_update_common_device(common_device, proj_weight, "wrapper___native_multi_head_self_attention", "proj_weight");
  c10::impl::check_and_update_common_device(common_device, proj_bias, "wrapper___native_multi_head_self_attention", "proj_bias");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper___native_multi_head_self_attention", "mask");

  const OptionalDeviceGuard device_guard(device_of(query));
  return at::native::multi_head_self_attention_cuda(query, qkv_weight, qkv_bias, proj_weight, proj_bias, num_head, mask);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__native_layer_norm_backward(const at::Tensor & grad_out, const at::Tensor & input, at::IntArrayRef normalized_shape, const at::Tensor & mean, const at::Tensor & rstd, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, ::std::array<bool,3> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper__native_layer_norm_backward", "grad_out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_layer_norm_backward", "input");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__native_layer_norm_backward", "mean");
  c10::impl::check_and_update_common_device(common_device, rstd, "wrapper__native_layer_norm_backward", "rstd");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__native_layer_norm_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__native_layer_norm_backward", "bias");

  const OptionalDeviceGuard device_guard(device_of(grad_out));
  return at::native::layer_norm_backward_cuda(grad_out, input, normalized_shape, mean, rstd, weight, bias, output_mask);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_nan_to_num_out_out(const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_nan_to_num_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_nan_to_num_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nan_to_num_out(self, nan, posinf, neginf, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_linspace_out_out(const at::Scalar & start, const at::Scalar & end, int64_t steps, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_linspace_out_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::linspace_cuda_out(start, end, steps, out);
}

} // anonymous namespace
struct structured_log_out_functional final : public at::native::structured_log_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_log(const at::Tensor & self) {
  // No device check

structured_log_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_log_out_out final : public at::native::structured_log_out {
    structured_log_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_log_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_log_out_inplace final : public at::native::structured_log_out {
    structured_log_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log_(at::Tensor & self) {
  // No device check

structured_log_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_log10_out_functional final : public at::native::structured_log10_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log10_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_log10(const at::Tensor & self) {
  // No device check

structured_log10_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_log10_out_out final : public at::native::structured_log10_out {
    structured_log10_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log10_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log10_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_log10_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_log10_out_inplace final : public at::native::structured_log10_out {
    structured_log10_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log10_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log10_(at::Tensor & self) {
  // No device check

structured_log10_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_log1p_out_functional final : public at::native::structured_log1p_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log1p_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_log1p(const at::Tensor & self) {
  // No device check

structured_log1p_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_log1p_out_out final : public at::native::structured_log1p_out {
    structured_log1p_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log1p_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log1p_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_log1p_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_log1p_out_inplace final : public at::native::structured_log1p_out {
    structured_log1p_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log1p_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log1p_(at::Tensor & self) {
  // No device check

structured_log1p_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_log2_out_functional final : public at::native::structured_log2_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_log2(const at::Tensor & self) {
  // No device check

structured_log2_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_log2_out_out final : public at::native::structured_log2_out {
    structured_log2_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log2_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_log2_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_log2_out_inplace final : public at::native::structured_log2_out {
    structured_log2_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_log2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_log2_(at::Tensor & self) {
  // No device check

structured_log2_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_logaddexp_out_functional final : public at::native::structured_logaddexp_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_logaddexp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_logaddexp(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_logaddexp", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_logaddexp", "other");
structured_logaddexp_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_logaddexp_out_out final : public at::native::structured_logaddexp_out {
    structured_logaddexp_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_logaddexp_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_logaddexp_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_logaddexp_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_logaddexp_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_logaddexp_out_out", "other");
structured_logaddexp_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_logaddexp2_out_functional final : public at::native::structured_logaddexp2_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_logaddexp2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_logaddexp2(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_logaddexp2", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_logaddexp2", "other");
structured_logaddexp2_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_logaddexp2_out_out final : public at::native::structured_logaddexp2_out {
    structured_logaddexp2_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_logaddexp2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_logaddexp2_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_logaddexp2_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_logaddexp2_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_logaddexp2_out_out", "other");
structured_logaddexp2_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_xlogy_out_functional final : public at::native::structured_xlogy_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_xlogy_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_xlogy_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_xlogy_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_xlogy_out_out final : public at::native::structured_xlogy_out {
    structured_xlogy_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_xlogy_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_xlogy_out_OutTensor(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_xlogy_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_xlogy_out_inplace final : public at::native::structured_xlogy_out {
    structured_xlogy_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_xlogy_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_xlogy__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_xlogy_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_logspace_out_out(const at::Scalar & start, const at::Scalar & end, int64_t steps, double base, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_logspace_out_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::logspace_cuda_out(start, end, steps, base, out);
}

} // anonymous namespace
struct structured_log_softmax_cuda_out_functional final : public at::native::structured_log_softmax_cuda_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__log_softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__log_softmax", "self");
structured_log_softmax_cuda_out_functional op;
op.meta(self, dim, half_to_float);
op.impl(self, dim, half_to_float, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_log_softmax_cuda_out_out final : public at::native::structured_log_softmax_cuda_out {
    structured_log_softmax_cuda_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__log_softmax_out_out(const at::Tensor & self, int64_t dim, bool half_to_float, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__log_softmax_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__log_softmax_out_out", "self");
structured_log_softmax_cuda_out_out op(out);
op.meta(self, dim, half_to_float);
op.impl(self, dim, half_to_float, op.outputs_[0]);
return out;
}
struct structured_log_softmax_backward_cuda_out_functional final : public at::native::structured_log_softmax_backward_cuda_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__log_softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__log_softmax_backward_data", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper__log_softmax_backward_data", "output");
structured_log_softmax_backward_cuda_out_functional op;
op.meta(grad_output, output, dim, input_dtype);
op.impl(grad_output, output, dim, input_dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_log_softmax_backward_cuda_out_out final : public at::native::structured_log_softmax_backward_cuda_out {
    structured_log_softmax_backward_cuda_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__log_softmax_backward_data_out_out(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__log_softmax_backward_data_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__log_softmax_backward_data_out_out", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper__log_softmax_backward_data_out_out", "output");
structured_log_softmax_backward_cuda_out_out op(out);
op.meta(grad_output, output, dim, input_dtype);
op.impl(grad_output, output, dim, input_dtype, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper___logcumsumexp(const at::Tensor & self, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___logcumsumexp", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_logcumsumexp_cuda(self, dim);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out__logcumsumexp_out_out(const at::Tensor & self, int64_t dim, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__logcumsumexp_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out__logcumsumexp_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_logcumsumexp_out_cuda(self, dim, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___aminmax(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___aminmax", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_aminmax_all(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper_dim__aminmax_dim(const at::Tensor & self, int64_t dim, bool keepdim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_dim__aminmax_dim", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_aminmax(self, dim, keepdim);
}

} // anonymous namespace
struct structured_aminmax_out_functional final : public at::native::structured_aminmax_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_aminmax(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
  // No device check

structured_aminmax_out_functional op;
op.meta(self, dim, keepdim);
op.impl(self, dim, keepdim, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_aminmax_out_out final : public at::native::structured_aminmax_out {
    structured_aminmax_out_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_aminmax_out_out(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim, at::Tensor & min, at::Tensor & max) {
  // No device check

structured_aminmax_out_out op(min, max);
op.meta(self, dim, keepdim);
op.impl(self, dim, keepdim, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(min, max);
}
namespace {

at::Tensor wrapper___compute_linear_combination(const at::Tensor & input, const at::Tensor & coefficients) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper___compute_linear_combination", "input");
  c10::impl::check_and_update_common_device(common_device, coefficients, "wrapper___compute_linear_combination", "coefficients");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::_compute_linear_combination(input, coefficients);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out__compute_linear_combination_out_out(const at::Tensor & input, const at::Tensor & coefficients, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__compute_linear_combination_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper_out__compute_linear_combination_out_out", "input");
  c10::impl::check_and_update_common_device(common_device, coefficients, "wrapper_out__compute_linear_combination_out_out", "coefficients");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::_compute_linear_combination_out(input, coefficients, out);
}

} // anonymous namespace
struct structured_max_out_functional final : public at::native::structured_max_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_max_dim(const at::Tensor & self, int64_t dim, bool keepdim) {
  // No device check

structured_max_out_functional op;
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_max_out_out final : public at::native::structured_max_out {
    structured_max_out_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_max_out_dim_max(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & max, at::Tensor & max_values) {
  // No device check

structured_max_out_out op(max, max_values);
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(max, max_values);
}
namespace {

at::Tensor & wrapper_out_amax_out_out(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_amax_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_amax_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::amax_out(self, dim, keepdim, out);
}

} // anonymous namespace
struct structured_mean_out_functional final : public at::native::structured_mean_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_mean_dim(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
  // No device check

structured_mean_out_functional op;
op.meta(self, dim, keepdim, dtype);
op.impl(self, dim, keepdim, dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_mean_out_out final : public at::native::structured_mean_out {
    structured_mean_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_mean_out_out(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  // No device check

structured_mean_out_out op(out);
op.meta(self, dim, keepdim, dtype);
op.impl(self, dim, keepdim, dtype, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__median(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__median", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::median_cuda(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_dim_values_median_out_dim_values(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & values, at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, values, "wrapper_dim_values_median_out_dim_values", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_dim_values_median_out_dim_values", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_dim_values_median_out_dim_values", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::median_out_cuda(self, dim, keepdim, values, indices);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__nanmedian(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__nanmedian", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nanmedian_cuda(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_dim_values_nanmedian_out_dim_values(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & values, at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, values, "wrapper_dim_values_nanmedian_out_dim_values", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_dim_values_nanmedian_out_dim_values", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_dim_values_nanmedian_out_dim_values", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nanmedian_out_cuda(self, dim, keepdim, values, indices);
}

} // anonymous namespace
struct structured_min_out_functional final : public at::native::structured_min_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_min_dim(const at::Tensor & self, int64_t dim, bool keepdim) {
  // No device check

structured_min_out_functional op;
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_min_out_out final : public at::native::structured_min_out {
    structured_min_out_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_min_out_dim_min(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & min, at::Tensor & min_indices) {
  // No device check

structured_min_out_out op(min, min_indices);
auto precompute = op.meta(self, dim, keepdim);
(void)precompute;
op.impl(self, precompute.dim, keepdim, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(min, min_indices);
}
namespace {

at::Tensor & wrapper_out_amin_out_out(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_amin_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_amin_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::amin_out(self, dim, keepdim, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__miopen_batch_norm(const at::Tensor & input, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double exponential_average_factor, double epsilon) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__miopen_batch_norm", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_batch_norm", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__miopen_batch_norm", "bias");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__miopen_batch_norm", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__miopen_batch_norm", "running_var");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::miopen_batch_norm(input, weight, bias, running_mean, running_var, training, exponential_average_factor, epsilon);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__miopen_batch_norm_backward(const at::Tensor & input, const at::Tensor & grad_output, const at::Tensor & weight, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, const c10::optional<at::Tensor> & save_mean, const c10::optional<at::Tensor> & save_var, double epsilon) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__miopen_batch_norm_backward", "input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__miopen_batch_norm_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_batch_norm_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__miopen_batch_norm_backward", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__miopen_batch_norm_backward", "running_var");
  c10::impl::check_and_update_common_device(common_device, save_mean, "wrapper__miopen_batch_norm_backward", "save_mean");
  c10::impl::check_and_update_common_device(common_device, save_var, "wrapper__miopen_batch_norm_backward", "save_var");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::miopen_batch_norm_backward(input, grad_output, weight, running_mean, running_var, save_mean, save_var, epsilon);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__miopen_convolution(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__miopen_convolution", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_convolution", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__miopen_convolution", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::miopen_convolution(self, weight, bias, padding, stride, dilation, groups, benchmark, deterministic);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__miopen_convolution_transpose(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__miopen_convolution_transpose", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_convolution_transpose", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__miopen_convolution_transpose", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::miopen_convolution_transpose(self, weight, bias, padding, output_padding, stride, dilation, groups, benchmark, deterministic);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__miopen_depthwise_convolution(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__miopen_depthwise_convolution", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_depthwise_convolution", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__miopen_depthwise_convolution", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::miopen_depthwise_convolution(self, weight, bias, padding, stride, dilation, groups, benchmark, deterministic);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper__miopen_rnn(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__miopen_rnn", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_rnn", "weight");
  c10::impl::check_and_update_common_device(common_device, hx, "wrapper__miopen_rnn", "hx");
  c10::impl::check_and_update_common_device(common_device, cx, "wrapper__miopen_rnn", "cx");
  c10::impl::check_and_update_common_device(common_device, dropout_state, "wrapper__miopen_rnn", "dropout_state");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::miopen_rnn(input, weight, weight_stride0, hx, cx, mode, hidden_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,::std::vector<at::Tensor>> wrapper__miopen_rnn_backward(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const at::Tensor & weight_buf, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, const at::Tensor & output, const c10::optional<at::Tensor> & grad_output, const c10::optional<at::Tensor> & grad_hy, const c10::optional<at::Tensor> & grad_cy, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state, const at::Tensor & reserve, ::std::array<bool,4> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__miopen_rnn_backward", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__miopen_rnn_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, weight_buf, "wrapper__miopen_rnn_backward", "weight_buf");
  c10::impl::check_and_update_common_device(common_device, hx, "wrapper__miopen_rnn_backward", "hx");
  c10::impl::check_and_update_common_device(common_device, cx, "wrapper__miopen_rnn_backward", "cx");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper__miopen_rnn_backward", "output");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__miopen_rnn_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, grad_hy, "wrapper__miopen_rnn_backward", "grad_hy");
  c10::impl::check_and_update_common_device(common_device, grad_cy, "wrapper__miopen_rnn_backward", "grad_cy");
  c10::impl::check_and_update_common_device(common_device, dropout_state, "wrapper__miopen_rnn_backward", "dropout_state");
  c10::impl::check_and_update_common_device(common_device, reserve, "wrapper__miopen_rnn_backward", "reserve");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::miopen_rnn_backward(input, weight, weight_stride0, weight_buf, hx, cx, output, grad_output, grad_hy, grad_cy, mode, hidden_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state, reserve, output_mask);
}

} // anonymous namespace
struct structured_mm_out_cuda_functional final : public at::native::structured_mm_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_mm(const at::Tensor & self, const at::Tensor & mat2) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_mm", "self");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_mm", "mat2");
structured_mm_out_cuda_functional op;
op.meta(self, mat2);
op.impl(self, mat2, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_mm_out_cuda_out final : public at::native::structured_mm_out_cuda {
    structured_mm_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_mm_out_out(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_mm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_mm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_mm_out_out", "mat2");
structured_mm_out_cuda_out op(out);
op.meta(self, mat2);
op.impl(self, mat2, op.outputs_[0]);
return out;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__mode(const at::Tensor & self, int64_t dim, bool keepdim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__mode", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mode(self, dim, keepdim);
}

} // anonymous namespace
struct structured_mul_out_functional final : public at::native::structured_mul_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_mul_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_mul_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_mul_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_mul_out_out final : public at::native::structured_mul_out {
    structured_mul_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_mul_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_mul_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_mul_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_mul_out_inplace final : public at::native::structured_mul_out {
    structured_mul_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_mul_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_mul__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_mul_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_mvlgamma_out_out(const at::Tensor & self, int64_t p, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_mvlgamma_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_mvlgamma_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mvlgamma_out(self, p, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__native_batch_norm(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double momentum, double eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_batch_norm", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__native_batch_norm", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__native_batch_norm", "bias");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__native_batch_norm", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__native_batch_norm", "running_var");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::batch_norm_cuda(input, weight, bias, running_mean, running_var, training, momentum, eps);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> wrapper_out_native_batch_norm_out_out(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double momentum, double eps, at::Tensor & out, at::Tensor & save_mean, at::Tensor & save_invstd) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_native_batch_norm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, save_mean, "wrapper_out_native_batch_norm_out_out", "save_mean");
  c10::impl::check_and_update_common_device(common_device, save_invstd, "wrapper_out_native_batch_norm_out_out", "save_invstd");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper_out_native_batch_norm_out_out", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_out_native_batch_norm_out_out", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_out_native_batch_norm_out_out", "bias");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper_out_native_batch_norm_out_out", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper_out_native_batch_norm_out_out", "running_var");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::batch_norm_cuda_out(input, weight, bias, running_mean, running_var, training, momentum, eps, out, save_mean, save_invstd);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__batch_norm_stats(const at::Tensor & input, double eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_stats", "input");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::batch_norm_stats_cuda(input, eps);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__batch_norm_elemt(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const at::Tensor & mean, const at::Tensor & invstd, double eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_elemt", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__batch_norm_elemt", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__batch_norm_elemt", "bias");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__batch_norm_elemt", "mean");
  c10::impl::check_and_update_common_device(common_device, invstd, "wrapper__batch_norm_elemt", "invstd");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::batch_norm_elemt_cuda(input, weight, bias, mean, invstd, eps);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_batch_norm_elemt_out_out(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const at::Tensor & mean, const at::Tensor & invstd, double eps, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_batch_norm_elemt_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper_out_batch_norm_elemt_out_out", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_out_batch_norm_elemt_out_out", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_out_batch_norm_elemt_out_out", "bias");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper_out_batch_norm_elemt_out_out", "mean");
  c10::impl::check_and_update_common_device(common_device, invstd, "wrapper_out_batch_norm_elemt_out_out", "invstd");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::batch_norm_elemt_cuda_out(input, weight, bias, mean, invstd, eps, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__batch_norm_gather_stats(const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, double momentum, double eps, int64_t count) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_gather_stats", "input");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__batch_norm_gather_stats", "mean");
  c10::impl::check_and_update_common_device(common_device, invstd, "wrapper__batch_norm_gather_stats", "invstd");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__batch_norm_gather_stats", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__batch_norm_gather_stats", "running_var");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::batch_norm_gather_stats_cuda(input, mean, invstd, running_mean, running_var, momentum, eps, count);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__batch_norm_gather_stats_with_counts(const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, double momentum, double eps, const at::Tensor & counts) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_gather_stats_with_counts", "input");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__batch_norm_gather_stats_with_counts", "mean");
  c10::impl::check_and_update_common_device(common_device, invstd, "wrapper__batch_norm_gather_stats_with_counts", "invstd");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__batch_norm_gather_stats_with_counts", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__batch_norm_gather_stats_with_counts", "running_var");
  c10::impl::check_and_update_common_device(common_device, counts, "wrapper__batch_norm_gather_stats_with_counts", "counts");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::batch_norm_gather_stats_with_counts_cuda(input, mean, invstd, running_mean, running_var, momentum, eps, counts);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__native_batch_norm_backward(const at::Tensor & grad_out, const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, const c10::optional<at::Tensor> & save_mean, const c10::optional<at::Tensor> & save_invstd, bool train, double eps, ::std::array<bool,3> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper__native_batch_norm_backward", "grad_out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__native_batch_norm_backward", "input");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__native_batch_norm_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__native_batch_norm_backward", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__native_batch_norm_backward", "running_var");
  c10::impl::check_and_update_common_device(common_device, save_mean, "wrapper__native_batch_norm_backward", "save_mean");
  c10::impl::check_and_update_common_device(common_device, save_invstd, "wrapper__native_batch_norm_backward", "save_invstd");

  const OptionalDeviceGuard device_guard(device_of(grad_out));
  return at::native::batch_norm_backward_cuda(grad_out, input, weight, running_mean, running_var, save_mean, save_invstd, train, eps, output_mask);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper__batch_norm_backward_reduce(const at::Tensor & grad_out, const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & weight, bool input_g, bool weight_g, bool bias_g) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper__batch_norm_backward_reduce", "grad_out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_backward_reduce", "input");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__batch_norm_backward_reduce", "mean");
  c10::impl::check_and_update_common_device(common_device, invstd, "wrapper__batch_norm_backward_reduce", "invstd");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__batch_norm_backward_reduce", "weight");

  const OptionalDeviceGuard device_guard(device_of(grad_out));
  return at::native::batch_norm_backward_reduce_cuda(grad_out, input, mean, invstd, weight, input_g, weight_g, bias_g);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__batch_norm_backward_elemt(const at::Tensor & grad_out, const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & weight, const at::Tensor & mean_dy, const at::Tensor & mean_dy_xmu, const at::Tensor & count) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper__batch_norm_backward_elemt", "grad_out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_backward_elemt", "input");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper__batch_norm_backward_elemt", "mean");
  c10::impl::check_and_update_common_device(common_device, invstd, "wrapper__batch_norm_backward_elemt", "invstd");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__batch_norm_backward_elemt", "weight");
  c10::impl::check_and_update_common_device(common_device, mean_dy, "wrapper__batch_norm_backward_elemt", "mean_dy");
  c10::impl::check_and_update_common_device(common_device, mean_dy_xmu, "wrapper__batch_norm_backward_elemt", "mean_dy_xmu");
  c10::impl::check_and_update_common_device(common_device, count, "wrapper__batch_norm_backward_elemt", "count");

  const OptionalDeviceGuard device_guard(device_of(grad_out));
  return at::native::batch_norm_backward_elemt_cuda(grad_out, input, mean, invstd, weight, mean_dy, mean_dy_xmu, count);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__batch_norm_update_stats(const at::Tensor & input, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, double momentum) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__batch_norm_update_stats", "input");
  c10::impl::check_and_update_common_device(common_device, running_mean, "wrapper__batch_norm_update_stats", "running_mean");
  c10::impl::check_and_update_common_device(common_device, running_var, "wrapper__batch_norm_update_stats", "running_var");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::batch_norm_update_stats_cuda(input, running_mean, running_var, momentum);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___cdist_forward(const at::Tensor & x1, const at::Tensor & x2, double p, c10::optional<int64_t> compute_mode) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, x1, "wrapper___cdist_forward", "x1");
  c10::impl::check_and_update_common_device(common_device, x2, "wrapper___cdist_forward", "x2");

  const OptionalDeviceGuard device_guard(device_of(x1));
  return at::native::_cdist_forward(x1, x2, p, compute_mode);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___cdist_backward(const at::Tensor & grad, const at::Tensor & x1, const at::Tensor & x2, double p, const at::Tensor & cdist) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper___cdist_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, x1, "wrapper___cdist_backward", "x1");
  c10::impl::check_and_update_common_device(common_device, x2, "wrapper___cdist_backward", "x2");
  c10::impl::check_and_update_common_device(common_device, cdist, "wrapper___cdist_backward", "cdist");

  const OptionalDeviceGuard device_guard(device_of(grad));
  return at::native::_cdist_backward(grad, x1, x2, p, cdist);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___pdist_forward(const at::Tensor & self, double p) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___pdist_forward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_pdist_forward(self, p);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___pdist_backward(const at::Tensor & grad, const at::Tensor & self, double p, const at::Tensor & pdist) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper___pdist_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper___pdist_backward", "self");
  c10::impl::check_and_update_common_device(common_device, pdist, "wrapper___pdist_backward", "pdist");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_pdist_backward(grad, self, p, pdist);
}

} // anonymous namespace
namespace {

bool wrapper__is_pinned(const at::Tensor & self, c10::optional<at::Device> device) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__is_pinned", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::is_pinned_cuda(self, device);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___pin_memory(const at::Tensor & self, c10::optional<at::Device> device) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___pin_memory", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_pin_memory_cuda(self, device);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_generator_out_randperm_out_generator_out(int64_t n, c10::optional<at::Generator> generator, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_generator_out_randperm_out_generator_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::randperm_out_cuda(n, generator, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_range_out_out(const at::Scalar & start, const at::Scalar & end, const at::Scalar & step, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_range_out_out", "out");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::range_cuda_out(start, end, step, out);
}

} // anonymous namespace
struct structured_reciprocal_out_functional final : public at::native::structured_reciprocal_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_reciprocal_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_reciprocal(const at::Tensor & self) {
  // No device check

structured_reciprocal_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_reciprocal_out_out final : public at::native::structured_reciprocal_out {
    structured_reciprocal_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_reciprocal_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_reciprocal_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_reciprocal_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_reciprocal_out_inplace final : public at::native::structured_reciprocal_out {
    structured_reciprocal_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_reciprocal_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_reciprocal_(at::Tensor & self) {
  // No device check

structured_reciprocal_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_neg_out_functional final : public at::native::structured_neg_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_neg_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_neg(const at::Tensor & self) {
  // No device check

structured_neg_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_neg_out_out final : public at::native::structured_neg_out {
    structured_neg_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_neg_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_neg_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_neg_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_neg_out_inplace final : public at::native::structured_neg_out {
    structured_neg_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_neg_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_neg_(at::Tensor & self) {
  // No device check

structured_neg_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Tensor_repeat_interleave_Tensor(const at::Tensor & repeats, c10::optional<int64_t> output_size) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, repeats, "wrapper_Tensor_repeat_interleave_Tensor", "repeats");

  const OptionalDeviceGuard device_guard(device_of(repeats));
  return at::native::repeat_interleave_cuda(repeats, output_size);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___reshape_alias(const at::Tensor & self, at::IntArrayRef size, at::IntArrayRef stride) {
    // No device check


  // DeviceGuard omitted
  return at::native::_reshape_alias(self, size, stride);
}

} // anonymous namespace
struct structured_round_out_functional final : public at::native::structured_round_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_round_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_round(const at::Tensor & self) {
  // No device check

structured_round_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_round_out_out final : public at::native::structured_round_out {
    structured_round_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_round_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_round_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_round_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_round_out_inplace final : public at::native::structured_round_out {
    structured_round_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_round_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_round_(at::Tensor & self) {
  // No device check

structured_round_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_round_decimals_out_functional final : public at::native::structured_round_decimals_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_round_decimals_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_round_decimals(const at::Tensor & self, int64_t decimals) {
  // No device check

structured_round_decimals_out_functional op;
op.meta(self, decimals);
op.impl(self, decimals, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_round_decimals_out_out final : public at::native::structured_round_decimals_out {
    structured_round_decimals_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_round_decimals_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_round_out_decimals_out(const at::Tensor & self, int64_t decimals, at::Tensor & out) {
  // No device check

structured_round_decimals_out_out op(out);
op.meta(self, decimals);
op.impl(self, decimals, op.outputs_[0]);
return out;
}
struct structured_round_decimals_out_inplace final : public at::native::structured_round_decimals_out {
    structured_round_decimals_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_round_decimals_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_round__decimals(at::Tensor & self, int64_t decimals) {
  // No device check

structured_round_decimals_out_inplace op(self);
op.meta(self, decimals);
op.impl(self, decimals, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__relu(const at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::relu(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__relu_(at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::relu_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__prelu(const at::Tensor & self, const at::Tensor & weight) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__prelu", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__prelu", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::prelu_cuda(self, weight);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__prelu_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__prelu_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__prelu_backward", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__prelu_backward", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::prelu_backward_cuda(grad_output, self, weight);
}

} // anonymous namespace
struct structured_gelu_out_cuda_functional final : public at::native::structured_gelu_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gelu_out_cuda::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_gelu(const at::Tensor & self) {
  // No device check

structured_gelu_out_cuda_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_gelu_out_cuda_out final : public at::native::structured_gelu_out_cuda {
    structured_gelu_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gelu_out_cuda::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gelu_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_gelu_out_cuda_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_gelu_backward_out_cuda_functional final : public at::native::structured_gelu_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gelu_backward_out_cuda::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_gelu_backward(const at::Tensor & grad, const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper_gelu_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gelu_backward", "self");
structured_gelu_backward_out_cuda_functional op;
op.meta(grad, self);
op.impl(grad, self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_gelu_backward_out_cuda_out final : public at::native::structured_gelu_backward_out_cuda {
    structured_gelu_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gelu_backward_out_cuda::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gelu_backward_out_grad_input(const at::Tensor & grad, const at::Tensor & self, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_gelu_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad, "wrapper_gelu_backward_out_grad_input", "grad");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gelu_backward_out_grad_input", "self");
structured_gelu_backward_out_cuda_out op(grad_input);
op.meta(grad, self);
op.impl(grad, self, op.outputs_[0]);
return grad_input;
}
struct structured_hardshrink_out_functional final : public at::native::structured_hardshrink_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardshrink_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_hardshrink(const at::Tensor & self, const at::Scalar & lambd) {
  // No device check

structured_hardshrink_out_functional op;
op.meta(self, lambd);
op.impl(self, lambd, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_hardshrink_out_out final : public at::native::structured_hardshrink_out {
    structured_hardshrink_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardshrink_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hardshrink_out_out(const at::Tensor & self, const at::Scalar & lambd, at::Tensor & out) {
  // No device check

structured_hardshrink_out_out op(out);
op.meta(self, lambd);
op.impl(self, lambd, op.outputs_[0]);
return out;
}
struct structured_hardshrink_backward_out_functional final : public at::native::structured_hardshrink_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardshrink_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_hardshrink_backward(const at::Tensor & grad_out, const at::Tensor & self, const at::Scalar & lambd) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper_hardshrink_backward", "grad_out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hardshrink_backward", "self");
structured_hardshrink_backward_out_functional op;
op.meta(grad_out, self, lambd);
op.impl(grad_out, self, lambd, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_hardshrink_backward_out_out final : public at::native::structured_hardshrink_backward_out {
    structured_hardshrink_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardshrink_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hardshrink_backward_out_grad_input(const at::Tensor & grad_out, const at::Tensor & self, const at::Scalar & lambd, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_hardshrink_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_out, "wrapper_hardshrink_backward_out_grad_input", "grad_out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hardshrink_backward_out_grad_input", "self");
structured_hardshrink_backward_out_out op(grad_input);
op.meta(grad_out, self, lambd);
op.impl(grad_out, self, lambd, op.outputs_[0]);
return grad_input;
}
struct structured_rsqrt_out_functional final : public at::native::structured_rsqrt_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_rsqrt_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_rsqrt(const at::Tensor & self) {
  // No device check

structured_rsqrt_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_rsqrt_out_out final : public at::native::structured_rsqrt_out {
    structured_rsqrt_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_rsqrt_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_rsqrt_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_rsqrt_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_rsqrt_out_inplace final : public at::native::structured_rsqrt_out {
    structured_rsqrt_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_rsqrt_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_rsqrt_(at::Tensor & self) {
  // No device check

structured_rsqrt_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_silu_out_functional final : public at::native::structured_silu_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_silu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_silu(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_silu", "self");
structured_silu_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_silu_out_out final : public at::native::structured_silu_out {
    structured_silu_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_silu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_silu_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_silu_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_silu_out_out", "self");
structured_silu_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_silu_out_inplace final : public at::native::structured_silu_out {
    structured_silu_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_silu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_silu_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_silu_", "self");
structured_silu_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_silu_backward_out_functional final : public at::native::structured_silu_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_silu_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_silu_backward(const at::Tensor & grad_output, const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_silu_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_silu_backward", "self");
structured_silu_backward_out_functional op;
op.meta(grad_output, self);
op.impl(grad_output, self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_silu_backward_out_out final : public at::native::structured_silu_backward_out {
    structured_silu_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_silu_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_silu_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_silu_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_silu_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_silu_backward_out_grad_input", "self");
structured_silu_backward_out_out op(grad_input);
op.meta(grad_output, self);
op.impl(grad_output, self, op.outputs_[0]);
return grad_input;
}
struct structured_mish_out_functional final : public at::native::structured_mish_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_mish_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_mish(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_mish", "self");
structured_mish_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_mish_out_out final : public at::native::structured_mish_out {
    structured_mish_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_mish_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_mish_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_mish_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_mish_out_out", "self");
structured_mish_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_mish_out_inplace final : public at::native::structured_mish_out {
    structured_mish_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_mish_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_mish_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_mish_", "self");
structured_mish_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__mish_backward(const at::Tensor & grad_output, const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__mish_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__mish_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mish_backward(grad_output, self);
}

} // anonymous namespace
struct structured_sigmoid_out_functional final : public at::native::structured_sigmoid_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sigmoid_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sigmoid(const at::Tensor & self) {
  // No device check

structured_sigmoid_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sigmoid_out_out final : public at::native::structured_sigmoid_out {
    structured_sigmoid_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sigmoid_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sigmoid_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_sigmoid_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sigmoid_out_inplace final : public at::native::structured_sigmoid_out {
    structured_sigmoid_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sigmoid_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sigmoid_(at::Tensor & self) {
  // No device check

structured_sigmoid_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__logit(const at::Tensor & self, c10::optional<double> eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__logit", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logit(self, eps);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_logit_out_out(const at::Tensor & self, c10::optional<double> eps, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_logit_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_logit_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logit_out(self, eps, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__logit_(at::Tensor & self, c10::optional<double> eps) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__logit_", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::logit_(self, eps);
}

} // anonymous namespace
struct structured_sin_out_functional final : public at::native::structured_sin_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sin(const at::Tensor & self) {
  // No device check

structured_sin_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sin_out_out final : public at::native::structured_sin_out {
    structured_sin_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sin_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_sin_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sin_out_inplace final : public at::native::structured_sin_out {
    structured_sin_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sin_(at::Tensor & self) {
  // No device check

structured_sin_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_sinc_out_functional final : public at::native::structured_sinc_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sinc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sinc(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sinc", "self");
structured_sinc_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sinc_out_out final : public at::native::structured_sinc_out {
    structured_sinc_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sinc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sinc_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_sinc_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sinc_out_out", "self");
structured_sinc_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sinc_out_inplace final : public at::native::structured_sinc_out {
    structured_sinc_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sinc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sinc_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sinc_", "self");
structured_sinc_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_sinh_out_functional final : public at::native::structured_sinh_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sinh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sinh(const at::Tensor & self) {
  // No device check

structured_sinh_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sinh_out_out final : public at::native::structured_sinh_out {
    structured_sinh_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sinh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sinh_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_sinh_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sinh_out_inplace final : public at::native::structured_sinh_out {
    structured_sinh_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sinh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sinh_(at::Tensor & self) {
  // No device check

structured_sinh_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_softmax_cuda_out_functional final : public at::native::structured_softmax_cuda_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__softmax", "self");
structured_softmax_cuda_out_functional op;
op.meta(self, dim, half_to_float);
op.impl(self, dim, half_to_float, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_softmax_cuda_out_out final : public at::native::structured_softmax_cuda_out {
    structured_softmax_cuda_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__softmax_out_out(const at::Tensor & self, int64_t dim, bool half_to_float, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__softmax_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__softmax_out_out", "self");
structured_softmax_cuda_out_out op(out);
op.meta(self, dim, half_to_float);
op.impl(self, dim, half_to_float, op.outputs_[0]);
return out;
}
struct structured_softmax_backward_cuda_out_functional final : public at::native::structured_softmax_backward_cuda_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__softmax_backward_data", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper__softmax_backward_data", "output");
structured_softmax_backward_cuda_out_functional op;
op.meta(grad_output, output, dim, input_dtype);
op.impl(grad_output, output, dim, input_dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_softmax_backward_cuda_out_out final : public at::native::structured_softmax_backward_cuda_out {
    structured_softmax_backward_cuda_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__softmax_backward_data_out_out(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper__softmax_backward_data_out_out", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__softmax_backward_data_out_out", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper__softmax_backward_data_out_out", "output");
structured_softmax_backward_cuda_out_out op(grad_input);
op.meta(grad_output, output, dim, input_dtype);
op.impl(grad_output, output, dim, input_dtype, op.outputs_[0]);
return grad_input;
}
namespace {

at::Tensor wrapper__squeeze(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::squeeze(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_dim_squeeze_dim(const at::Tensor & self, int64_t dim) {
    // No device check


  // DeviceGuard omitted
  return at::native::squeeze(self, dim);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sspaddmm_out_out(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_sspaddmm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_sspaddmm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, mat1, "wrapper_out_sspaddmm_out_out", "mat1");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_out_sspaddmm_out_out", "mat2");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_sspaddmm_out_only_sparse_cuda(self, mat1, mat2, beta, alpha, out);
}

} // anonymous namespace
struct structured_sum_out_functional final : public at::native::structured_sum_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sum_dim_IntList(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
  // No device check

structured_sum_out_functional op;
op.meta(self, dim, keepdim, dtype);
op.impl(self, dim, keepdim, dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sum_out_out final : public at::native::structured_sum_out {
    structured_sum_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sum_out_IntList_out(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  // No device check

structured_sum_out_out op(out);
op.meta(self, dim, keepdim, dtype);
op.impl(self, dim, keepdim, dtype, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__nansum(const at::Tensor & self, c10::optional<at::ScalarType> dtype) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__nansum", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nansum(self, dtype);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_dim_IntList_nansum_dim_IntList(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_dim_IntList_nansum_dim_IntList", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nansum(self, dim, keepdim, dtype);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_IntList_out_nansum_out_IntList_out(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_IntList_out_nansum_out_IntList_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_IntList_out_nansum_out_IntList_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nansum_out(self, dim, keepdim, dtype, out);
}

} // anonymous namespace
struct structured_sqrt_out_functional final : public at::native::structured_sqrt_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sqrt_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sqrt(const at::Tensor & self) {
  // No device check

structured_sqrt_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sqrt_out_out final : public at::native::structured_sqrt_out {
    structured_sqrt_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sqrt_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sqrt_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_sqrt_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sqrt_out_inplace final : public at::native::structured_sqrt_out {
    structured_sqrt_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sqrt_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sqrt_(at::Tensor & self) {
  // No device check

structured_sqrt_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_square_out_out(const at::Tensor & self, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_square_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_square_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::square_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_correction_std_correction(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::std(self, dim, correction, keepdim);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_correction_out_std_out_correction_out(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::std_out(self, dim, correction, keepdim, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper_correction_std_mean_correction(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::std_mean(self, dim, correction, keepdim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__prod(const at::Tensor & self, c10::optional<at::ScalarType> dtype) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::prod(self, dtype);
}

} // anonymous namespace
struct structured_prod_out_functional final : public at::native::structured_prod_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_prod_dim_int(const at::Tensor & self, int64_t dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
  // No device check

structured_prod_out_functional op;
op.meta(self, dim, keepdim, dtype);
op.impl(self, dim, keepdim, dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_prod_out_out final : public at::native::structured_prod_out {
    structured_prod_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_prod_out_int_out(const at::Tensor & self, int64_t dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  // No device check

structured_prod_out_out op(out);
op.meta(self, dim, keepdim, dtype);
op.impl(self, dim, keepdim, dtype, op.outputs_[0]);
return out;
}
struct structured_tan_out_functional final : public at::native::structured_tan_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tan_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_tan(const at::Tensor & self) {
  // No device check

structured_tan_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_tan_out_out final : public at::native::structured_tan_out {
    structured_tan_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tan_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tan_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_tan_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_tan_out_inplace final : public at::native::structured_tan_out {
    structured_tan_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tan_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tan_(at::Tensor & self) {
  // No device check

structured_tan_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_tanh_out_functional final : public at::native::structured_tanh_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tanh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_tanh(const at::Tensor & self) {
  // No device check

structured_tanh_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_tanh_out_out final : public at::native::structured_tanh_out {
    structured_tanh_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tanh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tanh_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_tanh_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_tanh_out_inplace final : public at::native::structured_tanh_out {
    structured_tanh_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tanh_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tanh_(at::Tensor & self) {
  // No device check

structured_tanh_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_out_tensordot_out_out(const at::Tensor & self, const at::Tensor & other, at::IntArrayRef dims_self, at::IntArrayRef dims_other, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_tensordot_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_tensordot_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_out_tensordot_out_out", "other");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::tensordot_out(self, other, dims_self, dims_other, out);
}

} // anonymous namespace
struct structured_threshold_out_functional final : public at::native::structured_threshold_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_threshold_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_threshold(const at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value) {
  // No device check

structured_threshold_out_functional op;
op.meta(self, threshold, value);
op.impl(self, threshold, value, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_threshold_out_out final : public at::native::structured_threshold_out {
    structured_threshold_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_threshold_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_threshold_out_out(const at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value, at::Tensor & out) {
  // No device check

structured_threshold_out_out op(out);
op.meta(self, threshold, value);
op.impl(self, threshold, value, op.outputs_[0]);
return out;
}
struct structured_threshold_out_inplace final : public at::native::structured_threshold_out {
    structured_threshold_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_threshold_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_threshold_(at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value) {
  // No device check

structured_threshold_out_inplace op(self);
op.meta(self, threshold, value);
op.impl(self, threshold, value, op.outputs_[0]);
return self;
}
struct structured_threshold_backward_out_functional final : public at::native::structured_threshold_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_threshold_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_threshold_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & threshold) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_threshold_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_threshold_backward", "self");
structured_threshold_backward_out_functional op;
op.meta(grad_output, self, threshold);
op.impl(grad_output, self, threshold, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_threshold_backward_out_out final : public at::native::structured_threshold_backward_out {
    structured_threshold_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_threshold_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_threshold_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & threshold, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_threshold_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_threshold_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_threshold_backward_out_grad_input", "self");
structured_threshold_backward_out_out op(grad_input);
op.meta(grad_output, self, threshold);
op.impl(grad_output, self, threshold, op.outputs_[0]);
return grad_input;
}
namespace {

at::Tensor wrapper__flip(const at::Tensor & self, at::IntArrayRef dims) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__flip", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::flip(self, dims);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__roll(const at::Tensor & self, at::IntArrayRef shifts, at::IntArrayRef dims) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__roll", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::roll_cuda(self, shifts, dims);
}

} // anonymous namespace
struct structured_trunc_out_functional final : public at::native::structured_trunc_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_trunc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_trunc(const at::Tensor & self) {
  // No device check

structured_trunc_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_trunc_out_out final : public at::native::structured_trunc_out {
    structured_trunc_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_trunc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_trunc_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_trunc_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_trunc_out_inplace final : public at::native::structured_trunc_out {
    structured_trunc_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_trunc_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_trunc_(at::Tensor & self) {
  // No device check

structured_trunc_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___unique(const at::Tensor & self, bool sorted, bool return_inverse) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___unique", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_unique_cuda(self, sorted, return_inverse);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__unique_dim(const at::Tensor & self, int64_t dim, bool sorted, bool return_inverse, bool return_counts) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__unique_dim", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::unique_dim_cuda(self, dim, sorted, return_inverse, return_counts);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__unique_consecutive(const at::Tensor & self, bool return_inverse, bool return_counts, c10::optional<int64_t> dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__unique_consecutive", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::unique_consecutive_cuda(self, return_inverse, return_counts, dim);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__unique_dim_consecutive(const at::Tensor & self, int64_t dim, bool return_inverse, bool return_counts) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__unique_dim_consecutive", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::unique_dim_consecutive_cuda(self, dim, return_inverse, return_counts);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper___unique2(const at::Tensor & self, bool sorted, bool return_inverse, bool return_counts) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___unique2", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_unique2_cuda(self, sorted, return_inverse, return_counts);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__unsqueeze(const at::Tensor & self, int64_t dim) {
    // No device check


  // DeviceGuard omitted
  return at::native::unsqueeze(self, dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_correction_var_correction(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::var(self, dim, correction, keepdim);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_correction_out_var_out_correction_out(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::var_out(self, dim, correction, keepdim, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper_correction_var_mean_correction(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::var_mean(self, dim, correction, keepdim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___s_where(const at::Tensor & condition, const at::Tensor & self, const at::Tensor & other) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, condition, "wrapper___s_where", "condition");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper___s_where", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper___s_where", "other");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_s_where(condition, self, other);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___weight_norm_cuda_interface(const at::Tensor & v, const at::Tensor & g, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, v, "wrapper___weight_norm_cuda_interface", "v");
  c10::impl::check_and_update_common_device(common_device, g, "wrapper___weight_norm_cuda_interface", "g");

  const OptionalDeviceGuard device_guard(device_of(v));
  return at::native::weight_norm_cuda(v, g, dim);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___weight_norm_cuda_interface_backward(const at::Tensor & grad_w, const at::Tensor & saved_v, const at::Tensor & saved_g, const at::Tensor & saved_norms, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_w, "wrapper___weight_norm_cuda_interface_backward", "grad_w");
  c10::impl::check_and_update_common_device(common_device, saved_v, "wrapper___weight_norm_cuda_interface_backward", "saved_v");
  c10::impl::check_and_update_common_device(common_device, saved_g, "wrapper___weight_norm_cuda_interface_backward", "saved_g");
  c10::impl::check_and_update_common_device(common_device, saved_norms, "wrapper___weight_norm_cuda_interface_backward", "saved_norms");

  const OptionalDeviceGuard device_guard(device_of(grad_w));
  return at::native::weight_norm_cuda_backward(grad_w, saved_v, saved_g, saved_norms, dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___efficientzerotensor(at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning


  globalContext().lazyInitCUDA();

  const DeviceGuard device_guard(device_or_default(device));
  return at::native::_efficientzerotensor_cuda(size, dtype, layout, device, pin_memory);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___standard_gamma_grad(const at::Tensor & self, const at::Tensor & output) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___standard_gamma_grad", "self");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper___standard_gamma_grad", "output");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_standard_gamma_grad_cuda(self, output);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___standard_gamma(const at::Tensor & self, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___standard_gamma", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_s_gamma_cuda(self, generator);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___dirichlet_grad(const at::Tensor & x, const at::Tensor & alpha, const at::Tensor & total) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, x, "wrapper___dirichlet_grad", "x");
  c10::impl::check_and_update_common_device(common_device, alpha, "wrapper___dirichlet_grad", "alpha");
  c10::impl::check_and_update_common_device(common_device, total, "wrapper___dirichlet_grad", "total");

  const OptionalDeviceGuard device_guard(device_of(x));
  return at::native::_dirichlet_grad_cuda(x, alpha, total);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sample_dirichlet(const at::Tensor & self, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___sample_dirichlet", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_s_dirichlet_cuda(self, generator);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__poisson(const at::Tensor & self, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_s_poisson_cuda(self, generator);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__binomial(const at::Tensor & count, const at::Tensor & prob, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(count));
  return at::native::_s_binomial_cuda(count, prob, generator);
}

} // anonymous namespace
struct structured_norm_dtype_out_functional final : public at::native::structured_norm_dtype_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_norm_ScalarOpt_dim_dtype(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype) {
  // No device check

structured_norm_dtype_out_functional op;
op.meta(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim, dtype);
op.impl(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim, dtype, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_norm_dtype_out_out final : public at::native::structured_norm_dtype_out {
    structured_norm_dtype_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_norm_out_dtype_out(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype, at::Tensor & out) {
  // No device check

structured_norm_dtype_out_out op(out);
op.meta(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim, dtype);
op.impl(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim, dtype, op.outputs_[0]);
return out;
}
struct structured_norm_out_functional final : public at::native::structured_norm_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_norm_ScalarOpt_dim(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim) {
  // No device check

structured_norm_out_functional op;
op.meta(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim);
op.impl(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_norm_out_out final : public at::native::structured_norm_out {
    structured_norm_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_norm_out_out(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::Tensor & out) {
  // No device check

structured_norm_out_out op(out);
op.meta(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim);
op.impl(self, (p.has_value() ? at::OptionalScalarRef(&(p.value())) : at::OptionalScalarRef()), dim, keepdim, op.outputs_[0]);
return out;
}
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_Tensor_out_frexp_out_Tensor_out(const at::Tensor & self, at::Tensor & mantissa, at::Tensor & exponent) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, mantissa, "wrapper_Tensor_out_frexp_out_Tensor_out", "mantissa");
  c10::impl::check_and_update_common_device(common_device, exponent, "wrapper_Tensor_out_frexp_out_Tensor_out", "exponent");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_out_frexp_out_Tensor_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::frexp_out(self, mantissa, exponent);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__zero_(at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::zero_(self);
}

} // anonymous namespace
struct structured_sub_out_functional final : public at::native::structured_sub_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sub_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sub_Tensor(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
  // No device check

structured_sub_out_functional op;
op.meta(self, other, alpha);
op.impl(self, other, alpha, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sub_out_out final : public at::native::structured_sub_out {
    structured_sub_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sub_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sub_out_out(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
  // No device check

structured_sub_out_out op(out);
op.meta(self, other, alpha);
op.impl(self, other, alpha, op.outputs_[0]);
return out;
}
struct structured_sub_out_inplace final : public at::native::structured_sub_out {
    structured_sub_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sub_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sub__Tensor(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
  // No device check

structured_sub_out_inplace op(self);
op.meta(self, other, alpha);
op.impl(self, other, alpha, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Tensor_rsub_Tensor(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::rsub(self, other, alpha);
}

} // anonymous namespace
struct structured_heaviside_out_functional final : public at::native::structured_heaviside_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_heaviside_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_heaviside(const at::Tensor & self, const at::Tensor & values) {
  // No device check

structured_heaviside_out_functional op;
op.meta(self, values);
op.impl(self, values, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_heaviside_out_out final : public at::native::structured_heaviside_out {
    structured_heaviside_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_heaviside_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_heaviside_out_out(const at::Tensor & self, const at::Tensor & values, at::Tensor & out) {
  // No device check

structured_heaviside_out_out op(out);
op.meta(self, values);
op.impl(self, values, op.outputs_[0]);
return out;
}
struct structured_heaviside_out_inplace final : public at::native::structured_heaviside_out {
    structured_heaviside_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_heaviside_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_heaviside_(at::Tensor & self, const at::Tensor & values) {
  // No device check

structured_heaviside_out_inplace op(self);
op.meta(self, values);
op.impl(self, values, op.outputs_[0]);
return self;
}
struct structured_addmm_out_cuda_functional final : public at::native::structured_addmm_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_addmm(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_addmm", "self");
  c10::impl::check_and_update_common_device(common_device, mat1, "wrapper_addmm", "mat1");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_addmm", "mat2");
structured_addmm_out_cuda_functional op;
op.meta(self, mat1, mat2, beta, alpha);
op.impl(self, mat1, mat2, beta, alpha, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_addmm_out_cuda_out final : public at::native::structured_addmm_out_cuda {
    structured_addmm_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addmm_out_out(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_addmm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_addmm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, mat1, "wrapper_addmm_out_out", "mat1");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_addmm_out_out", "mat2");
structured_addmm_out_cuda_out op(out);
op.meta(self, mat1, mat2, beta, alpha);
op.impl(self, mat1, mat2, beta, alpha, op.outputs_[0]);
return out;
}
struct structured_addmm_out_cuda_inplace final : public at::native::structured_addmm_out_cuda {
    structured_addmm_out_cuda_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addmm_(at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_addmm_", "self");
  c10::impl::check_and_update_common_device(common_device, mat1, "wrapper_addmm_", "mat1");
  c10::impl::check_and_update_common_device(common_device, mat2, "wrapper_addmm_", "mat2");
structured_addmm_out_cuda_inplace op(self);
op.meta(self, mat1, mat2, beta, alpha);
op.impl(self, mat1, mat2, beta, alpha, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_sparse_dim_to_sparse_sparse_dim(const at::Tensor & self, int64_t sparse_dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_sparse_dim_to_sparse_sparse_dim", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::dense_to_sparse(self, sparse_dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__to_sparse(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__to_sparse", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::dense_to_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__quantize_per_tensor_dynamic(const at::Tensor & self, at::ScalarType dtype, bool reduce_range) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__quantize_per_tensor_dynamic", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::quantize_per_tensor_dynamic(self, dtype, reduce_range);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__quantize_per_tensor(const at::Tensor & self, double scale, int64_t zero_point, at::ScalarType dtype) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__quantize_per_tensor", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::quantize_per_tensor(self, scale, zero_point, dtype);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_tensor_qparams_quantize_per_tensor_tensor_qparams(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, at::ScalarType dtype) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_tensor_qparams_quantize_per_tensor_tensor_qparams", "self");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper_tensor_qparams_quantize_per_tensor_tensor_qparams", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper_tensor_qparams_quantize_per_tensor_tensor_qparams", "zero_point");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::quantize_per_tensor_tensor_qparams(self, scale, zero_point, dtype);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__quantize_per_channel(const at::Tensor & self, const at::Tensor & scales, const at::Tensor & zero_points, int64_t axis, at::ScalarType dtype) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__quantize_per_channel", "self");
  c10::impl::check_and_update_common_device(common_device, scales, "wrapper__quantize_per_channel", "scales");
  c10::impl::check_and_update_common_device(common_device, zero_points, "wrapper__quantize_per_channel", "zero_points");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::quantize_per_channel(self, scales, zero_points, axis, dtype);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_self_dequantize_self(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_self_dequantize_self", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::dequantize_cpu_or_cuda(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___make_per_tensor_quantized_tensor(const at::Tensor & self, double scale, int64_t zero_point) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___make_per_tensor_quantized_tensor", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::make_per_tensor_quantized_tensor_cuda(self, scale, zero_point);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___make_per_channel_quantized_tensor(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t axis) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___make_per_channel_quantized_tensor", "self");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper___make_per_channel_quantized_tensor", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper___make_per_channel_quantized_tensor", "zero_point");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::make_per_channel_quantized_tensor_cuda(self, scale, zero_point, axis);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__fake_quantize_per_tensor_affine_cachemask(const at::Tensor & self, double scale, int64_t zero_point, int64_t quant_min, int64_t quant_max) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__fake_quantize_per_tensor_affine_cachemask", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fake_quantize_per_tensor_affine_cachemask(self, scale, zero_point, quant_min, quant_max);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, const at::Tensor & fake_quant_enabled, int64_t quant_min, int64_t quant_max) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams", "self");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams", "zero_point");
  c10::impl::check_and_update_common_device(common_device, fake_quant_enabled, "wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams", "fake_quant_enabled");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fake_quantize_per_tensor_affine_cachemask_tensor_qparams(self, scale, zero_point, fake_quant_enabled, quant_min, quant_max);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___fake_quantize_learnable_per_tensor_affine(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t quant_min, int64_t quant_max, double grad_factor) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fake_quantize_learnable_per_tensor_affine", "self");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper___fake_quantize_learnable_per_tensor_affine", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper___fake_quantize_learnable_per_tensor_affine", "zero_point");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fake_quantize_learnable_per_tensor_affine(self, scale, zero_point, quant_min, quant_max, grad_factor);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__fake_quantize_per_channel_affine_cachemask(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t axis, int64_t quant_min, int64_t quant_max) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__fake_quantize_per_channel_affine_cachemask", "self");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper__fake_quantize_per_channel_affine_cachemask", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper__fake_quantize_per_channel_affine_cachemask", "zero_point");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fake_quantize_per_channel_affine_cachemask(self, scale, zero_point, axis, quant_min, quant_max);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___fake_quantize_learnable_per_channel_affine(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t axis, int64_t quant_min, int64_t quant_max, double grad_factor) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fake_quantize_learnable_per_channel_affine", "self");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper___fake_quantize_learnable_per_channel_affine", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper___fake_quantize_learnable_per_channel_affine", "zero_point");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_fake_quantize_learnable_per_channel_affine(self, scale, zero_point, axis, quant_min, quant_max, grad_factor);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___fused_moving_avg_obs_fq_helper(const at::Tensor & self, const at::Tensor & observer_on, const at::Tensor & fake_quant_on, at::Tensor & running_min, at::Tensor & running_max, at::Tensor & scale, at::Tensor & zero_point, double averaging_const, int64_t quant_min, int64_t quant_max, int64_t ch_axis, bool per_row_fake_quant, bool symmetric_quant) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___fused_moving_avg_obs_fq_helper", "self");
  c10::impl::check_and_update_common_device(common_device, observer_on, "wrapper___fused_moving_avg_obs_fq_helper", "observer_on");
  c10::impl::check_and_update_common_device(common_device, fake_quant_on, "wrapper___fused_moving_avg_obs_fq_helper", "fake_quant_on");
  c10::impl::check_and_update_common_device(common_device, running_min, "wrapper___fused_moving_avg_obs_fq_helper", "running_min");
  c10::impl::check_and_update_common_device(common_device, running_max, "wrapper___fused_moving_avg_obs_fq_helper", "running_max");
  c10::impl::check_and_update_common_device(common_device, scale, "wrapper___fused_moving_avg_obs_fq_helper", "scale");
  c10::impl::check_and_update_common_device(common_device, zero_point, "wrapper___fused_moving_avg_obs_fq_helper", "zero_point");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fused_moving_avg_obs_fake_quant_cuda(self, observer_on, fake_quant_on, running_min, running_max, scale, zero_point, averaging_const, quant_min, quant_max, ch_axis, per_row_fake_quant, symmetric_quant);
}

} // anonymous namespace
namespace {

at::Scalar wrapper___local_scalar_dense(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___local_scalar_dense", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_local_scalar_dense_cuda(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper___thnn_fused_lstm_cell(const at::Tensor & input_gates, const at::Tensor & hidden_gates, const at::Tensor & cx, const c10::optional<at::Tensor> & input_bias, const c10::optional<at::Tensor> & hidden_bias) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input_gates, "wrapper___thnn_fused_lstm_cell", "input_gates");
  c10::impl::check_and_update_common_device(common_device, hidden_gates, "wrapper___thnn_fused_lstm_cell", "hidden_gates");
  c10::impl::check_and_update_common_device(common_device, cx, "wrapper___thnn_fused_lstm_cell", "cx");
  c10::impl::check_and_update_common_device(common_device, input_bias, "wrapper___thnn_fused_lstm_cell", "input_bias");
  c10::impl::check_and_update_common_device(common_device, hidden_bias, "wrapper___thnn_fused_lstm_cell", "hidden_bias");

  const OptionalDeviceGuard device_guard(device_of(input_gates));
  return at::native::_thnn_fused_lstm_cell_cuda(input_gates, hidden_gates, cx, input_bias, hidden_bias);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper___thnn_fused_lstm_cell_backward(const c10::optional<at::Tensor> & grad_hy, const c10::optional<at::Tensor> & grad_cy, const at::Tensor & cx, const at::Tensor & cy, const at::Tensor & workspace, bool has_bias) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_hy, "wrapper___thnn_fused_lstm_cell_backward", "grad_hy");
  c10::impl::check_and_update_common_device(common_device, grad_cy, "wrapper___thnn_fused_lstm_cell_backward", "grad_cy");
  c10::impl::check_and_update_common_device(common_device, cx, "wrapper___thnn_fused_lstm_cell_backward", "cx");
  c10::impl::check_and_update_common_device(common_device, cy, "wrapper___thnn_fused_lstm_cell_backward", "cy");
  c10::impl::check_and_update_common_device(common_device, workspace, "wrapper___thnn_fused_lstm_cell_backward", "workspace");

  const OptionalDeviceGuard device_guard(device_of(grad_hy));
  return at::native::_thnn_fused_lstm_cell_backward_cuda(grad_hy, grad_cy, cx, cy, workspace, has_bias);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___thnn_fused_gru_cell(const at::Tensor & input_gates, const at::Tensor & hidden_gates, const at::Tensor & hx, const c10::optional<at::Tensor> & input_bias, const c10::optional<at::Tensor> & hidden_bias) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input_gates, "wrapper___thnn_fused_gru_cell", "input_gates");
  c10::impl::check_and_update_common_device(common_device, hidden_gates, "wrapper___thnn_fused_gru_cell", "hidden_gates");
  c10::impl::check_and_update_common_device(common_device, hx, "wrapper___thnn_fused_gru_cell", "hx");
  c10::impl::check_and_update_common_device(common_device, input_bias, "wrapper___thnn_fused_gru_cell", "input_bias");
  c10::impl::check_and_update_common_device(common_device, hidden_bias, "wrapper___thnn_fused_gru_cell", "hidden_bias");

  const OptionalDeviceGuard device_guard(device_of(input_gates));
  return at::native::_thnn_fused_gru_cell_cuda(input_gates, hidden_gates, hx, input_bias, hidden_bias);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> wrapper___thnn_fused_gru_cell_backward(const at::Tensor & grad_hy, const at::Tensor & workspace, bool has_bias) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_hy, "wrapper___thnn_fused_gru_cell_backward", "grad_hy");
  c10::impl::check_and_update_common_device(common_device, workspace, "wrapper___thnn_fused_gru_cell_backward", "workspace");

  const OptionalDeviceGuard device_guard(device_of(grad_hy));
  return at::native::_thnn_fused_gru_cell_backward_cuda(grad_hy, workspace, has_bias);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_source_Storage_set__source_Storage(at::Tensor & self, at::Storage source) {
    // No device check


  // DeviceGuard omitted
  return at::native::set_(self, source);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_source_Storage_storage_offset_set__source_Storage_storage_offset(at::Tensor & self, at::Storage source, int64_t storage_offset, at::IntArrayRef size, at::IntArrayRef stride) {
    // No device check


  // DeviceGuard omitted
  return at::native::set_storage_cuda_(self, source, storage_offset, size, stride);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_source_Tensor_set__source_Tensor(at::Tensor & self, const at::Tensor & source) {
    // No device check


  // DeviceGuard omitted
  return at::native::set_tensor_(self, source);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__set_(at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__set_", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::set_cuda_(self);
}

} // anonymous namespace
namespace {

bool wrapper__is_set_to(const at::Tensor & self, const at::Tensor & tensor) {
    // No device check


  // DeviceGuard omitted
  return at::native::is_set_to(self, tensor);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Scalar_masked_fill__Scalar(at::Tensor & self, const at::Tensor & mask, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_fill__cuda(self, mask, value);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_masked_fill__Tensor(at::Tensor & self, const at::Tensor & mask, const at::Tensor & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_fill__cuda(self, mask, value);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__masked_scatter_(at::Tensor & self, const at::Tensor & mask, const at::Tensor & source) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__masked_scatter_", "self");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper__masked_scatter_", "mask");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper__masked_scatter_", "source");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_scatter__cuda(self, mask, source);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___masked_softmax(const at::Tensor & self, const at::Tensor & mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___masked_softmax", "self");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper___masked_softmax", "mask");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_softmax_cuda(self, mask);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__view(const at::Tensor & self, at::IntArrayRef size) {
    // No device check


  // DeviceGuard omitted
  return at::native::view(self, size);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__put_(at::Tensor & self, const at::Tensor & index, const at::Tensor & source, bool accumulate) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__put_", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper__put_", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper__put_", "source");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::put_(self, index, source, accumulate);
}

} // anonymous namespace
struct structured_index_add_cuda_out_functional final : public at::native::structured_index_add_cuda_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_index_add(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_index_add", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_index_add", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper_index_add", "source");
structured_index_add_cuda_out_functional op;
auto precompute = op.meta(self, dim, index, source, alpha);
(void)precompute;
op.impl(self, precompute.dim, index, source, alpha, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_index_add_cuda_out_out final : public at::native::structured_index_add_cuda_out {
    structured_index_add_cuda_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_index_add_out_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_index_add_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_index_add_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_index_add_out_out", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper_index_add_out_out", "source");
structured_index_add_cuda_out_out op(out);
auto precompute = op.meta(self, dim, index, source, alpha);
(void)precompute;
op.impl(self, precompute.dim, index, source, alpha, op.outputs_[0]);
return out;
}
struct structured_index_add_cuda_out_inplace final : public at::native::structured_index_add_cuda_out {
    structured_index_add_cuda_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_index_add_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_index_add_", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_index_add_", "index");
  c10::impl::check_and_update_common_device(common_device, source, "wrapper_index_add_", "source");
structured_index_add_cuda_out_inplace op(self);
auto precompute = op.meta(self, dim, index, source, alpha);
(void)precompute;
op.impl(self, precompute.dim, index, source, alpha, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper_int_Scalar_index_fill__int_Scalar(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::index_fill_(self, dim, index, value);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_int_Tensor_index_fill__int_Tensor(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::index_fill_(self, dim, index, value);
}

} // anonymous namespace
struct structured_scatter_src_out_functional final : public at::native::structured_scatter_src_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_scatter_src(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_src", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_src", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_src", "src");
structured_scatter_src_out_functional op;
op.meta(self, dim, index, src);
op.impl(self, dim, index, src, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_scatter_src_out_out final : public at::native::structured_scatter_src_out {
    structured_scatter_src_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter_out_src_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_scatter_out_src_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_out_src_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_out_src_out", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_out_src_out", "src");
structured_scatter_src_out_out op(out);
op.meta(self, dim, index, src);
op.impl(self, dim, index, src, op.outputs_[0]);
return out;
}
struct structured_scatter_src_out_inplace final : public at::native::structured_scatter_src_out {
    structured_scatter_src_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter__src(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter__src", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter__src", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter__src", "src");
structured_scatter_src_out_inplace op(self);
op.meta(self, dim, index, src);
op.impl(self, dim, index, src, op.outputs_[0]);
return self;
}
struct structured_scatter_value_out_functional final : public at::native::structured_scatter_value_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_scatter_value(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_value", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_value", "index");
structured_scatter_value_out_functional op;
op.meta(self, dim, index, value);
op.impl(self, dim, index, value, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_scatter_value_out_out final : public at::native::structured_scatter_value_out {
    structured_scatter_value_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter_out_value_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_scatter_out_value_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_out_value_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_out_value_out", "index");
structured_scatter_value_out_out op(out);
op.meta(self, dim, index, value);
op.impl(self, dim, index, value, op.outputs_[0]);
return out;
}
struct structured_scatter_value_out_inplace final : public at::native::structured_scatter_value_out {
    structured_scatter_value_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter__value(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter__value", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter__value", "index");
structured_scatter_value_out_inplace op(self);
op.meta(self, dim, index, value);
op.impl(self, dim, index, value, op.outputs_[0]);
return self;
}
struct structured_scatter_reduce_out_functional final : public at::native::structured_scatter_reduce_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_scatter_reduce(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_reduce", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_reduce", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_reduce", "src");
structured_scatter_reduce_out_functional op;
op.meta(self, dim, index, src, reduce);
op.impl(self, dim, index, src, reduce, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_scatter_reduce_out_out final : public at::native::structured_scatter_reduce_out {
    structured_scatter_reduce_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter_out_reduce_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_scatter_out_reduce_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_out_reduce_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_out_reduce_out", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_out_reduce_out", "src");
structured_scatter_reduce_out_out op(out);
op.meta(self, dim, index, src, reduce);
op.impl(self, dim, index, src, reduce, op.outputs_[0]);
return out;
}
struct structured_scatter_reduce_out_inplace final : public at::native::structured_scatter_reduce_out {
    structured_scatter_reduce_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter__reduce(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter__reduce", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter__reduce", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter__reduce", "src");
structured_scatter_reduce_out_inplace op(self);
op.meta(self, dim, index, src, reduce);
op.impl(self, dim, index, src, reduce, op.outputs_[0]);
return self;
}
struct structured_scatter_value_reduce_out_functional final : public at::native::structured_scatter_value_reduce_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_scatter_value_reduce(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_value_reduce", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_value_reduce", "index");
structured_scatter_value_reduce_out_functional op;
op.meta(self, dim, index, value, reduce);
op.impl(self, dim, index, value, reduce, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_scatter_value_reduce_out_out final : public at::native::structured_scatter_value_reduce_out {
    structured_scatter_value_reduce_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter_out_value_reduce_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_scatter_out_value_reduce_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_out_value_reduce_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_out_value_reduce_out", "index");
structured_scatter_value_reduce_out_out op(out);
op.meta(self, dim, index, value, reduce);
op.impl(self, dim, index, value, reduce, op.outputs_[0]);
return out;
}
struct structured_scatter_value_reduce_out_inplace final : public at::native::structured_scatter_value_reduce_out {
    structured_scatter_value_reduce_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter__value_reduce(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter__value_reduce", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter__value_reduce", "index");
structured_scatter_value_reduce_out_inplace op(self);
op.meta(self, dim, index, value, reduce);
op.impl(self, dim, index, value, reduce, op.outputs_[0]);
return self;
}
struct structured_scatter_add_functional final : public at::native::structured_scatter_add {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_scatter_add(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_add", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_add", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_add", "src");
structured_scatter_add_functional op;
op.meta(self, dim, index, src);
op.impl(self, dim, index, src, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_scatter_add_out final : public at::native::structured_scatter_add {
    structured_scatter_add_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter_add_out_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_scatter_add_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_add_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_add_out_out", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_add_out_out", "src");
structured_scatter_add_out op(out);
op.meta(self, dim, index, src);
op.impl(self, dim, index, src, op.outputs_[0]);
return out;
}
struct structured_scatter_add_inplace final : public at::native::structured_scatter_add {
    structured_scatter_add_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_scatter_add_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_scatter_add_", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_scatter_add_", "index");
  c10::impl::check_and_update_common_device(common_device, src, "wrapper_scatter_add_", "src");
structured_scatter_add_inplace op(self);
op.meta(self, dim, index, src);
op.impl(self, dim, index, src, op.outputs_[0]);
return self;
}
struct structured_eq_Scalar_out_functional final : public at::native::structured_eq_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_eq_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_eq_Scalar(const at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_eq_Scalar_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_eq_Scalar_out_out final : public at::native::structured_eq_Scalar_out {
    structured_eq_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_eq_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_eq_out_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
  // No device check

structured_eq_Scalar_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_eq_Scalar_out_inplace final : public at::native::structured_eq_Scalar_out {
    structured_eq_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_eq_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_eq__Scalar(at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_eq_Scalar_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_eq_Tensor_out_functional final : public at::native::structured_eq_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_eq_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_eq_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_eq_Tensor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_eq_Tensor_out_out final : public at::native::structured_eq_Tensor_out {
    structured_eq_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_eq_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_eq_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_eq_Tensor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_eq_Tensor_out_inplace final : public at::native::structured_eq_Tensor_out {
    structured_eq_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_eq_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_eq__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_eq_Tensor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_bitwise_and_out_functional final : public at::native::structured_bitwise_and_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_and_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bitwise_and_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_and_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bitwise_and_out_out final : public at::native::structured_bitwise_and_out {
    structured_bitwise_and_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_and_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_and_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_bitwise_and_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_bitwise_and_out_inplace final : public at::native::structured_bitwise_and_out {
    structured_bitwise_and_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_and_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_and__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_and_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_bitwise_or_out_functional final : public at::native::structured_bitwise_or_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_or_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bitwise_or_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_or_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bitwise_or_out_out final : public at::native::structured_bitwise_or_out {
    structured_bitwise_or_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_or_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_or_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_bitwise_or_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_bitwise_or_out_inplace final : public at::native::structured_bitwise_or_out {
    structured_bitwise_or_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_or_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_or__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_or_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_bitwise_xor_out_functional final : public at::native::structured_bitwise_xor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_xor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bitwise_xor_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_xor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bitwise_xor_out_out final : public at::native::structured_bitwise_xor_out {
    structured_bitwise_xor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_xor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_xor_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_bitwise_xor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_bitwise_xor_out_inplace final : public at::native::structured_bitwise_xor_out {
    structured_bitwise_xor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_xor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_xor__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_xor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Scalar___lshift___Scalar(const at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__lshift__(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Scalar___ilshift___Scalar(at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__ilshift__(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor___lshift___Tensor(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__lshift__(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor___ilshift___Tensor(at::Tensor & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__ilshift__(self, other);
}

} // anonymous namespace
struct structured_bitwise_left_shift_out_functional final : public at::native::structured_bitwise_left_shift_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_left_shift_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bitwise_left_shift_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_left_shift_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bitwise_left_shift_out_out final : public at::native::structured_bitwise_left_shift_out {
    structured_bitwise_left_shift_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_left_shift_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_left_shift_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_bitwise_left_shift_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_bitwise_left_shift_out_inplace final : public at::native::structured_bitwise_left_shift_out {
    structured_bitwise_left_shift_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_left_shift_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_left_shift__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_left_shift_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Tensor_Scalar_bitwise_left_shift_Tensor_Scalar(const at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bitwise_left_shift(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_Scalar_out_bitwise_left_shift_out_Tensor_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bitwise_left_shift_out(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_Scalar_bitwise_left_shift__Tensor_Scalar(at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bitwise_left_shift_(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Scalar_Tensor_bitwise_left_shift_Scalar_Tensor(const at::Scalar & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(other));
  return at::native::bitwise_left_shift(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Scalar___rshift___Scalar(const at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__rshift__(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Scalar___irshift___Scalar(at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__irshift__(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor___rshift___Tensor(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__rshift__(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor___irshift___Tensor(at::Tensor & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::__irshift__(self, other);
}

} // anonymous namespace
struct structured_bitwise_right_shift_out_functional final : public at::native::structured_bitwise_right_shift_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_right_shift_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_bitwise_right_shift_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_right_shift_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_bitwise_right_shift_out_out final : public at::native::structured_bitwise_right_shift_out {
    structured_bitwise_right_shift_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_right_shift_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_right_shift_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_bitwise_right_shift_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_bitwise_right_shift_out_inplace final : public at::native::structured_bitwise_right_shift_out {
    structured_bitwise_right_shift_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_bitwise_right_shift_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_bitwise_right_shift__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_bitwise_right_shift_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Tensor_Scalar_bitwise_right_shift_Tensor_Scalar(const at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bitwise_right_shift(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_Scalar_out_bitwise_right_shift_out_Tensor_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bitwise_right_shift_out(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_Scalar_bitwise_right_shift__Tensor_Scalar(at::Tensor & self, const at::Scalar & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bitwise_right_shift_(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Scalar_Tensor_bitwise_right_shift_Scalar_Tensor(const at::Scalar & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(other));
  return at::native::bitwise_right_shift(self, other);
}

} // anonymous namespace
struct structured_tril_cuda_functional final : public at::native::structured_tril_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_tril(const at::Tensor & self, int64_t diagonal) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_tril", "self");
structured_tril_cuda_functional op;
op.meta(self, diagonal);
op.impl(self, diagonal, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_tril_cuda_out final : public at::native::structured_tril_cuda {
    structured_tril_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tril_out_out(const at::Tensor & self, int64_t diagonal, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_tril_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_tril_out_out", "self");
structured_tril_cuda_out op(out);
op.meta(self, diagonal);
op.impl(self, diagonal, op.outputs_[0]);
return out;
}
struct structured_tril_cuda_inplace final : public at::native::structured_tril_cuda {
    structured_tril_cuda_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tril_(at::Tensor & self, int64_t diagonal) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_tril_", "self");
structured_tril_cuda_inplace op(self);
op.meta(self, diagonal);
op.impl(self, diagonal, op.outputs_[0]);
return self;
}
struct structured_triu_cuda_functional final : public at::native::structured_triu_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_triu(const at::Tensor & self, int64_t diagonal) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_triu", "self");
structured_triu_cuda_functional op;
op.meta(self, diagonal);
op.impl(self, diagonal, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_triu_cuda_out final : public at::native::structured_triu_cuda {
    structured_triu_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_triu_out_out(const at::Tensor & self, int64_t diagonal, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_triu_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_triu_out_out", "self");
structured_triu_cuda_out op(out);
op.meta(self, diagonal);
op.impl(self, diagonal, op.outputs_[0]);
return out;
}
struct structured_triu_cuda_inplace final : public at::native::structured_triu_cuda {
    structured_triu_cuda_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_triu_(at::Tensor & self, int64_t diagonal) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_triu_", "self");
structured_triu_cuda_inplace op(self);
op.meta(self, diagonal);
op.impl(self, diagonal, op.outputs_[0]);
return self;
}
struct structured_digamma_out_functional final : public at::native::structured_digamma_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_digamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_digamma(const at::Tensor & self) {
  // No device check

structured_digamma_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_digamma_out_out final : public at::native::structured_digamma_out {
    structured_digamma_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_digamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_digamma_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_digamma_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_digamma_out_inplace final : public at::native::structured_digamma_out {
    structured_digamma_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_digamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_digamma_(at::Tensor & self) {
  // No device check

structured_digamma_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_lerp_Scalar_functional final : public at::native::structured_lerp_Scalar {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lerp_Scalar::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_lerp_Scalar(const at::Tensor & self, const at::Tensor & end, const at::Scalar & weight) {
  // No device check

structured_lerp_Scalar_functional op;
op.meta(self, end, weight);
op.impl(self, end, weight, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_lerp_Scalar_out final : public at::native::structured_lerp_Scalar {
    structured_lerp_Scalar_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lerp_Scalar::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lerp_out_Scalar_out(const at::Tensor & self, const at::Tensor & end, const at::Scalar & weight, at::Tensor & out) {
  // No device check

structured_lerp_Scalar_out op(out);
op.meta(self, end, weight);
op.impl(self, end, weight, op.outputs_[0]);
return out;
}
struct structured_lerp_Scalar_inplace final : public at::native::structured_lerp_Scalar {
    structured_lerp_Scalar_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lerp_Scalar::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lerp__Scalar(at::Tensor & self, const at::Tensor & end, const at::Scalar & weight) {
  // No device check

structured_lerp_Scalar_inplace op(self);
op.meta(self, end, weight);
op.impl(self, end, weight, op.outputs_[0]);
return self;
}
struct structured_lerp_Tensor_functional final : public at::native::structured_lerp_Tensor {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lerp_Tensor::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_lerp_Tensor(const at::Tensor & self, const at::Tensor & end, const at::Tensor & weight) {
  // No device check

structured_lerp_Tensor_functional op;
op.meta(self, end, weight);
op.impl(self, end, weight, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_lerp_Tensor_out final : public at::native::structured_lerp_Tensor {
    structured_lerp_Tensor_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lerp_Tensor::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lerp_out_Tensor_out(const at::Tensor & self, const at::Tensor & end, const at::Tensor & weight, at::Tensor & out) {
  // No device check

structured_lerp_Tensor_out op(out);
op.meta(self, end, weight);
op.impl(self, end, weight, op.outputs_[0]);
return out;
}
struct structured_lerp_Tensor_inplace final : public at::native::structured_lerp_Tensor {
    structured_lerp_Tensor_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lerp_Tensor::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lerp__Tensor(at::Tensor & self, const at::Tensor & end, const at::Tensor & weight) {
  // No device check

structured_lerp_Tensor_inplace op(self);
op.meta(self, end, weight);
op.impl(self, end, weight, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__addbmm(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__addbmm", "self");
  c10::impl::check_and_update_common_device(common_device, batch1, "wrapper__addbmm", "batch1");
  c10::impl::check_and_update_common_device(common_device, batch2, "wrapper__addbmm", "batch2");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::addbmm(self, batch1, batch2, beta, alpha);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_addbmm_out_out(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_addbmm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_addbmm_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, batch1, "wrapper_out_addbmm_out_out", "batch1");
  c10::impl::check_and_update_common_device(common_device, batch2, "wrapper_out_addbmm_out_out", "batch2");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::addbmm_out(self, batch1, batch2, beta, alpha, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__addbmm_(at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__addbmm_", "self");
  c10::impl::check_and_update_common_device(common_device, batch1, "wrapper__addbmm_", "batch1");
  c10::impl::check_and_update_common_device(common_device, batch2, "wrapper__addbmm_", "batch2");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::addbmm_(self, batch1, batch2, beta, alpha);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_from_random__from(at::Tensor & self, int64_t from, c10::optional<int64_t> to, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::random_(self, from, to, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_to_random__to(at::Tensor & self, int64_t to, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::random_(self, to, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__random_(at::Tensor & self, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::random_(self, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__uniform_(at::Tensor & self, double from, double to, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::uniform_(self, from, to, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__cauchy_(at::Tensor & self, double median, double sigma, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cauchy_(self, median, sigma, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__log_normal_(at::Tensor & self, double mean, double std, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::log_normal_(self, mean, std, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__exponential_(at::Tensor & self, double lambd, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::exponential_(self, lambd, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__geometric_(at::Tensor & self, double p, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::geometric_(self, p, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_diag_out_out(const at::Tensor & self, int64_t diagonal, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_diag_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_diag_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::diag_cuda_out(self, diagonal, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__tril_indices(int64_t row, int64_t col, int64_t offset, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning


  globalContext().lazyInitCUDA();

  const DeviceGuard device_guard(device_or_default(device));
  return at::native::tril_indices_cuda(row, col, offset, dtype, layout, device, pin_memory);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__triu_indices(int64_t row, int64_t col, int64_t offset, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning


  globalContext().lazyInitCUDA();

  const DeviceGuard device_guard(device_or_default(device));
  return at::native::triu_indices_cuda(row, col, offset, dtype, layout, device, pin_memory);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__trace(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__trace", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::trace_cuda(self);
}

} // anonymous namespace
struct structured_ne_Scalar_out_functional final : public at::native::structured_ne_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ne_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_ne_Scalar(const at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_ne_Scalar_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_ne_Scalar_out_out final : public at::native::structured_ne_Scalar_out {
    structured_ne_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ne_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ne_out_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
  // No device check

structured_ne_Scalar_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_ne_Scalar_out_inplace final : public at::native::structured_ne_Scalar_out {
    structured_ne_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ne_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ne__Scalar(at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_ne_Scalar_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_ne_Tensor_out_functional final : public at::native::structured_ne_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ne_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_ne_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_ne_Tensor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_ne_Tensor_out_out final : public at::native::structured_ne_Tensor_out {
    structured_ne_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ne_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ne_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_ne_Tensor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_ne_Tensor_out_inplace final : public at::native::structured_ne_Tensor_out {
    structured_ne_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ne_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ne__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_ne_Tensor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_ge_Scalar_out_functional final : public at::native::structured_ge_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ge_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_ge_Scalar(const at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_ge_Scalar_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_ge_Scalar_out_out final : public at::native::structured_ge_Scalar_out {
    structured_ge_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ge_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ge_out_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
  // No device check

structured_ge_Scalar_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_ge_Scalar_out_inplace final : public at::native::structured_ge_Scalar_out {
    structured_ge_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ge_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ge__Scalar(at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_ge_Scalar_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_ge_Tensor_out_functional final : public at::native::structured_ge_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ge_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_ge_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_ge_Tensor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_ge_Tensor_out_out final : public at::native::structured_ge_Tensor_out {
    structured_ge_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ge_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ge_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_ge_Tensor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_ge_Tensor_out_inplace final : public at::native::structured_ge_Tensor_out {
    structured_ge_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_ge_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_ge__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_ge_Tensor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_le_Scalar_out_functional final : public at::native::structured_le_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_le_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_le_Scalar(const at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_le_Scalar_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_le_Scalar_out_out final : public at::native::structured_le_Scalar_out {
    structured_le_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_le_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_le_out_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
  // No device check

structured_le_Scalar_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_le_Scalar_out_inplace final : public at::native::structured_le_Scalar_out {
    structured_le_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_le_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_le__Scalar(at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_le_Scalar_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_le_Tensor_out_functional final : public at::native::structured_le_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_le_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_le_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_le_Tensor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_le_Tensor_out_out final : public at::native::structured_le_Tensor_out {
    structured_le_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_le_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_le_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_le_Tensor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_le_Tensor_out_inplace final : public at::native::structured_le_Tensor_out {
    structured_le_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_le_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_le__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_le_Tensor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_gt_Scalar_out_functional final : public at::native::structured_gt_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gt_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_gt_Scalar(const at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_gt_Scalar_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_gt_Scalar_out_out final : public at::native::structured_gt_Scalar_out {
    structured_gt_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gt_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gt_out_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
  // No device check

structured_gt_Scalar_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_gt_Scalar_out_inplace final : public at::native::structured_gt_Scalar_out {
    structured_gt_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gt_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gt__Scalar(at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_gt_Scalar_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_gt_Tensor_out_functional final : public at::native::structured_gt_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gt_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_gt_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_gt_Tensor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_gt_Tensor_out_out final : public at::native::structured_gt_Tensor_out {
    structured_gt_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gt_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gt_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_gt_Tensor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_gt_Tensor_out_inplace final : public at::native::structured_gt_Tensor_out {
    structured_gt_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_gt_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gt__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_gt_Tensor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_lt_Scalar_out_functional final : public at::native::structured_lt_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lt_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_lt_Scalar(const at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_lt_Scalar_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_lt_Scalar_out_out final : public at::native::structured_lt_Scalar_out {
    structured_lt_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lt_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lt_out_Scalar_out(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
  // No device check

structured_lt_Scalar_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_lt_Scalar_out_inplace final : public at::native::structured_lt_Scalar_out {
    structured_lt_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lt_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lt__Scalar(at::Tensor & self, const at::Scalar & other) {
  // No device check

structured_lt_Scalar_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_lt_Tensor_out_functional final : public at::native::structured_lt_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lt_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_lt_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_lt_Tensor_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_lt_Tensor_out_out final : public at::native::structured_lt_Tensor_out {
    structured_lt_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lt_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lt_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_lt_Tensor_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_lt_Tensor_out_inplace final : public at::native::structured_lt_Tensor_out {
    structured_lt_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lt_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lt__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_lt_Tensor_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__take(const at::Tensor & self, const at::Tensor & index) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__take", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper__take", "index");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::take(self, index);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_take_out_out(const at::Tensor & self, const at::Tensor & index, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_take_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_take_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_out_take_out_out", "index");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::take_out(self, index, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__index_select(const at::Tensor & self, int64_t dim, const at::Tensor & index) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__index_select", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper__index_select", "index");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::index_select_cuda(self, dim, index);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_index_select_out_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_index_select_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_index_select_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_out_index_select_out_out", "index");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::index_select_out_cuda(self, dim, index, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__masked_select(const at::Tensor & self, const at::Tensor & mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__masked_select", "self");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper__masked_select", "mask");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_select_cuda(self, mask);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_masked_select_out_out(const at::Tensor & self, const at::Tensor & mask, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_masked_select_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_masked_select_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, mask, "wrapper_out_masked_select_out_out", "mask");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::masked_select_out_cuda(self, mask, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__nonzero(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__nonzero", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nonzero_cuda(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_nonzero_out_out(const at::Tensor & self, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_nonzero_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_nonzero_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nonzero_out_cuda(self, out);
}

} // anonymous namespace
struct structured_gather_out_functional final : public at::native::structured_gather_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_gather(const at::Tensor & self, int64_t dim, const at::Tensor & index, bool sparse_grad) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gather", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_gather", "index");
structured_gather_out_functional op;
op.meta(self, dim, index, sparse_grad);
op.impl(self, dim, index, sparse_grad, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_gather_out_out final : public at::native::structured_gather_out {
    structured_gather_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_gather_out_out(const at::Tensor & self, int64_t dim, const at::Tensor & index, bool sparse_grad, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_gather_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_gather_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, index, "wrapper_gather_out_out", "index");
structured_gather_out_out op(out);
op.meta(self, dim, index, sparse_grad);
op.impl(self, dim, index, sparse_grad, op.outputs_[0]);
return out;
}
struct structured_addcmul_out_functional final : public at::native::structured_addcmul_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_addcmul_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_addcmul(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
  // No device check

structured_addcmul_out_functional op;
op.meta(self, tensor1, tensor2, value);
op.impl(self, tensor1, tensor2, value, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_addcmul_out_out final : public at::native::structured_addcmul_out {
    structured_addcmul_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_addcmul_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addcmul_out_out(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value, at::Tensor & out) {
  // No device check

structured_addcmul_out_out op(out);
op.meta(self, tensor1, tensor2, value);
op.impl(self, tensor1, tensor2, value, op.outputs_[0]);
return out;
}
struct structured_addcmul_out_inplace final : public at::native::structured_addcmul_out {
    structured_addcmul_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_addcmul_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addcmul_(at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
  // No device check

structured_addcmul_out_inplace op(self);
op.meta(self, tensor1, tensor2, value);
op.impl(self, tensor1, tensor2, value, op.outputs_[0]);
return self;
}
struct structured_addcdiv_out_functional final : public at::native::structured_addcdiv_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_addcdiv_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_addcdiv(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
  // No device check

structured_addcdiv_out_functional op;
op.meta(self, tensor1, tensor2, value);
op.impl(self, tensor1, tensor2, value, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_addcdiv_out_out final : public at::native::structured_addcdiv_out {
    structured_addcdiv_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_addcdiv_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addcdiv_out_out(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value, at::Tensor & out) {
  // No device check

structured_addcdiv_out_out op(out);
op.meta(self, tensor1, tensor2, value);
op.impl(self, tensor1, tensor2, value, op.outputs_[0]);
return out;
}
struct structured_addcdiv_out_inplace final : public at::native::structured_addcdiv_out {
    structured_addcdiv_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_addcdiv_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_addcdiv_(at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
  // No device check

structured_addcdiv_out_inplace op(self);
op.meta(self, tensor1, tensor2, value);
op.impl(self, tensor1, tensor2, value, op.outputs_[0]);
return self;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__lstsq(const at::Tensor & self, const at::Tensor & A) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__lstsq", "self");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper__lstsq", "A");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::legacy_lstsq_cuda(self, A);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_X_lstsq_out_X(const at::Tensor & self, const at::Tensor & A, at::Tensor & X, at::Tensor & qr) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, X, "wrapper_X_lstsq_out_X", "X");
  c10::impl::check_and_update_common_device(common_device, qr, "wrapper_X_lstsq_out_X", "qr");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_X_lstsq_out_X", "self");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper_X_lstsq_out_X", "A");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::legacy_lstsq_out_cuda(self, A, X, qr);
}

} // anonymous namespace
struct structured_triangular_solve_out_functional final : public at::native::structured_triangular_solve_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_triangular_solve(const at::Tensor & self, const at::Tensor & A, bool upper, bool transpose, bool unitriangular) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_triangular_solve", "self");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper_triangular_solve", "A");
structured_triangular_solve_out_functional op;
op.meta(self, A, upper, transpose, unitriangular);
op.impl(self, A, upper, transpose, unitriangular, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_triangular_solve_out_out final : public at::native::structured_triangular_solve_out {
    structured_triangular_solve_out_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_triangular_solve_out_X(const at::Tensor & self, const at::Tensor & A, bool upper, bool transpose, bool unitriangular, at::Tensor & X, at::Tensor & M) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, X, "wrapper_triangular_solve_out_X", "X");
  c10::impl::check_and_update_common_device(common_device, M, "wrapper_triangular_solve_out_X", "M");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_triangular_solve_out_X", "self");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper_triangular_solve_out_X", "A");
structured_triangular_solve_out_out op(X, M);
op.meta(self, A, upper, transpose, unitriangular);
op.impl(self, A, upper, transpose, unitriangular, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(X, M);
}
namespace {

at::Tensor wrapper__linalg_solve_triangular(const at::Tensor & self, const at::Tensor & B, bool upper, bool left, bool unitriangular) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_solve_triangular", "self");
  c10::impl::check_and_update_common_device(common_device, B, "wrapper__linalg_solve_triangular", "B");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_solve_triangular(self, B, upper, left, unitriangular);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_linalg_solve_triangular_out_out(const at::Tensor & self, const at::Tensor & B, bool upper, bool left, bool unitriangular, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_linalg_solve_triangular_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_linalg_solve_triangular_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, B, "wrapper_out_linalg_solve_triangular_out_out", "B");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_solve_triangular_out(self, B, upper, left, unitriangular, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___symeig_helper(const at::Tensor & self, bool eigenvectors, bool upper) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___symeig_helper", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_symeig_helper_cuda(self, eigenvectors, upper);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cholesky(const at::Tensor & self, bool upper) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cholesky", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cholesky(self, upper);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_cholesky_out_out(const at::Tensor & self, bool upper, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_cholesky_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_cholesky_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cholesky_out(self, upper, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___cholesky_solve_helper(const at::Tensor & self, const at::Tensor & A, bool upper) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___cholesky_solve_helper", "self");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper___cholesky_solve_helper", "A");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_cholesky_solve_helper_cuda(self, A, upper);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___solve_helper(const at::Tensor & self, const at::Tensor & A) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___solve_helper", "self");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper___solve_helper", "A");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_solve_helper_cuda(self, A);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__cholesky_inverse(const at::Tensor & self, bool upper) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__cholesky_inverse", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cholesky_inverse(self, upper);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_cholesky_inverse_out_out(const at::Tensor & self, bool upper, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_cholesky_inverse_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_cholesky_inverse_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cholesky_inverse_out(self, upper, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__geqrf(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__geqrf", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::geqrf(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_a_geqrf_out_a(const at::Tensor & self, at::Tensor & a, at::Tensor & tau) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, a, "wrapper_a_geqrf_out_a", "a");
  c10::impl::check_and_update_common_device(common_device, tau, "wrapper_a_geqrf_out_a", "tau");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_a_geqrf_out_a", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::geqrf_out(self, a, tau);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__ormqr(const at::Tensor & self, const at::Tensor & input2, const at::Tensor & input3, bool left, bool transpose) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__ormqr", "self");
  c10::impl::check_and_update_common_device(common_device, input2, "wrapper__ormqr", "input2");
  c10::impl::check_and_update_common_device(common_device, input3, "wrapper__ormqr", "input3");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::ormqr(self, input2, input3, left, transpose);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_ormqr_out_out(const at::Tensor & self, const at::Tensor & input2, const at::Tensor & input3, bool left, bool transpose, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_ormqr_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_ormqr_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, input2, "wrapper_out_ormqr_out_out", "input2");
  c10::impl::check_and_update_common_device(common_device, input3, "wrapper_out_ormqr_out_out", "input3");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::ormqr_out(self, input2, input3, left, transpose, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__lu_solve(const at::Tensor & self, const at::Tensor & LU_data, const at::Tensor & LU_pivots) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__lu_solve", "self");
  c10::impl::check_and_update_common_device(common_device, LU_data, "wrapper__lu_solve", "LU_data");
  c10::impl::check_and_update_common_device(common_device, LU_pivots, "wrapper__lu_solve", "LU_pivots");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::lu_solve(self, LU_data, LU_pivots);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_lu_solve_out_out(const at::Tensor & self, const at::Tensor & LU_data, const at::Tensor & LU_pivots, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_lu_solve_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_lu_solve_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, LU_data, "wrapper_out_lu_solve_out_out", "LU_data");
  c10::impl::check_and_update_common_device(common_device, LU_pivots, "wrapper_out_lu_solve_out_out", "LU_pivots");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::lu_solve_out(self, LU_data, LU_pivots, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__lu_unpack(const at::Tensor & LU_data, const at::Tensor & LU_pivots, bool unpack_data, bool unpack_pivots) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, LU_data, "wrapper__lu_unpack", "LU_data");
  c10::impl::check_and_update_common_device(common_device, LU_pivots, "wrapper__lu_unpack", "LU_pivots");

  const OptionalDeviceGuard device_guard(device_of(LU_data));
  return at::native::lu_unpack(LU_data, LU_pivots, unpack_data, unpack_pivots);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> wrapper_out_lu_unpack_out_out(const at::Tensor & LU_data, const at::Tensor & LU_pivots, bool unpack_data, bool unpack_pivots, at::Tensor & P, at::Tensor & L, at::Tensor & U) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, P, "wrapper_out_lu_unpack_out_out", "P");
  c10::impl::check_and_update_common_device(common_device, L, "wrapper_out_lu_unpack_out_out", "L");
  c10::impl::check_and_update_common_device(common_device, U, "wrapper_out_lu_unpack_out_out", "U");
  c10::impl::check_and_update_common_device(common_device, LU_data, "wrapper_out_lu_unpack_out_out", "LU_data");
  c10::impl::check_and_update_common_device(common_device, LU_pivots, "wrapper_out_lu_unpack_out_out", "LU_pivots");

  const OptionalDeviceGuard device_guard(device_of(P));
  return at::native::lu_unpack_out(LU_data, LU_pivots, unpack_data, unpack_pivots, P, L, U);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__multinomial(const at::Tensor & self, int64_t num_samples, bool replacement, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__multinomial", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multinomial(self, num_samples, replacement, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_multinomial_out_out(const at::Tensor & self, int64_t num_samples, bool replacement, c10::optional<at::Generator> generator, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_multinomial_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_multinomial_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multinomial_out(self, num_samples, replacement, generator, out);
}

} // anonymous namespace
struct structured_lgamma_out_functional final : public at::native::structured_lgamma_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lgamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_lgamma(const at::Tensor & self) {
  // No device check

structured_lgamma_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_lgamma_out_out final : public at::native::structured_lgamma_out {
    structured_lgamma_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lgamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lgamma_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_lgamma_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_lgamma_out_inplace final : public at::native::structured_lgamma_out {
    structured_lgamma_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_lgamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_lgamma_(at::Tensor & self) {
  // No device check

structured_lgamma_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_polygamma_out_functional final : public at::native::structured_polygamma_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_polygamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_polygamma(int64_t n, const at::Tensor & self) {
  // No device check

structured_polygamma_out_functional op;
op.meta(n, self);
op.impl(n, self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_polygamma_out_out final : public at::native::structured_polygamma_out {
    structured_polygamma_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_polygamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_polygamma_out_out(int64_t n, const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_polygamma_out_out op(out);
op.meta(n, self);
op.impl(n, self, op.outputs_[0]);
return out;
}
struct structured_erfinv_out_functional final : public at::native::structured_erfinv_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erfinv_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_erfinv(const at::Tensor & self) {
  // No device check

structured_erfinv_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_erfinv_out_out final : public at::native::structured_erfinv_out {
    structured_erfinv_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erfinv_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_erfinv_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_erfinv_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_erfinv_out_inplace final : public at::native::structured_erfinv_out {
    structured_erfinv_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_erfinv_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_erfinv_(at::Tensor & self) {
  // No device check

structured_erfinv_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_i0_out_functional final : public at::native::structured_i0_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_i0_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_i0(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_i0", "self");
structured_i0_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_i0_out_out final : public at::native::structured_i0_out {
    structured_i0_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_i0_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_i0_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_i0_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_i0_out_out", "self");
structured_i0_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_i0_out_inplace final : public at::native::structured_i0_out {
    structured_i0_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_i0_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_i0_(at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_i0_", "self");
structured_i0_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_sign_out_functional final : public at::native::structured_sign_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sign_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sign(const at::Tensor & self) {
  // No device check

structured_sign_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sign_out_out final : public at::native::structured_sign_out {
    structured_sign_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sign_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sign_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_sign_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_sign_out_inplace final : public at::native::structured_sign_out {
    structured_sign_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sign_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sign_(at::Tensor & self) {
  // No device check

structured_sign_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_signbit_out_functional final : public at::native::structured_signbit_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_signbit_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_signbit(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_signbit", "self");
structured_signbit_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_signbit_out_out final : public at::native::structured_signbit_out {
    structured_signbit_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_signbit_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_signbit_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_signbit_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_signbit_out_out", "self");
structured_signbit_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_atan2_out_functional final : public at::native::structured_atan2_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atan2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_atan2(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_atan2_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_atan2_out_out final : public at::native::structured_atan2_out {
    structured_atan2_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atan2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_atan2_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_atan2_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_atan2_out_inplace final : public at::native::structured_atan2_out {
    structured_atan2_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_atan2_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_atan2_(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_atan2_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__histc(const at::Tensor & self, int64_t bins, const at::Scalar & min, const at::Scalar & max) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__histc", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_histc_cuda(self, bins, min, max);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_histc_out_out(const at::Tensor & self, int64_t bins, const at::Scalar & min, const at::Scalar & max, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_histc_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_histc_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_histc_out_cuda(self, bins, min, max, out);
}

} // anonymous namespace
struct structured_fmod_out_functional final : public at::native::structured_fmod_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmod_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_fmod_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_fmod_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_fmod_out_out final : public at::native::structured_fmod_out {
    structured_fmod_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmod_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_fmod_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_fmod_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_fmod_out_inplace final : public at::native::structured_fmod_out {
    structured_fmod_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmod_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_fmod__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_fmod_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_hypot_out_functional final : public at::native::structured_hypot_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hypot_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_hypot(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hypot", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_hypot", "other");
structured_hypot_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_hypot_out_out final : public at::native::structured_hypot_out {
    structured_hypot_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hypot_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hypot_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_hypot_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hypot_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_hypot_out_out", "other");
structured_hypot_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_hypot_out_inplace final : public at::native::structured_hypot_out {
    structured_hypot_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hypot_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hypot_(at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hypot_", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_hypot_", "other");
structured_hypot_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_igamma_out_functional final : public at::native::structured_igamma_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_igamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_igamma(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_igamma", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_igamma", "other");
structured_igamma_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_igamma_out_out final : public at::native::structured_igamma_out {
    structured_igamma_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_igamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_igamma_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_igamma_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_igamma_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_igamma_out_out", "other");
structured_igamma_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_igamma_out_inplace final : public at::native::structured_igamma_out {
    structured_igamma_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_igamma_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_igamma_(at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_igamma_", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_igamma_", "other");
structured_igamma_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_igammac_out_functional final : public at::native::structured_igammac_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_igammac_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_igammac(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_igammac", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_igammac", "other");
structured_igammac_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_igammac_out_out final : public at::native::structured_igammac_out {
    structured_igammac_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_igammac_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_igammac_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_igammac_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_igammac_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_igammac_out_out", "other");
structured_igammac_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_igammac_out_inplace final : public at::native::structured_igammac_out {
    structured_igammac_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_igammac_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_igammac_(at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_igammac_", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_igammac_", "other");
structured_igammac_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_nextafter_out_functional final : public at::native::structured_nextafter_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_nextafter_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_nextafter(const at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nextafter", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_nextafter", "other");
structured_nextafter_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_nextafter_out_out final : public at::native::structured_nextafter_out {
    structured_nextafter_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_nextafter_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_nextafter_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_nextafter_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nextafter_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_nextafter_out_out", "other");
structured_nextafter_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_nextafter_out_inplace final : public at::native::structured_nextafter_out {
    structured_nextafter_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_nextafter_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_nextafter_(at::Tensor & self, const at::Tensor & other) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nextafter_", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_nextafter_", "other");
structured_nextafter_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
struct structured_remainder_out_functional final : public at::native::structured_remainder_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_remainder_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_remainder_Tensor(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_remainder_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_remainder_out_out final : public at::native::structured_remainder_out {
    structured_remainder_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_remainder_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_remainder_out_Tensor_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_remainder_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_remainder_out_inplace final : public at::native::structured_remainder_out {
    structured_remainder_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_remainder_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_remainder__Tensor(at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_remainder_out_inplace op(self);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper_Scalar_Tensor_remainder_Scalar_Tensor(const at::Scalar & self, const at::Tensor & other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(other));
  return at::native::remainder(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__min(const at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::min(self);
}

} // anonymous namespace
struct structured_fmin_out_functional final : public at::native::structured_fmin_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_fmin(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_fmin_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_fmin_out_out final : public at::native::structured_fmin_out {
    structured_fmin_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmin_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_fmin_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_fmin_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__max(const at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max(self);
}

} // anonymous namespace
struct structured_fmax_out_functional final : public at::native::structured_fmax_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmax_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_fmax(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_fmax_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_fmax_out_out final : public at::native::structured_fmax_out {
    structured_fmax_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_fmax_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_fmax_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_fmax_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_maximum_out_functional final : public at::native::structured_maximum_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_maximum_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_maximum(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_maximum_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_maximum_out_out final : public at::native::structured_maximum_out {
    structured_maximum_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_maximum_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_maximum_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_maximum_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_minimum_out_functional final : public at::native::structured_minimum_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_minimum_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_minimum(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_minimum_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_minimum_out_out final : public at::native::structured_minimum_out {
    structured_minimum_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_minimum_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_minimum_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_minimum_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__sort(const at::Tensor & self, int64_t dim, bool descending) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::sort_cuda(self, dim, descending);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_values_sort_out_values(const at::Tensor & self, int64_t dim, bool descending, at::Tensor & values, at::Tensor & indices) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::sort_out_cuda(self, dim, descending, values, indices);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper_stable_sort_stable(const at::Tensor & self, c10::optional<bool> stable, int64_t dim, bool descending) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_stable_sort_stable", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::sort_stable_cuda(self, stable, dim, descending);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_values_stable_sort_out_values_stable(const at::Tensor & self, c10::optional<bool> stable, int64_t dim, bool descending, at::Tensor & values, at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, values, "wrapper_values_stable_sort_out_values_stable", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_values_stable_sort_out_values_stable", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_values_stable_sort_out_values_stable", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::sort_out_stable_cuda(self, stable, dim, descending, values, indices);
}

} // anonymous namespace
struct structured_topk_out_cuda_functional final : public at::native::structured_topk_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_topk(const at::Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_topk", "self");
structured_topk_out_cuda_functional op;
op.meta(self, k, dim, largest, sorted);
op.impl(self, k, dim, largest, sorted, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_topk_out_cuda_out final : public at::native::structured_topk_out_cuda {
    structured_topk_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_topk_out_values(const at::Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted, at::Tensor & values, at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, values, "wrapper_topk_out_values", "values");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_topk_out_values", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_topk_out_values", "self");
structured_topk_out_cuda_out op(values, indices);
op.meta(self, k, dim, largest, sorted);
op.impl(self, k, dim, largest, sorted, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(values, indices);
}
struct structured_all_all_out_functional final : public at::native::structured_all_all_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_all(const at::Tensor & self) {
  // No device check

structured_all_all_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_all_all_out_out final : public at::native::structured_all_all_out {
    structured_all_all_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_all_out_all_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_all_all_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_any_all_out_functional final : public at::native::structured_any_all_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_any(const at::Tensor & self) {
  // No device check

structured_any_all_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_any_all_out_out final : public at::native::structured_any_all_out {
    structured_any_all_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_any_out_all_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_any_all_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_renorm_out_functional final : public at::native::structured_renorm_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_renorm(const at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm) {
  // No device check

structured_renorm_out_functional op;
op.meta(self, p, dim, maxnorm);
op.impl(self, p, dim, maxnorm, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_renorm_out_out final : public at::native::structured_renorm_out {
    structured_renorm_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_renorm_out_out(const at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm, at::Tensor & out) {
  // No device check

structured_renorm_out_out op(out);
op.meta(self, p, dim, maxnorm);
op.impl(self, p, dim, maxnorm, op.outputs_[0]);
return out;
}
struct structured_renorm_out_inplace final : public at::native::structured_renorm_out {
    structured_renorm_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_renorm_(at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm) {
  // No device check

structured_renorm_out_inplace op(self);
op.meta(self, p, dim, maxnorm);
op.impl(self, p, dim, maxnorm, op.outputs_[0]);
return self;
}
namespace {

at::Tensor wrapper__unfold(const at::Tensor & self, int64_t dimension, int64_t size, int64_t step) {
    // No device check


  // DeviceGuard omitted
  return at::native::unfold(self, dimension, size, step);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__unfold_backward(const at::Tensor & grad_in, at::IntArrayRef input_sizes, int64_t dim, int64_t size, int64_t step) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_in, "wrapper__unfold_backward", "grad_in");

  const OptionalDeviceGuard device_guard(device_of(grad_in));
  return at::native::unfold_backward(grad_in, input_sizes, dim, size, step);
}

} // anonymous namespace
namespace {

bool wrapper__equal(const at::Tensor & self, const at::Tensor & other) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__equal", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper__equal", "other");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::cuda_equal(self, other);
}

} // anonymous namespace
struct structured_pow_Tensor_Tensor_out_functional final : public at::native::structured_pow_Tensor_Tensor_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_pow_Tensor_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_pow_Tensor_Tensor(const at::Tensor & self, const at::Tensor & exponent) {
  // No device check

structured_pow_Tensor_Tensor_out_functional op;
op.meta(self, exponent);
op.impl(self, exponent, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_pow_Tensor_Tensor_out_out final : public at::native::structured_pow_Tensor_Tensor_out {
    structured_pow_Tensor_Tensor_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_pow_Tensor_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_pow_out_Tensor_Tensor_out(const at::Tensor & self, const at::Tensor & exponent, at::Tensor & out) {
  // No device check

structured_pow_Tensor_Tensor_out_out op(out);
op.meta(self, exponent);
op.impl(self, exponent, op.outputs_[0]);
return out;
}
struct structured_pow_Tensor_Tensor_out_inplace final : public at::native::structured_pow_Tensor_Tensor_out {
    structured_pow_Tensor_Tensor_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_pow_Tensor_Tensor_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_pow__Tensor(at::Tensor & self, const at::Tensor & exponent) {
  // No device check

structured_pow_Tensor_Tensor_out_inplace op(self);
op.meta(self, exponent);
op.impl(self, exponent, op.outputs_[0]);
return self;
}
struct structured_pow_Scalar_out_functional final : public at::native::structured_pow_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_pow_Scalar(const at::Scalar & self, const at::Tensor & exponent) {
  // No device check

structured_pow_Scalar_out_functional op;
op.meta(self, exponent);
op.impl(self, exponent, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_pow_Scalar_out_out final : public at::native::structured_pow_Scalar_out {
    structured_pow_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_pow_out_Scalar_out(const at::Scalar & self, const at::Tensor & exponent, at::Tensor & out) {
  // No device check

structured_pow_Scalar_out_out op(out);
op.meta(self, exponent);
op.impl(self, exponent, op.outputs_[0]);
return out;
}
struct structured_pow_Tensor_Scalar_out_functional final : public at::native::structured_pow_Tensor_Scalar_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_pow_Tensor_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_pow_Tensor_Scalar(const at::Tensor & self, const at::Scalar & exponent) {
  // No device check

structured_pow_Tensor_Scalar_out_functional op;
op.meta(self, exponent);
op.impl(self, exponent, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_pow_Tensor_Scalar_out_out final : public at::native::structured_pow_Tensor_Scalar_out {
    structured_pow_Tensor_Scalar_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_pow_Tensor_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_pow_out_Tensor_Scalar_out(const at::Tensor & self, const at::Scalar & exponent, at::Tensor & out) {
  // No device check

structured_pow_Tensor_Scalar_out_out op(out);
op.meta(self, exponent);
op.impl(self, exponent, op.outputs_[0]);
return out;
}
struct structured_pow_Tensor_Scalar_out_inplace final : public at::native::structured_pow_Tensor_Scalar_out {
    structured_pow_Tensor_Scalar_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_pow_Tensor_Scalar_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_pow__Scalar(at::Tensor & self, const at::Scalar & exponent) {
  // No device check

structured_pow_Tensor_Scalar_out_inplace op(self);
op.meta(self, exponent);
op.impl(self, exponent, op.outputs_[0]);
return self;
}
namespace {

at::Tensor & wrapper__normal_(at::Tensor & self, double mean, double std, c10::optional<at::Generator> generator) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::normal_(self, mean, std, generator);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_float_normal_Tensor_float(const at::Tensor & mean, double std, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, mean, "wrapper_Tensor_float_normal_Tensor_float", "mean");

  const OptionalDeviceGuard device_guard(device_of(mean));
  return at::native::normal(mean, std, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_float_out_normal_out_Tensor_float_out(const at::Tensor & mean, double std, c10::optional<at::Generator> generator, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_Tensor_float_out_normal_out_Tensor_float_out", "out");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper_Tensor_float_out_normal_out_Tensor_float_out", "mean");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::normal_out(mean, std, generator, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_float_Tensor_normal_float_Tensor(double mean, const at::Tensor & std, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, std, "wrapper_float_Tensor_normal_float_Tensor", "std");

  const OptionalDeviceGuard device_guard(device_of(std));
  return at::native::normal(mean, std, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_float_Tensor_out_normal_out_float_Tensor_out(double mean, const at::Tensor & std, c10::optional<at::Generator> generator, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_float_Tensor_out_normal_out_float_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, std, "wrapper_float_Tensor_out_normal_out_float_Tensor_out", "std");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::normal_out(mean, std, generator, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_Tensor_normal_Tensor_Tensor(const at::Tensor & mean, const at::Tensor & std, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, mean, "wrapper_Tensor_Tensor_normal_Tensor_Tensor", "mean");
  c10::impl::check_and_update_common_device(common_device, std, "wrapper_Tensor_Tensor_normal_Tensor_Tensor", "std");

  const OptionalDeviceGuard device_guard(device_of(mean));
  return at::native::normal(mean, std, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out(const at::Tensor & mean, const at::Tensor & std, c10::optional<at::Generator> generator, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, mean, "wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out", "mean");
  c10::impl::check_and_update_common_device(common_device, std, "wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out", "std");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::normal_out(mean, std, generator, out);
}

} // anonymous namespace
namespace {

void wrapper___amp_foreach_non_finite_check_and_unscale_(at::TensorList self, at::Tensor & found_inf, const at::Tensor & inv_scale) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___amp_foreach_non_finite_check_and_unscale_", "self");
  c10::impl::check_and_update_common_device(common_device, found_inf, "wrapper___amp_foreach_non_finite_check_and_unscale_", "found_inf");
  c10::impl::check_and_update_common_device(common_device, inv_scale, "wrapper___amp_foreach_non_finite_check_and_unscale_", "inv_scale");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_amp_foreach_non_finite_check_and_unscale_cuda_(self, found_inf, inv_scale);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper___amp_update_scale_(at::Tensor & self, at::Tensor & growth_tracker, const at::Tensor & found_inf, double scale_growth_factor, double scale_backoff_factor, int64_t growth_interval) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___amp_update_scale_", "self");
  c10::impl::check_and_update_common_device(common_device, growth_tracker, "wrapper___amp_update_scale_", "growth_tracker");
  c10::impl::check_and_update_common_device(common_device, found_inf, "wrapper___amp_update_scale_", "found_inf");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_amp_update_scale_cuda_(self, growth_tracker, found_inf, scale_growth_factor, scale_backoff_factor, growth_interval);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___cat(at::TensorList tensors, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, tensors, "wrapper___cat", "tensors");

  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::cat_cuda(tensors, dim);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out__cat_out_out(at::TensorList tensors, int64_t dim, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__cat_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, tensors, "wrapper_out__cat_out_out", "tensors");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::cat_out_cuda(tensors, dim, out);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_add_Scalar(at::TensorList tensors, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_add_scalar_kernel_cuda(tensors, scalar);
}

} // anonymous namespace
namespace {

void wrapper_Scalar__foreach_add__Scalar(at::TensorList self, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_add_scalar_kernel_cuda_(self, scalar);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_sub_Scalar(at::TensorList tensors, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_sub_scalar_kernel_cuda(tensors, scalar);
}

} // anonymous namespace
namespace {

void wrapper_Scalar__foreach_sub__Scalar(at::TensorList self, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sub_scalar_kernel_cuda_(self, scalar);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_mul_Scalar(at::TensorList tensors, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_mul_scalar_kernel_cuda(tensors, scalar);
}

} // anonymous namespace
namespace {

void wrapper_Scalar__foreach_mul__Scalar(at::TensorList self, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_mul_scalar_kernel_cuda_(self, scalar);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_div_Scalar(at::TensorList tensors, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_div_scalar_kernel_cuda(tensors, scalar);
}

} // anonymous namespace
namespace {

void wrapper_Scalar__foreach_div__Scalar(at::TensorList self, const at::Scalar & scalar) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_div_scalar_kernel_cuda_(self, scalar);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_List__foreach_add_List(at::TensorList tensors1, at::TensorList tensors2, const at::Scalar & alpha) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors1));
  return at::native::foreach_tensor_add_list_kernel_cuda(tensors1, tensors2, alpha);
}

} // anonymous namespace
namespace {

void wrapper_List__foreach_add__List(at::TensorList self, at::TensorList other, const at::Scalar & alpha) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_add_list_kernel_cuda_(self, other, alpha);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_List__foreach_sub_List(at::TensorList tensors1, at::TensorList tensors2, const at::Scalar & alpha) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors1));
  return at::native::foreach_tensor_sub_list_kernel_cuda(tensors1, tensors2, alpha);
}

} // anonymous namespace
namespace {

void wrapper_List__foreach_sub__List(at::TensorList self, at::TensorList other, const at::Scalar & alpha) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sub_list_kernel_cuda_(self, other, alpha);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_List__foreach_mul_List(at::TensorList tensors1, at::TensorList tensors2) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors1));
  return at::native::foreach_tensor_mul_list_kernel_cuda(tensors1, tensors2);
}

} // anonymous namespace
namespace {

void wrapper_List__foreach_mul__List(at::TensorList self, at::TensorList other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_mul_list_kernel_cuda_(self, other);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_List__foreach_div_List(at::TensorList tensors1, at::TensorList tensors2) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors1));
  return at::native::foreach_tensor_div_list_kernel_cuda(tensors1, tensors2);
}

} // anonymous namespace
namespace {

void wrapper_List__foreach_div__List(at::TensorList self, at::TensorList other) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_div_list_kernel_cuda_(self, other);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_ScalarList__foreach_add_ScalarList(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_add_scalarlist_kernel_cuda(tensors, scalars);
}

} // anonymous namespace
namespace {

void wrapper_ScalarList__foreach_add__ScalarList(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_add_scalarlist_kernel_cuda_(self, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_ScalarList__foreach_sub_ScalarList(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_sub_scalarlist_kernel_cuda(tensors, scalars);
}

} // anonymous namespace
namespace {

void wrapper_ScalarList__foreach_sub__ScalarList(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sub_scalarlist_kernel_cuda_(self, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_ScalarList__foreach_div_ScalarList(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_div_scalarlist_kernel_cuda(tensors, scalars);
}

} // anonymous namespace
namespace {

void wrapper_ScalarList__foreach_div__ScalarList(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_div_scalarlist_kernel_cuda_(self, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_ScalarList__foreach_mul_ScalarList(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_mul_scalarlist_kernel_cuda(tensors, scalars);
}

} // anonymous namespace
namespace {

void wrapper_ScalarList__foreach_mul__ScalarList(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_mul_scalarlist_kernel_cuda_(self, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_exp(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_exp_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_zero_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_zero_cuda_(self);
}

} // anonymous namespace
namespace {

void wrapper___foreach_exp_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_exp_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_sqrt(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_sqrt_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_sqrt_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sqrt_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_abs(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_abs_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_abs_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_abs_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_acos(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_acos_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_acos_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_acos_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_asin(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_asin_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_asin_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_asin_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_atan(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_atan_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_atan_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_atan_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_ceil(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_ceil_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_ceil_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_ceil_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_cos(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_cos_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_cos_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_cos_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_cosh(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_cosh_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_cosh_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_cosh_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_erf(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_erf_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_erf_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_erf_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_erfc(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_erfc_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_erfc_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_erfc_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_expm1(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_expm1_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_expm1_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_expm1_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_floor(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_floor_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_floor_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_floor_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_log(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_log_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_log_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_log_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_log10(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_log10_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_log10_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_log10_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_log1p(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_log1p_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_log1p_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_log1p_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_log2(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_log2_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_log2_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_log2_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_neg(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_neg_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_neg_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_neg_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_tan(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_tan_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_tan_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_tan_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_tanh(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_tanh_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_tanh_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_tanh_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_sin(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_sin_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_sin_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sin_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_sinh(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_sinh_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_sinh_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sinh_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_round(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_round_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_round_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_round_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_lgamma(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_lgamma_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_lgamma_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_lgamma_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_frac(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_frac_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_frac_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_frac_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_reciprocal(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_reciprocal_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_reciprocal_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_reciprocal_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_sigmoid(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_sigmoid_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_sigmoid_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_sigmoid_cuda_(self);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper___foreach_trunc(at::TensorList tensors) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_trunc_cuda(tensors);
}

} // anonymous namespace
namespace {

void wrapper___foreach_trunc_(at::TensorList self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_trunc_cuda_(self);
}

} // anonymous namespace
namespace {

void wrapper_Scalar__foreach_addcdiv__Scalar(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_addcdiv_scalar_cuda_(self, tensor1, tensor2, value);
}

} // anonymous namespace
namespace {

void wrapper_Scalar__foreach_addcmul__Scalar(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_addcmul_scalar_cuda_(self, tensor1, tensor2, value);
}

} // anonymous namespace
namespace {

void wrapper_ScalarList__foreach_addcdiv__ScalarList(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_addcdiv_scalarlist_cuda_(self, tensor1, tensor2, scalars);
}

} // anonymous namespace
namespace {

void wrapper_ScalarList__foreach_addcmul__ScalarList(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::foreach_tensor_addcmul_scalarlist_cuda_(self, tensor1, tensor2, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_addcdiv_Scalar(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::foreach_tensor_addcdiv_scalar_cuda(input, tensor1, tensor2, value);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_addcmul_Scalar(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::foreach_tensor_addcmul_scalar_cuda(input, tensor1, tensor2, value);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_ScalarList__foreach_addcdiv_ScalarList(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::foreach_tensor_addcdiv_scalarlist_cuda(input, tensor1, tensor2, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_ScalarList__foreach_addcmul_ScalarList(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::foreach_tensor_addcmul_scalarlist_cuda(input, tensor1, tensor2, scalars);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_List__foreach_maximum_List(at::TensorList tensors1, at::TensorList tensors2) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors1));
  return at::native::foreach_tensor_maximum_cuda(tensors1, tensors2);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_List__foreach_minimum_List(at::TensorList tensors1, at::TensorList tensors2) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors1));
  return at::native::foreach_tensor_minimum_cuda(tensors1, tensors2);
}

} // anonymous namespace
namespace {

::std::vector<at::Tensor> wrapper_Scalar__foreach_norm_Scalar(at::TensorList tensors, const at::Scalar & ord) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(tensors));
  return at::native::foreach_tensor_norm_cuda(tensors, ord);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_bucketize_Tensor(const at::Tensor & self, const at::Tensor & boundaries, bool out_int32, bool right) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_bucketize_Tensor", "self");
  c10::impl::check_and_update_common_device(common_device, boundaries, "wrapper_Tensor_bucketize_Tensor", "boundaries");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bucketize_cuda(self, boundaries, out_int32, right);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_out_bucketize_out_Tensor_out(const at::Tensor & self, const at::Tensor & boundaries, bool out_int32, bool right, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_Tensor_out_bucketize_out_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_out_bucketize_out_Tensor_out", "self");
  c10::impl::check_and_update_common_device(common_device, boundaries, "wrapper_Tensor_out_bucketize_out_Tensor_out", "boundaries");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::bucketize_out_cuda(self, boundaries, out_int32, right, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Scalar_bucketize_Scalar(const at::Scalar & self, const at::Tensor & boundaries, bool out_int32, bool right) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, boundaries, "wrapper_Scalar_bucketize_Scalar", "boundaries");

  const OptionalDeviceGuard device_guard(device_of(boundaries));
  return at::native::bucketize_cuda(self, boundaries, out_int32, right);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_searchsorted_Tensor(const at::Tensor & sorted_sequence, const at::Tensor & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, sorted_sequence, "wrapper_Tensor_searchsorted_Tensor", "sorted_sequence");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_searchsorted_Tensor", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::searchsorted_cuda(sorted_sequence, self, out_int32, right, side, sorter);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_out_searchsorted_out_Tensor_out(const at::Tensor & sorted_sequence, const at::Tensor & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_Tensor_out_searchsorted_out_Tensor_out", "out");
  c10::impl::check_and_update_common_device(common_device, sorted_sequence, "wrapper_Tensor_out_searchsorted_out_Tensor_out", "sorted_sequence");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_Tensor_out_searchsorted_out_Tensor_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::searchsorted_out_cuda(sorted_sequence, self, out_int32, right, side, sorter, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___torch_cuda_cu_linker_symbol_op(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___torch_cuda_cu_linker_symbol_op", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_torch_cuda_cu_linker_symbol_op_cuda(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Scalar_searchsorted_Scalar(const at::Tensor & sorted_sequence, const at::Scalar & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, sorted_sequence, "wrapper_Scalar_searchsorted_Scalar", "sorted_sequence");

  const OptionalDeviceGuard device_guard(device_of(sorted_sequence));
  return at::native::searchsorted_cuda(sorted_sequence, self, out_int32, right, side, sorter);
}

} // anonymous namespace
struct structured__convert_indices_from_coo_to_csr_structured_cuda_functional final : public at::native::structured__convert_indices_from_coo_to_csr_structured_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__convert_indices_from_coo_to_csr(const at::Tensor & self, int64_t size, bool out_int32) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__convert_indices_from_coo_to_csr", "self");
structured__convert_indices_from_coo_to_csr_structured_cuda_functional op;
op.meta(self, size, out_int32);
op.impl(self, size, out_int32, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__convert_indices_from_coo_to_csr_structured_cuda_out final : public at::native::structured__convert_indices_from_coo_to_csr_structured_cuda {
    structured__convert_indices_from_coo_to_csr_structured_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__convert_indices_from_coo_to_csr_out_out(const at::Tensor & self, int64_t size, bool out_int32, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__convert_indices_from_coo_to_csr_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__convert_indices_from_coo_to_csr_out_out", "self");
structured__convert_indices_from_coo_to_csr_structured_cuda_out op(out);
op.meta(self, size, out_int32);
op.impl(self, size, out_int32, op.outputs_[0]);
return out;
}
struct structured__convert_indices_from_csr_to_coo_structured_cuda_functional final : public at::native::structured__convert_indices_from_csr_to_coo_structured_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__convert_indices_from_csr_to_coo(const at::Tensor & crow_indices, const at::Tensor & col_indices, bool out_int32, bool transpose) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, crow_indices, "wrapper__convert_indices_from_csr_to_coo", "crow_indices");
  c10::impl::check_and_update_common_device(common_device, col_indices, "wrapper__convert_indices_from_csr_to_coo", "col_indices");
structured__convert_indices_from_csr_to_coo_structured_cuda_functional op;
op.meta(crow_indices, col_indices, out_int32, transpose);
op.impl(crow_indices, col_indices, out_int32, transpose, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__convert_indices_from_csr_to_coo_structured_cuda_out final : public at::native::structured__convert_indices_from_csr_to_coo_structured_cuda {
    structured__convert_indices_from_csr_to_coo_structured_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__convert_indices_from_csr_to_coo_out_out(const at::Tensor & crow_indices, const at::Tensor & col_indices, bool out_int32, bool transpose, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__convert_indices_from_csr_to_coo_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, crow_indices, "wrapper__convert_indices_from_csr_to_coo_out_out", "crow_indices");
  c10::impl::check_and_update_common_device(common_device, col_indices, "wrapper__convert_indices_from_csr_to_coo_out_out", "col_indices");
structured__convert_indices_from_csr_to_coo_structured_cuda_out op(out);
op.meta(crow_indices, col_indices, out_int32, transpose);
op.impl(crow_indices, col_indices, out_int32, transpose, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__mse_loss(const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mse_loss(self, target, reduction);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_mse_loss_out_out(const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mse_loss_out(self, target, reduction, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__mse_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__mse_loss_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__mse_loss_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__mse_loss_backward", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mse_loss_backward(grad_output, self, target, reduction);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_mse_loss_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_mse_loss_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_mse_loss_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_mse_loss_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_mse_loss_backward_out_grad_input", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::mse_loss_backward_out(grad_output, self, target, reduction, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_l1_loss_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_l1_loss_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_l1_loss_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_l1_loss_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_l1_loss_backward_out_grad_input", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::l1_loss_backward_out(grad_output, self, target, reduction, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__multi_margin_loss(const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__multi_margin_loss", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__multi_margin_loss", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__multi_margin_loss", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multi_margin_loss_cuda(self, target, p, margin, weight, reduction);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_multi_margin_loss_out_out(const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_multi_margin_loss_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_multi_margin_loss_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_out_multi_margin_loss_out_out", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_out_multi_margin_loss_out_out", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multi_margin_loss_cuda_out(self, target, p, margin, weight, reduction, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__multi_margin_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__multi_margin_loss_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__multi_margin_loss_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__multi_margin_loss_backward", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__multi_margin_loss_backward", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multi_margin_loss_cuda_backward(grad_output, self, target, p, margin, weight, reduction);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_multi_margin_loss_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_multi_margin_loss_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_multi_margin_loss_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_multi_margin_loss_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_multi_margin_loss_backward_out_grad_input", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_grad_input_multi_margin_loss_backward_out_grad_input", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multi_margin_loss_cuda_backward_out(grad_output, self, target, p, margin, weight, reduction, grad_input);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__multilabel_margin_loss_forward(const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__multilabel_margin_loss_forward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__multilabel_margin_loss_forward", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multilabel_margin_loss_forward_cuda(self, target, reduction);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_output_multilabel_margin_loss_forward_out_output(const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & output, at::Tensor & is_target) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, output, "wrapper_output_multilabel_margin_loss_forward_out_output", "output");
  c10::impl::check_and_update_common_device(common_device, is_target, "wrapper_output_multilabel_margin_loss_forward_out_output", "is_target");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_output_multilabel_margin_loss_forward_out_output", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_output_multilabel_margin_loss_forward_out_output", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multilabel_margin_loss_forward_out_cuda(self, target, reduction, output, is_target);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__multilabel_margin_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, const at::Tensor & is_target) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__multilabel_margin_loss_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__multilabel_margin_loss_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__multilabel_margin_loss_backward", "target");
  c10::impl::check_and_update_common_device(common_device, is_target, "wrapper__multilabel_margin_loss_backward", "is_target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multilabel_margin_loss_backward_cuda(grad_output, self, target, reduction, is_target);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, const at::Tensor & is_target, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input", "target");
  c10::impl::check_and_update_common_device(common_device, is_target, "wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input", "is_target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::multilabel_margin_loss_backward_cuda_out(grad_output, self, target, reduction, is_target, grad_input);
}

} // anonymous namespace
struct structured_nll_loss_forward_out_cuda_functional final : public at::native::structured_nll_loss_forward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_nll_loss_forward(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nll_loss_forward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_nll_loss_forward", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_nll_loss_forward", "weight");
structured_nll_loss_forward_out_cuda_functional op;
op.meta(self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index);
op.impl(self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_nll_loss_forward_out_cuda_out final : public at::native::structured_nll_loss_forward_out_cuda {
    structured_nll_loss_forward_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_nll_loss_forward_out_output(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, at::Tensor & output, at::Tensor & total_weight) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, output, "wrapper_nll_loss_forward_out_output", "output");
  c10::impl::check_and_update_common_device(common_device, total_weight, "wrapper_nll_loss_forward_out_output", "total_weight");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nll_loss_forward_out_output", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_nll_loss_forward_out_output", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_nll_loss_forward_out_output", "weight");
structured_nll_loss_forward_out_cuda_out op(output, total_weight);
op.meta(self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index);
op.impl(self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(output, total_weight);
}
struct structured_nll_loss_backward_out_cuda_functional final : public at::native::structured_nll_loss_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_nll_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_nll_loss_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nll_loss_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_nll_loss_backward", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_nll_loss_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, total_weight, "wrapper_nll_loss_backward", "total_weight");
structured_nll_loss_backward_out_cuda_functional op;
op.meta(grad_output, self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index, total_weight);
op.impl(grad_output, self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index, total_weight, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_nll_loss_backward_out_cuda_out final : public at::native::structured_nll_loss_backward_out_cuda {
    structured_nll_loss_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_nll_loss_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_nll_loss_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_nll_loss_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_nll_loss_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_nll_loss_backward_out_grad_input", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_nll_loss_backward_out_grad_input", "weight");
  c10::impl::check_and_update_common_device(common_device, total_weight, "wrapper_nll_loss_backward_out_grad_input", "total_weight");
structured_nll_loss_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index, total_weight);
op.impl(grad_output, self, target, ((weight.has_value() && (*weight).defined()) ? at::OptionalTensorRef(*weight) : at::OptionalTensorRef()), reduction, ignore_index, total_weight, op.outputs_[0]);
return grad_input;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__nll_loss2d_forward(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__nll_loss2d_forward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__nll_loss2d_forward", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__nll_loss2d_forward", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nll_loss2d_forward_cuda(self, target, weight, reduction, ignore_index);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_output_nll_loss2d_forward_out_output(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, at::Tensor & output, at::Tensor & total_weight) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, output, "wrapper_output_nll_loss2d_forward_out_output", "output");
  c10::impl::check_and_update_common_device(common_device, total_weight, "wrapper_output_nll_loss2d_forward_out_output", "total_weight");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_output_nll_loss2d_forward_out_output", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_output_nll_loss2d_forward_out_output", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_output_nll_loss2d_forward_out_output", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nll_loss2d_forward_out_cuda(self, target, weight, reduction, ignore_index, output, total_weight);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__nll_loss2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__nll_loss2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__nll_loss2d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__nll_loss2d_backward", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__nll_loss2d_backward", "weight");
  c10::impl::check_and_update_common_device(common_device, total_weight, "wrapper__nll_loss2d_backward", "total_weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nll_loss2d_backward_cuda(grad_output, self, target, weight, reduction, ignore_index, total_weight);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_nll_loss2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_nll_loss2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_nll_loss2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_nll_loss2d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_nll_loss2d_backward_out_grad_input", "target");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_grad_input_nll_loss2d_backward_out_grad_input", "weight");
  c10::impl::check_and_update_common_device(common_device, total_weight, "wrapper_grad_input_nll_loss2d_backward_out_grad_input", "total_weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::nll_loss2d_backward_out_cuda(grad_output, self, target, weight, reduction, ignore_index, total_weight, grad_input);
}

} // anonymous namespace
struct structured_smooth_l1_loss_out_functional final : public at::native::structured_smooth_l1_loss_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_smooth_l1_loss_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_smooth_l1_loss(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta) {
  // No device check

structured_smooth_l1_loss_out_functional op;
op.meta(self, target, reduction, beta);
op.impl(self, target, reduction, beta, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_smooth_l1_loss_out_out final : public at::native::structured_smooth_l1_loss_out {
    structured_smooth_l1_loss_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_smooth_l1_loss_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_smooth_l1_loss_out_out(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta, at::Tensor & out) {
  // No device check

structured_smooth_l1_loss_out_out op(out);
op.meta(self, target, reduction, beta);
op.impl(self, target, reduction, beta, op.outputs_[0]);
return out;
}
namespace {

at::Tensor & wrapper_grad_input_smooth_l1_loss_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_smooth_l1_loss_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_smooth_l1_loss_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_smooth_l1_loss_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_grad_input_smooth_l1_loss_backward_out_grad_input", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::smooth_l1_loss_backward_out(grad_output, self, target, reduction, beta, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__huber_loss(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__huber_loss", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper__huber_loss", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::huber_loss(self, target, reduction, delta);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_huber_loss_out_out(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_huber_loss_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_huber_loss_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_out_huber_loss_out_out", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::huber_loss_out(self, target, reduction, delta, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_huber_loss_backward_out_out(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_out_huber_loss_backward_out_out", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_out_huber_loss_backward_out_out", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_huber_loss_backward_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, target, "wrapper_out_huber_loss_backward_out_out", "target");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::huber_loss_backward_out(grad_output, self, target, reduction, delta, grad_input);
}

} // anonymous namespace
struct structured_elu_out_functional final : public at::native::structured_elu_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_elu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_elu(const at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale) {
  // No device check

structured_elu_out_functional op;
op.meta(self, alpha, scale, input_scale);
op.impl(self, alpha, scale, input_scale, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_elu_out_out final : public at::native::structured_elu_out {
    structured_elu_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_elu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_elu_out_out(const at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, at::Tensor & out) {
  // No device check

structured_elu_out_out op(out);
op.meta(self, alpha, scale, input_scale);
op.impl(self, alpha, scale, input_scale, op.outputs_[0]);
return out;
}
struct structured_elu_out_inplace final : public at::native::structured_elu_out {
    structured_elu_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_elu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_elu_(at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale) {
  // No device check

structured_elu_out_inplace op(self);
op.meta(self, alpha, scale, input_scale);
op.impl(self, alpha, scale, input_scale, op.outputs_[0]);
return self;
}
struct structured_elu_backward_out_functional final : public at::native::structured_elu_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_elu_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_elu_backward(const at::Tensor & grad_output, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, bool is_result, const at::Tensor & self_or_result) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_elu_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self_or_result, "wrapper_elu_backward", "self_or_result");
structured_elu_backward_out_functional op;
op.meta(grad_output, alpha, scale, input_scale, is_result, self_or_result);
op.impl(grad_output, alpha, scale, input_scale, is_result, self_or_result, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_elu_backward_out_out final : public at::native::structured_elu_backward_out {
    structured_elu_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_elu_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_elu_backward_out_grad_input(const at::Tensor & grad_output, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, bool is_result, const at::Tensor & self_or_result, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_elu_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_elu_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self_or_result, "wrapper_elu_backward_out_grad_input", "self_or_result");
structured_elu_backward_out_out op(grad_input);
op.meta(grad_output, alpha, scale, input_scale, is_result, self_or_result);
op.impl(grad_output, alpha, scale, input_scale, is_result, self_or_result, op.outputs_[0]);
return grad_input;
}
struct structured_glu_out_functional final : public at::native::structured_glu_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_glu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_glu(const at::Tensor & self, int64_t dim) {
  // No device check

structured_glu_out_functional op;
op.meta(self, dim);
op.impl(self, dim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_glu_out_out final : public at::native::structured_glu_out {
    structured_glu_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_glu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_glu_out_out(const at::Tensor & self, int64_t dim, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_glu_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_glu_out_out", "self");
structured_glu_out_out op(out);
op.meta(self, dim);
op.impl(self, dim, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__glu_backward(const at::Tensor & grad_output, const at::Tensor & self, int64_t dim) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__glu_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__glu_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::glu_backward_cuda(grad_output, self, dim);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_glu_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, int64_t dim, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_glu_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_glu_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_glu_backward_out_grad_input", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::glu_backward_cuda_out(grad_output, self, dim, grad_input);
}

} // anonymous namespace
struct structured_hardsigmoid_out_functional final : public at::native::structured_hardsigmoid_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardsigmoid_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_hardsigmoid(const at::Tensor & self) {
  // No device check

structured_hardsigmoid_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_hardsigmoid_out_out final : public at::native::structured_hardsigmoid_out {
    structured_hardsigmoid_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardsigmoid_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hardsigmoid_out_out(const at::Tensor & self, at::Tensor & out) {
  // No device check

structured_hardsigmoid_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_hardsigmoid_out_inplace final : public at::native::structured_hardsigmoid_out {
    structured_hardsigmoid_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardsigmoid_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hardsigmoid_(at::Tensor & self) {
  // No device check

structured_hardsigmoid_out_inplace op(self);
op.meta(self);
op.impl(self, op.outputs_[0]);
return self;
}
struct structured_hardsigmoid_backward_out_functional final : public at::native::structured_hardsigmoid_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardsigmoid_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_hardsigmoid_backward(const at::Tensor & grad_output, const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_hardsigmoid_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hardsigmoid_backward", "self");
structured_hardsigmoid_backward_out_functional op;
op.meta(grad_output, self);
op.impl(grad_output, self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_hardsigmoid_backward_out_out final : public at::native::structured_hardsigmoid_backward_out {
    structured_hardsigmoid_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_hardsigmoid_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_hardsigmoid_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_hardsigmoid_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_hardsigmoid_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_hardsigmoid_backward_out_grad_input", "self");
structured_hardsigmoid_backward_out_out op(grad_input);
op.meta(grad_output, self);
op.impl(grad_output, self, op.outputs_[0]);
return grad_input;
}
namespace {

at::Tensor wrapper__hardtanh(const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardtanh(self, min_val, max_val);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_hardtanh_out_out(const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardtanh_out(self, min_val, max_val, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__hardtanh_(at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardtanh_(self, min_val, max_val);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__hardtanh_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__hardtanh_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__hardtanh_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardtanh_backward(grad_output, self, min_val, max_val);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_hardtanh_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_hardtanh_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_hardtanh_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_hardtanh_backward_out_grad_input", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardtanh_backward_out(grad_output, self, min_val, max_val, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__hardswish(const at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardswish(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_hardswish_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardswish_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__hardswish_(at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardswish_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__hardswish_backward(const at::Tensor & grad_output, const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__hardswish_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__hardswish_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::hardswish_backward(grad_output, self);
}

} // anonymous namespace
struct structured_leaky_relu_out_functional final : public at::native::structured_leaky_relu_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_leaky_relu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_leaky_relu(const at::Tensor & self, const at::Scalar & negative_slope) {
  // No device check

structured_leaky_relu_out_functional op;
op.meta(self, negative_slope);
op.impl(self, negative_slope, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_leaky_relu_out_out final : public at::native::structured_leaky_relu_out {
    structured_leaky_relu_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_leaky_relu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_leaky_relu_out_out(const at::Tensor & self, const at::Scalar & negative_slope, at::Tensor & out) {
  // No device check

structured_leaky_relu_out_out op(out);
op.meta(self, negative_slope);
op.impl(self, negative_slope, op.outputs_[0]);
return out;
}
struct structured_leaky_relu_out_inplace final : public at::native::structured_leaky_relu_out {
    structured_leaky_relu_out_inplace(Tensor& self) : outputs_{std::ref(self)} {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        check_inplace(out, sizes, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_leaky_relu_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_leaky_relu_(at::Tensor & self, const at::Scalar & negative_slope) {
  // No device check

structured_leaky_relu_out_inplace op(self);
op.meta(self, negative_slope);
op.impl(self, negative_slope, op.outputs_[0]);
return self;
}
struct structured_leaky_relu_backward_out_functional final : public at::native::structured_leaky_relu_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_leaky_relu_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_leaky_relu_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & negative_slope, bool self_is_result) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_leaky_relu_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_leaky_relu_backward", "self");
structured_leaky_relu_backward_out_functional op;
op.meta(grad_output, self, negative_slope, self_is_result);
op.impl(grad_output, self, negative_slope, self_is_result, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_leaky_relu_backward_out_out final : public at::native::structured_leaky_relu_backward_out {
    structured_leaky_relu_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_leaky_relu_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_leaky_relu_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & negative_slope, bool self_is_result, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_leaky_relu_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_leaky_relu_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_leaky_relu_backward_out_grad_input", "self");
structured_leaky_relu_backward_out_out op(grad_input);
op.meta(grad_output, self, negative_slope, self_is_result);
op.impl(grad_output, self, negative_slope, self_is_result, op.outputs_[0]);
return grad_input;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__log_sigmoid_forward(const at::Tensor & self) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::log_sigmoid_forward_cuda(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_output_log_sigmoid_forward_out_output(const at::Tensor & self, at::Tensor & output, at::Tensor & buffer) {
    // No device check


  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::log_sigmoid_forward_out_cuda(self, output, buffer);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__log_sigmoid_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & buffer) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__log_sigmoid_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__log_sigmoid_backward", "self");
  c10::impl::check_and_update_common_device(common_device, buffer, "wrapper__log_sigmoid_backward", "buffer");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::log_sigmoid_backward_cuda(grad_output, self, buffer);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_log_sigmoid_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & buffer, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_log_sigmoid_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_log_sigmoid_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_log_sigmoid_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, buffer, "wrapper_grad_input_log_sigmoid_backward_out_grad_input", "buffer");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::log_sigmoid_backward_cuda_out(grad_output, self, buffer, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__rrelu_with_noise(const at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__rrelu_with_noise", "self");
  c10::impl::check_and_update_common_device(common_device, noise, "wrapper__rrelu_with_noise", "noise");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::rrelu_with_noise_cuda(self, noise, lower, upper, training, generator);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_rrelu_with_noise_out_out(const at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_rrelu_with_noise_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_rrelu_with_noise_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, noise, "wrapper_out_rrelu_with_noise_out_out", "noise");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::rrelu_with_noise_out_cuda(self, noise, lower, upper, training, generator, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__rrelu_with_noise_(at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__rrelu_with_noise_", "self");
  c10::impl::check_and_update_common_device(common_device, noise, "wrapper__rrelu_with_noise_", "noise");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::rrelu_with_noise_cuda_(self, noise, lower, upper, training, generator);
}

} // anonymous namespace
struct structured_softplus_out_functional final : public at::native::structured_softplus_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softplus_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_softplus(const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold) {
  // No device check

structured_softplus_out_functional op;
op.meta(self, beta, threshold);
op.impl(self, beta, threshold, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_softplus_out_out final : public at::native::structured_softplus_out {
    structured_softplus_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softplus_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_softplus_out_out(const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold, at::Tensor & out) {
  // No device check

structured_softplus_out_out op(out);
op.meta(self, beta, threshold);
op.impl(self, beta, threshold, op.outputs_[0]);
return out;
}
struct structured_softplus_backward_out_functional final : public at::native::structured_softplus_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softplus_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_softplus_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_softplus_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_softplus_backward", "self");
structured_softplus_backward_out_functional op;
op.meta(grad_output, self, beta, threshold);
op.impl(grad_output, self, beta, threshold, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_softplus_backward_out_out final : public at::native::structured_softplus_backward_out {
    structured_softplus_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softplus_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_softplus_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_softplus_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_softplus_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_softplus_backward_out_grad_input", "self");
structured_softplus_backward_out_out op(grad_input);
op.meta(grad_output, self, beta, threshold);
op.impl(grad_output, self, beta, threshold, op.outputs_[0]);
return grad_input;
}
struct structured_softshrink_out_functional final : public at::native::structured_softshrink_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softshrink_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_softshrink(const at::Tensor & self, const at::Scalar & lambd) {
  // No device check

structured_softshrink_out_functional op;
op.meta(self, lambd);
op.impl(self, lambd, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_softshrink_out_out final : public at::native::structured_softshrink_out {
    structured_softshrink_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softshrink_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_softshrink_out_out(const at::Tensor & self, const at::Scalar & lambd, at::Tensor & out) {
  // No device check

structured_softshrink_out_out op(out);
op.meta(self, lambd);
op.impl(self, lambd, op.outputs_[0]);
return out;
}
struct structured_softshrink_backward_out_functional final : public at::native::structured_softshrink_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softshrink_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_softshrink_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & lambd) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_softshrink_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_softshrink_backward", "self");
structured_softshrink_backward_out_functional op;
op.meta(grad_output, self, lambd);
op.impl(grad_output, self, lambd, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_softshrink_backward_out_out final : public at::native::structured_softshrink_backward_out {
    structured_softshrink_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_softshrink_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_softshrink_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & lambd, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_softshrink_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_softshrink_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_softshrink_backward_out_grad_input", "self");
structured_softshrink_backward_out_out op(grad_input);
op.meta(grad_output, self, lambd);
op.impl(grad_output, self, lambd, op.outputs_[0]);
return grad_input;
}
namespace {

at::Tensor & wrapper_out_adaptive_avg_pool2d_out_out(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_adaptive_avg_pool2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_adaptive_avg_pool2d_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool2d_out_cuda(self, output_size, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___adaptive_avg_pool2d(const at::Tensor & self, at::IntArrayRef output_size) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___adaptive_avg_pool2d", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool2d_cuda(self, output_size);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___adaptive_avg_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper___adaptive_avg_pool2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper___adaptive_avg_pool2d_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool2d_backward_cuda(grad_output, self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_adaptive_avg_pool3d_out_out(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_adaptive_avg_pool3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_adaptive_avg_pool3d_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool3d_out_cuda(self, output_size, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___adaptive_avg_pool3d(const at::Tensor & self, at::IntArrayRef output_size) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___adaptive_avg_pool3d", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool3d_cuda(self, output_size);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool3d_backward_out_cuda(grad_output, self, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___adaptive_avg_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper___adaptive_avg_pool3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper___adaptive_avg_pool3d_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::adaptive_avg_pool3d_backward_cuda(grad_output, self);
}

} // anonymous namespace
struct structured_adaptive_max_pool2d_out_cuda_functional final : public at::native::structured_adaptive_max_pool2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_adaptive_max_pool2d(const at::Tensor & self, at::IntArrayRef output_size) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool2d", "self");
structured_adaptive_max_pool2d_out_cuda_functional op;
op.meta(self, output_size);
op.impl(self, output_size, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_adaptive_max_pool2d_out_cuda_out final : public at::native::structured_adaptive_max_pool2d_out_cuda {
    structured_adaptive_max_pool2d_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_adaptive_max_pool2d_out_out(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out, at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_adaptive_max_pool2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_adaptive_max_pool2d_out_out", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool2d_out_out", "self");
structured_adaptive_max_pool2d_out_cuda_out op(out, indices);
op.meta(self, output_size);
op.impl(self, output_size, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(out, indices);
}
struct structured_adaptive_max_pool2d_backward_out_cuda_functional final : public at::native::structured_adaptive_max_pool2d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_adaptive_max_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_adaptive_max_pool2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool2d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_adaptive_max_pool2d_backward", "indices");
structured_adaptive_max_pool2d_backward_out_cuda_functional op;
op.meta(grad_output, self, indices);
op.impl(grad_output, self, indices, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_adaptive_max_pool2d_backward_out_cuda_out final : public at::native::structured_adaptive_max_pool2d_backward_out_cuda {
    structured_adaptive_max_pool2d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_adaptive_max_pool2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_adaptive_max_pool2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_adaptive_max_pool2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool2d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_adaptive_max_pool2d_backward_out_grad_input", "indices");
structured_adaptive_max_pool2d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, indices);
op.impl(grad_output, self, indices, op.outputs_[0]);
return grad_input;
}
struct structured_adaptive_max_pool3d_out_cuda_functional final : public at::native::structured_adaptive_max_pool3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_adaptive_max_pool3d(const at::Tensor & self, at::IntArrayRef output_size) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool3d", "self");
structured_adaptive_max_pool3d_out_cuda_functional op;
op.meta(self, output_size);
op.impl(self, output_size, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_adaptive_max_pool3d_out_cuda_out final : public at::native::structured_adaptive_max_pool3d_out_cuda {
    structured_adaptive_max_pool3d_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_adaptive_max_pool3d_out_out(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out, at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_adaptive_max_pool3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_adaptive_max_pool3d_out_out", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool3d_out_out", "self");
structured_adaptive_max_pool3d_out_cuda_out op(out, indices);
op.meta(self, output_size);
op.impl(self, output_size, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(out, indices);
}
struct structured_adaptive_max_pool3d_backward_out_cuda_functional final : public at::native::structured_adaptive_max_pool3d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_adaptive_max_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_adaptive_max_pool3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool3d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_adaptive_max_pool3d_backward", "indices");
structured_adaptive_max_pool3d_backward_out_cuda_functional op;
op.meta(grad_output, self, indices);
op.impl(grad_output, self, indices, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_adaptive_max_pool3d_backward_out_cuda_out final : public at::native::structured_adaptive_max_pool3d_backward_out_cuda {
    structured_adaptive_max_pool3d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_adaptive_max_pool3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_adaptive_max_pool3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_adaptive_max_pool3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_adaptive_max_pool3d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_adaptive_max_pool3d_backward_out_grad_input", "indices");
structured_adaptive_max_pool3d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, indices);
op.impl(grad_output, self, indices, op.outputs_[0]);
return grad_input;
}
struct structured_avg_pool2d_out_cuda_functional final : public at::native::structured_avg_pool2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_avg_pool2d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool2d", "self");
structured_avg_pool2d_out_cuda_functional op;
auto precompute = op.meta(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
(void)precompute;
op.impl(self, precompute.kH, precompute.kW, precompute.dH, precompute.dW, precompute.padH, precompute.padW, ceil_mode, count_include_pad, divisor_override, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_avg_pool2d_out_cuda_out final : public at::native::structured_avg_pool2d_out_cuda {
    structured_avg_pool2d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_avg_pool2d_out_out(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_avg_pool2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool2d_out_out", "self");
structured_avg_pool2d_out_cuda_out op(out);
auto precompute = op.meta(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
(void)precompute;
op.impl(self, precompute.kH, precompute.kW, precompute.dH, precompute.dW, precompute.padH, precompute.padW, ceil_mode, count_include_pad, divisor_override, op.outputs_[0]);
return out;
}
struct structured_avg_pool2d_backward_out_cuda_functional final : public at::native::structured_avg_pool2d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_avg_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_avg_pool2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool2d_backward", "self");
structured_avg_pool2d_backward_out_cuda_functional op;
op.meta(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
op.impl(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_avg_pool2d_backward_out_cuda_out final : public at::native::structured_avg_pool2d_backward_out_cuda {
    structured_avg_pool2d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_avg_pool2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_avg_pool2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_avg_pool2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool2d_backward_out_grad_input", "self");
structured_avg_pool2d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
op.impl(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, op.outputs_[0]);
return grad_input;
}
struct structured_avg_pool3d_out_cuda_functional final : public at::native::structured_avg_pool3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_avg_pool3d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool3d", "self");
structured_avg_pool3d_out_cuda_functional op;
op.meta(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
op.impl(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_avg_pool3d_out_cuda_out final : public at::native::structured_avg_pool3d_out_cuda {
    structured_avg_pool3d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_avg_pool3d_out_out(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_avg_pool3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool3d_out_out", "self");
structured_avg_pool3d_out_cuda_out op(out);
op.meta(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
op.impl(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, op.outputs_[0]);
return out;
}
struct structured_avg_pool3d_backward_out_cuda_functional final : public at::native::structured_avg_pool3d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_avg_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_avg_pool3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool3d_backward", "self");
structured_avg_pool3d_backward_out_cuda_functional op;
op.meta(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
op.impl(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_avg_pool3d_backward_out_cuda_out final : public at::native::structured_avg_pool3d_backward_out_cuda {
    structured_avg_pool3d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_avg_pool3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_avg_pool3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_avg_pool3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_avg_pool3d_backward_out_grad_input", "self");
structured_avg_pool3d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
op.impl(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, op.outputs_[0]);
return grad_input;
}
struct structured_fractional_max_pool2d_out_cuda_functional final : public at::native::structured_fractional_max_pool2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_fractional_max_pool2d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_fractional_max_pool2d", "self");
  c10::impl::check_and_update_common_device(common_device, random_samples, "wrapper_fractional_max_pool2d", "random_samples");
structured_fractional_max_pool2d_out_cuda_functional op;
op.meta(self, kernel_size, output_size, random_samples);
op.impl(self, kernel_size, output_size, random_samples, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_fractional_max_pool2d_out_cuda_out final : public at::native::structured_fractional_max_pool2d_out_cuda {
    structured_fractional_max_pool2d_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_fractional_max_pool2d_out_output(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples, at::Tensor & output, at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, output, "wrapper_fractional_max_pool2d_out_output", "output");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_fractional_max_pool2d_out_output", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_fractional_max_pool2d_out_output", "self");
  c10::impl::check_and_update_common_device(common_device, random_samples, "wrapper_fractional_max_pool2d_out_output", "random_samples");
structured_fractional_max_pool2d_out_cuda_out op(output, indices);
op.meta(self, kernel_size, output_size, random_samples);
op.impl(self, kernel_size, output_size, random_samples, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(output, indices);
}
struct structured_fractional_max_pool2d_backward_cuda_functional final : public at::native::structured_fractional_max_pool2d_backward_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_fractional_max_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_fractional_max_pool2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_fractional_max_pool2d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_fractional_max_pool2d_backward", "indices");
structured_fractional_max_pool2d_backward_cuda_functional op;
op.meta(grad_output, self, kernel_size, output_size, indices);
op.impl(grad_output, self, kernel_size, output_size, indices, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_fractional_max_pool2d_backward_cuda_out final : public at::native::structured_fractional_max_pool2d_backward_cuda {
    structured_fractional_max_pool2d_backward_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_fractional_max_pool2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_fractional_max_pool2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_fractional_max_pool2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_fractional_max_pool2d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_fractional_max_pool2d_backward_out_grad_input", "indices");
structured_fractional_max_pool2d_backward_cuda_out op(grad_input);
op.meta(grad_output, self, kernel_size, output_size, indices);
op.impl(grad_output, self, kernel_size, output_size, indices, op.outputs_[0]);
return grad_input;
}
struct structured_fractional_max_pool3d_out_cuda_functional final : public at::native::structured_fractional_max_pool3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_fractional_max_pool3d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_fractional_max_pool3d", "self");
  c10::impl::check_and_update_common_device(common_device, random_samples, "wrapper_fractional_max_pool3d", "random_samples");
structured_fractional_max_pool3d_out_cuda_functional op;
auto precompute = op.meta(self, kernel_size, output_size, random_samples);
(void)precompute;
op.impl(self, precompute.poolSizeT, precompute.poolSizeH, precompute.poolSizeW, precompute.outputT, precompute.outputH, precompute.outputW, random_samples, precompute.numBatch, precompute.numPlanes, precompute.inputT, precompute.inputH, precompute.inputW, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_fractional_max_pool3d_out_cuda_out final : public at::native::structured_fractional_max_pool3d_out_cuda {
    structured_fractional_max_pool3d_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_fractional_max_pool3d_out_output(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples, at::Tensor & output, at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, output, "wrapper_fractional_max_pool3d_out_output", "output");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_fractional_max_pool3d_out_output", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_fractional_max_pool3d_out_output", "self");
  c10::impl::check_and_update_common_device(common_device, random_samples, "wrapper_fractional_max_pool3d_out_output", "random_samples");
structured_fractional_max_pool3d_out_cuda_out op(output, indices);
auto precompute = op.meta(self, kernel_size, output_size, random_samples);
(void)precompute;
op.impl(self, precompute.poolSizeT, precompute.poolSizeH, precompute.poolSizeW, precompute.outputT, precompute.outputH, precompute.outputW, random_samples, precompute.numBatch, precompute.numPlanes, precompute.inputT, precompute.inputH, precompute.inputW, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(output, indices);
}
namespace {

at::Tensor wrapper__fractional_max_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__fractional_max_pool3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__fractional_max_pool3d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__fractional_max_pool3d_backward", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fractional_max_pool3d_backward_cuda(grad_output, self, kernel_size, output_size, indices);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::fractional_max_pool3d_backward_out_cuda(grad_output, self, kernel_size, output_size, indices, grad_input);
}

} // anonymous namespace
struct structured_max_pool2d_with_indices_out_cuda_functional final : public at::native::structured_max_pool2d_with_indices_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor> wrapper_max_pool2d_with_indices(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_max_pool2d_with_indices", "self");
structured_max_pool2d_with_indices_out_cuda_functional op;
op.meta(self, kernel_size, stride, padding, dilation, ceil_mode);
op.impl(self, kernel_size, stride, padding, dilation, ceil_mode, *op.outputs_[0], *op.outputs_[1]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take());
}
struct structured_max_pool2d_with_indices_out_cuda_out final : public at::native::structured_max_pool2d_with_indices_out_cuda {
    structured_max_pool2d_with_indices_out_cuda_out(Tensor& out0, Tensor& out1) : outputs_{ std::ref(out0), std::ref(out1) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 2> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &> wrapper_max_pool2d_with_indices_out_out(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, at::Tensor & out, at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_max_pool2d_with_indices_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_max_pool2d_with_indices_out_out", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_max_pool2d_with_indices_out_out", "self");
structured_max_pool2d_with_indices_out_cuda_out op(out, indices);
op.meta(self, kernel_size, stride, padding, dilation, ceil_mode);
op.impl(self, kernel_size, stride, padding, dilation, ceil_mode, op.outputs_[0], op.outputs_[1]);
return std::forward_as_tuple(out, indices);
}
struct structured_max_pool2d_with_indices_backward_out_cuda_functional final : public at::native::structured_max_pool2d_with_indices_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_max_pool2d_with_indices_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_max_pool2d_with_indices_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_max_pool2d_with_indices_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_max_pool2d_with_indices_backward", "indices");
structured_max_pool2d_with_indices_backward_out_cuda_functional op;
op.meta(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices);
op.impl(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_max_pool2d_with_indices_backward_out_cuda_out final : public at::native::structured_max_pool2d_with_indices_backward_out_cuda {
    structured_max_pool2d_with_indices_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_max_pool2d_with_indices_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_max_pool2d_with_indices_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_max_pool2d_with_indices_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_max_pool2d_with_indices_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_max_pool2d_with_indices_backward_out_grad_input", "indices");
structured_max_pool2d_with_indices_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices);
op.impl(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, op.outputs_[0]);
return grad_input;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__max_pool3d_with_indices(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__max_pool3d_with_indices", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_pool3d_with_indices_cuda(self, kernel_size, stride, padding, dilation, ceil_mode);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_out_max_pool3d_with_indices_out_out(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, at::Tensor & out, at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_max_pool3d_with_indices_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_out_max_pool3d_with_indices_out_out", "indices");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_max_pool3d_with_indices_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_pool3d_with_indices_out_cuda(self, kernel_size, stride, padding, dilation, ceil_mode, out, indices);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__max_pool3d_with_indices_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__max_pool3d_with_indices_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__max_pool3d_with_indices_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__max_pool3d_with_indices_backward", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_pool3d_with_indices_backward_cuda(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_pool3d_with_indices_backward_out_cuda(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__max_unpool2d(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__max_unpool2d", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__max_unpool2d", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling2d_forward_cuda(self, indices, output_size);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_max_unpool2d_out_out(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_max_unpool2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_max_unpool2d_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_out_max_unpool2d_out_out", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling2d_forward_out_cuda(self, indices, output_size, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__max_unpool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__max_unpool2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__max_unpool2d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__max_unpool2d_backward", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling2d_backward_cuda(grad_output, self, indices, output_size);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_max_unpool2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_max_unpool2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_max_unpool2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_max_unpool2d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_grad_input_max_unpool2d_backward_out_grad_input", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling2d_backward_out_cuda(grad_output, self, indices, output_size, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__max_unpool3d(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__max_unpool3d", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__max_unpool3d", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling3d_forward_cuda(self, indices, output_size, stride, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_max_unpool3d_out_out(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_max_unpool3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_max_unpool3d_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_out_max_unpool3d_out_out", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling3d_forward_out_cuda(self, indices, output_size, stride, padding, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__max_unpool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__max_unpool3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__max_unpool3d_backward", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper__max_unpool3d_backward", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling3d_backward_cuda(grad_output, self, indices, output_size, stride, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_max_unpool3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_max_unpool3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_max_unpool3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_max_unpool3d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, indices, "wrapper_grad_input_max_unpool3d_backward_out_grad_input", "indices");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::max_unpooling3d_backward_out_cuda(grad_output, self, indices, output_size, stride, padding, grad_input);
}

} // anonymous namespace
struct structured_reflection_pad1d_out_cuda_functional final : public at::native::structured_reflection_pad1d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_reflection_pad1d(const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad1d", "self");
structured_reflection_pad1d_out_cuda_functional op;
op.meta(self, padding);
op.impl(self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_reflection_pad1d_out_cuda_out final : public at::native::structured_reflection_pad1d_out_cuda {
    structured_reflection_pad1d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_reflection_pad1d_out_out(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_reflection_pad1d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad1d_out_out", "self");
structured_reflection_pad1d_out_cuda_out op(out);
op.meta(self, padding);
op.impl(self, padding, op.outputs_[0]);
return out;
}
struct structured_reflection_pad1d_backward_out_cuda_functional final : public at::native::structured_reflection_pad1d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_reflection_pad1d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_reflection_pad1d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad1d_backward", "self");
structured_reflection_pad1d_backward_out_cuda_functional op;
op.meta(grad_output, self, padding);
op.impl(grad_output, self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_reflection_pad1d_backward_out_cuda_out final : public at::native::structured_reflection_pad1d_backward_out_cuda {
    structured_reflection_pad1d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_reflection_pad1d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_reflection_pad1d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_reflection_pad1d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad1d_backward_out_grad_input", "self");
structured_reflection_pad1d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, padding);
op.impl(grad_output, self, padding, op.outputs_[0]);
return grad_input;
}
namespace {

at::Tensor wrapper__reflection_pad2d(const at::Tensor & self, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__reflection_pad2d", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::reflection_pad2d_cuda(self, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_reflection_pad2d_out_out(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_reflection_pad2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_reflection_pad2d_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::reflection_pad2d_out_cuda(self, padding, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__reflection_pad2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__reflection_pad2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__reflection_pad2d_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::reflection_pad2d_backward_cuda(grad_output, self, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_reflection_pad2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_reflection_pad2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_reflection_pad2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_reflection_pad2d_backward_out_grad_input", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::reflection_pad2d_backward_out_cuda(grad_output, self, padding, grad_input);
}

} // anonymous namespace
struct structured_reflection_pad3d_out_cuda_functional final : public at::native::structured_reflection_pad3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_reflection_pad3d(const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad3d", "self");
structured_reflection_pad3d_out_cuda_functional op;
op.meta(self, padding);
op.impl(self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_reflection_pad3d_out_cuda_out final : public at::native::structured_reflection_pad3d_out_cuda {
    structured_reflection_pad3d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_reflection_pad3d_out_out(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_reflection_pad3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad3d_out_out", "self");
structured_reflection_pad3d_out_cuda_out op(out);
op.meta(self, padding);
op.impl(self, padding, op.outputs_[0]);
return out;
}
struct structured_reflection_pad3d_backward_out_cuda_functional final : public at::native::structured_reflection_pad3d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_reflection_pad3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_reflection_pad3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad3d_backward", "self");
structured_reflection_pad3d_backward_out_cuda_functional op;
op.meta(grad_output, self, padding);
op.impl(grad_output, self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_reflection_pad3d_backward_out_cuda_out final : public at::native::structured_reflection_pad3d_backward_out_cuda {
    structured_reflection_pad3d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_reflection_pad3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_reflection_pad3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_reflection_pad3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_reflection_pad3d_backward_out_grad_input", "self");
structured_reflection_pad3d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, padding);
op.impl(grad_output, self, padding, op.outputs_[0]);
return grad_input;
}
struct structured_replication_pad1d_out_cuda_functional final : public at::native::structured_replication_pad1d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_replication_pad1d(const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad1d", "self");
structured_replication_pad1d_out_cuda_functional op;
op.meta(self, padding);
op.impl(self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_replication_pad1d_out_cuda_out final : public at::native::structured_replication_pad1d_out_cuda {
    structured_replication_pad1d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_replication_pad1d_out_out(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_replication_pad1d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad1d_out_out", "self");
structured_replication_pad1d_out_cuda_out op(out);
op.meta(self, padding);
op.impl(self, padding, op.outputs_[0]);
return out;
}
struct structured_replication_pad1d_backward_out_cuda_functional final : public at::native::structured_replication_pad1d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_replication_pad1d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_replication_pad1d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad1d_backward", "self");
structured_replication_pad1d_backward_out_cuda_functional op;
op.meta(grad_output, self, padding);
op.impl(grad_output, self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_replication_pad1d_backward_out_cuda_out final : public at::native::structured_replication_pad1d_backward_out_cuda {
    structured_replication_pad1d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_replication_pad1d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_replication_pad1d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_replication_pad1d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad1d_backward_out_grad_input", "self");
structured_replication_pad1d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, self, padding);
op.impl(grad_output, self, padding, op.outputs_[0]);
return grad_input;
}
struct structured_replication_pad2d_out_cuda_functional final : public at::native::structured_replication_pad2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_replication_pad2d(const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad2d", "self");
structured_replication_pad2d_out_cuda_functional op;
op.meta(self, padding);
op.impl(self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_replication_pad2d_out_cuda_out final : public at::native::structured_replication_pad2d_out_cuda {
    structured_replication_pad2d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_replication_pad2d_out_out(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_replication_pad2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad2d_out_out", "self");
structured_replication_pad2d_out_cuda_out op(out);
op.meta(self, padding);
op.impl(self, padding, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__replication_pad2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__replication_pad2d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__replication_pad2d_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::replication_pad2d_backward_cuda(grad_output, self, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_replication_pad2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_replication_pad2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_replication_pad2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_replication_pad2d_backward_out_grad_input", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::replication_pad2d_backward_out_cuda(grad_output, self, padding, grad_input);
}

} // anonymous namespace
struct structured_replication_pad3d_out_cuda_functional final : public at::native::structured_replication_pad3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_replication_pad3d(const at::Tensor & self, at::IntArrayRef padding) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad3d", "self");
structured_replication_pad3d_out_cuda_functional op;
op.meta(self, padding);
op.impl(self, padding, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_replication_pad3d_out_cuda_out final : public at::native::structured_replication_pad3d_out_cuda {
    structured_replication_pad3d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_replication_pad3d_out_out(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_replication_pad3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_replication_pad3d_out_out", "self");
structured_replication_pad3d_out_cuda_out op(out);
op.meta(self, padding);
op.impl(self, padding, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__replication_pad3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__replication_pad3d_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__replication_pad3d_backward", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::replication_pad3d_backward_cuda(grad_output, self, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_replication_pad3d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_replication_pad3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_replication_pad3d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input_replication_pad3d_backward_out_grad_input", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::replication_pad3d_backward_out_cuda(grad_output, self, padding, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_vec_upsample_nearest3d_vec(const at::Tensor & input, c10::optional<at::IntArrayRef> output_size, c10::optional<at::ArrayRef<double>> scale_factors) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper_vec_upsample_nearest3d_vec", "input");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::upsample_nearest3d_cuda(input, output_size, scale_factors);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_vec__upsample_nearest_exact3d_vec(const at::Tensor & input, c10::optional<at::IntArrayRef> output_size, c10::optional<at::ArrayRef<double>> scale_factors) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper_vec__upsample_nearest_exact3d_vec", "input");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::_upsample_nearest_exact3d_cuda(input, output_size, scale_factors);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_vec_upsample_nearest3d_backward_vec(const at::Tensor & grad_output, c10::optional<at::IntArrayRef> output_size, at::IntArrayRef input_size, c10::optional<at::ArrayRef<double>> scale_factors) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_vec_upsample_nearest3d_backward_vec", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::upsample_nearest3d_backward_cuda(grad_output, output_size, input_size, scale_factors);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_vec__upsample_nearest_exact3d_backward_vec(const at::Tensor & grad_output, c10::optional<at::IntArrayRef> output_size, at::IntArrayRef input_size, c10::optional<at::ArrayRef<double>> scale_factors) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_vec__upsample_nearest_exact3d_backward_vec", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::_upsample_nearest_exact3d_backward_cuda(grad_output, output_size, input_size, scale_factors);
}

} // anonymous namespace
struct structured_upsample_linear1d_out_cuda_functional final : public at::native::structured_upsample_linear1d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_linear1d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_linear1d", "self");
structured_upsample_linear1d_out_cuda_functional op;
op.meta(self, output_size, align_corners, scales);
op.impl(self, output_size, align_corners, scales, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_linear1d_out_cuda_out final : public at::native::structured_upsample_linear1d_out_cuda {
    structured_upsample_linear1d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_linear1d_out_out(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_linear1d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_linear1d_out_out", "self");
structured_upsample_linear1d_out_cuda_out op(out);
op.meta(self, output_size, align_corners, scales);
op.impl(self, output_size, align_corners, scales, op.outputs_[0]);
return out;
}
struct structured_upsample_linear1d_backward_out_cuda_functional final : public at::native::structured_upsample_linear1d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_linear1d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_linear1d_backward", "grad_output");
structured_upsample_linear1d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, align_corners, scales);
op.impl(grad_output, output_size, input_size, align_corners, scales, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_linear1d_backward_out_cuda_out final : public at::native::structured_upsample_linear1d_backward_out_cuda {
    structured_upsample_linear1d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_linear1d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_linear1d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_linear1d_backward_out_grad_input", "grad_output");
structured_upsample_linear1d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, align_corners, scales);
op.impl(grad_output, output_size, input_size, align_corners, scales, op.outputs_[0]);
return grad_input;
}
struct structured_upsample_bilinear2d_out_cuda_functional final : public at::native::structured_upsample_bilinear2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_bilinear2d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_bilinear2d", "self");
structured_upsample_bilinear2d_out_cuda_functional op;
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_bilinear2d_out_cuda_out final : public at::native::structured_upsample_bilinear2d_out_cuda {
    structured_upsample_bilinear2d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_bilinear2d_out_out(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_bilinear2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_bilinear2d_out_out", "self");
structured_upsample_bilinear2d_out_cuda_out op(out);
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured_upsample_bilinear2d_backward_out_cuda_functional final : public at::native::structured_upsample_bilinear2d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_bilinear2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_bilinear2d_backward", "grad_output");
structured_upsample_bilinear2d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_bilinear2d_backward_out_cuda_out final : public at::native::structured_upsample_bilinear2d_backward_out_cuda {
    structured_upsample_bilinear2d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_bilinear2d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_bilinear2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_bilinear2d_backward_out_grad_input", "grad_output");
structured_upsample_bilinear2d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured__upsample_bilinear2d_aa_out_cuda_functional final : public at::native::structured__upsample_bilinear2d_aa_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_bilinear2d_aa(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_bilinear2d_aa", "self");
structured__upsample_bilinear2d_aa_out_cuda_functional op;
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_bilinear2d_aa_out_cuda_out final : public at::native::structured__upsample_bilinear2d_aa_out_cuda {
    structured__upsample_bilinear2d_aa_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_bilinear2d_aa_out_out(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__upsample_bilinear2d_aa_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_bilinear2d_aa_out_out", "self");
structured__upsample_bilinear2d_aa_out_cuda_out op(out);
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured__upsample_bilinear2d_aa_backward_out_cuda_functional final : public at::native::structured__upsample_bilinear2d_aa_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_bilinear2d_aa_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_bilinear2d_aa_backward", "grad_output");
structured__upsample_bilinear2d_aa_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_bilinear2d_aa_backward_out_cuda_out final : public at::native::structured__upsample_bilinear2d_aa_backward_out_cuda {
    structured__upsample_bilinear2d_aa_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_bilinear2d_aa_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper__upsample_bilinear2d_aa_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_bilinear2d_aa_backward_out_grad_input", "grad_output");
structured__upsample_bilinear2d_aa_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured_upsample_bicubic2d_out_cuda_functional final : public at::native::structured_upsample_bicubic2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_bicubic2d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_bicubic2d", "self");
structured_upsample_bicubic2d_out_cuda_functional op;
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_bicubic2d_out_cuda_out final : public at::native::structured_upsample_bicubic2d_out_cuda {
    structured_upsample_bicubic2d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_bicubic2d_out_out(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_bicubic2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_bicubic2d_out_out", "self");
structured_upsample_bicubic2d_out_cuda_out op(out);
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured_upsample_bicubic2d_backward_out_cuda_functional final : public at::native::structured_upsample_bicubic2d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_bicubic2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_bicubic2d_backward", "grad_output");
structured_upsample_bicubic2d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_bicubic2d_backward_out_cuda_out final : public at::native::structured_upsample_bicubic2d_backward_out_cuda {
    structured_upsample_bicubic2d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_bicubic2d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_bicubic2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_bicubic2d_backward_out_grad_input", "grad_output");
structured_upsample_bicubic2d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured__upsample_bicubic2d_aa_out_cuda_functional final : public at::native::structured__upsample_bicubic2d_aa_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_bicubic2d_aa(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_bicubic2d_aa", "self");
structured__upsample_bicubic2d_aa_out_cuda_functional op;
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_bicubic2d_aa_out_cuda_out final : public at::native::structured__upsample_bicubic2d_aa_out_cuda {
    structured__upsample_bicubic2d_aa_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_bicubic2d_aa_out_out(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__upsample_bicubic2d_aa_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_bicubic2d_aa_out_out", "self");
structured__upsample_bicubic2d_aa_out_cuda_out op(out);
op.meta(self, output_size, align_corners, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured__upsample_bicubic2d_aa_backward_out_cuda_functional final : public at::native::structured__upsample_bicubic2d_aa_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_bicubic2d_aa_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_bicubic2d_aa_backward", "grad_output");
structured__upsample_bicubic2d_aa_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_bicubic2d_aa_backward_out_cuda_out final : public at::native::structured__upsample_bicubic2d_aa_backward_out_cuda {
    structured__upsample_bicubic2d_aa_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_bicubic2d_aa_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper__upsample_bicubic2d_aa_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_bicubic2d_aa_backward_out_grad_input", "grad_output");
structured__upsample_bicubic2d_aa_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured_upsample_trilinear3d_out_cuda_functional final : public at::native::structured_upsample_trilinear3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_trilinear3d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_trilinear3d", "self");
structured_upsample_trilinear3d_out_cuda_functional op;
op.meta(self, output_size, align_corners, scales_d, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_d, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_trilinear3d_out_cuda_out final : public at::native::structured_upsample_trilinear3d_out_cuda {
    structured_upsample_trilinear3d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_trilinear3d_out_out(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_trilinear3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_trilinear3d_out_out", "self");
structured_upsample_trilinear3d_out_cuda_out op(out);
op.meta(self, output_size, align_corners, scales_d, scales_h, scales_w);
op.impl(self, output_size, align_corners, scales_d, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured_upsample_trilinear3d_backward_out_cuda_functional final : public at::native::structured_upsample_trilinear3d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_trilinear3d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_trilinear3d_backward", "grad_output");
structured_upsample_trilinear3d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_trilinear3d_backward_out_cuda_out final : public at::native::structured_upsample_trilinear3d_backward_out_cuda {
    structured_upsample_trilinear3d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_trilinear3d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_trilinear3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_trilinear3d_backward_out_grad_input", "grad_output");
structured_upsample_trilinear3d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured_upsample_nearest1d_out_cuda_functional final : public at::native::structured_upsample_nearest1d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_nearest1d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_nearest1d", "self");
structured_upsample_nearest1d_out_cuda_functional op;
op.meta(self, output_size, scales);
op.impl(self, output_size, scales, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_nearest1d_out_cuda_out final : public at::native::structured_upsample_nearest1d_out_cuda {
    structured_upsample_nearest1d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_nearest1d_out_out(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_nearest1d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_nearest1d_out_out", "self");
structured_upsample_nearest1d_out_cuda_out op(out);
op.meta(self, output_size, scales);
op.impl(self, output_size, scales, op.outputs_[0]);
return out;
}
struct structured__upsample_nearest_exact1d_out_cuda_functional final : public at::native::structured__upsample_nearest_exact1d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_nearest_exact1d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_nearest_exact1d", "self");
structured__upsample_nearest_exact1d_out_cuda_functional op;
op.meta(self, output_size, scales);
op.impl(self, output_size, scales, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_nearest_exact1d_out_cuda_out final : public at::native::structured__upsample_nearest_exact1d_out_cuda {
    structured__upsample_nearest_exact1d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_nearest_exact1d_out_out(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__upsample_nearest_exact1d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_nearest_exact1d_out_out", "self");
structured__upsample_nearest_exact1d_out_cuda_out op(out);
op.meta(self, output_size, scales);
op.impl(self, output_size, scales, op.outputs_[0]);
return out;
}
struct structured_upsample_nearest1d_backward_out_cuda_functional final : public at::native::structured_upsample_nearest1d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_nearest1d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_nearest1d_backward", "grad_output");
structured_upsample_nearest1d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, scales);
op.impl(grad_output, output_size, input_size, scales, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_nearest1d_backward_out_cuda_out final : public at::native::structured_upsample_nearest1d_backward_out_cuda {
    structured_upsample_nearest1d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_nearest1d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_nearest1d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_nearest1d_backward_out_grad_input", "grad_output");
structured_upsample_nearest1d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, scales);
op.impl(grad_output, output_size, input_size, scales, op.outputs_[0]);
return grad_input;
}
struct structured__upsample_nearest_exact1d_backward_out_cuda_functional final : public at::native::structured__upsample_nearest_exact1d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_nearest_exact1d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_nearest_exact1d_backward", "grad_output");
structured__upsample_nearest_exact1d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, scales);
op.impl(grad_output, output_size, input_size, scales, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_nearest_exact1d_backward_out_cuda_out final : public at::native::structured__upsample_nearest_exact1d_backward_out_cuda {
    structured__upsample_nearest_exact1d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_nearest_exact1d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper__upsample_nearest_exact1d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_nearest_exact1d_backward_out_grad_input", "grad_output");
structured__upsample_nearest_exact1d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, scales);
op.impl(grad_output, output_size, input_size, scales, op.outputs_[0]);
return grad_input;
}
struct structured_upsample_nearest2d_out_cuda_functional final : public at::native::structured_upsample_nearest2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_nearest2d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_nearest2d", "self");
structured_upsample_nearest2d_out_cuda_functional op;
op.meta(self, output_size, scales_h, scales_w);
op.impl(self, output_size, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_nearest2d_out_cuda_out final : public at::native::structured_upsample_nearest2d_out_cuda {
    structured_upsample_nearest2d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_nearest2d_out_out(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_nearest2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_nearest2d_out_out", "self");
structured_upsample_nearest2d_out_cuda_out op(out);
op.meta(self, output_size, scales_h, scales_w);
op.impl(self, output_size, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured__upsample_nearest_exact2d_out_cuda_functional final : public at::native::structured__upsample_nearest_exact2d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_nearest_exact2d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_nearest_exact2d", "self");
structured__upsample_nearest_exact2d_out_cuda_functional op;
op.meta(self, output_size, scales_h, scales_w);
op.impl(self, output_size, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_nearest_exact2d_out_cuda_out final : public at::native::structured__upsample_nearest_exact2d_out_cuda {
    structured__upsample_nearest_exact2d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_nearest_exact2d_out_out(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__upsample_nearest_exact2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_nearest_exact2d_out_out", "self");
structured__upsample_nearest_exact2d_out_cuda_out op(out);
op.meta(self, output_size, scales_h, scales_w);
op.impl(self, output_size, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured_upsample_nearest2d_backward_out_cuda_functional final : public at::native::structured_upsample_nearest2d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_nearest2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_nearest2d_backward", "grad_output");
structured_upsample_nearest2d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_nearest2d_backward_out_cuda_out final : public at::native::structured_upsample_nearest2d_backward_out_cuda {
    structured_upsample_nearest2d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_nearest2d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_nearest2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_nearest2d_backward_out_grad_input", "grad_output");
structured_upsample_nearest2d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured__upsample_nearest_exact2d_backward_out_cuda_functional final : public at::native::structured__upsample_nearest_exact2d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_nearest_exact2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_nearest_exact2d_backward", "grad_output");
structured__upsample_nearest_exact2d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_nearest_exact2d_backward_out_cuda_out final : public at::native::structured__upsample_nearest_exact2d_backward_out_cuda {
    structured__upsample_nearest_exact2d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_nearest_exact2d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper__upsample_nearest_exact2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_nearest_exact2d_backward_out_grad_input", "grad_output");
structured__upsample_nearest_exact2d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured_upsample_nearest3d_out_cuda_functional final : public at::native::structured_upsample_nearest3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_nearest3d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_nearest3d", "self");
structured_upsample_nearest3d_out_cuda_functional op;
op.meta(self, output_size, scales_d, scales_h, scales_w);
op.impl(self, output_size, scales_d, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_nearest3d_out_cuda_out final : public at::native::structured_upsample_nearest3d_out_cuda {
    structured_upsample_nearest3d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_nearest3d_out_out(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_upsample_nearest3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_upsample_nearest3d_out_out", "self");
structured_upsample_nearest3d_out_cuda_out op(out);
op.meta(self, output_size, scales_d, scales_h, scales_w);
op.impl(self, output_size, scales_d, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured__upsample_nearest_exact3d_out_cuda_functional final : public at::native::structured__upsample_nearest_exact3d_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_nearest_exact3d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_nearest_exact3d", "self");
structured__upsample_nearest_exact3d_out_cuda_functional op;
op.meta(self, output_size, scales_d, scales_h, scales_w);
op.impl(self, output_size, scales_d, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_nearest_exact3d_out_cuda_out final : public at::native::structured__upsample_nearest_exact3d_out_cuda {
    structured__upsample_nearest_exact3d_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_nearest_exact3d_out_out(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper__upsample_nearest_exact3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper__upsample_nearest_exact3d_out_out", "self");
structured__upsample_nearest_exact3d_out_cuda_out op(out);
op.meta(self, output_size, scales_d, scales_h, scales_w);
op.impl(self, output_size, scales_d, scales_h, scales_w, op.outputs_[0]);
return out;
}
struct structured_upsample_nearest3d_backward_out_cuda_functional final : public at::native::structured_upsample_nearest3d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_upsample_nearest3d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_nearest3d_backward", "grad_output");
structured_upsample_nearest3d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, scales_d, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_d, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_upsample_nearest3d_backward_out_cuda_out final : public at::native::structured_upsample_nearest3d_backward_out_cuda {
    structured_upsample_nearest3d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_upsample_nearest3d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_upsample_nearest3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_upsample_nearest3d_backward_out_grad_input", "grad_output");
structured_upsample_nearest3d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, scales_d, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_d, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured__upsample_nearest_exact3d_backward_out_cuda_functional final : public at::native::structured__upsample_nearest_exact3d_backward_out_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper__upsample_nearest_exact3d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_nearest_exact3d_backward", "grad_output");
structured__upsample_nearest_exact3d_backward_out_cuda_functional op;
op.meta(grad_output, output_size, input_size, scales_d, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_d, scales_h, scales_w, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured__upsample_nearest_exact3d_backward_out_cuda_out final : public at::native::structured__upsample_nearest_exact3d_backward_out_cuda {
    structured__upsample_nearest_exact3d_backward_out_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper__upsample_nearest_exact3d_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper__upsample_nearest_exact3d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__upsample_nearest_exact3d_backward_out_grad_input", "grad_output");
structured__upsample_nearest_exact3d_backward_out_cuda_out op(grad_input);
op.meta(grad_output, output_size, input_size, scales_d, scales_h, scales_w);
op.impl(grad_output, output_size, input_size, scales_d, scales_h, scales_w, op.outputs_[0]);
return grad_input;
}
struct structured_sigmoid_backward_out_functional final : public at::native::structured_sigmoid_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sigmoid_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_sigmoid_backward(const at::Tensor & grad_output, const at::Tensor & output) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_sigmoid_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper_sigmoid_backward", "output");
structured_sigmoid_backward_out_functional op;
op.meta(grad_output, output);
op.impl(grad_output, output, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_sigmoid_backward_out_out final : public at::native::structured_sigmoid_backward_out {
    structured_sigmoid_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_sigmoid_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_sigmoid_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & output, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_sigmoid_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_sigmoid_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper_sigmoid_backward_out_grad_input", "output");
structured_sigmoid_backward_out_out op(grad_input);
op.meta(grad_output, output);
op.impl(grad_output, output, op.outputs_[0]);
return grad_input;
}
struct structured_logit_backward_out_functional final : public at::native::structured_logit_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_logit_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_logit_backward(const at::Tensor & grad_output, const at::Tensor & self, c10::optional<double> eps) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_logit_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_logit_backward", "self");
structured_logit_backward_out_functional op;
op.meta(grad_output, self, eps);
op.impl(grad_output, self, eps, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_logit_backward_out_out final : public at::native::structured_logit_backward_out {
    structured_logit_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_logit_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_logit_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, c10::optional<double> eps, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_logit_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_logit_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_logit_backward_out_grad_input", "self");
structured_logit_backward_out_out op(grad_input);
op.meta(grad_output, self, eps);
op.impl(grad_output, self, eps, op.outputs_[0]);
return grad_input;
}
struct structured_tanh_backward_out_functional final : public at::native::structured_tanh_backward_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tanh_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_tanh_backward(const at::Tensor & grad_output, const at::Tensor & output) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_tanh_backward", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper_tanh_backward", "output");
structured_tanh_backward_out_functional op;
op.meta(grad_output, output);
op.impl(grad_output, output, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_tanh_backward_out_out final : public at::native::structured_tanh_backward_out {
    structured_tanh_backward_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_tanh_backward_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_tanh_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & output, at::Tensor & grad_input) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_tanh_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_tanh_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper_tanh_backward_out_grad_input", "output");
structured_tanh_backward_out_out op(grad_input);
op.meta(grad_output, output);
op.impl(grad_output, output, op.outputs_[0]);
return grad_input;
}
struct structured_slow_conv_transpose2d_structured_cuda_functional final : public at::native::structured_slow_conv_transpose2d_structured_cuda {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_slow_conv_transpose2d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_slow_conv_transpose2d", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_slow_conv_transpose2d", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_slow_conv_transpose2d", "bias");
structured_slow_conv_transpose2d_structured_cuda_functional op;
op.meta(self, weight, kernel_size, ((bias.has_value() && (*bias).defined()) ? at::OptionalTensorRef(*bias) : at::OptionalTensorRef()), stride, padding, output_padding, dilation);
op.impl(self, weight, kernel_size, ((bias.has_value() && (*bias).defined()) ? at::OptionalTensorRef(*bias) : at::OptionalTensorRef()), stride, padding, output_padding, dilation, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_slow_conv_transpose2d_structured_cuda_out final : public at::native::structured_slow_conv_transpose2d_structured_cuda {
    structured_slow_conv_transpose2d_structured_cuda_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_slow_conv_transpose2d_out_out(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_slow_conv_transpose2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_slow_conv_transpose2d_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_slow_conv_transpose2d_out_out", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_slow_conv_transpose2d_out_out", "bias");
structured_slow_conv_transpose2d_structured_cuda_out op(out);
op.meta(self, weight, kernel_size, ((bias.has_value() && (*bias).defined()) ? at::OptionalTensorRef(*bias) : at::OptionalTensorRef()), stride, padding, output_padding, dilation);
op.impl(self, weight, kernel_size, ((bias.has_value() && (*bias).defined()) ? at::OptionalTensorRef(*bias) : at::OptionalTensorRef()), stride, padding, output_padding, dilation, op.outputs_[0]);
return out;
}
namespace {

at::Tensor wrapper__slow_conv_transpose3d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__slow_conv_transpose3d", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__slow_conv_transpose3d", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__slow_conv_transpose3d", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv_transpose3d_cuda(self, weight, kernel_size, bias, stride, padding, output_padding, dilation);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_slow_conv_transpose3d_out_out(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_slow_conv_transpose3d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_slow_conv_transpose3d_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_out_slow_conv_transpose3d_out_out", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_out_slow_conv_transpose3d_out_out", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv_transpose3d_out_cuda(self, weight, kernel_size, bias, stride, padding, output_padding, dilation, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___slow_conv2d_forward(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___slow_conv2d_forward", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper___slow_conv2d_forward", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper___slow_conv2d_forward", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv2d_forward_cuda(self, weight, kernel_size, bias, stride, padding);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_output__slow_conv2d_forward_out_output(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & output) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, output, "wrapper_output__slow_conv2d_forward_out_output", "output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_output__slow_conv2d_forward_out_output", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_output__slow_conv2d_forward_out_output", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_output__slow_conv2d_forward_out_output", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv2d_forward_out_cuda(self, weight, kernel_size, bias, stride, padding, output);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> wrapper_grad_input__slow_conv2d_backward_out_grad_input(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & grad_input, at::Tensor & grad_weight, at::Tensor & grad_bias) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input__slow_conv2d_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_weight, "wrapper_grad_input__slow_conv2d_backward_out_grad_input", "grad_weight");
  c10::impl::check_and_update_common_device(common_device, grad_bias, "wrapper_grad_input__slow_conv2d_backward_out_grad_input", "grad_bias");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input__slow_conv2d_backward_out_grad_input", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_grad_input__slow_conv2d_backward_out_grad_input", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_grad_input__slow_conv2d_backward_out_grad_input", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv2d_backward_out_cuda(grad_output, self, weight, kernel_size, stride, padding, grad_input, grad_weight, grad_bias);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper_output_mask__slow_conv2d_backward_output_mask(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, ::std::array<bool,3> output_mask) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_output_mask__slow_conv2d_backward_output_mask", "grad_output");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_output_mask__slow_conv2d_backward_output_mask", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_output_mask__slow_conv2d_backward_output_mask", "weight");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv2d_backward_cuda(grad_output, self, weight, kernel_size, stride, padding, output_mask);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___conv_depthwise2d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___conv_depthwise2d", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper___conv_depthwise2d", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper___conv_depthwise2d", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::conv_depthwise2d_cuda(self, weight, kernel_size, bias, stride, padding, dilation);
}

} // anonymous namespace
namespace {

const at::Tensor & wrapper_out__conv_depthwise2d_out_out(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, const at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out__conv_depthwise2d_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out__conv_depthwise2d_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper_out__conv_depthwise2d_out_out", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper_out__conv_depthwise2d_out_out", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::conv_depthwise2d_cuda_out(self, weight, kernel_size, bias, stride, padding, dilation, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__conv_depthwise3d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__conv_depthwise3d", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__conv_depthwise3d", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__conv_depthwise3d", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::conv_depthwise3d_cuda(self, weight, kernel_size, bias, stride, padding, dilation);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__slow_conv_dilated2d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__slow_conv_dilated2d", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__slow_conv_dilated2d", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__slow_conv_dilated2d", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv_dilated2d_cuda(self, weight, kernel_size, bias, stride, padding, dilation);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__slow_conv_dilated3d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__slow_conv_dilated3d", "self");
  c10::impl::check_and_update_common_device(common_device, weight, "wrapper__slow_conv_dilated3d", "weight");
  c10::impl::check_and_update_common_device(common_device, bias, "wrapper__slow_conv_dilated3d", "bias");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::slow_conv_dilated3d_cuda(self, weight, kernel_size, bias, stride, padding, dilation);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__col2im(const at::Tensor & self, at::IntArrayRef output_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__col2im", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::col2im_cuda(self, output_size, kernel_size, dilation, padding, stride);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_col2im_out_out(const at::Tensor & self, at::IntArrayRef output_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_col2im_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_col2im_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::col2im_out_cuda(self, output_size, kernel_size, dilation, padding, stride, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__col2im_backward(const at::Tensor & grad_output, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__col2im_backward", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::col2im_backward_cuda(grad_output, kernel_size, dilation, padding, stride);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_col2im_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_col2im_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_col2im_backward_out_grad_input", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(grad_input));
  return at::native::col2im_backward_out_cuda(grad_output, kernel_size, dilation, padding, stride, grad_input);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__im2col(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__im2col", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::im2col_cuda(self, kernel_size, dilation, padding, stride);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_im2col_out_out(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_im2col_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_im2col_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::im2col_out_cuda(self, kernel_size, dilation, padding, stride, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__im2col_backward(const at::Tensor & grad_output, at::IntArrayRef input_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper__im2col_backward", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(grad_output));
  return at::native::im2col_backward_cuda(grad_output, input_size, kernel_size, dilation, padding, stride);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_grad_input_im2col_backward_out_grad_input(const at::Tensor & grad_output, at::IntArrayRef input_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & grad_input) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad_input, "wrapper_grad_input_im2col_backward_out_grad_input", "grad_input");
  c10::impl::check_and_update_common_device(common_device, grad_output, "wrapper_grad_input_im2col_backward_out_grad_input", "grad_output");

  const OptionalDeviceGuard device_guard(device_of(grad_input));
  return at::native::im2col_backward_out_cuda(grad_output, input_size, kernel_size, dilation, padding, stride, grad_input);
}

} // anonymous namespace
namespace {

void wrapper__record_stream(at::Tensor & self, at::Stream s) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__record_stream", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::record_stream_cuda(self, s);
}

} // anonymous namespace
struct structured_isposinf_out_functional final : public at::native::structured_isposinf_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_isposinf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_isposinf(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_isposinf", "self");
structured_isposinf_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_isposinf_out_out final : public at::native::structured_isposinf_out {
    structured_isposinf_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_isposinf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_isposinf_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_isposinf_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_isposinf_out_out", "self");
structured_isposinf_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_isneginf_out_functional final : public at::native::structured_isneginf_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_isneginf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_isneginf(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_isneginf", "self");
structured_isneginf_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_isneginf_out_out final : public at::native::structured_isneginf_out {
    structured_isneginf_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_isneginf_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_isneginf_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_isneginf_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_isneginf_out_out", "self");
structured_isneginf_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_special_entr_out_functional final : public at::native::structured_special_entr_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_entr_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_entr(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_entr", "self");
structured_special_entr_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_entr_out_out final : public at::native::structured_special_entr_out {
    structured_special_entr_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_entr_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_entr_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_special_entr_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_entr_out_out", "self");
structured_special_entr_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_special_ndtri_out_functional final : public at::native::structured_special_ndtri_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_ndtri_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_ndtri(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_ndtri", "self");
structured_special_ndtri_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_ndtri_out_out final : public at::native::structured_special_ndtri_out {
    structured_special_ndtri_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_ndtri_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_ndtri_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_special_ndtri_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_ndtri_out_out", "self");
structured_special_ndtri_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_special_erfcx_out_functional final : public at::native::structured_special_erfcx_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_erfcx_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_erfcx(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_erfcx", "self");
structured_special_erfcx_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_erfcx_out_out final : public at::native::structured_special_erfcx_out {
    structured_special_erfcx_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_erfcx_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_erfcx_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_special_erfcx_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_erfcx_out_out", "self");
structured_special_erfcx_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_special_xlog1py_out_functional final : public at::native::structured_special_xlog1py_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_xlog1py_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_xlog1py(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_special_xlog1py_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_xlog1py_out_out final : public at::native::structured_special_xlog1py_out {
    structured_special_xlog1py_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_xlog1py_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_xlog1py_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_special_xlog1py_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_special_zeta_out_functional final : public at::native::structured_special_zeta_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_zeta_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_zeta(const at::Tensor & self, const at::Tensor & other) {
  // No device check

structured_special_zeta_out_functional op;
op.meta(self, other);
op.impl(self, other, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_zeta_out_out final : public at::native::structured_special_zeta_out {
    structured_special_zeta_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_zeta_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_zeta_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
  // No device check

structured_special_zeta_out_out op(out);
op.meta(self, other);
op.impl(self, other, op.outputs_[0]);
return out;
}
struct structured_special_i0e_out_functional final : public at::native::structured_special_i0e_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_i0e_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_i0e(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_i0e", "self");
structured_special_i0e_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_i0e_out_out final : public at::native::structured_special_i0e_out {
    structured_special_i0e_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_i0e_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_i0e_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_special_i0e_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_i0e_out_out", "self");
structured_special_i0e_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_special_i1_out_functional final : public at::native::structured_special_i1_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_i1_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_i1(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_i1", "self");
structured_special_i1_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_i1_out_out final : public at::native::structured_special_i1_out {
    structured_special_i1_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_i1_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_i1_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_special_i1_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_i1_out_out", "self");
structured_special_i1_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
struct structured_special_i1e_out_functional final : public at::native::structured_special_i1e_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_i1e_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_special_i1e(const at::Tensor & self) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_i1e", "self");
structured_special_i1e_out_functional op;
op.meta(self);
op.impl(self, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_special_i1e_out_out final : public at::native::structured_special_i1e_out {
    structured_special_i1e_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output
        at::native::structured_special_i1e_out::set_output(output_idx, sizes, strides, options, names);
    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_special_i1e_out_out(const at::Tensor & self, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_special_i1e_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_special_i1e_out_out", "self");
structured_special_i1e_out_out op(out);
op.meta(self);
op.impl(self, op.outputs_[0]);
return out;
}
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__linalg_cholesky_ex(const at::Tensor & self, bool upper, bool check_errors) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_cholesky_ex", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_cholesky_ex(self, upper, check_errors);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_L_linalg_cholesky_ex_out_L(const at::Tensor & self, bool upper, bool check_errors, at::Tensor & L, at::Tensor & info) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, L, "wrapper_L_linalg_cholesky_ex_out_L", "L");
  c10::impl::check_and_update_common_device(common_device, info, "wrapper_L_linalg_cholesky_ex_out_L", "info");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_L_linalg_cholesky_ex_out_L", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_cholesky_ex_out(self, upper, check_errors, L, info);
}

} // anonymous namespace
struct structured_linalg_cross_out_functional final : public at::native::structured_linalg_cross_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor wrapper_linalg_cross(const at::Tensor & self, const at::Tensor & other, int64_t dim) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper_linalg_cross", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_linalg_cross", "other");
structured_linalg_cross_out_functional op;
auto precompute = op.meta(self, other, dim);
(void)precompute;
op.impl(self, other, precompute.dim, *op.outputs_[0]);
return std::move(op.outputs_[0]).take();
}
struct structured_linalg_cross_out_out final : public at::native::structured_linalg_cross_out {
    structured_linalg_cross_out_out(Tensor& out0) : outputs_{ std::ref(out0) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 1> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

at::Tensor & wrapper_linalg_cross_out_out(const at::Tensor & self, const at::Tensor & other, int64_t dim, at::Tensor & out) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_linalg_cross_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_linalg_cross_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_linalg_cross_out_out", "other");
structured_linalg_cross_out_out op(out);
auto precompute = op.meta(self, other, dim);
(void)precompute;
op.impl(self, other, precompute.dim, op.outputs_[0]);
return out;
}
struct structured_linalg_lu_factor_ex_out_functional final : public at::native::structured_linalg_lu_factor_ex_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 3> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper_linalg_lu_factor_ex(const at::Tensor & A, bool pivot, bool check_errors) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, A, "wrapper_linalg_lu_factor_ex", "A");
structured_linalg_lu_factor_ex_out_functional op;
op.meta(A, pivot, check_errors);
op.impl(A, pivot, check_errors, *op.outputs_[0], *op.outputs_[1], *op.outputs_[2]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take(), std::move(op.outputs_[2]).take());
}
struct structured_linalg_lu_factor_ex_out_out final : public at::native::structured_linalg_lu_factor_ex_out {
    structured_linalg_lu_factor_ex_out_out(Tensor& out0, Tensor& out1, Tensor& out2) : outputs_{ std::ref(out0), std::ref(out1), std::ref(out2) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 3> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> wrapper_linalg_lu_factor_ex_out_out(const at::Tensor & A, bool pivot, bool check_errors, at::Tensor & LU, at::Tensor & pivots, at::Tensor & info) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, LU, "wrapper_linalg_lu_factor_ex_out_out", "LU");
  c10::impl::check_and_update_common_device(common_device, pivots, "wrapper_linalg_lu_factor_ex_out_out", "pivots");
  c10::impl::check_and_update_common_device(common_device, info, "wrapper_linalg_lu_factor_ex_out_out", "info");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper_linalg_lu_factor_ex_out_out", "A");
structured_linalg_lu_factor_ex_out_out op(LU, pivots, info);
op.meta(A, pivot, check_errors);
op.impl(A, pivot, check_errors, op.outputs_[0], op.outputs_[1], op.outputs_[2]);
return std::forward_as_tuple(LU, pivots, info);
}
namespace {

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper___det_lu_based_helper(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___det_lu_based_helper", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_det_lu_based_helper(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___det_lu_based_helper_backward_helper(const at::Tensor & det_grad, const at::Tensor & det, const at::Tensor & self, const at::Tensor & lu, const at::Tensor & pivs) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, det_grad, "wrapper___det_lu_based_helper_backward_helper", "det_grad");
  c10::impl::check_and_update_common_device(common_device, det, "wrapper___det_lu_based_helper_backward_helper", "det");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper___det_lu_based_helper_backward_helper", "self");
  c10::impl::check_and_update_common_device(common_device, lu, "wrapper___det_lu_based_helper_backward_helper", "lu");
  c10::impl::check_and_update_common_device(common_device, pivs, "wrapper___det_lu_based_helper_backward_helper", "pivs");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_det_lu_based_helper_backward_helper(det_grad, det, self, lu, pivs);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &,at::Tensor &> wrapper_out_linalg_lstsq_out_out(const at::Tensor & self, const at::Tensor & b, c10::optional<double> rcond, c10::optional<c10::string_view> driver, at::Tensor & solution, at::Tensor & residuals, at::Tensor & rank, at::Tensor & singular_values) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, solution, "wrapper_out_linalg_lstsq_out_out", "solution");
  c10::impl::check_and_update_common_device(common_device, residuals, "wrapper_out_linalg_lstsq_out_out", "residuals");
  c10::impl::check_and_update_common_device(common_device, rank, "wrapper_out_linalg_lstsq_out_out", "rank");
  c10::impl::check_and_update_common_device(common_device, singular_values, "wrapper_out_linalg_lstsq_out_out", "singular_values");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_linalg_lstsq_out_out", "self");
  c10::impl::check_and_update_common_device(common_device, b, "wrapper_out_linalg_lstsq_out_out", "b");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_lstsq_out(self, b, rcond, driver, solution, residuals, rank, singular_values);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__linalg_matrix_exp(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_matrix_exp", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_matrix_exp(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__linalg_slogdet(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_slogdet", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_slogdet(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_out_linalg_slogdet_out_out(const at::Tensor & self, at::Tensor & sign, at::Tensor & logabsdet) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, sign, "wrapper_out_linalg_slogdet_out_out", "sign");
  c10::impl::check_and_update_common_device(common_device, logabsdet, "wrapper_out_linalg_slogdet_out_out", "logabsdet");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_linalg_slogdet_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_slogdet_out(self, sign, logabsdet);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__linalg_eig(const at::Tensor & self) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_eig", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_eig(self);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_out_linalg_eig_out_out(const at::Tensor & self, at::Tensor & eigenvalues, at::Tensor & eigenvectors) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, eigenvalues, "wrapper_out_linalg_eig_out_out", "eigenvalues");
  c10::impl::check_and_update_common_device(common_device, eigenvectors, "wrapper_out_linalg_eig_out_out", "eigenvectors");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_linalg_eig_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_eig_out(self, eigenvalues, eigenvectors);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper__linalg_eigh(const at::Tensor & self, c10::string_view UPLO) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_eigh", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_eigh(self, UPLO);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor &,at::Tensor &> wrapper_eigvals_linalg_eigh_out_eigvals(const at::Tensor & self, c10::string_view UPLO, at::Tensor & eigvals, at::Tensor & eigvecs) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, eigvals, "wrapper_eigvals_linalg_eigh_out_eigvals", "eigvals");
  c10::impl::check_and_update_common_device(common_device, eigvecs, "wrapper_eigvals_linalg_eigh_out_eigvals", "eigvecs");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_eigvals_linalg_eigh_out_eigvals", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_eigh_out(self, UPLO, eigvals, eigvecs);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_linalg_eigvalsh_out_out(const at::Tensor & self, c10::string_view UPLO, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_linalg_eigvalsh_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_linalg_eigvalsh_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_eigvalsh_out(self, UPLO, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__linalg_householder_product(const at::Tensor & input, const at::Tensor & tau) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__linalg_householder_product", "input");
  c10::impl::check_and_update_common_device(common_device, tau, "wrapper__linalg_householder_product", "tau");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::linalg_householder_product(input, tau);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_linalg_householder_product_out_out(const at::Tensor & input, const at::Tensor & tau, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_linalg_householder_product_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper_out_linalg_householder_product_out_out", "input");
  c10::impl::check_and_update_common_device(common_device, tau, "wrapper_out_linalg_householder_product_out_out", "tau");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::linalg_householder_product_out(input, tau, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper___linalg_inv_out_helper_(at::Tensor & self, at::Tensor & infos_lu, at::Tensor & infos_getri) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___linalg_inv_out_helper_", "self");
  c10::impl::check_and_update_common_device(common_device, infos_lu, "wrapper___linalg_inv_out_helper_", "infos_lu");
  c10::impl::check_and_update_common_device(common_device, infos_getri, "wrapper___linalg_inv_out_helper_", "infos_getri");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_linalg_inv_out_helper_cuda(self, infos_lu, infos_getri);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__linalg_vector_norm(const at::Tensor & self, const at::Scalar & ord, c10::optional<at::IntArrayRef> dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper__linalg_vector_norm", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_vector_norm(self, ord, dim, keepdim, dtype);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_linalg_vector_norm_out_out(const at::Tensor & self, const at::Scalar & ord, c10::optional<at::IntArrayRef> dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_linalg_vector_norm_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, self, "wrapper_out_linalg_vector_norm_out_out", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::linalg_vector_norm_out(self, ord, dim, keepdim, dtype, out);
}

} // anonymous namespace
struct structured__linalg_svd_out_functional final : public at::native::structured__linalg_svd_out {

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        outputs_[output_idx] = create_out(sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(*outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return *outputs_[output_idx];
    }
    std::array<c10::ExclusivelyOwned<Tensor>, 3> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor,at::Tensor,at::Tensor> wrapper__linalg_svd(const at::Tensor & A, bool full_matrices, bool compute_uv) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, A, "wrapper__linalg_svd", "A");
structured__linalg_svd_out_functional op;
op.meta(A, full_matrices, compute_uv);
op.impl(A, full_matrices, compute_uv, *op.outputs_[0], *op.outputs_[1], *op.outputs_[2]);
return std::make_tuple(std::move(op.outputs_[0]).take(), std::move(op.outputs_[1]).take(), std::move(op.outputs_[2]).take());
}
struct structured__linalg_svd_out_out final : public at::native::structured__linalg_svd_out {
    structured__linalg_svd_out_out(Tensor& out0, Tensor& out1, Tensor& out2) : outputs_{ std::ref(out0), std::ref(out1), std::ref(out2) } {}

    void set_output(int64_t output_idx, IntArrayRef sizes, IntArrayRef strides,
                    TensorOptions options, DimnameList names) override {

        auto current_device = guard_.current_device();
        if (C10_UNLIKELY(current_device.has_value())) {
          TORCH_INTERNAL_ASSERT(*current_device == options.device(),
            "structured kernels don't support multi-device outputs");
        } else {
          guard_.reset_device(options.device());
        }


        const auto& out = outputs_[output_idx].get();
        resize_out(out, sizes, strides, options);
        if (!names.empty()) {
          namedinference::propagate_names(outputs_[output_idx], names);
        }
        // super must happen after, so that downstream can use maybe_get_output
        // to retrieve the output

    }

    const Tensor& maybe_get_output(int64_t output_idx) override {
        return outputs_[output_idx];
    }
    std::array<std::reference_wrapper<Tensor>, 3> outputs_;
    c10::cuda::OptionalCUDAGuard guard_;
};

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> wrapper__linalg_svd_out_U(const at::Tensor & A, bool full_matrices, bool compute_uv, at::Tensor & U, at::Tensor & S, at::Tensor & Vh) {
c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, U, "wrapper__linalg_svd_out_U", "U");
  c10::impl::check_and_update_common_device(common_device, S, "wrapper__linalg_svd_out_U", "S");
  c10::impl::check_and_update_common_device(common_device, Vh, "wrapper__linalg_svd_out_U", "Vh");
  c10::impl::check_and_update_common_device(common_device, A, "wrapper__linalg_svd_out_U", "A");
structured__linalg_svd_out_out op(U, S, Vh);
op.meta(A, full_matrices, compute_uv);
op.impl(A, full_matrices, compute_uv, op.outputs_[0], op.outputs_[1], op.outputs_[2]);
return std::forward_as_tuple(U, S, Vh);
}
namespace {

at::Tensor wrapper__linalg_solve(const at::Tensor & input, const at::Tensor & other) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, input, "wrapper__linalg_solve", "input");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper__linalg_solve", "other");

  const OptionalDeviceGuard device_guard(device_of(input));
  return at::native::linalg_solve(input, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_linalg_solve_out_out(const at::Tensor & input, const at::Tensor & other, at::Tensor & out) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, out, "wrapper_out_linalg_solve_out_out", "out");
  c10::impl::check_and_update_common_device(common_device, input, "wrapper_out_linalg_solve_out_out", "input");
  c10::impl::check_and_update_common_device(common_device, other, "wrapper_out_linalg_solve_out_out", "other");

  const OptionalDeviceGuard device_guard(device_of(out));
  return at::native::linalg_solve_out(input, other, out);
}

} // anonymous namespace
namespace {

::std::tuple<at::Tensor,at::Tensor> wrapper___linalg_qr_helper(const at::Tensor & self, c10::string_view mode) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, self, "wrapper___linalg_qr_helper", "self");

  const OptionalDeviceGuard device_guard(device_of(self));
  return at::native::_linalg_qr_helper_cuda(self, mode);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__segment_reduce(const at::Tensor & data, c10::string_view reduce, const c10::optional<at::Tensor> & lengths, const c10::optional<at::Tensor> & indices, int64_t axis, bool unsafe, const c10::optional<at::Scalar> & initial) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, data, "wrapper__segment_reduce", "data");

  const OptionalDeviceGuard device_guard(device_of(data));
  return at::native::segment_reduce_kernel(data, reduce, lengths, indices, axis, unsafe, initial);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___segment_reduce_backward(const at::Tensor & grad, const at::Tensor & output, const at::Tensor & data, c10::string_view reduce, const c10::optional<at::Tensor> & lengths, int64_t axis) {
  c10::optional<Device> common_device = nullopt;
(void)common_device; // Suppress unused variable warning

  c10::impl::check_and_update_common_device(common_device, grad, "wrapper___segment_reduce_backward", "grad");
  c10::impl::check_and_update_common_device(common_device, output, "wrapper___segment_reduce_backward", "output");
  c10::impl::check_and_update_common_device(common_device, data, "wrapper___segment_reduce_backward", "data");

  const OptionalDeviceGuard device_guard(device_of(grad));
  return at::native::_segment_reduce_backward_kernel(grad, output, data, reduce, lengths, axis);
}

} // anonymous namespace

TORCH_LIBRARY_IMPL(aten, CUDA, m) {
  m.impl("_assert_async",
  TORCH_FN(wrapper___assert_async));
  m.impl("_use_cudnn_ctc_loss",
  TORCH_FN(wrapper___use_cudnn_ctc_loss));
  m.impl("_cudnn_ctc_loss",
  TORCH_FN(wrapper___cudnn_ctc_loss));
  m.impl("_cudnn_rnn_flatten_weight",
  TORCH_FN(wrapper___cudnn_rnn_flatten_weight));
  m.impl("_cudnn_rnn",
  TORCH_FN(wrapper___cudnn_rnn));
  m.impl("_cudnn_rnn_backward",
  TORCH_FN(wrapper___cudnn_rnn_backward));
  m.impl("_cudnn_init_dropout_state",
  TORCH_FN(wrapper___cudnn_init_dropout_state));
  m.impl("_fused_dropout",
  TORCH_FN(wrapper___fused_dropout));
  m.impl("_masked_scale",
  TORCH_FN(wrapper___masked_scale));
  m.impl("native_dropout",
  TORCH_FN(wrapper__native_dropout));
  m.impl("native_dropout_backward",
  TORCH_FN(wrapper__native_dropout_backward));
  m.impl("abs.out",
  TORCH_FN(wrapper_out_abs_out_out));
  m.impl("angle",
  TORCH_FN(wrapper__angle));
  m.impl("angle.out",
  TORCH_FN(wrapper_out_angle_out_out));
  m.impl("view_as_real",
  TORCH_FN(wrapper__view_as_real));
  m.impl("view_as_complex",
  TORCH_FN(wrapper__view_as_complex));
  m.impl("sgn", TORCH_FN(wrapper_sgn));
  m.impl("sgn.out", TORCH_FN(wrapper_sgn_out_out));
  m.impl("sgn_", TORCH_FN(wrapper_sgn_));
  m.impl("conj_physical.out",
  TORCH_FN(wrapper_out_conj_physical_out_out));
  m.impl("acos", TORCH_FN(wrapper_acos));
  m.impl("acos.out", TORCH_FN(wrapper_acos_out_out));
  m.impl("acos_", TORCH_FN(wrapper_acos_));
  m.impl("add.Tensor", TORCH_FN(wrapper_add_Tensor));
  m.impl("add.out", TORCH_FN(wrapper_add_out_out));
  m.impl("add_.Tensor", TORCH_FN(wrapper_add__Tensor));
  m.impl("addmv", TORCH_FN(wrapper_addmv));
  m.impl("addmv.out", TORCH_FN(wrapper_addmv_out_out));
  m.impl("addmv_", TORCH_FN(wrapper_addmv_));
  m.impl("addr",
  TORCH_FN(wrapper__addr));
  m.impl("addr.out",
  TORCH_FN(wrapper_out_addr_out_out));
  m.impl("all.dim", TORCH_FN(wrapper_all_dim));
  m.impl("all.out", TORCH_FN(wrapper_all_out_out));
  m.impl("any.dim", TORCH_FN(wrapper_any_dim));
  m.impl("any.out", TORCH_FN(wrapper_any_out_out));
  m.impl("arange.start_out",
  TORCH_FN(wrapper_start_out_arange_out_start_out));
  m.impl("argmax", TORCH_FN(wrapper_argmax));
  m.impl("argmax.out", TORCH_FN(wrapper_argmax_out_out));
  m.impl("argmin", TORCH_FN(wrapper_argmin));
  m.impl("argmin.out", TORCH_FN(wrapper_argmin_out_out));
  m.impl("acosh", TORCH_FN(wrapper_acosh));
  m.impl("acosh.out", TORCH_FN(wrapper_acosh_out_out));
  m.impl("acosh_", TORCH_FN(wrapper_acosh_));
  m.impl("asinh", TORCH_FN(wrapper_asinh));
  m.impl("asinh.out", TORCH_FN(wrapper_asinh_out_out));
  m.impl("asinh_", TORCH_FN(wrapper_asinh_));
  m.impl("atanh", TORCH_FN(wrapper_atanh));
  m.impl("atanh.out", TORCH_FN(wrapper_atanh_out_out));
  m.impl("atanh_", TORCH_FN(wrapper_atanh_));
  m.impl("as_strided",
  TORCH_FN(wrapper__as_strided));
  m.impl("asin", TORCH_FN(wrapper_asin));
  m.impl("asin.out", TORCH_FN(wrapper_asin_out_out));
  m.impl("asin_", TORCH_FN(wrapper_asin_));
  m.impl("atan", TORCH_FN(wrapper_atan));
  m.impl("atan.out", TORCH_FN(wrapper_atan_out_out));
  m.impl("atan_", TORCH_FN(wrapper_atan_));
  m.impl("baddbmm", TORCH_FN(wrapper_baddbmm));
  m.impl("baddbmm.out", TORCH_FN(wrapper_baddbmm_out_out));
  m.impl("baddbmm_", TORCH_FN(wrapper_baddbmm_));
  m.impl("bernoulli.out",
  TORCH_FN(wrapper_out_bernoulli_out_out));
  m.impl("bernoulli_.Tensor",
  TORCH_FN(wrapper_Tensor_bernoulli__Tensor));
  m.impl("bernoulli_.float",
  TORCH_FN(wrapper_float_bernoulli__float));
  m.impl("binary_cross_entropy",
  TORCH_FN(wrapper__binary_cross_entropy));
  m.impl("binary_cross_entropy.out",
  TORCH_FN(wrapper_out_binary_cross_entropy_out_out));
  m.impl("binary_cross_entropy_backward",
  TORCH_FN(wrapper__binary_cross_entropy_backward));
  m.impl("binary_cross_entropy_backward.grad_input",
  TORCH_FN(wrapper_grad_input_binary_cross_entropy_backward_out_grad_input));
  m.impl("bincount",
  TORCH_FN(wrapper__bincount));
  m.impl("bitwise_not", TORCH_FN(wrapper_bitwise_not));
  m.impl("bitwise_not.out", TORCH_FN(wrapper_bitwise_not_out_out));
  m.impl("bitwise_not_", TORCH_FN(wrapper_bitwise_not_));
  m.impl("copysign.Tensor", TORCH_FN(wrapper_copysign_Tensor));
  m.impl("copysign.out", TORCH_FN(wrapper_copysign_out_out));
  m.impl("copysign_.Tensor", TORCH_FN(wrapper_copysign__Tensor));
  m.impl("logical_not.out",
  TORCH_FN(wrapper_out_logical_not_out_out));
  m.impl("logical_xor.out",
  TORCH_FN(wrapper_out_logical_xor_out_out));
  m.impl("logical_and.out",
  TORCH_FN(wrapper_out_logical_and_out_out));
  m.impl("logical_or.out",
  TORCH_FN(wrapper_out_logical_or_out_out));
  m.impl("bmm", TORCH_FN(wrapper_bmm));
  m.impl("bmm.out", TORCH_FN(wrapper_bmm_out_out));
  m.impl("ceil", TORCH_FN(wrapper_ceil));
  m.impl("ceil.out", TORCH_FN(wrapper_ceil_out_out));
  m.impl("ceil_", TORCH_FN(wrapper_ceil_));
  m.impl("clamp", TORCH_FN(wrapper_clamp));
  m.impl("clamp.out", TORCH_FN(wrapper_clamp_out_out));
  m.impl("clamp_", TORCH_FN(wrapper_clamp_));
  m.impl("clamp.Tensor",
  TORCH_FN(wrapper_Tensor_clamp_Tensor));
  m.impl("clamp.Tensor_out",
  TORCH_FN(wrapper_Tensor_out_clamp_out_Tensor_out));
  m.impl("clamp_max.out",
  TORCH_FN(wrapper_out_clamp_max_out_out));
  m.impl("clamp_max.Tensor_out",
  TORCH_FN(wrapper_Tensor_out_clamp_max_out_Tensor_out));
  m.impl("clamp_min.out",
  TORCH_FN(wrapper_out_clamp_min_out_out));
  m.impl("clamp_min.Tensor_out",
  TORCH_FN(wrapper_Tensor_out_clamp_min_out_Tensor_out));
  m.impl("complex.out",
  TORCH_FN(wrapper_out_complex_out_out));
  m.impl("polar.out",
  TORCH_FN(wrapper_out_polar_out_out));
  m.impl("convolution_backward",
  TORCH_FN(wrapper__convolution_backward));
  m.impl("cos", TORCH_FN(wrapper_cos));
  m.impl("cos.out", TORCH_FN(wrapper_cos_out_out));
  m.impl("cos_", TORCH_FN(wrapper_cos_));
  m.impl("cosh", TORCH_FN(wrapper_cosh));
  m.impl("cosh.out", TORCH_FN(wrapper_cosh_out_out));
  m.impl("cosh_", TORCH_FN(wrapper_cosh_));
  m.impl("count_nonzero.dim_IntList",
  TORCH_FN(wrapper_dim_IntList_count_nonzero_dim_IntList));
  m.impl("cudnn_affine_grid_generator",
  TORCH_FN(wrapper__cudnn_affine_grid_generator));
  m.impl("cudnn_affine_grid_generator_backward",
  TORCH_FN(wrapper__cudnn_affine_grid_generator_backward));
  m.impl("cudnn_batch_norm",
  TORCH_FN(wrapper__cudnn_batch_norm));
  m.impl("cudnn_batch_norm_backward",
  TORCH_FN(wrapper__cudnn_batch_norm_backward));
  m.impl("cudnn_convolution",
  TORCH_FN(wrapper__cudnn_convolution));
  m.impl("cudnn_convolution_transpose",
  TORCH_FN(wrapper__cudnn_convolution_transpose));
  m.impl("cudnn_convolution_relu",
  TORCH_FN(wrapper__cudnn_convolution_relu));
  m.impl("cudnn_convolution_add_relu",
  TORCH_FN(wrapper__cudnn_convolution_add_relu));
  m.impl("cudnn_grid_sampler",
  TORCH_FN(wrapper__cudnn_grid_sampler));
  m.impl("cudnn_grid_sampler_backward",
  TORCH_FN(wrapper__cudnn_grid_sampler_backward));
  m.impl("_cummax_helper",
  TORCH_FN(wrapper___cummax_helper));
  m.impl("_cummin_helper",
  TORCH_FN(wrapper___cummin_helper));
  m.impl("cumprod", TORCH_FN(wrapper_cumprod));
  m.impl("cumprod.out", TORCH_FN(wrapper_cumprod_out_out));
  m.impl("cumprod_", TORCH_FN(wrapper_cumprod_));
  m.impl("cumsum", TORCH_FN(wrapper_cumsum));
  m.impl("cumsum.out", TORCH_FN(wrapper_cumsum_out_out));
  m.impl("cumsum_", TORCH_FN(wrapper_cumsum_));
  m.impl("_ctc_loss",
  TORCH_FN(wrapper___ctc_loss));
  m.impl("_ctc_loss_backward",
  TORCH_FN(wrapper___ctc_loss_backward));
  m.impl("div.Tensor", TORCH_FN(wrapper_div_Tensor));
  m.impl("div.out", TORCH_FN(wrapper_div_out_out));
  m.impl("div_.Tensor", TORCH_FN(wrapper_div__Tensor));
  m.impl("div.Tensor_mode", TORCH_FN(wrapper_div_Tensor_mode));
  m.impl("div.out_mode", TORCH_FN(wrapper_div_out_out_mode));
  m.impl("div_.Tensor_mode", TORCH_FN(wrapper_div__Tensor_mode));
  m.impl("dot",
  TORCH_FN(wrapper__dot));
  m.impl("vdot",
  TORCH_FN(wrapper__vdot));
  m.impl("embedding_dense_backward",
  TORCH_FN(wrapper__embedding_dense_backward));
  m.impl("embedding_renorm_",
  TORCH_FN(wrapper__embedding_renorm_));
  m.impl("_embedding_bag_forward_only",
  TORCH_FN(wrapper___embedding_bag_forward_only));
  m.impl("_embedding_bag",
  TORCH_FN(wrapper___embedding_bag));
  m.impl("_embedding_bag_dense_backward",
  TORCH_FN(wrapper___embedding_bag_dense_backward));
  m.impl("_embedding_bag_per_sample_weights_backward",
  TORCH_FN(wrapper___embedding_bag_per_sample_weights_backward));
  m.impl("empty.memory_format",
  TORCH_FN(wrapper_memory_format_empty_memory_format));
  m.impl("resize_",
  TORCH_FN(wrapper__resize_));
  m.impl("empty_strided",
  TORCH_FN(wrapper__empty_strided));
  m.impl("erf", TORCH_FN(wrapper_erf));
  m.impl("erf.out", TORCH_FN(wrapper_erf_out_out));
  m.impl("erf_", TORCH_FN(wrapper_erf_));
  m.impl("erfc", TORCH_FN(wrapper_erfc));
  m.impl("erfc.out", TORCH_FN(wrapper_erfc_out_out));
  m.impl("erfc_", TORCH_FN(wrapper_erfc_));
  m.impl("exp", TORCH_FN(wrapper_exp));
  m.impl("exp.out", TORCH_FN(wrapper_exp_out_out));
  m.impl("exp_", TORCH_FN(wrapper_exp_));
  m.impl("exp2", TORCH_FN(wrapper_exp2));
  m.impl("exp2.out", TORCH_FN(wrapper_exp2_out_out));
  m.impl("exp2_", TORCH_FN(wrapper_exp2_));
  m.impl("expm1", TORCH_FN(wrapper_expm1));
  m.impl("expm1.out", TORCH_FN(wrapper_expm1_out_out));
  m.impl("expm1_", TORCH_FN(wrapper_expm1_));
  m.impl("eye.out",
  TORCH_FN(wrapper_out_eye_out_out));
  m.impl("eye.m_out",
  TORCH_FN(wrapper_m_out_eye_out_m_out));
  m.impl("fill_.Scalar",
  TORCH_FN(wrapper_Scalar_fill__Scalar));
  m.impl("fill_.Tensor",
  TORCH_FN(wrapper_Tensor_fill__Tensor));
  m.impl("floor", TORCH_FN(wrapper_floor));
  m.impl("floor.out", TORCH_FN(wrapper_floor_out_out));
  m.impl("floor_", TORCH_FN(wrapper_floor_));
  m.impl("floor_divide",
  TORCH_FN(wrapper__floor_divide));
  m.impl("floor_divide.out",
  TORCH_FN(wrapper_out_floor_divide_out_out));
  m.impl("floor_divide_.Tensor",
  TORCH_FN(wrapper_Tensor_floor_divide__Tensor));
  m.impl("frac", TORCH_FN(wrapper_frac));
  m.impl("frac.out", TORCH_FN(wrapper_frac_out_out));
  m.impl("frac_", TORCH_FN(wrapper_frac_));
  m.impl("gcd", TORCH_FN(wrapper_gcd));
  m.impl("gcd.out", TORCH_FN(wrapper_gcd_out_out));
  m.impl("gcd_", TORCH_FN(wrapper_gcd_));
  m.impl("lcm", TORCH_FN(wrapper_lcm));
  m.impl("lcm.out", TORCH_FN(wrapper_lcm_out_out));
  m.impl("lcm_", TORCH_FN(wrapper_lcm_));
  m.impl("grid_sampler_2d",
  TORCH_FN(wrapper__grid_sampler_2d));
  m.impl("grid_sampler_2d_backward",
  TORCH_FN(wrapper__grid_sampler_2d_backward));
  m.impl("grid_sampler_3d",
  TORCH_FN(wrapper__grid_sampler_3d));
  m.impl("grid_sampler_3d_backward",
  TORCH_FN(wrapper__grid_sampler_3d_backward));
  m.impl("native_group_norm",
  TORCH_FN(wrapper__native_group_norm));
  m.impl("native_group_norm_backward",
  TORCH_FN(wrapper__native_group_norm_backward));
  m.impl("_fft_r2c",
  TORCH_FN(wrapper___fft_r2c));
  m.impl("_fft_r2c.out",
  TORCH_FN(wrapper_out__fft_r2c_out_out));
  m.impl("_fft_c2r",
  TORCH_FN(wrapper___fft_c2r));
  m.impl("_fft_c2r.out",
  TORCH_FN(wrapper_out__fft_c2r_out_out));
  m.impl("_fft_c2c",
  TORCH_FN(wrapper___fft_c2c));
  m.impl("_fft_c2c.out",
  TORCH_FN(wrapper_out__fft_c2c_out_out));
  m.impl("index.Tensor",
  TORCH_FN(wrapper_Tensor_index_Tensor));
  m.impl("index_copy", TORCH_FN(wrapper_index_copy));
  m.impl("index_copy.out", TORCH_FN(wrapper_index_copy_out_out));
  m.impl("index_copy_", TORCH_FN(wrapper_index_copy_));
  m.impl("_index_put_impl_",
  TORCH_FN(wrapper___index_put_impl_));
  m.impl("isin.Tensor_Tensor", TORCH_FN(wrapper_isin_Tensor_Tensor));
  m.impl("isin.Tensor_Tensor_out", TORCH_FN(wrapper_isin_out_Tensor_Tensor_out));
  m.impl("isin.Tensor_Scalar", TORCH_FN(wrapper_isin_Tensor_Scalar));
  m.impl("isin.Tensor_Scalar_out", TORCH_FN(wrapper_isin_out_Tensor_Scalar_out));
  m.impl("isin.Scalar_Tensor", TORCH_FN(wrapper_isin_Scalar_Tensor));
  m.impl("isin.Scalar_Tensor_out", TORCH_FN(wrapper_isin_out_Scalar_Tensor_out));
  m.impl("isnan",
  TORCH_FN(wrapper__isnan));
  m.impl("kl_div_backward",
  TORCH_FN(wrapper__kl_div_backward));
  m.impl("kthvalue.values",
  TORCH_FN(wrapper_values_kthvalue_out_values));
  m.impl("native_layer_norm",
  TORCH_FN(wrapper__native_layer_norm));
  m.impl("_native_multi_head_self_attention",
  TORCH_FN(wrapper___native_multi_head_self_attention));
  m.impl("native_layer_norm_backward",
  TORCH_FN(wrapper__native_layer_norm_backward));
  m.impl("nan_to_num.out",
  TORCH_FN(wrapper_out_nan_to_num_out_out));
  m.impl("linspace.out",
  TORCH_FN(wrapper_out_linspace_out_out));
  m.impl("log", TORCH_FN(wrapper_log));
  m.impl("log.out", TORCH_FN(wrapper_log_out_out));
  m.impl("log_", TORCH_FN(wrapper_log_));
  m.impl("log10", TORCH_FN(wrapper_log10));
  m.impl("log10.out", TORCH_FN(wrapper_log10_out_out));
  m.impl("log10_", TORCH_FN(wrapper_log10_));
  m.impl("log1p", TORCH_FN(wrapper_log1p));
  m.impl("log1p.out", TORCH_FN(wrapper_log1p_out_out));
  m.impl("log1p_", TORCH_FN(wrapper_log1p_));
  m.impl("log2", TORCH_FN(wrapper_log2));
  m.impl("log2.out", TORCH_FN(wrapper_log2_out_out));
  m.impl("log2_", TORCH_FN(wrapper_log2_));
  m.impl("logaddexp", TORCH_FN(wrapper_logaddexp));
  m.impl("logaddexp.out", TORCH_FN(wrapper_logaddexp_out_out));
  m.impl("logaddexp2", TORCH_FN(wrapper_logaddexp2));
  m.impl("logaddexp2.out", TORCH_FN(wrapper_logaddexp2_out_out));
  m.impl("xlogy.Tensor", TORCH_FN(wrapper_xlogy_Tensor));
  m.impl("xlogy.OutTensor", TORCH_FN(wrapper_xlogy_out_OutTensor));
  m.impl("xlogy_.Tensor", TORCH_FN(wrapper_xlogy__Tensor));
  m.impl("logspace.out",
  TORCH_FN(wrapper_out_logspace_out_out));
  m.impl("_log_softmax", TORCH_FN(wrapper__log_softmax));
  m.impl("_log_softmax.out", TORCH_FN(wrapper__log_softmax_out_out));
  m.impl("_log_softmax_backward_data", TORCH_FN(wrapper__log_softmax_backward_data));
  m.impl("_log_softmax_backward_data.out", TORCH_FN(wrapper__log_softmax_backward_data_out_out));
  m.impl("_logcumsumexp",
  TORCH_FN(wrapper___logcumsumexp));
  m.impl("_logcumsumexp.out",
  TORCH_FN(wrapper_out__logcumsumexp_out_out));
  m.impl("_aminmax",
  TORCH_FN(wrapper___aminmax));
  m.impl("_aminmax.dim",
  TORCH_FN(wrapper_dim__aminmax_dim));
  m.impl("aminmax", TORCH_FN(wrapper_aminmax));
  m.impl("aminmax.out", TORCH_FN(wrapper_aminmax_out_out));
  m.impl("_compute_linear_combination",
  TORCH_FN(wrapper___compute_linear_combination));
  m.impl("_compute_linear_combination.out",
  TORCH_FN(wrapper_out__compute_linear_combination_out_out));
  m.impl("max.dim", TORCH_FN(wrapper_max_dim));
  m.impl("max.dim_max", TORCH_FN(wrapper_max_out_dim_max));
  m.impl("amax.out",
  TORCH_FN(wrapper_out_amax_out_out));
  m.impl("mean.dim", TORCH_FN(wrapper_mean_dim));
  m.impl("mean.out", TORCH_FN(wrapper_mean_out_out));
  m.impl("median",
  TORCH_FN(wrapper__median));
  m.impl("median.dim_values",
  TORCH_FN(wrapper_dim_values_median_out_dim_values));
  m.impl("nanmedian",
  TORCH_FN(wrapper__nanmedian));
  m.impl("nanmedian.dim_values",
  TORCH_FN(wrapper_dim_values_nanmedian_out_dim_values));
  m.impl("min.dim", TORCH_FN(wrapper_min_dim));
  m.impl("min.dim_min", TORCH_FN(wrapper_min_out_dim_min));
  m.impl("amin.out",
  TORCH_FN(wrapper_out_amin_out_out));
  m.impl("miopen_batch_norm",
  TORCH_FN(wrapper__miopen_batch_norm));
  m.impl("miopen_batch_norm_backward",
  TORCH_FN(wrapper__miopen_batch_norm_backward));
  m.impl("miopen_convolution",
  TORCH_FN(wrapper__miopen_convolution));
  m.impl("miopen_convolution_transpose",
  TORCH_FN(wrapper__miopen_convolution_transpose));
  m.impl("miopen_depthwise_convolution",
  TORCH_FN(wrapper__miopen_depthwise_convolution));
  m.impl("miopen_rnn",
  TORCH_FN(wrapper__miopen_rnn));
  m.impl("miopen_rnn_backward",
  TORCH_FN(wrapper__miopen_rnn_backward));
  m.impl("mm", TORCH_FN(wrapper_mm));
  m.impl("mm.out", TORCH_FN(wrapper_mm_out_out));
  m.impl("mode",
  TORCH_FN(wrapper__mode));
  m.impl("mul.Tensor", TORCH_FN(wrapper_mul_Tensor));
  m.impl("mul.out", TORCH_FN(wrapper_mul_out_out));
  m.impl("mul_.Tensor", TORCH_FN(wrapper_mul__Tensor));
  m.impl("mvlgamma.out",
  TORCH_FN(wrapper_out_mvlgamma_out_out));
  m.impl("native_batch_norm",
  TORCH_FN(wrapper__native_batch_norm));
  m.impl("native_batch_norm.out",
  TORCH_FN(wrapper_out_native_batch_norm_out_out));
  m.impl("batch_norm_stats",
  TORCH_FN(wrapper__batch_norm_stats));
  m.impl("batch_norm_elemt",
  TORCH_FN(wrapper__batch_norm_elemt));
  m.impl("batch_norm_elemt.out",
  TORCH_FN(wrapper_out_batch_norm_elemt_out_out));
  m.impl("batch_norm_gather_stats",
  TORCH_FN(wrapper__batch_norm_gather_stats));
  m.impl("batch_norm_gather_stats_with_counts",
  TORCH_FN(wrapper__batch_norm_gather_stats_with_counts));
  m.impl("native_batch_norm_backward",
  TORCH_FN(wrapper__native_batch_norm_backward));
  m.impl("batch_norm_backward_reduce",
  TORCH_FN(wrapper__batch_norm_backward_reduce));
  m.impl("batch_norm_backward_elemt",
  TORCH_FN(wrapper__batch_norm_backward_elemt));
  m.impl("batch_norm_update_stats",
  TORCH_FN(wrapper__batch_norm_update_stats));
  m.impl("_cdist_forward",
  TORCH_FN(wrapper___cdist_forward));
  m.impl("_cdist_backward",
  TORCH_FN(wrapper___cdist_backward));
  m.impl("_pdist_forward",
  TORCH_FN(wrapper___pdist_forward));
  m.impl("_pdist_backward",
  TORCH_FN(wrapper___pdist_backward));
  m.impl("is_pinned",
  TORCH_FN(wrapper__is_pinned));
  m.impl("_pin_memory",
  TORCH_FN(wrapper___pin_memory));
  m.impl("randperm.generator_out",
  TORCH_FN(wrapper_generator_out_randperm_out_generator_out));
  m.impl("range.out",
  TORCH_FN(wrapper_out_range_out_out));
  m.impl("reciprocal", TORCH_FN(wrapper_reciprocal));
  m.impl("reciprocal.out", TORCH_FN(wrapper_reciprocal_out_out));
  m.impl("reciprocal_", TORCH_FN(wrapper_reciprocal_));
  m.impl("neg", TORCH_FN(wrapper_neg));
  m.impl("neg.out", TORCH_FN(wrapper_neg_out_out));
  m.impl("neg_", TORCH_FN(wrapper_neg_));
  m.impl("repeat_interleave.Tensor",
  TORCH_FN(wrapper_Tensor_repeat_interleave_Tensor));
  m.impl("_reshape_alias",
  TORCH_FN(wrapper___reshape_alias));
  m.impl("round", TORCH_FN(wrapper_round));
  m.impl("round.out", TORCH_FN(wrapper_round_out_out));
  m.impl("round_", TORCH_FN(wrapper_round_));
  m.impl("round.decimals", TORCH_FN(wrapper_round_decimals));
  m.impl("round.decimals_out", TORCH_FN(wrapper_round_out_decimals_out));
  m.impl("round_.decimals", TORCH_FN(wrapper_round__decimals));
  m.impl("relu",
  TORCH_FN(wrapper__relu));
  m.impl("relu_",
  TORCH_FN(wrapper__relu_));
  m.impl("prelu",
  TORCH_FN(wrapper__prelu));
  m.impl("prelu_backward",
  TORCH_FN(wrapper__prelu_backward));
  m.impl("gelu", TORCH_FN(wrapper_gelu));
  m.impl("gelu.out", TORCH_FN(wrapper_gelu_out_out));
  m.impl("gelu_backward", TORCH_FN(wrapper_gelu_backward));
  m.impl("gelu_backward.grad_input", TORCH_FN(wrapper_gelu_backward_out_grad_input));
  m.impl("hardshrink", TORCH_FN(wrapper_hardshrink));
  m.impl("hardshrink.out", TORCH_FN(wrapper_hardshrink_out_out));
  m.impl("hardshrink_backward", TORCH_FN(wrapper_hardshrink_backward));
  m.impl("hardshrink_backward.grad_input", TORCH_FN(wrapper_hardshrink_backward_out_grad_input));
  m.impl("rsqrt", TORCH_FN(wrapper_rsqrt));
  m.impl("rsqrt.out", TORCH_FN(wrapper_rsqrt_out_out));
  m.impl("rsqrt_", TORCH_FN(wrapper_rsqrt_));
  m.impl("silu", TORCH_FN(wrapper_silu));
  m.impl("silu.out", TORCH_FN(wrapper_silu_out_out));
  m.impl("silu_", TORCH_FN(wrapper_silu_));
  m.impl("silu_backward", TORCH_FN(wrapper_silu_backward));
  m.impl("silu_backward.grad_input", TORCH_FN(wrapper_silu_backward_out_grad_input));
  m.impl("mish", TORCH_FN(wrapper_mish));
  m.impl("mish.out", TORCH_FN(wrapper_mish_out_out));
  m.impl("mish_", TORCH_FN(wrapper_mish_));
  m.impl("mish_backward",
  TORCH_FN(wrapper__mish_backward));
  m.impl("sigmoid", TORCH_FN(wrapper_sigmoid));
  m.impl("sigmoid.out", TORCH_FN(wrapper_sigmoid_out_out));
  m.impl("sigmoid_", TORCH_FN(wrapper_sigmoid_));
  m.impl("logit",
  TORCH_FN(wrapper__logit));
  m.impl("logit.out",
  TORCH_FN(wrapper_out_logit_out_out));
  m.impl("logit_",
  TORCH_FN(wrapper__logit_));
  m.impl("sin", TORCH_FN(wrapper_sin));
  m.impl("sin.out", TORCH_FN(wrapper_sin_out_out));
  m.impl("sin_", TORCH_FN(wrapper_sin_));
  m.impl("sinc", TORCH_FN(wrapper_sinc));
  m.impl("sinc.out", TORCH_FN(wrapper_sinc_out_out));
  m.impl("sinc_", TORCH_FN(wrapper_sinc_));
  m.impl("sinh", TORCH_FN(wrapper_sinh));
  m.impl("sinh.out", TORCH_FN(wrapper_sinh_out_out));
  m.impl("sinh_", TORCH_FN(wrapper_sinh_));
  m.impl("_softmax", TORCH_FN(wrapper__softmax));
  m.impl("_softmax.out", TORCH_FN(wrapper__softmax_out_out));
  m.impl("_softmax_backward_data", TORCH_FN(wrapper__softmax_backward_data));
  m.impl("_softmax_backward_data.out", TORCH_FN(wrapper__softmax_backward_data_out_out));
  m.impl("squeeze",
  TORCH_FN(wrapper__squeeze));
  m.impl("squeeze.dim",
  TORCH_FN(wrapper_dim_squeeze_dim));
  m.impl("sspaddmm.out",
  TORCH_FN(wrapper_out_sspaddmm_out_out));
  m.impl("sum.dim_IntList", TORCH_FN(wrapper_sum_dim_IntList));
  m.impl("sum.IntList_out", TORCH_FN(wrapper_sum_out_IntList_out));
  m.impl("nansum",
  TORCH_FN(wrapper__nansum));
  m.impl("nansum.dim_IntList",
  TORCH_FN(wrapper_dim_IntList_nansum_dim_IntList));
  m.impl("nansum.IntList_out",
  TORCH_FN(wrapper_IntList_out_nansum_out_IntList_out));
  m.impl("sqrt", TORCH_FN(wrapper_sqrt));
  m.impl("sqrt.out", TORCH_FN(wrapper_sqrt_out_out));
  m.impl("sqrt_", TORCH_FN(wrapper_sqrt_));
  m.impl("square.out",
  TORCH_FN(wrapper_out_square_out_out));
  m.impl("std.correction",
  TORCH_FN(wrapper_correction_std_correction));
  m.impl("std.correction_out",
  TORCH_FN(wrapper_correction_out_std_out_correction_out));
  m.impl("std_mean.correction",
  TORCH_FN(wrapper_correction_std_mean_correction));
  m.impl("prod",
  TORCH_FN(wrapper__prod));
  m.impl("prod.dim_int", TORCH_FN(wrapper_prod_dim_int));
  m.impl("prod.int_out", TORCH_FN(wrapper_prod_out_int_out));
  m.impl("tan", TORCH_FN(wrapper_tan));
  m.impl("tan.out", TORCH_FN(wrapper_tan_out_out));
  m.impl("tan_", TORCH_FN(wrapper_tan_));
  m.impl("tanh", TORCH_FN(wrapper_tanh));
  m.impl("tanh.out", TORCH_FN(wrapper_tanh_out_out));
  m.impl("tanh_", TORCH_FN(wrapper_tanh_));
  m.impl("tensordot.out",
  TORCH_FN(wrapper_out_tensordot_out_out));
  m.impl("threshold", TORCH_FN(wrapper_threshold));
  m.impl("threshold.out", TORCH_FN(wrapper_threshold_out_out));
  m.impl("threshold_", TORCH_FN(wrapper_threshold_));
  m.impl("threshold_backward", TORCH_FN(wrapper_threshold_backward));
  m.impl("threshold_backward.grad_input", TORCH_FN(wrapper_threshold_backward_out_grad_input));
  m.impl("flip",
  TORCH_FN(wrapper__flip));
  m.impl("roll",
  TORCH_FN(wrapper__roll));
  m.impl("trunc", TORCH_FN(wrapper_trunc));
  m.impl("trunc.out", TORCH_FN(wrapper_trunc_out_out));
  m.impl("trunc_", TORCH_FN(wrapper_trunc_));
  m.impl("_unique",
  TORCH_FN(wrapper___unique));
  m.impl("unique_dim",
  TORCH_FN(wrapper__unique_dim));
  m.impl("unique_consecutive",
  TORCH_FN(wrapper__unique_consecutive));
  m.impl("unique_dim_consecutive",
  TORCH_FN(wrapper__unique_dim_consecutive));
  m.impl("_unique2",
  TORCH_FN(wrapper___unique2));
  m.impl("unsqueeze",
  TORCH_FN(wrapper__unsqueeze));
  m.impl("var.correction",
  TORCH_FN(wrapper_correction_var_correction));
  m.impl("var.correction_out",
  TORCH_FN(wrapper_correction_out_var_out_correction_out));
  m.impl("var_mean.correction",
  TORCH_FN(wrapper_correction_var_mean_correction));
  m.impl("_s_where",
  TORCH_FN(wrapper___s_where));
  m.impl("_weight_norm_cuda_interface",
  TORCH_FN(wrapper___weight_norm_cuda_interface));
  m.impl("_weight_norm_cuda_interface_backward",
  TORCH_FN(wrapper___weight_norm_cuda_interface_backward));
  m.impl("_efficientzerotensor",
  TORCH_FN(wrapper___efficientzerotensor));
  m.impl("_standard_gamma_grad",
  TORCH_FN(wrapper___standard_gamma_grad));
  m.impl("_standard_gamma",
  TORCH_FN(wrapper___standard_gamma));
  m.impl("_dirichlet_grad",
  TORCH_FN(wrapper___dirichlet_grad));
  m.impl("_sample_dirichlet",
  TORCH_FN(wrapper___sample_dirichlet));
  m.impl("poisson",
  TORCH_FN(wrapper__poisson));
  m.impl("binomial",
  TORCH_FN(wrapper__binomial));
  m.impl("norm.ScalarOpt_dim_dtype", TORCH_FN(wrapper_norm_ScalarOpt_dim_dtype));
  m.impl("norm.dtype_out", TORCH_FN(wrapper_norm_out_dtype_out));
  m.impl("norm.ScalarOpt_dim", TORCH_FN(wrapper_norm_ScalarOpt_dim));
  m.impl("norm.out", TORCH_FN(wrapper_norm_out_out));
  m.impl("frexp.Tensor_out",
  TORCH_FN(wrapper_Tensor_out_frexp_out_Tensor_out));
  m.impl("zero_",
  TORCH_FN(wrapper__zero_));
  m.impl("sub.Tensor", TORCH_FN(wrapper_sub_Tensor));
  m.impl("sub.out", TORCH_FN(wrapper_sub_out_out));
  m.impl("sub_.Tensor", TORCH_FN(wrapper_sub__Tensor));
  m.impl("rsub.Tensor",
  TORCH_FN(wrapper_Tensor_rsub_Tensor));
  m.impl("heaviside", TORCH_FN(wrapper_heaviside));
  m.impl("heaviside.out", TORCH_FN(wrapper_heaviside_out_out));
  m.impl("heaviside_", TORCH_FN(wrapper_heaviside_));
  m.impl("addmm", TORCH_FN(wrapper_addmm));
  m.impl("addmm.out", TORCH_FN(wrapper_addmm_out_out));
  m.impl("addmm_", TORCH_FN(wrapper_addmm_));
  m.impl("to_sparse.sparse_dim",
  TORCH_FN(wrapper_sparse_dim_to_sparse_sparse_dim));
  m.impl("to_sparse",
  TORCH_FN(wrapper__to_sparse));
  m.impl("quantize_per_tensor_dynamic",
  TORCH_FN(wrapper__quantize_per_tensor_dynamic));
  m.impl("quantize_per_tensor",
  TORCH_FN(wrapper__quantize_per_tensor));
  m.impl("quantize_per_tensor.tensor_qparams",
  TORCH_FN(wrapper_tensor_qparams_quantize_per_tensor_tensor_qparams));
  m.impl("quantize_per_channel",
  TORCH_FN(wrapper__quantize_per_channel));
  m.impl("dequantize.self",
  TORCH_FN(wrapper_self_dequantize_self));
  m.impl("_make_per_tensor_quantized_tensor",
  TORCH_FN(wrapper___make_per_tensor_quantized_tensor));
  m.impl("_make_per_channel_quantized_tensor",
  TORCH_FN(wrapper___make_per_channel_quantized_tensor));
  m.impl("fake_quantize_per_tensor_affine_cachemask",
  TORCH_FN(wrapper__fake_quantize_per_tensor_affine_cachemask));
  m.impl("_fake_quantize_per_tensor_affine_cachemask_tensor_qparams",
  TORCH_FN(wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams));
  m.impl("_fake_quantize_learnable_per_tensor_affine",
  TORCH_FN(wrapper___fake_quantize_learnable_per_tensor_affine));
  m.impl("fake_quantize_per_channel_affine_cachemask",
  TORCH_FN(wrapper__fake_quantize_per_channel_affine_cachemask));
  m.impl("_fake_quantize_learnable_per_channel_affine",
  TORCH_FN(wrapper___fake_quantize_learnable_per_channel_affine));
  m.impl("_fused_moving_avg_obs_fq_helper",
  TORCH_FN(wrapper___fused_moving_avg_obs_fq_helper));
  m.impl("_local_scalar_dense",
  TORCH_FN(wrapper___local_scalar_dense));
  m.impl("_thnn_fused_lstm_cell",
  TORCH_FN(wrapper___thnn_fused_lstm_cell));
  m.impl("_thnn_fused_lstm_cell_backward",
  TORCH_FN(wrapper___thnn_fused_lstm_cell_backward));
  m.impl("_thnn_fused_gru_cell",
  TORCH_FN(wrapper___thnn_fused_gru_cell));
  m.impl("_thnn_fused_gru_cell_backward",
  TORCH_FN(wrapper___thnn_fused_gru_cell_backward));
  m.impl("set_.source_Storage",
  TORCH_FN(wrapper_source_Storage_set__source_Storage));
  m.impl("set_.source_Storage_storage_offset",
  TORCH_FN(wrapper_source_Storage_storage_offset_set__source_Storage_storage_offset));
  m.impl("set_.source_Tensor",
  TORCH_FN(wrapper_source_Tensor_set__source_Tensor));
  m.impl("set_",
  TORCH_FN(wrapper__set_));
  m.impl("is_set_to",
  TORCH_FN(wrapper__is_set_to));
  m.impl("masked_fill_.Scalar",
  TORCH_FN(wrapper_Scalar_masked_fill__Scalar));
  m.impl("masked_fill_.Tensor",
  TORCH_FN(wrapper_Tensor_masked_fill__Tensor));
  m.impl("masked_scatter_",
  TORCH_FN(wrapper__masked_scatter_));
  m.impl("_masked_softmax",
  TORCH_FN(wrapper___masked_softmax));
  m.impl("view",
  TORCH_FN(wrapper__view));
  m.impl("put_",
  TORCH_FN(wrapper__put_));
  m.impl("index_add", TORCH_FN(wrapper_index_add));
  m.impl("index_add.out", TORCH_FN(wrapper_index_add_out_out));
  m.impl("index_add_", TORCH_FN(wrapper_index_add_));
  m.impl("index_fill_.int_Scalar",
  TORCH_FN(wrapper_int_Scalar_index_fill__int_Scalar));
  m.impl("index_fill_.int_Tensor",
  TORCH_FN(wrapper_int_Tensor_index_fill__int_Tensor));
  m.impl("scatter.src", TORCH_FN(wrapper_scatter_src));
  m.impl("scatter.src_out", TORCH_FN(wrapper_scatter_out_src_out));
  m.impl("scatter_.src", TORCH_FN(wrapper_scatter__src));
  m.impl("scatter.value", TORCH_FN(wrapper_scatter_value));
  m.impl("scatter.value_out", TORCH_FN(wrapper_scatter_out_value_out));
  m.impl("scatter_.value", TORCH_FN(wrapper_scatter__value));
  m.impl("scatter.reduce", TORCH_FN(wrapper_scatter_reduce));
  m.impl("scatter.reduce_out", TORCH_FN(wrapper_scatter_out_reduce_out));
  m.impl("scatter_.reduce", TORCH_FN(wrapper_scatter__reduce));
  m.impl("scatter.value_reduce", TORCH_FN(wrapper_scatter_value_reduce));
  m.impl("scatter.value_reduce_out", TORCH_FN(wrapper_scatter_out_value_reduce_out));
  m.impl("scatter_.value_reduce", TORCH_FN(wrapper_scatter__value_reduce));
  m.impl("scatter_add", TORCH_FN(wrapper_scatter_add));
  m.impl("scatter_add.out", TORCH_FN(wrapper_scatter_add_out_out));
  m.impl("scatter_add_", TORCH_FN(wrapper_scatter_add_));
  m.impl("eq.Scalar", TORCH_FN(wrapper_eq_Scalar));
  m.impl("eq.Scalar_out", TORCH_FN(wrapper_eq_out_Scalar_out));
  m.impl("eq_.Scalar", TORCH_FN(wrapper_eq__Scalar));
  m.impl("eq.Tensor", TORCH_FN(wrapper_eq_Tensor));
  m.impl("eq.Tensor_out", TORCH_FN(wrapper_eq_out_Tensor_out));
  m.impl("eq_.Tensor", TORCH_FN(wrapper_eq__Tensor));
  m.impl("bitwise_and.Tensor", TORCH_FN(wrapper_bitwise_and_Tensor));
  m.impl("bitwise_and.Tensor_out", TORCH_FN(wrapper_bitwise_and_out_Tensor_out));
  m.impl("bitwise_and_.Tensor", TORCH_FN(wrapper_bitwise_and__Tensor));
  m.impl("bitwise_or.Tensor", TORCH_FN(wrapper_bitwise_or_Tensor));
  m.impl("bitwise_or.Tensor_out", TORCH_FN(wrapper_bitwise_or_out_Tensor_out));
  m.impl("bitwise_or_.Tensor", TORCH_FN(wrapper_bitwise_or__Tensor));
  m.impl("bitwise_xor.Tensor", TORCH_FN(wrapper_bitwise_xor_Tensor));
  m.impl("bitwise_xor.Tensor_out", TORCH_FN(wrapper_bitwise_xor_out_Tensor_out));
  m.impl("bitwise_xor_.Tensor", TORCH_FN(wrapper_bitwise_xor__Tensor));
  m.impl("__lshift__.Scalar",
  TORCH_FN(wrapper_Scalar___lshift___Scalar));
  m.impl("__ilshift__.Scalar",
  TORCH_FN(wrapper_Scalar___ilshift___Scalar));
  m.impl("__lshift__.Tensor",
  TORCH_FN(wrapper_Tensor___lshift___Tensor));
  m.impl("__ilshift__.Tensor",
  TORCH_FN(wrapper_Tensor___ilshift___Tensor));
  m.impl("bitwise_left_shift.Tensor", TORCH_FN(wrapper_bitwise_left_shift_Tensor));
  m.impl("bitwise_left_shift.Tensor_out", TORCH_FN(wrapper_bitwise_left_shift_out_Tensor_out));
  m.impl("bitwise_left_shift_.Tensor", TORCH_FN(wrapper_bitwise_left_shift__Tensor));
  m.impl("bitwise_left_shift.Tensor_Scalar",
  TORCH_FN(wrapper_Tensor_Scalar_bitwise_left_shift_Tensor_Scalar));
  m.impl("bitwise_left_shift.Tensor_Scalar_out",
  TORCH_FN(wrapper_Tensor_Scalar_out_bitwise_left_shift_out_Tensor_Scalar_out));
  m.impl("bitwise_left_shift_.Tensor_Scalar",
  TORCH_FN(wrapper_Tensor_Scalar_bitwise_left_shift__Tensor_Scalar));
  m.impl("bitwise_left_shift.Scalar_Tensor",
  TORCH_FN(wrapper_Scalar_Tensor_bitwise_left_shift_Scalar_Tensor));
  m.impl("__rshift__.Scalar",
  TORCH_FN(wrapper_Scalar___rshift___Scalar));
  m.impl("__irshift__.Scalar",
  TORCH_FN(wrapper_Scalar___irshift___Scalar));
  m.impl("__rshift__.Tensor",
  TORCH_FN(wrapper_Tensor___rshift___Tensor));
  m.impl("__irshift__.Tensor",
  TORCH_FN(wrapper_Tensor___irshift___Tensor));
  m.impl("bitwise_right_shift.Tensor", TORCH_FN(wrapper_bitwise_right_shift_Tensor));
  m.impl("bitwise_right_shift.Tensor_out", TORCH_FN(wrapper_bitwise_right_shift_out_Tensor_out));
  m.impl("bitwise_right_shift_.Tensor", TORCH_FN(wrapper_bitwise_right_shift__Tensor));
  m.impl("bitwise_right_shift.Tensor_Scalar",
  TORCH_FN(wrapper_Tensor_Scalar_bitwise_right_shift_Tensor_Scalar));
  m.impl("bitwise_right_shift.Tensor_Scalar_out",
  TORCH_FN(wrapper_Tensor_Scalar_out_bitwise_right_shift_out_Tensor_Scalar_out));
  m.impl("bitwise_right_shift_.Tensor_Scalar",
  TORCH_FN(wrapper_Tensor_Scalar_bitwise_right_shift__Tensor_Scalar));
  m.impl("bitwise_right_shift.Scalar_Tensor",
  TORCH_FN(wrapper_Scalar_Tensor_bitwise_right_shift_Scalar_Tensor));
  m.impl("tril", TORCH_FN(wrapper_tril));
  m.impl("tril.out", TORCH_FN(wrapper_tril_out_out));
  m.impl("tril_", TORCH_FN(wrapper_tril_));
  m.impl("triu", TORCH_FN(wrapper_triu));
  m.impl("triu.out", TORCH_FN(wrapper_triu_out_out));
  m.impl("triu_", TORCH_FN(wrapper_triu_));
  m.impl("digamma", TORCH_FN(wrapper_digamma));
  m.impl("digamma.out", TORCH_FN(wrapper_digamma_out_out));
  m.impl("digamma_", TORCH_FN(wrapper_digamma_));
  m.impl("lerp.Scalar", TORCH_FN(wrapper_lerp_Scalar));
  m.impl("lerp.Scalar_out", TORCH_FN(wrapper_lerp_out_Scalar_out));
  m.impl("lerp_.Scalar", TORCH_FN(wrapper_lerp__Scalar));
  m.impl("lerp.Tensor", TORCH_FN(wrapper_lerp_Tensor));
  m.impl("lerp.Tensor_out", TORCH_FN(wrapper_lerp_out_Tensor_out));
  m.impl("lerp_.Tensor", TORCH_FN(wrapper_lerp__Tensor));
  m.impl("addbmm",
  TORCH_FN(wrapper__addbmm));
  m.impl("addbmm.out",
  TORCH_FN(wrapper_out_addbmm_out_out));
  m.impl("addbmm_",
  TORCH_FN(wrapper__addbmm_));
  m.impl("random_.from",
  TORCH_FN(wrapper_from_random__from));
  m.impl("random_.to",
  TORCH_FN(wrapper_to_random__to));
  m.impl("random_",
  TORCH_FN(wrapper__random_));
  m.impl("uniform_",
  TORCH_FN(wrapper__uniform_));
  m.impl("cauchy_",
  TORCH_FN(wrapper__cauchy_));
  m.impl("log_normal_",
  TORCH_FN(wrapper__log_normal_));
  m.impl("exponential_",
  TORCH_FN(wrapper__exponential_));
  m.impl("geometric_",
  TORCH_FN(wrapper__geometric_));
  m.impl("diag.out",
  TORCH_FN(wrapper_out_diag_out_out));
  m.impl("tril_indices",
  TORCH_FN(wrapper__tril_indices));
  m.impl("triu_indices",
  TORCH_FN(wrapper__triu_indices));
  m.impl("trace",
  TORCH_FN(wrapper__trace));
  m.impl("ne.Scalar", TORCH_FN(wrapper_ne_Scalar));
  m.impl("ne.Scalar_out", TORCH_FN(wrapper_ne_out_Scalar_out));
  m.impl("ne_.Scalar", TORCH_FN(wrapper_ne__Scalar));
  m.impl("ne.Tensor", TORCH_FN(wrapper_ne_Tensor));
  m.impl("ne.Tensor_out", TORCH_FN(wrapper_ne_out_Tensor_out));
  m.impl("ne_.Tensor", TORCH_FN(wrapper_ne__Tensor));
  m.impl("ge.Scalar", TORCH_FN(wrapper_ge_Scalar));
  m.impl("ge.Scalar_out", TORCH_FN(wrapper_ge_out_Scalar_out));
  m.impl("ge_.Scalar", TORCH_FN(wrapper_ge__Scalar));
  m.impl("ge.Tensor", TORCH_FN(wrapper_ge_Tensor));
  m.impl("ge.Tensor_out", TORCH_FN(wrapper_ge_out_Tensor_out));
  m.impl("ge_.Tensor", TORCH_FN(wrapper_ge__Tensor));
  m.impl("le.Scalar", TORCH_FN(wrapper_le_Scalar));
  m.impl("le.Scalar_out", TORCH_FN(wrapper_le_out_Scalar_out));
  m.impl("le_.Scalar", TORCH_FN(wrapper_le__Scalar));
  m.impl("le.Tensor", TORCH_FN(wrapper_le_Tensor));
  m.impl("le.Tensor_out", TORCH_FN(wrapper_le_out_Tensor_out));
  m.impl("le_.Tensor", TORCH_FN(wrapper_le__Tensor));
  m.impl("gt.Scalar", TORCH_FN(wrapper_gt_Scalar));
  m.impl("gt.Scalar_out", TORCH_FN(wrapper_gt_out_Scalar_out));
  m.impl("gt_.Scalar", TORCH_FN(wrapper_gt__Scalar));
  m.impl("gt.Tensor", TORCH_FN(wrapper_gt_Tensor));
  m.impl("gt.Tensor_out", TORCH_FN(wrapper_gt_out_Tensor_out));
  m.impl("gt_.Tensor", TORCH_FN(wrapper_gt__Tensor));
  m.impl("lt.Scalar", TORCH_FN(wrapper_lt_Scalar));
  m.impl("lt.Scalar_out", TORCH_FN(wrapper_lt_out_Scalar_out));
  m.impl("lt_.Scalar", TORCH_FN(wrapper_lt__Scalar));
  m.impl("lt.Tensor", TORCH_FN(wrapper_lt_Tensor));
  m.impl("lt.Tensor_out", TORCH_FN(wrapper_lt_out_Tensor_out));
  m.impl("lt_.Tensor", TORCH_FN(wrapper_lt__Tensor));
  m.impl("take",
  TORCH_FN(wrapper__take));
  m.impl("take.out",
  TORCH_FN(wrapper_out_take_out_out));
  m.impl("index_select",
  TORCH_FN(wrapper__index_select));
  m.impl("index_select.out",
  TORCH_FN(wrapper_out_index_select_out_out));
  m.impl("masked_select",
  TORCH_FN(wrapper__masked_select));
  m.impl("masked_select.out",
  TORCH_FN(wrapper_out_masked_select_out_out));
  m.impl("nonzero",
  TORCH_FN(wrapper__nonzero));
  m.impl("nonzero.out",
  TORCH_FN(wrapper_out_nonzero_out_out));
  m.impl("gather", TORCH_FN(wrapper_gather));
  m.impl("gather.out", TORCH_FN(wrapper_gather_out_out));
  m.impl("addcmul", TORCH_FN(wrapper_addcmul));
  m.impl("addcmul.out", TORCH_FN(wrapper_addcmul_out_out));
  m.impl("addcmul_", TORCH_FN(wrapper_addcmul_));
  m.impl("addcdiv", TORCH_FN(wrapper_addcdiv));
  m.impl("addcdiv.out", TORCH_FN(wrapper_addcdiv_out_out));
  m.impl("addcdiv_", TORCH_FN(wrapper_addcdiv_));
  m.impl("lstsq",
  TORCH_FN(wrapper__lstsq));
  m.impl("lstsq.X",
  TORCH_FN(wrapper_X_lstsq_out_X));
  m.impl("triangular_solve", TORCH_FN(wrapper_triangular_solve));
  m.impl("triangular_solve.X", TORCH_FN(wrapper_triangular_solve_out_X));
  m.impl("linalg_solve_triangular",
  TORCH_FN(wrapper__linalg_solve_triangular));
  m.impl("linalg_solve_triangular.out",
  TORCH_FN(wrapper_out_linalg_solve_triangular_out_out));
  m.impl("_symeig_helper",
  TORCH_FN(wrapper___symeig_helper));
  m.impl("cholesky",
  TORCH_FN(wrapper__cholesky));
  m.impl("cholesky.out",
  TORCH_FN(wrapper_out_cholesky_out_out));
  m.impl("_cholesky_solve_helper",
  TORCH_FN(wrapper___cholesky_solve_helper));
  m.impl("_solve_helper",
  TORCH_FN(wrapper___solve_helper));
  m.impl("cholesky_inverse",
  TORCH_FN(wrapper__cholesky_inverse));
  m.impl("cholesky_inverse.out",
  TORCH_FN(wrapper_out_cholesky_inverse_out_out));
  m.impl("geqrf",
  TORCH_FN(wrapper__geqrf));
  m.impl("geqrf.a",
  TORCH_FN(wrapper_a_geqrf_out_a));
  m.impl("ormqr",
  TORCH_FN(wrapper__ormqr));
  m.impl("ormqr.out",
  TORCH_FN(wrapper_out_ormqr_out_out));
  m.impl("lu_solve",
  TORCH_FN(wrapper__lu_solve));
  m.impl("lu_solve.out",
  TORCH_FN(wrapper_out_lu_solve_out_out));
  m.impl("lu_unpack",
  TORCH_FN(wrapper__lu_unpack));
  m.impl("lu_unpack.out",
  TORCH_FN(wrapper_out_lu_unpack_out_out));
  m.impl("multinomial",
  TORCH_FN(wrapper__multinomial));
  m.impl("multinomial.out",
  TORCH_FN(wrapper_out_multinomial_out_out));
  m.impl("lgamma", TORCH_FN(wrapper_lgamma));
  m.impl("lgamma.out", TORCH_FN(wrapper_lgamma_out_out));
  m.impl("lgamma_", TORCH_FN(wrapper_lgamma_));
  m.impl("polygamma", TORCH_FN(wrapper_polygamma));
  m.impl("polygamma.out", TORCH_FN(wrapper_polygamma_out_out));
  m.impl("erfinv", TORCH_FN(wrapper_erfinv));
  m.impl("erfinv.out", TORCH_FN(wrapper_erfinv_out_out));
  m.impl("erfinv_", TORCH_FN(wrapper_erfinv_));
  m.impl("i0", TORCH_FN(wrapper_i0));
  m.impl("i0.out", TORCH_FN(wrapper_i0_out_out));
  m.impl("i0_", TORCH_FN(wrapper_i0_));
  m.impl("sign", TORCH_FN(wrapper_sign));
  m.impl("sign.out", TORCH_FN(wrapper_sign_out_out));
  m.impl("sign_", TORCH_FN(wrapper_sign_));
  m.impl("signbit", TORCH_FN(wrapper_signbit));
  m.impl("signbit.out", TORCH_FN(wrapper_signbit_out_out));
  m.impl("atan2", TORCH_FN(wrapper_atan2));
  m.impl("atan2.out", TORCH_FN(wrapper_atan2_out_out));
  m.impl("atan2_", TORCH_FN(wrapper_atan2_));
  m.impl("histc",
  TORCH_FN(wrapper__histc));
  m.impl("histc.out",
  TORCH_FN(wrapper_out_histc_out_out));
  m.impl("fmod.Tensor", TORCH_FN(wrapper_fmod_Tensor));
  m.impl("fmod.Tensor_out", TORCH_FN(wrapper_fmod_out_Tensor_out));
  m.impl("fmod_.Tensor", TORCH_FN(wrapper_fmod__Tensor));
  m.impl("hypot", TORCH_FN(wrapper_hypot));
  m.impl("hypot.out", TORCH_FN(wrapper_hypot_out_out));
  m.impl("hypot_", TORCH_FN(wrapper_hypot_));
  m.impl("igamma", TORCH_FN(wrapper_igamma));
  m.impl("igamma.out", TORCH_FN(wrapper_igamma_out_out));
  m.impl("igamma_", TORCH_FN(wrapper_igamma_));
  m.impl("igammac", TORCH_FN(wrapper_igammac));
  m.impl("igammac.out", TORCH_FN(wrapper_igammac_out_out));
  m.impl("igammac_", TORCH_FN(wrapper_igammac_));
  m.impl("nextafter", TORCH_FN(wrapper_nextafter));
  m.impl("nextafter.out", TORCH_FN(wrapper_nextafter_out_out));
  m.impl("nextafter_", TORCH_FN(wrapper_nextafter_));
  m.impl("remainder.Tensor", TORCH_FN(wrapper_remainder_Tensor));
  m.impl("remainder.Tensor_out", TORCH_FN(wrapper_remainder_out_Tensor_out));
  m.impl("remainder_.Tensor", TORCH_FN(wrapper_remainder__Tensor));
  m.impl("remainder.Scalar_Tensor",
  TORCH_FN(wrapper_Scalar_Tensor_remainder_Scalar_Tensor));
  m.impl("min",
  TORCH_FN(wrapper__min));
  m.impl("fmin", TORCH_FN(wrapper_fmin));
  m.impl("fmin.out", TORCH_FN(wrapper_fmin_out_out));
  m.impl("max",
  TORCH_FN(wrapper__max));
  m.impl("fmax", TORCH_FN(wrapper_fmax));
  m.impl("fmax.out", TORCH_FN(wrapper_fmax_out_out));
  m.impl("maximum", TORCH_FN(wrapper_maximum));
  m.impl("maximum.out", TORCH_FN(wrapper_maximum_out_out));
  m.impl("minimum", TORCH_FN(wrapper_minimum));
  m.impl("minimum.out", TORCH_FN(wrapper_minimum_out_out));
  m.impl("sort",
  TORCH_FN(wrapper__sort));
  m.impl("sort.values",
  TORCH_FN(wrapper_values_sort_out_values));
  m.impl("sort.stable",
  TORCH_FN(wrapper_stable_sort_stable));
  m.impl("sort.values_stable",
  TORCH_FN(wrapper_values_stable_sort_out_values_stable));
  m.impl("topk", TORCH_FN(wrapper_topk));
  m.impl("topk.values", TORCH_FN(wrapper_topk_out_values));
  m.impl("all", TORCH_FN(wrapper_all));
  m.impl("all.all_out", TORCH_FN(wrapper_all_out_all_out));
  m.impl("any", TORCH_FN(wrapper_any));
  m.impl("any.all_out", TORCH_FN(wrapper_any_out_all_out));
  m.impl("renorm", TORCH_FN(wrapper_renorm));
  m.impl("renorm.out", TORCH_FN(wrapper_renorm_out_out));
  m.impl("renorm_", TORCH_FN(wrapper_renorm_));
  m.impl("unfold",
  TORCH_FN(wrapper__unfold));
  m.impl("unfold_backward",
  TORCH_FN(wrapper__unfold_backward));
  m.impl("equal",
  TORCH_FN(wrapper__equal));
  m.impl("pow.Tensor_Tensor", TORCH_FN(wrapper_pow_Tensor_Tensor));
  m.impl("pow.Tensor_Tensor_out", TORCH_FN(wrapper_pow_out_Tensor_Tensor_out));
  m.impl("pow_.Tensor", TORCH_FN(wrapper_pow__Tensor));
  m.impl("pow.Scalar", TORCH_FN(wrapper_pow_Scalar));
  m.impl("pow.Scalar_out", TORCH_FN(wrapper_pow_out_Scalar_out));
  m.impl("pow.Tensor_Scalar", TORCH_FN(wrapper_pow_Tensor_Scalar));
  m.impl("pow.Tensor_Scalar_out", TORCH_FN(wrapper_pow_out_Tensor_Scalar_out));
  m.impl("pow_.Scalar", TORCH_FN(wrapper_pow__Scalar));
  m.impl("normal_",
  TORCH_FN(wrapper__normal_));
  m.impl("normal.Tensor_float",
  TORCH_FN(wrapper_Tensor_float_normal_Tensor_float));
  m.impl("normal.Tensor_float_out",
  TORCH_FN(wrapper_Tensor_float_out_normal_out_Tensor_float_out));
  m.impl("normal.float_Tensor",
  TORCH_FN(wrapper_float_Tensor_normal_float_Tensor));
  m.impl("normal.float_Tensor_out",
  TORCH_FN(wrapper_float_Tensor_out_normal_out_float_Tensor_out));
  m.impl("normal.Tensor_Tensor",
  TORCH_FN(wrapper_Tensor_Tensor_normal_Tensor_Tensor));
  m.impl("normal.Tensor_Tensor_out",
  TORCH_FN(wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out));
  m.impl("_amp_foreach_non_finite_check_and_unscale_",
  TORCH_FN(wrapper___amp_foreach_non_finite_check_and_unscale_));
  m.impl("_amp_update_scale_",
  TORCH_FN(wrapper___amp_update_scale_));
  m.impl("_cat",
  TORCH_FN(wrapper___cat));
  m.impl("_cat.out",
  TORCH_FN(wrapper_out__cat_out_out));
  m.impl("_foreach_add.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_add_Scalar));
  m.impl("_foreach_add_.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_add__Scalar));
  m.impl("_foreach_sub.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_sub_Scalar));
  m.impl("_foreach_sub_.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_sub__Scalar));
  m.impl("_foreach_mul.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_mul_Scalar));
  m.impl("_foreach_mul_.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_mul__Scalar));
  m.impl("_foreach_div.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_div_Scalar));
  m.impl("_foreach_div_.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_div__Scalar));
  m.impl("_foreach_add.List",
  TORCH_FN(wrapper_List__foreach_add_List));
  m.impl("_foreach_add_.List",
  TORCH_FN(wrapper_List__foreach_add__List));
  m.impl("_foreach_sub.List",
  TORCH_FN(wrapper_List__foreach_sub_List));
  m.impl("_foreach_sub_.List",
  TORCH_FN(wrapper_List__foreach_sub__List));
  m.impl("_foreach_mul.List",
  TORCH_FN(wrapper_List__foreach_mul_List));
  m.impl("_foreach_mul_.List",
  TORCH_FN(wrapper_List__foreach_mul__List));
  m.impl("_foreach_div.List",
  TORCH_FN(wrapper_List__foreach_div_List));
  m.impl("_foreach_div_.List",
  TORCH_FN(wrapper_List__foreach_div__List));
  m.impl("_foreach_add.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_add_ScalarList));
  m.impl("_foreach_add_.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_add__ScalarList));
  m.impl("_foreach_sub.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_sub_ScalarList));
  m.impl("_foreach_sub_.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_sub__ScalarList));
  m.impl("_foreach_div.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_div_ScalarList));
  m.impl("_foreach_div_.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_div__ScalarList));
  m.impl("_foreach_mul.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_mul_ScalarList));
  m.impl("_foreach_mul_.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_mul__ScalarList));
  m.impl("_foreach_exp",
  TORCH_FN(wrapper___foreach_exp));
  m.impl("_foreach_zero_",
  TORCH_FN(wrapper___foreach_zero_));
  m.impl("_foreach_exp_",
  TORCH_FN(wrapper___foreach_exp_));
  m.impl("_foreach_sqrt",
  TORCH_FN(wrapper___foreach_sqrt));
  m.impl("_foreach_sqrt_",
  TORCH_FN(wrapper___foreach_sqrt_));
  m.impl("_foreach_abs",
  TORCH_FN(wrapper___foreach_abs));
  m.impl("_foreach_abs_",
  TORCH_FN(wrapper___foreach_abs_));
  m.impl("_foreach_acos",
  TORCH_FN(wrapper___foreach_acos));
  m.impl("_foreach_acos_",
  TORCH_FN(wrapper___foreach_acos_));
  m.impl("_foreach_asin",
  TORCH_FN(wrapper___foreach_asin));
  m.impl("_foreach_asin_",
  TORCH_FN(wrapper___foreach_asin_));
  m.impl("_foreach_atan",
  TORCH_FN(wrapper___foreach_atan));
  m.impl("_foreach_atan_",
  TORCH_FN(wrapper___foreach_atan_));
  m.impl("_foreach_ceil",
  TORCH_FN(wrapper___foreach_ceil));
  m.impl("_foreach_ceil_",
  TORCH_FN(wrapper___foreach_ceil_));
  m.impl("_foreach_cos",
  TORCH_FN(wrapper___foreach_cos));
  m.impl("_foreach_cos_",
  TORCH_FN(wrapper___foreach_cos_));
  m.impl("_foreach_cosh",
  TORCH_FN(wrapper___foreach_cosh));
  m.impl("_foreach_cosh_",
  TORCH_FN(wrapper___foreach_cosh_));
  m.impl("_foreach_erf",
  TORCH_FN(wrapper___foreach_erf));
  m.impl("_foreach_erf_",
  TORCH_FN(wrapper___foreach_erf_));
  m.impl("_foreach_erfc",
  TORCH_FN(wrapper___foreach_erfc));
  m.impl("_foreach_erfc_",
  TORCH_FN(wrapper___foreach_erfc_));
  m.impl("_foreach_expm1",
  TORCH_FN(wrapper___foreach_expm1));
  m.impl("_foreach_expm1_",
  TORCH_FN(wrapper___foreach_expm1_));
  m.impl("_foreach_floor",
  TORCH_FN(wrapper___foreach_floor));
  m.impl("_foreach_floor_",
  TORCH_FN(wrapper___foreach_floor_));
  m.impl("_foreach_log",
  TORCH_FN(wrapper___foreach_log));
  m.impl("_foreach_log_",
  TORCH_FN(wrapper___foreach_log_));
  m.impl("_foreach_log10",
  TORCH_FN(wrapper___foreach_log10));
  m.impl("_foreach_log10_",
  TORCH_FN(wrapper___foreach_log10_));
  m.impl("_foreach_log1p",
  TORCH_FN(wrapper___foreach_log1p));
  m.impl("_foreach_log1p_",
  TORCH_FN(wrapper___foreach_log1p_));
  m.impl("_foreach_log2",
  TORCH_FN(wrapper___foreach_log2));
  m.impl("_foreach_log2_",
  TORCH_FN(wrapper___foreach_log2_));
  m.impl("_foreach_neg",
  TORCH_FN(wrapper___foreach_neg));
  m.impl("_foreach_neg_",
  TORCH_FN(wrapper___foreach_neg_));
  m.impl("_foreach_tan",
  TORCH_FN(wrapper___foreach_tan));
  m.impl("_foreach_tan_",
  TORCH_FN(wrapper___foreach_tan_));
  m.impl("_foreach_tanh",
  TORCH_FN(wrapper___foreach_tanh));
  m.impl("_foreach_tanh_",
  TORCH_FN(wrapper___foreach_tanh_));
  m.impl("_foreach_sin",
  TORCH_FN(wrapper___foreach_sin));
  m.impl("_foreach_sin_",
  TORCH_FN(wrapper___foreach_sin_));
  m.impl("_foreach_sinh",
  TORCH_FN(wrapper___foreach_sinh));
  m.impl("_foreach_sinh_",
  TORCH_FN(wrapper___foreach_sinh_));
  m.impl("_foreach_round",
  TORCH_FN(wrapper___foreach_round));
  m.impl("_foreach_round_",
  TORCH_FN(wrapper___foreach_round_));
  m.impl("_foreach_lgamma",
  TORCH_FN(wrapper___foreach_lgamma));
  m.impl("_foreach_lgamma_",
  TORCH_FN(wrapper___foreach_lgamma_));
  m.impl("_foreach_frac",
  TORCH_FN(wrapper___foreach_frac));
  m.impl("_foreach_frac_",
  TORCH_FN(wrapper___foreach_frac_));
  m.impl("_foreach_reciprocal",
  TORCH_FN(wrapper___foreach_reciprocal));
  m.impl("_foreach_reciprocal_",
  TORCH_FN(wrapper___foreach_reciprocal_));
  m.impl("_foreach_sigmoid",
  TORCH_FN(wrapper___foreach_sigmoid));
  m.impl("_foreach_sigmoid_",
  TORCH_FN(wrapper___foreach_sigmoid_));
  m.impl("_foreach_trunc",
  TORCH_FN(wrapper___foreach_trunc));
  m.impl("_foreach_trunc_",
  TORCH_FN(wrapper___foreach_trunc_));
  m.impl("_foreach_addcdiv_.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_addcdiv__Scalar));
  m.impl("_foreach_addcmul_.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_addcmul__Scalar));
  m.impl("_foreach_addcdiv_.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_addcdiv__ScalarList));
  m.impl("_foreach_addcmul_.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_addcmul__ScalarList));
  m.impl("_foreach_addcdiv.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_addcdiv_Scalar));
  m.impl("_foreach_addcmul.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_addcmul_Scalar));
  m.impl("_foreach_addcdiv.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_addcdiv_ScalarList));
  m.impl("_foreach_addcmul.ScalarList",
  TORCH_FN(wrapper_ScalarList__foreach_addcmul_ScalarList));
  m.impl("_foreach_maximum.List",
  TORCH_FN(wrapper_List__foreach_maximum_List));
  m.impl("_foreach_minimum.List",
  TORCH_FN(wrapper_List__foreach_minimum_List));
  m.impl("_foreach_norm.Scalar",
  TORCH_FN(wrapper_Scalar__foreach_norm_Scalar));
  m.impl("bucketize.Tensor",
  TORCH_FN(wrapper_Tensor_bucketize_Tensor));
  m.impl("bucketize.Tensor_out",
  TORCH_FN(wrapper_Tensor_out_bucketize_out_Tensor_out));
  m.impl("bucketize.Scalar",
  TORCH_FN(wrapper_Scalar_bucketize_Scalar));
  m.impl("searchsorted.Tensor",
  TORCH_FN(wrapper_Tensor_searchsorted_Tensor));
  m.impl("searchsorted.Tensor_out",
  TORCH_FN(wrapper_Tensor_out_searchsorted_out_Tensor_out));
  m.impl("_torch_cuda_cu_linker_symbol_op",
  TORCH_FN(wrapper___torch_cuda_cu_linker_symbol_op));
  m.impl("searchsorted.Scalar",
  TORCH_FN(wrapper_Scalar_searchsorted_Scalar));
  m.impl("_convert_indices_from_coo_to_csr", TORCH_FN(wrapper__convert_indices_from_coo_to_csr));
  m.impl("_convert_indices_from_coo_to_csr.out", TORCH_FN(wrapper__convert_indices_from_coo_to_csr_out_out));
  m.impl("_convert_indices_from_csr_to_coo", TORCH_FN(wrapper__convert_indices_from_csr_to_coo));
  m.impl("_convert_indices_from_csr_to_coo.out", TORCH_FN(wrapper__convert_indices_from_csr_to_coo_out_out));
  m.impl("mse_loss",
  TORCH_FN(wrapper__mse_loss));
  m.impl("mse_loss.out",
  TORCH_FN(wrapper_out_mse_loss_out_out));
  m.impl("mse_loss_backward",
  TORCH_FN(wrapper__mse_loss_backward));
  m.impl("mse_loss_backward.grad_input",
  TORCH_FN(wrapper_grad_input_mse_loss_backward_out_grad_input));
  m.impl("l1_loss_backward.grad_input",
  TORCH_FN(wrapper_grad_input_l1_loss_backward_out_grad_input));
  m.impl("multi_margin_loss",
  TORCH_FN(wrapper__multi_margin_loss));
  m.impl("multi_margin_loss.out",
  TORCH_FN(wrapper_out_multi_margin_loss_out_out));
  m.impl("multi_margin_loss_backward",
  TORCH_FN(wrapper__multi_margin_loss_backward));
  m.impl("multi_margin_loss_backward.grad_input",
  TORCH_FN(wrapper_grad_input_multi_margin_loss_backward_out_grad_input));
  m.impl("multilabel_margin_loss_forward",
  TORCH_FN(wrapper__multilabel_margin_loss_forward));
  m.impl("multilabel_margin_loss_forward.output",
  TORCH_FN(wrapper_output_multilabel_margin_loss_forward_out_output));
  m.impl("multilabel_margin_loss_backward",
  TORCH_FN(wrapper__multilabel_margin_loss_backward));
  m.impl("multilabel_margin_loss_backward.grad_input",
  TORCH_FN(wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input));
  m.impl("nll_loss_forward", TORCH_FN(wrapper_nll_loss_forward));
  m.impl("nll_loss_forward.output", TORCH_FN(wrapper_nll_loss_forward_out_output));
  m.impl("nll_loss_backward", TORCH_FN(wrapper_nll_loss_backward));
  m.impl("nll_loss_backward.grad_input", TORCH_FN(wrapper_nll_loss_backward_out_grad_input));
  m.impl("nll_loss2d_forward",
  TORCH_FN(wrapper__nll_loss2d_forward));
  m.impl("nll_loss2d_forward.output",
  TORCH_FN(wrapper_output_nll_loss2d_forward_out_output));
  m.impl("nll_loss2d_backward",
  TORCH_FN(wrapper__nll_loss2d_backward));
  m.impl("nll_loss2d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_nll_loss2d_backward_out_grad_input));
  m.impl("smooth_l1_loss", TORCH_FN(wrapper_smooth_l1_loss));
  m.impl("smooth_l1_loss.out", TORCH_FN(wrapper_smooth_l1_loss_out_out));
  m.impl("smooth_l1_loss_backward.grad_input",
  TORCH_FN(wrapper_grad_input_smooth_l1_loss_backward_out_grad_input));
  m.impl("huber_loss",
  TORCH_FN(wrapper__huber_loss));
  m.impl("huber_loss.out",
  TORCH_FN(wrapper_out_huber_loss_out_out));
  m.impl("huber_loss_backward.out",
  TORCH_FN(wrapper_out_huber_loss_backward_out_out));
  m.impl("elu", TORCH_FN(wrapper_elu));
  m.impl("elu.out", TORCH_FN(wrapper_elu_out_out));
  m.impl("elu_", TORCH_FN(wrapper_elu_));
  m.impl("elu_backward", TORCH_FN(wrapper_elu_backward));
  m.impl("elu_backward.grad_input", TORCH_FN(wrapper_elu_backward_out_grad_input));
  m.impl("glu", TORCH_FN(wrapper_glu));
  m.impl("glu.out", TORCH_FN(wrapper_glu_out_out));
  m.impl("glu_backward",
  TORCH_FN(wrapper__glu_backward));
  m.impl("glu_backward.grad_input",
  TORCH_FN(wrapper_grad_input_glu_backward_out_grad_input));
  m.impl("hardsigmoid", TORCH_FN(wrapper_hardsigmoid));
  m.impl("hardsigmoid.out", TORCH_FN(wrapper_hardsigmoid_out_out));
  m.impl("hardsigmoid_", TORCH_FN(wrapper_hardsigmoid_));
  m.impl("hardsigmoid_backward", TORCH_FN(wrapper_hardsigmoid_backward));
  m.impl("hardsigmoid_backward.grad_input", TORCH_FN(wrapper_hardsigmoid_backward_out_grad_input));
  m.impl("hardtanh",
  TORCH_FN(wrapper__hardtanh));
  m.impl("hardtanh.out",
  TORCH_FN(wrapper_out_hardtanh_out_out));
  m.impl("hardtanh_",
  TORCH_FN(wrapper__hardtanh_));
  m.impl("hardtanh_backward",
  TORCH_FN(wrapper__hardtanh_backward));
  m.impl("hardtanh_backward.grad_input",
  TORCH_FN(wrapper_grad_input_hardtanh_backward_out_grad_input));
  m.impl("hardswish",
  TORCH_FN(wrapper__hardswish));
  m.impl("hardswish.out",
  TORCH_FN(wrapper_out_hardswish_out_out));
  m.impl("hardswish_",
  TORCH_FN(wrapper__hardswish_));
  m.impl("hardswish_backward",
  TORCH_FN(wrapper__hardswish_backward));
  m.impl("leaky_relu", TORCH_FN(wrapper_leaky_relu));
  m.impl("leaky_relu.out", TORCH_FN(wrapper_leaky_relu_out_out));
  m.impl("leaky_relu_", TORCH_FN(wrapper_leaky_relu_));
  m.impl("leaky_relu_backward", TORCH_FN(wrapper_leaky_relu_backward));
  m.impl("leaky_relu_backward.grad_input", TORCH_FN(wrapper_leaky_relu_backward_out_grad_input));
  m.impl("log_sigmoid_forward",
  TORCH_FN(wrapper__log_sigmoid_forward));
  m.impl("log_sigmoid_forward.output",
  TORCH_FN(wrapper_output_log_sigmoid_forward_out_output));
  m.impl("log_sigmoid_backward",
  TORCH_FN(wrapper__log_sigmoid_backward));
  m.impl("log_sigmoid_backward.grad_input",
  TORCH_FN(wrapper_grad_input_log_sigmoid_backward_out_grad_input));
  m.impl("rrelu_with_noise",
  TORCH_FN(wrapper__rrelu_with_noise));
  m.impl("rrelu_with_noise.out",
  TORCH_FN(wrapper_out_rrelu_with_noise_out_out));
  m.impl("rrelu_with_noise_",
  TORCH_FN(wrapper__rrelu_with_noise_));
  m.impl("softplus", TORCH_FN(wrapper_softplus));
  m.impl("softplus.out", TORCH_FN(wrapper_softplus_out_out));
  m.impl("softplus_backward", TORCH_FN(wrapper_softplus_backward));
  m.impl("softplus_backward.grad_input", TORCH_FN(wrapper_softplus_backward_out_grad_input));
  m.impl("softshrink", TORCH_FN(wrapper_softshrink));
  m.impl("softshrink.out", TORCH_FN(wrapper_softshrink_out_out));
  m.impl("softshrink_backward", TORCH_FN(wrapper_softshrink_backward));
  m.impl("softshrink_backward.grad_input", TORCH_FN(wrapper_softshrink_backward_out_grad_input));
  m.impl("adaptive_avg_pool2d.out",
  TORCH_FN(wrapper_out_adaptive_avg_pool2d_out_out));
  m.impl("_adaptive_avg_pool2d",
  TORCH_FN(wrapper___adaptive_avg_pool2d));
  m.impl("_adaptive_avg_pool2d_backward",
  TORCH_FN(wrapper___adaptive_avg_pool2d_backward));
  m.impl("adaptive_avg_pool3d.out",
  TORCH_FN(wrapper_out_adaptive_avg_pool3d_out_out));
  m.impl("_adaptive_avg_pool3d",
  TORCH_FN(wrapper___adaptive_avg_pool3d));
  m.impl("adaptive_avg_pool3d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input));
  m.impl("_adaptive_avg_pool3d_backward",
  TORCH_FN(wrapper___adaptive_avg_pool3d_backward));
  m.impl("adaptive_max_pool2d", TORCH_FN(wrapper_adaptive_max_pool2d));
  m.impl("adaptive_max_pool2d.out", TORCH_FN(wrapper_adaptive_max_pool2d_out_out));
  m.impl("adaptive_max_pool2d_backward", TORCH_FN(wrapper_adaptive_max_pool2d_backward));
  m.impl("adaptive_max_pool2d_backward.grad_input", TORCH_FN(wrapper_adaptive_max_pool2d_backward_out_grad_input));
  m.impl("adaptive_max_pool3d", TORCH_FN(wrapper_adaptive_max_pool3d));
  m.impl("adaptive_max_pool3d.out", TORCH_FN(wrapper_adaptive_max_pool3d_out_out));
  m.impl("adaptive_max_pool3d_backward", TORCH_FN(wrapper_adaptive_max_pool3d_backward));
  m.impl("adaptive_max_pool3d_backward.grad_input", TORCH_FN(wrapper_adaptive_max_pool3d_backward_out_grad_input));
  m.impl("avg_pool2d", TORCH_FN(wrapper_avg_pool2d));
  m.impl("avg_pool2d.out", TORCH_FN(wrapper_avg_pool2d_out_out));
  m.impl("avg_pool2d_backward", TORCH_FN(wrapper_avg_pool2d_backward));
  m.impl("avg_pool2d_backward.grad_input", TORCH_FN(wrapper_avg_pool2d_backward_out_grad_input));
  m.impl("avg_pool3d", TORCH_FN(wrapper_avg_pool3d));
  m.impl("avg_pool3d.out", TORCH_FN(wrapper_avg_pool3d_out_out));
  m.impl("avg_pool3d_backward", TORCH_FN(wrapper_avg_pool3d_backward));
  m.impl("avg_pool3d_backward.grad_input", TORCH_FN(wrapper_avg_pool3d_backward_out_grad_input));
  m.impl("fractional_max_pool2d", TORCH_FN(wrapper_fractional_max_pool2d));
  m.impl("fractional_max_pool2d.output", TORCH_FN(wrapper_fractional_max_pool2d_out_output));
  m.impl("fractional_max_pool2d_backward", TORCH_FN(wrapper_fractional_max_pool2d_backward));
  m.impl("fractional_max_pool2d_backward.grad_input", TORCH_FN(wrapper_fractional_max_pool2d_backward_out_grad_input));
  m.impl("fractional_max_pool3d", TORCH_FN(wrapper_fractional_max_pool3d));
  m.impl("fractional_max_pool3d.output", TORCH_FN(wrapper_fractional_max_pool3d_out_output));
  m.impl("fractional_max_pool3d_backward",
  TORCH_FN(wrapper__fractional_max_pool3d_backward));
  m.impl("fractional_max_pool3d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input));
  m.impl("max_pool2d_with_indices", TORCH_FN(wrapper_max_pool2d_with_indices));
  m.impl("max_pool2d_with_indices.out", TORCH_FN(wrapper_max_pool2d_with_indices_out_out));
  m.impl("max_pool2d_with_indices_backward", TORCH_FN(wrapper_max_pool2d_with_indices_backward));
  m.impl("max_pool2d_with_indices_backward.grad_input", TORCH_FN(wrapper_max_pool2d_with_indices_backward_out_grad_input));
  m.impl("max_pool3d_with_indices",
  TORCH_FN(wrapper__max_pool3d_with_indices));
  m.impl("max_pool3d_with_indices.out",
  TORCH_FN(wrapper_out_max_pool3d_with_indices_out_out));
  m.impl("max_pool3d_with_indices_backward",
  TORCH_FN(wrapper__max_pool3d_with_indices_backward));
  m.impl("max_pool3d_with_indices_backward.grad_input",
  TORCH_FN(wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input));
  m.impl("max_unpool2d",
  TORCH_FN(wrapper__max_unpool2d));
  m.impl("max_unpool2d.out",
  TORCH_FN(wrapper_out_max_unpool2d_out_out));
  m.impl("max_unpool2d_backward",
  TORCH_FN(wrapper__max_unpool2d_backward));
  m.impl("max_unpool2d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_max_unpool2d_backward_out_grad_input));
  m.impl("max_unpool3d",
  TORCH_FN(wrapper__max_unpool3d));
  m.impl("max_unpool3d.out",
  TORCH_FN(wrapper_out_max_unpool3d_out_out));
  m.impl("max_unpool3d_backward",
  TORCH_FN(wrapper__max_unpool3d_backward));
  m.impl("max_unpool3d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_max_unpool3d_backward_out_grad_input));
  m.impl("reflection_pad1d", TORCH_FN(wrapper_reflection_pad1d));
  m.impl("reflection_pad1d.out", TORCH_FN(wrapper_reflection_pad1d_out_out));
  m.impl("reflection_pad1d_backward", TORCH_FN(wrapper_reflection_pad1d_backward));
  m.impl("reflection_pad1d_backward.grad_input", TORCH_FN(wrapper_reflection_pad1d_backward_out_grad_input));
  m.impl("reflection_pad2d",
  TORCH_FN(wrapper__reflection_pad2d));
  m.impl("reflection_pad2d.out",
  TORCH_FN(wrapper_out_reflection_pad2d_out_out));
  m.impl("reflection_pad2d_backward",
  TORCH_FN(wrapper__reflection_pad2d_backward));
  m.impl("reflection_pad2d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_reflection_pad2d_backward_out_grad_input));
  m.impl("reflection_pad3d", TORCH_FN(wrapper_reflection_pad3d));
  m.impl("reflection_pad3d.out", TORCH_FN(wrapper_reflection_pad3d_out_out));
  m.impl("reflection_pad3d_backward", TORCH_FN(wrapper_reflection_pad3d_backward));
  m.impl("reflection_pad3d_backward.grad_input", TORCH_FN(wrapper_reflection_pad3d_backward_out_grad_input));
  m.impl("replication_pad1d", TORCH_FN(wrapper_replication_pad1d));
  m.impl("replication_pad1d.out", TORCH_FN(wrapper_replication_pad1d_out_out));
  m.impl("replication_pad1d_backward", TORCH_FN(wrapper_replication_pad1d_backward));
  m.impl("replication_pad1d_backward.grad_input", TORCH_FN(wrapper_replication_pad1d_backward_out_grad_input));
  m.impl("replication_pad2d", TORCH_FN(wrapper_replication_pad2d));
  m.impl("replication_pad2d.out", TORCH_FN(wrapper_replication_pad2d_out_out));
  m.impl("replication_pad2d_backward",
  TORCH_FN(wrapper__replication_pad2d_backward));
  m.impl("replication_pad2d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_replication_pad2d_backward_out_grad_input));
  m.impl("replication_pad3d", TORCH_FN(wrapper_replication_pad3d));
  m.impl("replication_pad3d.out", TORCH_FN(wrapper_replication_pad3d_out_out));
  m.impl("replication_pad3d_backward",
  TORCH_FN(wrapper__replication_pad3d_backward));
  m.impl("replication_pad3d_backward.grad_input",
  TORCH_FN(wrapper_grad_input_replication_pad3d_backward_out_grad_input));
  m.impl("upsample_nearest3d.vec",
  TORCH_FN(wrapper_vec_upsample_nearest3d_vec));
  m.impl("_upsample_nearest_exact3d.vec",
  TORCH_FN(wrapper_vec__upsample_nearest_exact3d_vec));
  m.impl("upsample_nearest3d_backward.vec",
  TORCH_FN(wrapper_vec_upsample_nearest3d_backward_vec));
  m.impl("_upsample_nearest_exact3d_backward.vec",
  TORCH_FN(wrapper_vec__upsample_nearest_exact3d_backward_vec));
  m.impl("upsample_linear1d", TORCH_FN(wrapper_upsample_linear1d));
  m.impl("upsample_linear1d.out", TORCH_FN(wrapper_upsample_linear1d_out_out));
  m.impl("upsample_linear1d_backward", TORCH_FN(wrapper_upsample_linear1d_backward));
  m.impl("upsample_linear1d_backward.grad_input", TORCH_FN(wrapper_upsample_linear1d_backward_out_grad_input));
  m.impl("upsample_bilinear2d", TORCH_FN(wrapper_upsample_bilinear2d));
  m.impl("upsample_bilinear2d.out", TORCH_FN(wrapper_upsample_bilinear2d_out_out));
  m.impl("upsample_bilinear2d_backward", TORCH_FN(wrapper_upsample_bilinear2d_backward));
  m.impl("upsample_bilinear2d_backward.grad_input", TORCH_FN(wrapper_upsample_bilinear2d_backward_out_grad_input));
  m.impl("_upsample_bilinear2d_aa", TORCH_FN(wrapper__upsample_bilinear2d_aa));
  m.impl("_upsample_bilinear2d_aa.out", TORCH_FN(wrapper__upsample_bilinear2d_aa_out_out));
  m.impl("_upsample_bilinear2d_aa_backward", TORCH_FN(wrapper__upsample_bilinear2d_aa_backward));
  m.impl("_upsample_bilinear2d_aa_backward.grad_input", TORCH_FN(wrapper__upsample_bilinear2d_aa_backward_out_grad_input));
  m.impl("upsample_bicubic2d", TORCH_FN(wrapper_upsample_bicubic2d));
  m.impl("upsample_bicubic2d.out", TORCH_FN(wrapper_upsample_bicubic2d_out_out));
  m.impl("upsample_bicubic2d_backward", TORCH_FN(wrapper_upsample_bicubic2d_backward));
  m.impl("upsample_bicubic2d_backward.grad_input", TORCH_FN(wrapper_upsample_bicubic2d_backward_out_grad_input));
  m.impl("_upsample_bicubic2d_aa", TORCH_FN(wrapper__upsample_bicubic2d_aa));
  m.impl("_upsample_bicubic2d_aa.out", TORCH_FN(wrapper__upsample_bicubic2d_aa_out_out));
  m.impl("_upsample_bicubic2d_aa_backward", TORCH_FN(wrapper__upsample_bicubic2d_aa_backward));
  m.impl("_upsample_bicubic2d_aa_backward.grad_input", TORCH_FN(wrapper__upsample_bicubic2d_aa_backward_out_grad_input));
  m.impl("upsample_trilinear3d", TORCH_FN(wrapper_upsample_trilinear3d));
  m.impl("upsample_trilinear3d.out", TORCH_FN(wrapper_upsample_trilinear3d_out_out));
  m.impl("upsample_trilinear3d_backward", TORCH_FN(wrapper_upsample_trilinear3d_backward));
  m.impl("upsample_trilinear3d_backward.grad_input", TORCH_FN(wrapper_upsample_trilinear3d_backward_out_grad_input));
  m.impl("upsample_nearest1d", TORCH_FN(wrapper_upsample_nearest1d));
  m.impl("upsample_nearest1d.out", TORCH_FN(wrapper_upsample_nearest1d_out_out));
  m.impl("_upsample_nearest_exact1d", TORCH_FN(wrapper__upsample_nearest_exact1d));
  m.impl("_upsample_nearest_exact1d.out", TORCH_FN(wrapper__upsample_nearest_exact1d_out_out));
  m.impl("upsample_nearest1d_backward", TORCH_FN(wrapper_upsample_nearest1d_backward));
  m.impl("upsample_nearest1d_backward.grad_input", TORCH_FN(wrapper_upsample_nearest1d_backward_out_grad_input));
  m.impl("_upsample_nearest_exact1d_backward", TORCH_FN(wrapper__upsample_nearest_exact1d_backward));
  m.impl("_upsample_nearest_exact1d_backward.grad_input", TORCH_FN(wrapper__upsample_nearest_exact1d_backward_out_grad_input));
  m.impl("upsample_nearest2d", TORCH_FN(wrapper_upsample_nearest2d));
  m.impl("upsample_nearest2d.out", TORCH_FN(wrapper_upsample_nearest2d_out_out));
  m.impl("_upsample_nearest_exact2d", TORCH_FN(wrapper__upsample_nearest_exact2d));
  m.impl("_upsample_nearest_exact2d.out", TORCH_FN(wrapper__upsample_nearest_exact2d_out_out));
  m.impl("upsample_nearest2d_backward", TORCH_FN(wrapper_upsample_nearest2d_backward));
  m.impl("upsample_nearest2d_backward.grad_input", TORCH_FN(wrapper_upsample_nearest2d_backward_out_grad_input));
  m.impl("_upsample_nearest_exact2d_backward", TORCH_FN(wrapper__upsample_nearest_exact2d_backward));
  m.impl("_upsample_nearest_exact2d_backward.grad_input", TORCH_FN(wrapper__upsample_nearest_exact2d_backward_out_grad_input));
  m.impl("upsample_nearest3d", TORCH_FN(wrapper_upsample_nearest3d));
  m.impl("upsample_nearest3d.out", TORCH_FN(wrapper_upsample_nearest3d_out_out));
  m.impl("_upsample_nearest_exact3d", TORCH_FN(wrapper__upsample_nearest_exact3d));
  m.impl("_upsample_nearest_exact3d.out", TORCH_FN(wrapper__upsample_nearest_exact3d_out_out));
  m.impl("upsample_nearest3d_backward", TORCH_FN(wrapper_upsample_nearest3d_backward));
  m.impl("upsample_nearest3d_backward.grad_input", TORCH_FN(wrapper_upsample_nearest3d_backward_out_grad_input));
  m.impl("_upsample_nearest_exact3d_backward", TORCH_FN(wrapper__upsample_nearest_exact3d_backward));
  m.impl("_upsample_nearest_exact3d_backward.grad_input", TORCH_FN(wrapper__upsample_nearest_exact3d_backward_out_grad_input));
  m.impl("sigmoid_backward", TORCH_FN(wrapper_sigmoid_backward));
  m.impl("sigmoid_backward.grad_input", TORCH_FN(wrapper_sigmoid_backward_out_grad_input));
  m.impl("logit_backward", TORCH_FN(wrapper_logit_backward));
  m.impl("logit_backward.grad_input", TORCH_FN(wrapper_logit_backward_out_grad_input));
  m.impl("tanh_backward", TORCH_FN(wrapper_tanh_backward));
  m.impl("tanh_backward.grad_input", TORCH_FN(wrapper_tanh_backward_out_grad_input));
  m.impl("slow_conv_transpose2d", TORCH_FN(wrapper_slow_conv_transpose2d));
  m.impl("slow_conv_transpose2d.out", TORCH_FN(wrapper_slow_conv_transpose2d_out_out));
  m.impl("slow_conv_transpose3d",
  TORCH_FN(wrapper__slow_conv_transpose3d));
  m.impl("slow_conv_transpose3d.out",
  TORCH_FN(wrapper_out_slow_conv_transpose3d_out_out));
  m.impl("_slow_conv2d_forward",
  TORCH_FN(wrapper___slow_conv2d_forward));
  m.impl("_slow_conv2d_forward.output",
  TORCH_FN(wrapper_output__slow_conv2d_forward_out_output));
  m.impl("_slow_conv2d_backward.grad_input",
  TORCH_FN(wrapper_grad_input__slow_conv2d_backward_out_grad_input));
  m.impl("_slow_conv2d_backward.output_mask",
  TORCH_FN(wrapper_output_mask__slow_conv2d_backward_output_mask));
  m.impl("_conv_depthwise2d",
  TORCH_FN(wrapper___conv_depthwise2d));
  m.impl("_conv_depthwise2d.out",
  TORCH_FN(wrapper_out__conv_depthwise2d_out_out));
  m.impl("conv_depthwise3d",
  TORCH_FN(wrapper__conv_depthwise3d));
  m.impl("slow_conv_dilated2d",
  TORCH_FN(wrapper__slow_conv_dilated2d));
  m.impl("slow_conv_dilated3d",
  TORCH_FN(wrapper__slow_conv_dilated3d));
  m.impl("col2im",
  TORCH_FN(wrapper__col2im));
  m.impl("col2im.out",
  TORCH_FN(wrapper_out_col2im_out_out));
  m.impl("col2im_backward",
  TORCH_FN(wrapper__col2im_backward));
  m.impl("col2im_backward.grad_input",
  TORCH_FN(wrapper_grad_input_col2im_backward_out_grad_input));
  m.impl("im2col",
  TORCH_FN(wrapper__im2col));
  m.impl("im2col.out",
  TORCH_FN(wrapper_out_im2col_out_out));
  m.impl("im2col_backward",
  TORCH_FN(wrapper__im2col_backward));
  m.impl("im2col_backward.grad_input",
  TORCH_FN(wrapper_grad_input_im2col_backward_out_grad_input));
  m.impl("record_stream",
  TORCH_FN(wrapper__record_stream));
  m.impl("isposinf", TORCH_FN(wrapper_isposinf));
  m.impl("isposinf.out", TORCH_FN(wrapper_isposinf_out_out));
  m.impl("isneginf", TORCH_FN(wrapper_isneginf));
  m.impl("isneginf.out", TORCH_FN(wrapper_isneginf_out_out));
  m.impl("special_entr", TORCH_FN(wrapper_special_entr));
  m.impl("special_entr.out", TORCH_FN(wrapper_special_entr_out_out));
  m.impl("special_ndtri", TORCH_FN(wrapper_special_ndtri));
  m.impl("special_ndtri.out", TORCH_FN(wrapper_special_ndtri_out_out));
  m.impl("special_erfcx", TORCH_FN(wrapper_special_erfcx));
  m.impl("special_erfcx.out", TORCH_FN(wrapper_special_erfcx_out_out));
  m.impl("special_xlog1py", TORCH_FN(wrapper_special_xlog1py));
  m.impl("special_xlog1py.out", TORCH_FN(wrapper_special_xlog1py_out_out));
  m.impl("special_zeta", TORCH_FN(wrapper_special_zeta));
  m.impl("special_zeta.out", TORCH_FN(wrapper_special_zeta_out_out));
  m.impl("special_i0e", TORCH_FN(wrapper_special_i0e));
  m.impl("special_i0e.out", TORCH_FN(wrapper_special_i0e_out_out));
  m.impl("special_i1", TORCH_FN(wrapper_special_i1));
  m.impl("special_i1.out", TORCH_FN(wrapper_special_i1_out_out));
  m.impl("special_i1e", TORCH_FN(wrapper_special_i1e));
  m.impl("special_i1e.out", TORCH_FN(wrapper_special_i1e_out_out));
  m.impl("linalg_cholesky_ex",
  TORCH_FN(wrapper__linalg_cholesky_ex));
  m.impl("linalg_cholesky_ex.L",
  TORCH_FN(wrapper_L_linalg_cholesky_ex_out_L));
  m.impl("linalg_cross", TORCH_FN(wrapper_linalg_cross));
  m.impl("linalg_cross.out", TORCH_FN(wrapper_linalg_cross_out_out));
  m.impl("linalg_lu_factor_ex", TORCH_FN(wrapper_linalg_lu_factor_ex));
  m.impl("linalg_lu_factor_ex.out", TORCH_FN(wrapper_linalg_lu_factor_ex_out_out));
  m.impl("_det_lu_based_helper",
  TORCH_FN(wrapper___det_lu_based_helper));
  m.impl("_det_lu_based_helper_backward_helper",
  TORCH_FN(wrapper___det_lu_based_helper_backward_helper));
  m.impl("linalg_lstsq.out",
  TORCH_FN(wrapper_out_linalg_lstsq_out_out));
  m.impl("linalg_matrix_exp",
  TORCH_FN(wrapper__linalg_matrix_exp));
  m.impl("linalg_slogdet",
  TORCH_FN(wrapper__linalg_slogdet));
  m.impl("linalg_slogdet.out",
  TORCH_FN(wrapper_out_linalg_slogdet_out_out));
  m.impl("linalg_eig",
  TORCH_FN(wrapper__linalg_eig));
  m.impl("linalg_eig.out",
  TORCH_FN(wrapper_out_linalg_eig_out_out));
  m.impl("linalg_eigh",
  TORCH_FN(wrapper__linalg_eigh));
  m.impl("linalg_eigh.eigvals",
  TORCH_FN(wrapper_eigvals_linalg_eigh_out_eigvals));
  m.impl("linalg_eigvalsh.out",
  TORCH_FN(wrapper_out_linalg_eigvalsh_out_out));
  m.impl("linalg_householder_product",
  TORCH_FN(wrapper__linalg_householder_product));
  m.impl("linalg_householder_product.out",
  TORCH_FN(wrapper_out_linalg_householder_product_out_out));
  m.impl("_linalg_inv_out_helper_",
  TORCH_FN(wrapper___linalg_inv_out_helper_));
  m.impl("linalg_vector_norm",
  TORCH_FN(wrapper__linalg_vector_norm));
  m.impl("linalg_vector_norm.out",
  TORCH_FN(wrapper_out_linalg_vector_norm_out_out));
  m.impl("_linalg_svd", TORCH_FN(wrapper__linalg_svd));
  m.impl("_linalg_svd.U", TORCH_FN(wrapper__linalg_svd_out_U));
  m.impl("linalg_solve",
  TORCH_FN(wrapper__linalg_solve));
  m.impl("linalg_solve.out",
  TORCH_FN(wrapper_out_linalg_solve_out_out));
  m.impl("_linalg_qr_helper",
  TORCH_FN(wrapper___linalg_qr_helper));
  m.impl("segment_reduce",
  TORCH_FN(wrapper__segment_reduce));
  m.impl("_segment_reduce_backward",
  TORCH_FN(wrapper___segment_reduce_backward));
}

} // anonymous namespace

namespace cuda {


void _assert_async(const at::Tensor & self) {
return wrapper___assert_async(self);
}

bool _use_cudnn_ctc_loss(const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, int64_t blank) {
return wrapper___use_cudnn_ctc_loss(log_probs, targets, input_lengths, target_lengths, blank);
}

::std::tuple<at::Tensor,at::Tensor> _cudnn_ctc_loss(const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, int64_t blank, bool deterministic, bool zero_infinity) {
return wrapper___cudnn_ctc_loss(log_probs, targets, input_lengths, target_lengths, blank, deterministic, zero_infinity);
}

at::Tensor _cudnn_rnn_flatten_weight(at::TensorList weight_arr, int64_t weight_stride0, int64_t input_size, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, bool batch_first, bool bidirectional) {
return wrapper___cudnn_rnn_flatten_weight(weight_arr, weight_stride0, input_size, mode, hidden_size, proj_size, num_layers, batch_first, bidirectional);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> _cudnn_rnn(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const c10::optional<at::Tensor> & weight_buf, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state) {
return wrapper___cudnn_rnn(input, weight, weight_stride0, weight_buf, hx, cx, mode, hidden_size, proj_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,::std::vector<at::Tensor>> _cudnn_rnn_backward(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const at::Tensor & weight_buf, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, const at::Tensor & output, const c10::optional<at::Tensor> & grad_output, const c10::optional<at::Tensor> & grad_hy, const c10::optional<at::Tensor> & grad_cy, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state, const at::Tensor & reserve, ::std::array<bool,4> output_mask) {
return wrapper___cudnn_rnn_backward(input, weight, weight_stride0, weight_buf, hx, cx, output, grad_output, grad_hy, grad_cy, mode, hidden_size, proj_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state, reserve, output_mask);
}

at::Tensor _cudnn_init_dropout_state(double dropout, bool train, int64_t dropout_seed, at::TensorOptions options) {
return wrapper___cudnn_init_dropout_state(dropout, train, dropout_seed, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor _cudnn_init_dropout_state(double dropout, bool train, int64_t dropout_seed, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper___cudnn_init_dropout_state(dropout, train, dropout_seed, dtype, layout, device, pin_memory);
}

::std::tuple<at::Tensor,at::Tensor> _fused_dropout(const at::Tensor & self, double p, c10::optional<at::Generator> generator) {
return wrapper___fused_dropout(self, p, generator);
}

at::Tensor _masked_scale(const at::Tensor & self, const at::Tensor & mask, double scale) {
return wrapper___masked_scale(self, mask, scale);
}

::std::tuple<at::Tensor,at::Tensor> native_dropout(const at::Tensor & input, double p, c10::optional<bool> train) {
return wrapper__native_dropout(input, p, train);
}

at::Tensor native_dropout_backward(const at::Tensor & grad_output, const at::Tensor & mask, double scale) {
return wrapper__native_dropout_backward(grad_output, mask, scale);
}

at::Tensor & abs_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_abs_out_out(self, out);
}

at::Tensor & abs_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_abs_out_out(self, out);
}

at::Tensor angle(const at::Tensor & self) {
return wrapper__angle(self);
}

at::Tensor & angle_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_angle_out_out(self, out);
}

at::Tensor & angle_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_angle_out_out(self, out);
}

at::Tensor view_as_real(const at::Tensor & self) {
return wrapper__view_as_real(self);
}

at::Tensor view_as_complex(const at::Tensor & self) {
return wrapper__view_as_complex(self);
}

at::Tensor sgn(const at::Tensor & self) {
return wrapper_sgn(self);
}

at::Tensor & sgn_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sgn_out_out(self, out);
}

at::Tensor & sgn_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sgn_out_out(self, out);
}

at::Tensor & sgn_(at::Tensor & self) {
return wrapper_sgn_(self);
}

at::Tensor & conj_physical_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_conj_physical_out_out(self, out);
}

at::Tensor & conj_physical_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_conj_physical_out_out(self, out);
}

at::Tensor acos(const at::Tensor & self) {
return wrapper_acos(self);
}

at::Tensor & acos_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_acos_out_out(self, out);
}

at::Tensor & acos_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_acos_out_out(self, out);
}

at::Tensor & acos_(at::Tensor & self) {
return wrapper_acos_(self);
}

at::Tensor add(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_add_Tensor(self, other, alpha);
}

at::Tensor & add_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_add_out_out(self, other, alpha, out);
}

at::Tensor & add_outf(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_add_out_out(self, other, alpha, out);
}

at::Tensor & add_(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_add__Tensor(self, other, alpha);
}

at::Tensor addmv(const at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_addmv(self, mat, vec, beta, alpha);
}

at::Tensor & addmv_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_addmv_out_out(self, mat, vec, beta, alpha, out);
}

at::Tensor & addmv_outf(const at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_addmv_out_out(self, mat, vec, beta, alpha, out);
}

at::Tensor & addmv_(at::Tensor & self, const at::Tensor & mat, const at::Tensor & vec, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_addmv_(self, mat, vec, beta, alpha);
}

at::Tensor addr(const at::Tensor & self, const at::Tensor & vec1, const at::Tensor & vec2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper__addr(self, vec1, vec2, beta, alpha);
}

at::Tensor & addr_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & vec1, const at::Tensor & vec2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_out_addr_out_out(self, vec1, vec2, beta, alpha, out);
}

at::Tensor & addr_outf(const at::Tensor & self, const at::Tensor & vec1, const at::Tensor & vec2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_addr_out_out(self, vec1, vec2, beta, alpha, out);
}

at::Tensor all(const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_all_dim(self, dim, keepdim);
}

at::Tensor & all_out(at::Tensor & out, const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_all_out_out(self, dim, keepdim, out);
}

at::Tensor & all_outf(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & out) {
return wrapper_all_out_out(self, dim, keepdim, out);
}

at::Tensor any(const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_any_dim(self, dim, keepdim);
}

at::Tensor & any_out(at::Tensor & out, const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_any_out_out(self, dim, keepdim, out);
}

at::Tensor & any_outf(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & out) {
return wrapper_any_out_out(self, dim, keepdim, out);
}

at::Tensor & arange_out(at::Tensor & out, const at::Scalar & start, const at::Scalar & end, const at::Scalar & step) {
return wrapper_start_out_arange_out_start_out(start, end, step, out);
}

at::Tensor & arange_outf(const at::Scalar & start, const at::Scalar & end, const at::Scalar & step, at::Tensor & out) {
return wrapper_start_out_arange_out_start_out(start, end, step, out);
}

at::Tensor argmax(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
return wrapper_argmax(self, dim, keepdim);
}

at::Tensor & argmax_out(at::Tensor & out, const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
return wrapper_argmax_out_out(self, dim, keepdim, out);
}

at::Tensor & argmax_outf(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim, at::Tensor & out) {
return wrapper_argmax_out_out(self, dim, keepdim, out);
}

at::Tensor argmin(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
return wrapper_argmin(self, dim, keepdim);
}

at::Tensor & argmin_out(at::Tensor & out, const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
return wrapper_argmin_out_out(self, dim, keepdim, out);
}

at::Tensor & argmin_outf(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim, at::Tensor & out) {
return wrapper_argmin_out_out(self, dim, keepdim, out);
}

at::Tensor acosh(const at::Tensor & self) {
return wrapper_acosh(self);
}

at::Tensor & acosh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_acosh_out_out(self, out);
}

at::Tensor & acosh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_acosh_out_out(self, out);
}

at::Tensor & acosh_(at::Tensor & self) {
return wrapper_acosh_(self);
}

at::Tensor asinh(const at::Tensor & self) {
return wrapper_asinh(self);
}

at::Tensor & asinh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_asinh_out_out(self, out);
}

at::Tensor & asinh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_asinh_out_out(self, out);
}

at::Tensor & asinh_(at::Tensor & self) {
return wrapper_asinh_(self);
}

at::Tensor atanh(const at::Tensor & self) {
return wrapper_atanh(self);
}

at::Tensor & atanh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_atanh_out_out(self, out);
}

at::Tensor & atanh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_atanh_out_out(self, out);
}

at::Tensor & atanh_(at::Tensor & self) {
return wrapper_atanh_(self);
}

at::Tensor as_strided(const at::Tensor & self, at::IntArrayRef size, at::IntArrayRef stride, c10::optional<int64_t> storage_offset) {
return wrapper__as_strided(self, size, stride, storage_offset);
}

at::Tensor asin(const at::Tensor & self) {
return wrapper_asin(self);
}

at::Tensor & asin_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_asin_out_out(self, out);
}

at::Tensor & asin_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_asin_out_out(self, out);
}

at::Tensor & asin_(at::Tensor & self) {
return wrapper_asin_(self);
}

at::Tensor atan(const at::Tensor & self) {
return wrapper_atan(self);
}

at::Tensor & atan_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_atan_out_out(self, out);
}

at::Tensor & atan_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_atan_out_out(self, out);
}

at::Tensor & atan_(at::Tensor & self) {
return wrapper_atan_(self);
}

at::Tensor baddbmm(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_baddbmm(self, batch1, batch2, beta, alpha);
}

at::Tensor & baddbmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_baddbmm_out_out(self, batch1, batch2, beta, alpha, out);
}

at::Tensor & baddbmm_outf(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_baddbmm_out_out(self, batch1, batch2, beta, alpha, out);
}

at::Tensor & baddbmm_(at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_baddbmm_(self, batch1, batch2, beta, alpha);
}

at::Tensor & bernoulli_out(at::Tensor & out, const at::Tensor & self, c10::optional<at::Generator> generator) {
return wrapper_out_bernoulli_out_out(self, generator, out);
}

at::Tensor & bernoulli_outf(const at::Tensor & self, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_out_bernoulli_out_out(self, generator, out);
}

at::Tensor & bernoulli_(at::Tensor & self, const at::Tensor & p, c10::optional<at::Generator> generator) {
return wrapper_Tensor_bernoulli__Tensor(self, p, generator);
}

at::Tensor & bernoulli_(at::Tensor & self, double p, c10::optional<at::Generator> generator) {
return wrapper_float_bernoulli__float(self, p, generator);
}

at::Tensor binary_cross_entropy(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper__binary_cross_entropy(self, target, weight, reduction);
}

at::Tensor & binary_cross_entropy_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper_out_binary_cross_entropy_out_out(self, target, weight, reduction, out);
}

at::Tensor & binary_cross_entropy_outf(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & out) {
return wrapper_out_binary_cross_entropy_out_out(self, target, weight, reduction, out);
}

at::Tensor binary_cross_entropy_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper__binary_cross_entropy_backward(grad_output, self, target, weight, reduction);
}

at::Tensor & binary_cross_entropy_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper_grad_input_binary_cross_entropy_backward_out_grad_input(grad_output, self, target, weight, reduction, grad_input);
}

at::Tensor & binary_cross_entropy_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & grad_input) {
return wrapper_grad_input_binary_cross_entropy_backward_out_grad_input(grad_output, self, target, weight, reduction, grad_input);
}

at::Tensor bincount(const at::Tensor & self, const c10::optional<at::Tensor> & weights, int64_t minlength) {
return wrapper__bincount(self, weights, minlength);
}

at::Tensor bitwise_not(const at::Tensor & self) {
return wrapper_bitwise_not(self);
}

at::Tensor & bitwise_not_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_bitwise_not_out_out(self, out);
}

at::Tensor & bitwise_not_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_bitwise_not_out_out(self, out);
}

at::Tensor & bitwise_not_(at::Tensor & self) {
return wrapper_bitwise_not_(self);
}

at::Tensor copysign(const at::Tensor & self, const at::Tensor & other) {
return wrapper_copysign_Tensor(self, other);
}

at::Tensor & copysign_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_copysign_out_out(self, other, out);
}

at::Tensor & copysign_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_copysign_out_out(self, other, out);
}

at::Tensor & copysign_(at::Tensor & self, const at::Tensor & other) {
return wrapper_copysign__Tensor(self, other);
}

at::Tensor & logical_not_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_logical_not_out_out(self, out);
}

at::Tensor & logical_not_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_logical_not_out_out(self, out);
}

at::Tensor & logical_xor_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_logical_xor_out_out(self, other, out);
}

at::Tensor & logical_xor_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_logical_xor_out_out(self, other, out);
}

at::Tensor & logical_and_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_logical_and_out_out(self, other, out);
}

at::Tensor & logical_and_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_logical_and_out_out(self, other, out);
}

at::Tensor & logical_or_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_logical_or_out_out(self, other, out);
}

at::Tensor & logical_or_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_logical_or_out_out(self, other, out);
}

at::Tensor bmm(const at::Tensor & self, const at::Tensor & mat2) {
return wrapper_bmm(self, mat2);
}

at::Tensor & bmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat2) {
return wrapper_bmm_out_out(self, mat2, out);
}

at::Tensor & bmm_outf(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
return wrapper_bmm_out_out(self, mat2, out);
}

at::Tensor ceil(const at::Tensor & self) {
return wrapper_ceil(self);
}

at::Tensor & ceil_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_ceil_out_out(self, out);
}

at::Tensor & ceil_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_ceil_out_out(self, out);
}

at::Tensor & ceil_(at::Tensor & self) {
return wrapper_ceil_(self);
}

at::Tensor clamp(const at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max) {
return wrapper_clamp(self, min, max);
}

at::Tensor & clamp_out(at::Tensor & out, const at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max) {
return wrapper_clamp_out_out(self, min, max, out);
}

at::Tensor & clamp_outf(const at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max, at::Tensor & out) {
return wrapper_clamp_out_out(self, min, max, out);
}

at::Tensor & clamp_(at::Tensor & self, const c10::optional<at::Scalar> & min, const c10::optional<at::Scalar> & max) {
return wrapper_clamp_(self, min, max);
}

at::Tensor clamp(const at::Tensor & self, const c10::optional<at::Tensor> & min, const c10::optional<at::Tensor> & max) {
return wrapper_Tensor_clamp_Tensor(self, min, max);
}

at::Tensor & clamp_out(at::Tensor & out, const at::Tensor & self, const c10::optional<at::Tensor> & min, const c10::optional<at::Tensor> & max) {
return wrapper_Tensor_out_clamp_out_Tensor_out(self, min, max, out);
}

at::Tensor & clamp_outf(const at::Tensor & self, const c10::optional<at::Tensor> & min, const c10::optional<at::Tensor> & max, at::Tensor & out) {
return wrapper_Tensor_out_clamp_out_Tensor_out(self, min, max, out);
}

at::Tensor & clamp_max_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & max) {
return wrapper_out_clamp_max_out_out(self, max, out);
}

at::Tensor & clamp_max_outf(const at::Tensor & self, const at::Scalar & max, at::Tensor & out) {
return wrapper_out_clamp_max_out_out(self, max, out);
}

at::Tensor & clamp_max_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & max) {
return wrapper_Tensor_out_clamp_max_out_Tensor_out(self, max, out);
}

at::Tensor & clamp_max_outf(const at::Tensor & self, const at::Tensor & max, at::Tensor & out) {
return wrapper_Tensor_out_clamp_max_out_Tensor_out(self, max, out);
}

at::Tensor & clamp_min_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & min) {
return wrapper_out_clamp_min_out_out(self, min, out);
}

at::Tensor & clamp_min_outf(const at::Tensor & self, const at::Scalar & min, at::Tensor & out) {
return wrapper_out_clamp_min_out_out(self, min, out);
}

at::Tensor & clamp_min_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & min) {
return wrapper_Tensor_out_clamp_min_out_Tensor_out(self, min, out);
}

at::Tensor & clamp_min_outf(const at::Tensor & self, const at::Tensor & min, at::Tensor & out) {
return wrapper_Tensor_out_clamp_min_out_Tensor_out(self, min, out);
}

at::Tensor & complex_out(at::Tensor & out, const at::Tensor & real, const at::Tensor & imag) {
return wrapper_out_complex_out_out(real, imag, out);
}

at::Tensor & complex_outf(const at::Tensor & real, const at::Tensor & imag, at::Tensor & out) {
return wrapper_out_complex_out_out(real, imag, out);
}

at::Tensor & polar_out(at::Tensor & out, const at::Tensor & abs, const at::Tensor & angle) {
return wrapper_out_polar_out_out(abs, angle, out);
}

at::Tensor & polar_outf(const at::Tensor & abs, const at::Tensor & angle, at::Tensor & out) {
return wrapper_out_polar_out_out(abs, angle, out);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> convolution_backward(const at::Tensor & grad_output, const at::Tensor & input, const at::Tensor & weight, c10::optional<at::IntArrayRef> bias_sizes, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool transposed, at::IntArrayRef output_padding, int64_t groups, ::std::array<bool,3> output_mask) {
return wrapper__convolution_backward(grad_output, input, weight, bias_sizes, stride, padding, dilation, transposed, output_padding, groups, output_mask);
}

at::Tensor cos(const at::Tensor & self) {
return wrapper_cos(self);
}

at::Tensor & cos_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_cos_out_out(self, out);
}

at::Tensor & cos_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_cos_out_out(self, out);
}

at::Tensor & cos_(at::Tensor & self) {
return wrapper_cos_(self);
}

at::Tensor cosh(const at::Tensor & self) {
return wrapper_cosh(self);
}

at::Tensor & cosh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_cosh_out_out(self, out);
}

at::Tensor & cosh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_cosh_out_out(self, out);
}

at::Tensor & cosh_(at::Tensor & self) {
return wrapper_cosh_(self);
}

at::Tensor count_nonzero(const at::Tensor & self, at::IntArrayRef dim) {
return wrapper_dim_IntList_count_nonzero_dim_IntList(self, dim);
}

at::Tensor cudnn_affine_grid_generator(const at::Tensor & theta, int64_t N, int64_t C, int64_t H, int64_t W) {
return wrapper__cudnn_affine_grid_generator(theta, N, C, H, W);
}

at::Tensor cudnn_affine_grid_generator_backward(const at::Tensor & grad, int64_t N, int64_t C, int64_t H, int64_t W) {
return wrapper__cudnn_affine_grid_generator_backward(grad, N, C, H, W);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> cudnn_batch_norm(const at::Tensor & input, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double exponential_average_factor, double epsilon) {
return wrapper__cudnn_batch_norm(input, weight, bias, running_mean, running_var, training, exponential_average_factor, epsilon);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> cudnn_batch_norm_backward(const at::Tensor & input, const at::Tensor & grad_output, const at::Tensor & weight, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, const c10::optional<at::Tensor> & save_mean, const c10::optional<at::Tensor> & save_var, double epsilon, const at::Tensor & reserveSpace) {
return wrapper__cudnn_batch_norm_backward(input, grad_output, weight, running_mean, running_var, save_mean, save_var, epsilon, reserveSpace);
}

at::Tensor cudnn_convolution(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic, bool allow_tf32) {
return wrapper__cudnn_convolution(self, weight, padding, stride, dilation, groups, benchmark, deterministic, allow_tf32);
}

at::Tensor cudnn_convolution_transpose(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic, bool allow_tf32) {
return wrapper__cudnn_convolution_transpose(self, weight, padding, output_padding, stride, dilation, groups, benchmark, deterministic, allow_tf32);
}

at::Tensor cudnn_convolution_relu(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, int64_t groups) {
return wrapper__cudnn_convolution_relu(self, weight, bias, stride, padding, dilation, groups);
}

at::Tensor cudnn_convolution_add_relu(const at::Tensor & self, const at::Tensor & weight, const at::Tensor & z, const c10::optional<at::Scalar> & alpha, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, int64_t groups) {
return wrapper__cudnn_convolution_add_relu(self, weight, z, alpha, bias, stride, padding, dilation, groups);
}

at::Tensor cudnn_grid_sampler(const at::Tensor & self, const at::Tensor & grid) {
return wrapper__cudnn_grid_sampler(self, grid);
}

::std::tuple<at::Tensor,at::Tensor> cudnn_grid_sampler_backward(const at::Tensor & self, const at::Tensor & grid, const at::Tensor & grad_output) {
return wrapper__cudnn_grid_sampler_backward(self, grid, grad_output);
}

void _cummax_helper(const at::Tensor & self, at::Tensor & values, at::Tensor & indices, int64_t dim) {
return wrapper___cummax_helper(self, values, indices, dim);
}

void _cummin_helper(const at::Tensor & self, at::Tensor & values, at::Tensor & indices, int64_t dim) {
return wrapper___cummin_helper(self, values, indices, dim);
}

at::Tensor cumprod(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
return wrapper_cumprod(self, dim, dtype);
}

at::Tensor & cumprod_out(at::Tensor & out, const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
return wrapper_cumprod_out_out(self, dim, dtype, out);
}

at::Tensor & cumprod_outf(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_cumprod_out_out(self, dim, dtype, out);
}

at::Tensor & cumprod_(at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
return wrapper_cumprod_(self, dim, dtype);
}

at::Tensor cumsum(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
return wrapper_cumsum(self, dim, dtype);
}

at::Tensor & cumsum_out(at::Tensor & out, const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
return wrapper_cumsum_out_out(self, dim, dtype, out);
}

at::Tensor & cumsum_outf(const at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_cumsum_out_out(self, dim, dtype, out);
}

at::Tensor & cumsum_(at::Tensor & self, int64_t dim, c10::optional<at::ScalarType> dtype) {
return wrapper_cumsum_(self, dim, dtype);
}

::std::tuple<at::Tensor,at::Tensor> _ctc_loss(const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, int64_t blank, bool zero_infinity) {
return wrapper___ctc_loss(log_probs, targets, input_lengths, target_lengths, blank, zero_infinity);
}

at::Tensor _ctc_loss_backward(const at::Tensor & grad, const at::Tensor & log_probs, const at::Tensor & targets, at::IntArrayRef input_lengths, at::IntArrayRef target_lengths, const at::Tensor & neg_log_likelihood, const at::Tensor & log_alpha, int64_t blank, bool zero_infinity) {
return wrapper___ctc_loss_backward(grad, log_probs, targets, input_lengths, target_lengths, neg_log_likelihood, log_alpha, blank, zero_infinity);
}

at::Tensor div(const at::Tensor & self, const at::Tensor & other) {
return wrapper_div_Tensor(self, other);
}

at::Tensor & div_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_div_out_out(self, other, out);
}

at::Tensor & div_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_div_out_out(self, other, out);
}

at::Tensor & div_(at::Tensor & self, const at::Tensor & other) {
return wrapper_div__Tensor(self, other);
}

at::Tensor div(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
return wrapper_div_Tensor_mode(self, other, rounding_mode);
}

at::Tensor & div_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
return wrapper_div_out_out_mode(self, other, rounding_mode, out);
}

at::Tensor & div_outf(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode, at::Tensor & out) {
return wrapper_div_out_out_mode(self, other, rounding_mode, out);
}

at::Tensor & div_(at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
return wrapper_div__Tensor_mode(self, other, rounding_mode);
}

at::Tensor dot(const at::Tensor & self, const at::Tensor & tensor) {
return wrapper__dot(self, tensor);
}

at::Tensor vdot(const at::Tensor & self, const at::Tensor & other) {
return wrapper__vdot(self, other);
}

at::Tensor embedding_dense_backward(const at::Tensor & grad_output, const at::Tensor & indices, int64_t num_weights, int64_t padding_idx, bool scale_grad_by_freq) {
return wrapper__embedding_dense_backward(grad_output, indices, num_weights, padding_idx, scale_grad_by_freq);
}

at::Tensor & embedding_renorm_(at::Tensor & self, const at::Tensor & indices, double max_norm, double norm_type) {
return wrapper__embedding_renorm_(self, indices, max_norm, norm_type);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> _embedding_bag_forward_only(const at::Tensor & weight, const at::Tensor & indices, const at::Tensor & offsets, bool scale_grad_by_freq, int64_t mode, bool sparse, const c10::optional<at::Tensor> & per_sample_weights, bool include_last_offset, int64_t padding_idx) {
return wrapper___embedding_bag_forward_only(weight, indices, offsets, scale_grad_by_freq, mode, sparse, per_sample_weights, include_last_offset, padding_idx);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> _embedding_bag(const at::Tensor & weight, const at::Tensor & indices, const at::Tensor & offsets, bool scale_grad_by_freq, int64_t mode, bool sparse, const c10::optional<at::Tensor> & per_sample_weights, bool include_last_offset, int64_t padding_idx) {
return wrapper___embedding_bag(weight, indices, offsets, scale_grad_by_freq, mode, sparse, per_sample_weights, include_last_offset, padding_idx);
}

at::Tensor _embedding_bag_dense_backward(const at::Tensor & grad, const at::Tensor & indices, const at::Tensor & offset2bag, const at::Tensor & bag_size, const at::Tensor & maximum_indices, int64_t num_weights, bool scale_grad_by_freq, int64_t mode, const c10::optional<at::Tensor> & per_sample_weights, int64_t padding_idx) {
return wrapper___embedding_bag_dense_backward(grad, indices, offset2bag, bag_size, maximum_indices, num_weights, scale_grad_by_freq, mode, per_sample_weights, padding_idx);
}

at::Tensor _embedding_bag_per_sample_weights_backward(const at::Tensor & grad, const at::Tensor & weight, const at::Tensor & indices, const at::Tensor & offsets, const at::Tensor & offset2bag, int64_t mode, int64_t padding_idx) {
return wrapper___embedding_bag_per_sample_weights_backward(grad, weight, indices, offsets, offset2bag, mode, padding_idx);
}

at::Tensor empty(at::IntArrayRef size, at::TensorOptions options, c10::optional<at::MemoryFormat> memory_format) {
return wrapper_memory_format_empty_memory_format(size, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt(), c10::impl::check_tensor_options_and_extract_memory_format(options, memory_format));
}

at::Tensor empty(at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory, c10::optional<at::MemoryFormat> memory_format) {
return wrapper_memory_format_empty_memory_format(size, dtype, layout, device, pin_memory, memory_format);
}

const at::Tensor & resize_(const at::Tensor & self, at::IntArrayRef size, c10::optional<at::MemoryFormat> memory_format) {
return wrapper__resize_(self, size, memory_format);
}

at::Tensor empty_strided(at::IntArrayRef size, at::IntArrayRef stride, at::TensorOptions options) {
return wrapper__empty_strided(size, stride, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor empty_strided(at::IntArrayRef size, at::IntArrayRef stride, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper__empty_strided(size, stride, dtype, layout, device, pin_memory);
}

at::Tensor erf(const at::Tensor & self) {
return wrapper_erf(self);
}

at::Tensor & erf_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_erf_out_out(self, out);
}

at::Tensor & erf_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_erf_out_out(self, out);
}

at::Tensor & erf_(at::Tensor & self) {
return wrapper_erf_(self);
}

at::Tensor erfc(const at::Tensor & self) {
return wrapper_erfc(self);
}

at::Tensor & erfc_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_erfc_out_out(self, out);
}

at::Tensor & erfc_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_erfc_out_out(self, out);
}

at::Tensor & erfc_(at::Tensor & self) {
return wrapper_erfc_(self);
}

at::Tensor exp(const at::Tensor & self) {
return wrapper_exp(self);
}

at::Tensor & exp_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_exp_out_out(self, out);
}

at::Tensor & exp_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_exp_out_out(self, out);
}

at::Tensor & exp_(at::Tensor & self) {
return wrapper_exp_(self);
}

at::Tensor exp2(const at::Tensor & self) {
return wrapper_exp2(self);
}

at::Tensor & exp2_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_exp2_out_out(self, out);
}

at::Tensor & exp2_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_exp2_out_out(self, out);
}

at::Tensor & exp2_(at::Tensor & self) {
return wrapper_exp2_(self);
}

at::Tensor expm1(const at::Tensor & self) {
return wrapper_expm1(self);
}

at::Tensor & expm1_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_expm1_out_out(self, out);
}

at::Tensor & expm1_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_expm1_out_out(self, out);
}

at::Tensor & expm1_(at::Tensor & self) {
return wrapper_expm1_(self);
}

at::Tensor & eye_out(at::Tensor & out, int64_t n) {
return wrapper_out_eye_out_out(n, out);
}

at::Tensor & eye_outf(int64_t n, at::Tensor & out) {
return wrapper_out_eye_out_out(n, out);
}

at::Tensor & eye_out(at::Tensor & out, int64_t n, int64_t m) {
return wrapper_m_out_eye_out_m_out(n, m, out);
}

at::Tensor & eye_outf(int64_t n, int64_t m, at::Tensor & out) {
return wrapper_m_out_eye_out_m_out(n, m, out);
}

at::Tensor & fill_(at::Tensor & self, const at::Scalar & value) {
return wrapper_Scalar_fill__Scalar(self, value);
}

at::Tensor & fill_(at::Tensor & self, const at::Tensor & value) {
return wrapper_Tensor_fill__Tensor(self, value);
}

at::Tensor floor(const at::Tensor & self) {
return wrapper_floor(self);
}

at::Tensor & floor_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_floor_out_out(self, out);
}

at::Tensor & floor_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_floor_out_out(self, out);
}

at::Tensor & floor_(at::Tensor & self) {
return wrapper_floor_(self);
}

at::Tensor floor_divide(const at::Tensor & self, const at::Tensor & other) {
return wrapper__floor_divide(self, other);
}

at::Tensor & floor_divide_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_floor_divide_out_out(self, other, out);
}

at::Tensor & floor_divide_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_floor_divide_out_out(self, other, out);
}

at::Tensor & floor_divide_(at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor_floor_divide__Tensor(self, other);
}

at::Tensor frac(const at::Tensor & self) {
return wrapper_frac(self);
}

at::Tensor & frac_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_frac_out_out(self, out);
}

at::Tensor & frac_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_frac_out_out(self, out);
}

at::Tensor & frac_(at::Tensor & self) {
return wrapper_frac_(self);
}

at::Tensor gcd(const at::Tensor & self, const at::Tensor & other) {
return wrapper_gcd(self, other);
}

at::Tensor & gcd_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_gcd_out_out(self, other, out);
}

at::Tensor & gcd_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_gcd_out_out(self, other, out);
}

at::Tensor & gcd_(at::Tensor & self, const at::Tensor & other) {
return wrapper_gcd_(self, other);
}

at::Tensor lcm(const at::Tensor & self, const at::Tensor & other) {
return wrapper_lcm(self, other);
}

at::Tensor & lcm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_lcm_out_out(self, other, out);
}

at::Tensor & lcm_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_lcm_out_out(self, other, out);
}

at::Tensor & lcm_(at::Tensor & self, const at::Tensor & other) {
return wrapper_lcm_(self, other);
}

at::Tensor grid_sampler_2d(const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners) {
return wrapper__grid_sampler_2d(input, grid, interpolation_mode, padding_mode, align_corners);
}

::std::tuple<at::Tensor,at::Tensor> grid_sampler_2d_backward(const at::Tensor & grad_output, const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners, ::std::array<bool,2> output_mask) {
return wrapper__grid_sampler_2d_backward(grad_output, input, grid, interpolation_mode, padding_mode, align_corners, output_mask);
}

at::Tensor grid_sampler_3d(const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners) {
return wrapper__grid_sampler_3d(input, grid, interpolation_mode, padding_mode, align_corners);
}

::std::tuple<at::Tensor,at::Tensor> grid_sampler_3d_backward(const at::Tensor & grad_output, const at::Tensor & input, const at::Tensor & grid, int64_t interpolation_mode, int64_t padding_mode, bool align_corners) {
return wrapper__grid_sampler_3d_backward(grad_output, input, grid, interpolation_mode, padding_mode, align_corners);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> native_group_norm(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, int64_t N, int64_t C, int64_t HxW, int64_t group, double eps) {
return wrapper__native_group_norm(input, weight, bias, N, C, HxW, group, eps);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> native_group_norm_backward(const at::Tensor & grad_out, const at::Tensor & input, const at::Tensor & mean, const at::Tensor & rstd, const c10::optional<at::Tensor> & weight, int64_t N, int64_t C, int64_t HxW, int64_t group, ::std::array<bool,3> output_mask) {
return wrapper__native_group_norm_backward(grad_out, input, mean, rstd, weight, N, C, HxW, group, output_mask);
}

at::Tensor _fft_r2c(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool onesided) {
return wrapper___fft_r2c(self, dim, normalization, onesided);
}

at::Tensor & _fft_r2c_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool onesided) {
return wrapper_out__fft_r2c_out_out(self, dim, normalization, onesided, out);
}

at::Tensor & _fft_r2c_outf(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool onesided, at::Tensor & out) {
return wrapper_out__fft_r2c_out_out(self, dim, normalization, onesided, out);
}

at::Tensor _fft_c2r(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, int64_t last_dim_size) {
return wrapper___fft_c2r(self, dim, normalization, last_dim_size);
}

at::Tensor & _fft_c2r_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, int64_t last_dim_size) {
return wrapper_out__fft_c2r_out_out(self, dim, normalization, last_dim_size, out);
}

at::Tensor & _fft_c2r_outf(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, int64_t last_dim_size, at::Tensor & out) {
return wrapper_out__fft_c2r_out_out(self, dim, normalization, last_dim_size, out);
}

at::Tensor _fft_c2c(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool forward) {
return wrapper___fft_c2c(self, dim, normalization, forward);
}

at::Tensor & _fft_c2c_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool forward) {
return wrapper_out__fft_c2c_out_out(self, dim, normalization, forward, out);
}

at::Tensor & _fft_c2c_outf(const at::Tensor & self, at::IntArrayRef dim, int64_t normalization, bool forward, at::Tensor & out) {
return wrapper_out__fft_c2c_out_out(self, dim, normalization, forward, out);
}

at::Tensor index(const at::Tensor & self, const c10::List<c10::optional<at::Tensor>> & indices) {
return wrapper_Tensor_index_Tensor(self, indices);
}

at::Tensor index_copy(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source) {
return wrapper_index_copy(self, dim, index, source);
}

at::Tensor & index_copy_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source) {
return wrapper_index_copy_out_out(self, dim, index, source, out);
}

at::Tensor & index_copy_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, at::Tensor & out) {
return wrapper_index_copy_out_out(self, dim, index, source, out);
}

at::Tensor & index_copy_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source) {
return wrapper_index_copy_(self, dim, index, source);
}

at::Tensor & _index_put_impl_(at::Tensor & self, const c10::List<c10::optional<at::Tensor>> & indices, const at::Tensor & values, bool accumulate, bool unsafe) {
return wrapper___index_put_impl_(self, indices, values, accumulate, unsafe);
}

at::Tensor isin(const at::Tensor & elements, const at::Tensor & test_elements, bool assume_unique, bool invert) {
return wrapper_isin_Tensor_Tensor(elements, test_elements, assume_unique, invert);
}

at::Tensor & isin_out(at::Tensor & out, const at::Tensor & elements, const at::Tensor & test_elements, bool assume_unique, bool invert) {
return wrapper_isin_out_Tensor_Tensor_out(elements, test_elements, assume_unique, invert, out);
}

at::Tensor & isin_outf(const at::Tensor & elements, const at::Tensor & test_elements, bool assume_unique, bool invert, at::Tensor & out) {
return wrapper_isin_out_Tensor_Tensor_out(elements, test_elements, assume_unique, invert, out);
}

at::Tensor isin(const at::Tensor & elements, const at::Scalar & test_element, bool assume_unique, bool invert) {
return wrapper_isin_Tensor_Scalar(elements, test_element, assume_unique, invert);
}

at::Tensor & isin_out(at::Tensor & out, const at::Tensor & elements, const at::Scalar & test_element, bool assume_unique, bool invert) {
return wrapper_isin_out_Tensor_Scalar_out(elements, test_element, assume_unique, invert, out);
}

at::Tensor & isin_outf(const at::Tensor & elements, const at::Scalar & test_element, bool assume_unique, bool invert, at::Tensor & out) {
return wrapper_isin_out_Tensor_Scalar_out(elements, test_element, assume_unique, invert, out);
}

at::Tensor isin(const at::Scalar & element, const at::Tensor & test_elements, bool assume_unique, bool invert) {
return wrapper_isin_Scalar_Tensor(element, test_elements, assume_unique, invert);
}

at::Tensor & isin_out(at::Tensor & out, const at::Scalar & element, const at::Tensor & test_elements, bool assume_unique, bool invert) {
return wrapper_isin_out_Scalar_Tensor_out(element, test_elements, assume_unique, invert, out);
}

at::Tensor & isin_outf(const at::Scalar & element, const at::Tensor & test_elements, bool assume_unique, bool invert, at::Tensor & out) {
return wrapper_isin_out_Scalar_Tensor_out(element, test_elements, assume_unique, invert, out);
}

at::Tensor isnan(const at::Tensor & self) {
return wrapper__isnan(self);
}

at::Tensor kl_div_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, bool log_target) {
return wrapper__kl_div_backward(grad_output, self, target, reduction, log_target);
}

::std::tuple<at::Tensor &,at::Tensor &> kthvalue_out(at::Tensor & values, at::Tensor & indices, const at::Tensor & self, int64_t k, int64_t dim, bool keepdim) {
return wrapper_values_kthvalue_out_values(self, k, dim, keepdim, values, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> kthvalue_outf(const at::Tensor & self, int64_t k, int64_t dim, bool keepdim, at::Tensor & values, at::Tensor & indices) {
return wrapper_values_kthvalue_out_values(self, k, dim, keepdim, values, indices);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> native_layer_norm(const at::Tensor & input, at::IntArrayRef normalized_shape, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, double eps) {
return wrapper__native_layer_norm(input, normalized_shape, weight, bias, eps);
}

at::Tensor _native_multi_head_self_attention(const at::Tensor & query, const at::Tensor & qkv_weight, const at::Tensor & qkv_bias, const at::Tensor & proj_weight, const at::Tensor & proj_bias, int64_t num_head, const c10::optional<at::Tensor> & mask) {
return wrapper___native_multi_head_self_attention(query, qkv_weight, qkv_bias, proj_weight, proj_bias, num_head, mask);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> native_layer_norm_backward(const at::Tensor & grad_out, const at::Tensor & input, at::IntArrayRef normalized_shape, const at::Tensor & mean, const at::Tensor & rstd, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, ::std::array<bool,3> output_mask) {
return wrapper__native_layer_norm_backward(grad_out, input, normalized_shape, mean, rstd, weight, bias, output_mask);
}

at::Tensor & nan_to_num_out(at::Tensor & out, const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf) {
return wrapper_out_nan_to_num_out_out(self, nan, posinf, neginf, out);
}

at::Tensor & nan_to_num_outf(const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf, at::Tensor & out) {
return wrapper_out_nan_to_num_out_out(self, nan, posinf, neginf, out);
}

at::Tensor & linspace_out(at::Tensor & out, const at::Scalar & start, const at::Scalar & end, int64_t steps) {
return wrapper_out_linspace_out_out(start, end, steps, out);
}

at::Tensor & linspace_outf(const at::Scalar & start, const at::Scalar & end, int64_t steps, at::Tensor & out) {
return wrapper_out_linspace_out_out(start, end, steps, out);
}

at::Tensor log(const at::Tensor & self) {
return wrapper_log(self);
}

at::Tensor & log_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_log_out_out(self, out);
}

at::Tensor & log_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_log_out_out(self, out);
}

at::Tensor & log_(at::Tensor & self) {
return wrapper_log_(self);
}

at::Tensor log10(const at::Tensor & self) {
return wrapper_log10(self);
}

at::Tensor & log10_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_log10_out_out(self, out);
}

at::Tensor & log10_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_log10_out_out(self, out);
}

at::Tensor & log10_(at::Tensor & self) {
return wrapper_log10_(self);
}

at::Tensor log1p(const at::Tensor & self) {
return wrapper_log1p(self);
}

at::Tensor & log1p_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_log1p_out_out(self, out);
}

at::Tensor & log1p_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_log1p_out_out(self, out);
}

at::Tensor & log1p_(at::Tensor & self) {
return wrapper_log1p_(self);
}

at::Tensor log2(const at::Tensor & self) {
return wrapper_log2(self);
}

at::Tensor & log2_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_log2_out_out(self, out);
}

at::Tensor & log2_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_log2_out_out(self, out);
}

at::Tensor & log2_(at::Tensor & self) {
return wrapper_log2_(self);
}

at::Tensor logaddexp(const at::Tensor & self, const at::Tensor & other) {
return wrapper_logaddexp(self, other);
}

at::Tensor & logaddexp_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_logaddexp_out_out(self, other, out);
}

at::Tensor & logaddexp_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_logaddexp_out_out(self, other, out);
}

at::Tensor logaddexp2(const at::Tensor & self, const at::Tensor & other) {
return wrapper_logaddexp2(self, other);
}

at::Tensor & logaddexp2_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_logaddexp2_out_out(self, other, out);
}

at::Tensor & logaddexp2_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_logaddexp2_out_out(self, other, out);
}

at::Tensor xlogy(const at::Tensor & self, const at::Tensor & other) {
return wrapper_xlogy_Tensor(self, other);
}

at::Tensor & xlogy_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_xlogy_out_OutTensor(self, other, out);
}

at::Tensor & xlogy_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_xlogy_out_OutTensor(self, other, out);
}

at::Tensor & xlogy_(at::Tensor & self, const at::Tensor & other) {
return wrapper_xlogy__Tensor(self, other);
}

at::Tensor & logspace_out(at::Tensor & out, const at::Scalar & start, const at::Scalar & end, int64_t steps, double base) {
return wrapper_out_logspace_out_out(start, end, steps, base, out);
}

at::Tensor & logspace_outf(const at::Scalar & start, const at::Scalar & end, int64_t steps, double base, at::Tensor & out) {
return wrapper_out_logspace_out_out(start, end, steps, base, out);
}

at::Tensor _log_softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
return wrapper__log_softmax(self, dim, half_to_float);
}

at::Tensor & _log_softmax_out(at::Tensor & out, const at::Tensor & self, int64_t dim, bool half_to_float) {
return wrapper__log_softmax_out_out(self, dim, half_to_float, out);
}

at::Tensor & _log_softmax_outf(const at::Tensor & self, int64_t dim, bool half_to_float, at::Tensor & out) {
return wrapper__log_softmax_out_out(self, dim, half_to_float, out);
}

at::Tensor _log_softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype) {
return wrapper__log_softmax_backward_data(grad_output, output, dim, input_dtype);
}

at::Tensor & _log_softmax_backward_data_out(at::Tensor & out, const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype) {
return wrapper__log_softmax_backward_data_out_out(grad_output, output, dim, input_dtype, out);
}

at::Tensor & _log_softmax_backward_data_outf(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype, at::Tensor & out) {
return wrapper__log_softmax_backward_data_out_out(grad_output, output, dim, input_dtype, out);
}

at::Tensor _logcumsumexp(const at::Tensor & self, int64_t dim) {
return wrapper___logcumsumexp(self, dim);
}

at::Tensor & _logcumsumexp_out(at::Tensor & out, const at::Tensor & self, int64_t dim) {
return wrapper_out__logcumsumexp_out_out(self, dim, out);
}

at::Tensor & _logcumsumexp_outf(const at::Tensor & self, int64_t dim, at::Tensor & out) {
return wrapper_out__logcumsumexp_out_out(self, dim, out);
}

::std::tuple<at::Tensor,at::Tensor> _aminmax(const at::Tensor & self) {
return wrapper___aminmax(self);
}

::std::tuple<at::Tensor,at::Tensor> _aminmax(const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_dim__aminmax_dim(self, dim, keepdim);
}

::std::tuple<at::Tensor,at::Tensor> aminmax(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
return wrapper_aminmax(self, dim, keepdim);
}

::std::tuple<at::Tensor &,at::Tensor &> aminmax_out(at::Tensor & min, at::Tensor & max, const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim) {
return wrapper_aminmax_out_out(self, dim, keepdim, min, max);
}

::std::tuple<at::Tensor &,at::Tensor &> aminmax_outf(const at::Tensor & self, c10::optional<int64_t> dim, bool keepdim, at::Tensor & min, at::Tensor & max) {
return wrapper_aminmax_out_out(self, dim, keepdim, min, max);
}

at::Tensor _compute_linear_combination(const at::Tensor & input, const at::Tensor & coefficients) {
return wrapper___compute_linear_combination(input, coefficients);
}

at::Tensor & _compute_linear_combination_out(at::Tensor & out, const at::Tensor & input, const at::Tensor & coefficients) {
return wrapper_out__compute_linear_combination_out_out(input, coefficients, out);
}

at::Tensor & _compute_linear_combination_outf(const at::Tensor & input, const at::Tensor & coefficients, at::Tensor & out) {
return wrapper_out__compute_linear_combination_out_out(input, coefficients, out);
}

::std::tuple<at::Tensor,at::Tensor> max(const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_max_dim(self, dim, keepdim);
}

::std::tuple<at::Tensor &,at::Tensor &> max_out(at::Tensor & max, at::Tensor & max_values, const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_max_out_dim_max(self, dim, keepdim, max, max_values);
}

::std::tuple<at::Tensor &,at::Tensor &> max_outf(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & max, at::Tensor & max_values) {
return wrapper_max_out_dim_max(self, dim, keepdim, max, max_values);
}

at::Tensor & amax_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, bool keepdim) {
return wrapper_out_amax_out_out(self, dim, keepdim, out);
}

at::Tensor & amax_outf(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, at::Tensor & out) {
return wrapper_out_amax_out_out(self, dim, keepdim, out);
}

at::Tensor mean(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_mean_dim(self, dim, keepdim, dtype);
}

at::Tensor & mean_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_mean_out_out(self, dim, keepdim, dtype, out);
}

at::Tensor & mean_outf(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_mean_out_out(self, dim, keepdim, dtype, out);
}

at::Tensor median(const at::Tensor & self) {
return wrapper__median(self);
}

::std::tuple<at::Tensor &,at::Tensor &> median_out(at::Tensor & values, at::Tensor & indices, const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_dim_values_median_out_dim_values(self, dim, keepdim, values, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> median_outf(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & values, at::Tensor & indices) {
return wrapper_dim_values_median_out_dim_values(self, dim, keepdim, values, indices);
}

at::Tensor nanmedian(const at::Tensor & self) {
return wrapper__nanmedian(self);
}

::std::tuple<at::Tensor &,at::Tensor &> nanmedian_out(at::Tensor & values, at::Tensor & indices, const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_dim_values_nanmedian_out_dim_values(self, dim, keepdim, values, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> nanmedian_outf(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & values, at::Tensor & indices) {
return wrapper_dim_values_nanmedian_out_dim_values(self, dim, keepdim, values, indices);
}

::std::tuple<at::Tensor,at::Tensor> min(const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_min_dim(self, dim, keepdim);
}

::std::tuple<at::Tensor &,at::Tensor &> min_out(at::Tensor & min, at::Tensor & min_indices, const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper_min_out_dim_min(self, dim, keepdim, min, min_indices);
}

::std::tuple<at::Tensor &,at::Tensor &> min_outf(const at::Tensor & self, int64_t dim, bool keepdim, at::Tensor & min, at::Tensor & min_indices) {
return wrapper_min_out_dim_min(self, dim, keepdim, min, min_indices);
}

at::Tensor & amin_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, bool keepdim) {
return wrapper_out_amin_out_out(self, dim, keepdim, out);
}

at::Tensor & amin_outf(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, at::Tensor & out) {
return wrapper_out_amin_out_out(self, dim, keepdim, out);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> miopen_batch_norm(const at::Tensor & input, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double exponential_average_factor, double epsilon) {
return wrapper__miopen_batch_norm(input, weight, bias, running_mean, running_var, training, exponential_average_factor, epsilon);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> miopen_batch_norm_backward(const at::Tensor & input, const at::Tensor & grad_output, const at::Tensor & weight, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, const c10::optional<at::Tensor> & save_mean, const c10::optional<at::Tensor> & save_var, double epsilon) {
return wrapper__miopen_batch_norm_backward(input, grad_output, weight, running_mean, running_var, save_mean, save_var, epsilon);
}

at::Tensor miopen_convolution(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic) {
return wrapper__miopen_convolution(self, weight, bias, padding, stride, dilation, groups, benchmark, deterministic);
}

at::Tensor miopen_convolution_transpose(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic) {
return wrapper__miopen_convolution_transpose(self, weight, bias, padding, output_padding, stride, dilation, groups, benchmark, deterministic);
}

at::Tensor miopen_depthwise_convolution(const at::Tensor & self, const at::Tensor & weight, const c10::optional<at::Tensor> & bias, at::IntArrayRef padding, at::IntArrayRef stride, at::IntArrayRef dilation, int64_t groups, bool benchmark, bool deterministic) {
return wrapper__miopen_depthwise_convolution(self, weight, bias, padding, stride, dilation, groups, benchmark, deterministic);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> miopen_rnn(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state) {
return wrapper__miopen_rnn(input, weight, weight_stride0, hx, cx, mode, hidden_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,::std::vector<at::Tensor>> miopen_rnn_backward(const at::Tensor & input, at::TensorList weight, int64_t weight_stride0, const at::Tensor & weight_buf, const at::Tensor & hx, const c10::optional<at::Tensor> & cx, const at::Tensor & output, const c10::optional<at::Tensor> & grad_output, const c10::optional<at::Tensor> & grad_hy, const c10::optional<at::Tensor> & grad_cy, int64_t mode, int64_t hidden_size, int64_t num_layers, bool batch_first, double dropout, bool train, bool bidirectional, at::IntArrayRef batch_sizes, const c10::optional<at::Tensor> & dropout_state, const at::Tensor & reserve, ::std::array<bool,4> output_mask) {
return wrapper__miopen_rnn_backward(input, weight, weight_stride0, weight_buf, hx, cx, output, grad_output, grad_hy, grad_cy, mode, hidden_size, num_layers, batch_first, dropout, train, bidirectional, batch_sizes, dropout_state, reserve, output_mask);
}

at::Tensor mm(const at::Tensor & self, const at::Tensor & mat2) {
return wrapper_mm(self, mat2);
}

at::Tensor & mm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat2) {
return wrapper_mm_out_out(self, mat2, out);
}

at::Tensor & mm_outf(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
return wrapper_mm_out_out(self, mat2, out);
}

::std::tuple<at::Tensor,at::Tensor> mode(const at::Tensor & self, int64_t dim, bool keepdim) {
return wrapper__mode(self, dim, keepdim);
}

at::Tensor mul(const at::Tensor & self, const at::Tensor & other) {
return wrapper_mul_Tensor(self, other);
}

at::Tensor & mul_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_mul_out_out(self, other, out);
}

at::Tensor & mul_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_mul_out_out(self, other, out);
}

at::Tensor & mul_(at::Tensor & self, const at::Tensor & other) {
return wrapper_mul__Tensor(self, other);
}

at::Tensor & mvlgamma_out(at::Tensor & out, const at::Tensor & self, int64_t p) {
return wrapper_out_mvlgamma_out_out(self, p, out);
}

at::Tensor & mvlgamma_outf(const at::Tensor & self, int64_t p, at::Tensor & out) {
return wrapper_out_mvlgamma_out_out(self, p, out);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> native_batch_norm(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double momentum, double eps) {
return wrapper__native_batch_norm(input, weight, bias, running_mean, running_var, training, momentum, eps);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> native_batch_norm_out(at::Tensor & out, at::Tensor & save_mean, at::Tensor & save_invstd, const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double momentum, double eps) {
return wrapper_out_native_batch_norm_out_out(input, weight, bias, running_mean, running_var, training, momentum, eps, out, save_mean, save_invstd);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> native_batch_norm_outf(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, bool training, double momentum, double eps, at::Tensor & out, at::Tensor & save_mean, at::Tensor & save_invstd) {
return wrapper_out_native_batch_norm_out_out(input, weight, bias, running_mean, running_var, training, momentum, eps, out, save_mean, save_invstd);
}

::std::tuple<at::Tensor,at::Tensor> batch_norm_stats(const at::Tensor & input, double eps) {
return wrapper__batch_norm_stats(input, eps);
}

at::Tensor batch_norm_elemt(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const at::Tensor & mean, const at::Tensor & invstd, double eps) {
return wrapper__batch_norm_elemt(input, weight, bias, mean, invstd, eps);
}

at::Tensor & batch_norm_elemt_out(at::Tensor & out, const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const at::Tensor & mean, const at::Tensor & invstd, double eps) {
return wrapper_out_batch_norm_elemt_out_out(input, weight, bias, mean, invstd, eps, out);
}

at::Tensor & batch_norm_elemt_outf(const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & bias, const at::Tensor & mean, const at::Tensor & invstd, double eps, at::Tensor & out) {
return wrapper_out_batch_norm_elemt_out_out(input, weight, bias, mean, invstd, eps, out);
}

::std::tuple<at::Tensor,at::Tensor> batch_norm_gather_stats(const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, double momentum, double eps, int64_t count) {
return wrapper__batch_norm_gather_stats(input, mean, invstd, running_mean, running_var, momentum, eps, count);
}

::std::tuple<at::Tensor,at::Tensor> batch_norm_gather_stats_with_counts(const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, double momentum, double eps, const at::Tensor & counts) {
return wrapper__batch_norm_gather_stats_with_counts(input, mean, invstd, running_mean, running_var, momentum, eps, counts);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> native_batch_norm_backward(const at::Tensor & grad_out, const at::Tensor & input, const c10::optional<at::Tensor> & weight, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, const c10::optional<at::Tensor> & save_mean, const c10::optional<at::Tensor> & save_invstd, bool train, double eps, ::std::array<bool,3> output_mask) {
return wrapper__native_batch_norm_backward(grad_out, input, weight, running_mean, running_var, save_mean, save_invstd, train, eps, output_mask);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor> batch_norm_backward_reduce(const at::Tensor & grad_out, const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & weight, bool input_g, bool weight_g, bool bias_g) {
return wrapper__batch_norm_backward_reduce(grad_out, input, mean, invstd, weight, input_g, weight_g, bias_g);
}

at::Tensor batch_norm_backward_elemt(const at::Tensor & grad_out, const at::Tensor & input, const at::Tensor & mean, const at::Tensor & invstd, const c10::optional<at::Tensor> & weight, const at::Tensor & mean_dy, const at::Tensor & mean_dy_xmu, const at::Tensor & count) {
return wrapper__batch_norm_backward_elemt(grad_out, input, mean, invstd, weight, mean_dy, mean_dy_xmu, count);
}

::std::tuple<at::Tensor,at::Tensor> batch_norm_update_stats(const at::Tensor & input, const c10::optional<at::Tensor> & running_mean, const c10::optional<at::Tensor> & running_var, double momentum) {
return wrapper__batch_norm_update_stats(input, running_mean, running_var, momentum);
}

at::Tensor _cdist_forward(const at::Tensor & x1, const at::Tensor & x2, double p, c10::optional<int64_t> compute_mode) {
return wrapper___cdist_forward(x1, x2, p, compute_mode);
}

at::Tensor _cdist_backward(const at::Tensor & grad, const at::Tensor & x1, const at::Tensor & x2, double p, const at::Tensor & cdist) {
return wrapper___cdist_backward(grad, x1, x2, p, cdist);
}

at::Tensor _pdist_forward(const at::Tensor & self, double p) {
return wrapper___pdist_forward(self, p);
}

at::Tensor _pdist_backward(const at::Tensor & grad, const at::Tensor & self, double p, const at::Tensor & pdist) {
return wrapper___pdist_backward(grad, self, p, pdist);
}

bool is_pinned(const at::Tensor & self, c10::optional<at::Device> device) {
return wrapper__is_pinned(self, device);
}

at::Tensor _pin_memory(const at::Tensor & self, c10::optional<at::Device> device) {
return wrapper___pin_memory(self, device);
}

at::Tensor & randperm_out(at::Tensor & out, int64_t n, c10::optional<at::Generator> generator) {
return wrapper_generator_out_randperm_out_generator_out(n, generator, out);
}

at::Tensor & randperm_outf(int64_t n, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_generator_out_randperm_out_generator_out(n, generator, out);
}

at::Tensor & range_out(at::Tensor & out, const at::Scalar & start, const at::Scalar & end, const at::Scalar & step) {
return wrapper_out_range_out_out(start, end, step, out);
}

at::Tensor & range_outf(const at::Scalar & start, const at::Scalar & end, const at::Scalar & step, at::Tensor & out) {
return wrapper_out_range_out_out(start, end, step, out);
}

at::Tensor reciprocal(const at::Tensor & self) {
return wrapper_reciprocal(self);
}

at::Tensor & reciprocal_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_reciprocal_out_out(self, out);
}

at::Tensor & reciprocal_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_reciprocal_out_out(self, out);
}

at::Tensor & reciprocal_(at::Tensor & self) {
return wrapper_reciprocal_(self);
}

at::Tensor neg(const at::Tensor & self) {
return wrapper_neg(self);
}

at::Tensor & neg_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_neg_out_out(self, out);
}

at::Tensor & neg_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_neg_out_out(self, out);
}

at::Tensor & neg_(at::Tensor & self) {
return wrapper_neg_(self);
}

at::Tensor repeat_interleave(const at::Tensor & repeats, c10::optional<int64_t> output_size) {
return wrapper_Tensor_repeat_interleave_Tensor(repeats, output_size);
}

at::Tensor _reshape_alias(const at::Tensor & self, at::IntArrayRef size, at::IntArrayRef stride) {
return wrapper___reshape_alias(self, size, stride);
}

at::Tensor round(const at::Tensor & self) {
return wrapper_round(self);
}

at::Tensor & round_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_round_out_out(self, out);
}

at::Tensor & round_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_round_out_out(self, out);
}

at::Tensor & round_(at::Tensor & self) {
return wrapper_round_(self);
}

at::Tensor round(const at::Tensor & self, int64_t decimals) {
return wrapper_round_decimals(self, decimals);
}

at::Tensor & round_out(at::Tensor & out, const at::Tensor & self, int64_t decimals) {
return wrapper_round_out_decimals_out(self, decimals, out);
}

at::Tensor & round_outf(const at::Tensor & self, int64_t decimals, at::Tensor & out) {
return wrapper_round_out_decimals_out(self, decimals, out);
}

at::Tensor & round_(at::Tensor & self, int64_t decimals) {
return wrapper_round__decimals(self, decimals);
}

at::Tensor relu(const at::Tensor & self) {
return wrapper__relu(self);
}

at::Tensor & relu_(at::Tensor & self) {
return wrapper__relu_(self);
}

at::Tensor prelu(const at::Tensor & self, const at::Tensor & weight) {
return wrapper__prelu(self, weight);
}

::std::tuple<at::Tensor,at::Tensor> prelu_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight) {
return wrapper__prelu_backward(grad_output, self, weight);
}

at::Tensor gelu(const at::Tensor & self) {
return wrapper_gelu(self);
}

at::Tensor & gelu_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_gelu_out_out(self, out);
}

at::Tensor & gelu_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_gelu_out_out(self, out);
}

at::Tensor gelu_backward(const at::Tensor & grad, const at::Tensor & self) {
return wrapper_gelu_backward(grad, self);
}

at::Tensor & gelu_backward_out(at::Tensor & grad_input, const at::Tensor & grad, const at::Tensor & self) {
return wrapper_gelu_backward_out_grad_input(grad, self, grad_input);
}

at::Tensor & gelu_backward_outf(const at::Tensor & grad, const at::Tensor & self, at::Tensor & grad_input) {
return wrapper_gelu_backward_out_grad_input(grad, self, grad_input);
}

at::Tensor hardshrink(const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_hardshrink(self, lambd);
}

at::Tensor & hardshrink_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_hardshrink_out_out(self, lambd, out);
}

at::Tensor & hardshrink_outf(const at::Tensor & self, const at::Scalar & lambd, at::Tensor & out) {
return wrapper_hardshrink_out_out(self, lambd, out);
}

at::Tensor hardshrink_backward(const at::Tensor & grad_out, const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_hardshrink_backward(grad_out, self, lambd);
}

at::Tensor & hardshrink_backward_out(at::Tensor & grad_input, const at::Tensor & grad_out, const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_hardshrink_backward_out_grad_input(grad_out, self, lambd, grad_input);
}

at::Tensor & hardshrink_backward_outf(const at::Tensor & grad_out, const at::Tensor & self, const at::Scalar & lambd, at::Tensor & grad_input) {
return wrapper_hardshrink_backward_out_grad_input(grad_out, self, lambd, grad_input);
}

at::Tensor rsqrt(const at::Tensor & self) {
return wrapper_rsqrt(self);
}

at::Tensor & rsqrt_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_rsqrt_out_out(self, out);
}

at::Tensor & rsqrt_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_rsqrt_out_out(self, out);
}

at::Tensor & rsqrt_(at::Tensor & self) {
return wrapper_rsqrt_(self);
}

at::Tensor silu(const at::Tensor & self) {
return wrapper_silu(self);
}

at::Tensor & silu_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_silu_out_out(self, out);
}

at::Tensor & silu_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_silu_out_out(self, out);
}

at::Tensor & silu_(at::Tensor & self) {
return wrapper_silu_(self);
}

at::Tensor silu_backward(const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper_silu_backward(grad_output, self);
}

at::Tensor & silu_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper_silu_backward_out_grad_input(grad_output, self, grad_input);
}

at::Tensor & silu_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::Tensor & grad_input) {
return wrapper_silu_backward_out_grad_input(grad_output, self, grad_input);
}

at::Tensor mish(const at::Tensor & self) {
return wrapper_mish(self);
}

at::Tensor & mish_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_mish_out_out(self, out);
}

at::Tensor & mish_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_mish_out_out(self, out);
}

at::Tensor & mish_(at::Tensor & self) {
return wrapper_mish_(self);
}

at::Tensor mish_backward(const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper__mish_backward(grad_output, self);
}

at::Tensor sigmoid(const at::Tensor & self) {
return wrapper_sigmoid(self);
}

at::Tensor & sigmoid_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sigmoid_out_out(self, out);
}

at::Tensor & sigmoid_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sigmoid_out_out(self, out);
}

at::Tensor & sigmoid_(at::Tensor & self) {
return wrapper_sigmoid_(self);
}

at::Tensor logit(const at::Tensor & self, c10::optional<double> eps) {
return wrapper__logit(self, eps);
}

at::Tensor & logit_out(at::Tensor & out, const at::Tensor & self, c10::optional<double> eps) {
return wrapper_out_logit_out_out(self, eps, out);
}

at::Tensor & logit_outf(const at::Tensor & self, c10::optional<double> eps, at::Tensor & out) {
return wrapper_out_logit_out_out(self, eps, out);
}

at::Tensor & logit_(at::Tensor & self, c10::optional<double> eps) {
return wrapper__logit_(self, eps);
}

at::Tensor sin(const at::Tensor & self) {
return wrapper_sin(self);
}

at::Tensor & sin_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sin_out_out(self, out);
}

at::Tensor & sin_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sin_out_out(self, out);
}

at::Tensor & sin_(at::Tensor & self) {
return wrapper_sin_(self);
}

at::Tensor sinc(const at::Tensor & self) {
return wrapper_sinc(self);
}

at::Tensor & sinc_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sinc_out_out(self, out);
}

at::Tensor & sinc_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sinc_out_out(self, out);
}

at::Tensor & sinc_(at::Tensor & self) {
return wrapper_sinc_(self);
}

at::Tensor sinh(const at::Tensor & self) {
return wrapper_sinh(self);
}

at::Tensor & sinh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sinh_out_out(self, out);
}

at::Tensor & sinh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sinh_out_out(self, out);
}

at::Tensor & sinh_(at::Tensor & self) {
return wrapper_sinh_(self);
}

at::Tensor _softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
return wrapper__softmax(self, dim, half_to_float);
}

at::Tensor & _softmax_out(at::Tensor & out, const at::Tensor & self, int64_t dim, bool half_to_float) {
return wrapper__softmax_out_out(self, dim, half_to_float, out);
}

at::Tensor & _softmax_outf(const at::Tensor & self, int64_t dim, bool half_to_float, at::Tensor & out) {
return wrapper__softmax_out_out(self, dim, half_to_float, out);
}

at::Tensor _softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype) {
return wrapper__softmax_backward_data(grad_output, output, dim, input_dtype);
}

at::Tensor & _softmax_backward_data_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype) {
return wrapper__softmax_backward_data_out_out(grad_output, output, dim, input_dtype, grad_input);
}

at::Tensor & _softmax_backward_data_outf(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, at::ScalarType input_dtype, at::Tensor & grad_input) {
return wrapper__softmax_backward_data_out_out(grad_output, output, dim, input_dtype, grad_input);
}

at::Tensor squeeze(const at::Tensor & self) {
return wrapper__squeeze(self);
}

at::Tensor squeeze(const at::Tensor & self, int64_t dim) {
return wrapper_dim_squeeze_dim(self, dim);
}

at::Tensor & sspaddmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_out_sspaddmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor & sspaddmm_outf(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_sspaddmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor sum(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_sum_dim_IntList(self, dim, keepdim, dtype);
}

at::Tensor & sum_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_sum_out_IntList_out(self, dim, keepdim, dtype, out);
}

at::Tensor & sum_outf(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_sum_out_IntList_out(self, dim, keepdim, dtype, out);
}

at::Tensor nansum(const at::Tensor & self, c10::optional<at::ScalarType> dtype) {
return wrapper__nansum(self, dtype);
}

at::Tensor nansum(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_dim_IntList_nansum_dim_IntList(self, dim, keepdim, dtype);
}

at::Tensor & nansum_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_IntList_out_nansum_out_IntList_out(self, dim, keepdim, dtype, out);
}

at::Tensor & nansum_outf(const at::Tensor & self, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_IntList_out_nansum_out_IntList_out(self, dim, keepdim, dtype, out);
}

at::Tensor sqrt(const at::Tensor & self) {
return wrapper_sqrt(self);
}

at::Tensor & sqrt_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sqrt_out_out(self, out);
}

at::Tensor & sqrt_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sqrt_out_out(self, out);
}

at::Tensor & sqrt_(at::Tensor & self) {
return wrapper_sqrt_(self);
}

at::Tensor & square_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_square_out_out(self, out);
}

at::Tensor & square_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_square_out_out(self, out);
}

at::Tensor std(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
return wrapper_correction_std_correction(self, dim, correction, keepdim);
}

at::Tensor & std_out(at::Tensor & out, const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
return wrapper_correction_out_std_out_correction_out(self, dim, correction, keepdim, out);
}

at::Tensor & std_outf(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim, at::Tensor & out) {
return wrapper_correction_out_std_out_correction_out(self, dim, correction, keepdim, out);
}

::std::tuple<at::Tensor,at::Tensor> std_mean(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
return wrapper_correction_std_mean_correction(self, dim, correction, keepdim);
}

at::Tensor prod(const at::Tensor & self, c10::optional<at::ScalarType> dtype) {
return wrapper__prod(self, dtype);
}

at::Tensor prod(const at::Tensor & self, int64_t dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_prod_dim_int(self, dim, keepdim, dtype);
}

at::Tensor & prod_out(at::Tensor & out, const at::Tensor & self, int64_t dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_prod_out_int_out(self, dim, keepdim, dtype, out);
}

at::Tensor & prod_outf(const at::Tensor & self, int64_t dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_prod_out_int_out(self, dim, keepdim, dtype, out);
}

at::Tensor tan(const at::Tensor & self) {
return wrapper_tan(self);
}

at::Tensor & tan_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_tan_out_out(self, out);
}

at::Tensor & tan_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_tan_out_out(self, out);
}

at::Tensor & tan_(at::Tensor & self) {
return wrapper_tan_(self);
}

at::Tensor tanh(const at::Tensor & self) {
return wrapper_tanh(self);
}

at::Tensor & tanh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_tanh_out_out(self, out);
}

at::Tensor & tanh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_tanh_out_out(self, out);
}

at::Tensor & tanh_(at::Tensor & self) {
return wrapper_tanh_(self);
}

at::Tensor & tensordot_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, at::IntArrayRef dims_self, at::IntArrayRef dims_other) {
return wrapper_out_tensordot_out_out(self, other, dims_self, dims_other, out);
}

at::Tensor & tensordot_outf(const at::Tensor & self, const at::Tensor & other, at::IntArrayRef dims_self, at::IntArrayRef dims_other, at::Tensor & out) {
return wrapper_out_tensordot_out_out(self, other, dims_self, dims_other, out);
}

at::Tensor threshold(const at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value) {
return wrapper_threshold(self, threshold, value);
}

at::Tensor & threshold_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value) {
return wrapper_threshold_out_out(self, threshold, value, out);
}

at::Tensor & threshold_outf(const at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value, at::Tensor & out) {
return wrapper_threshold_out_out(self, threshold, value, out);
}

at::Tensor & threshold_(at::Tensor & self, const at::Scalar & threshold, const at::Scalar & value) {
return wrapper_threshold_(self, threshold, value);
}

at::Tensor threshold_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & threshold) {
return wrapper_threshold_backward(grad_output, self, threshold);
}

at::Tensor & threshold_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & threshold) {
return wrapper_threshold_backward_out_grad_input(grad_output, self, threshold, grad_input);
}

at::Tensor & threshold_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & threshold, at::Tensor & grad_input) {
return wrapper_threshold_backward_out_grad_input(grad_output, self, threshold, grad_input);
}

at::Tensor flip(const at::Tensor & self, at::IntArrayRef dims) {
return wrapper__flip(self, dims);
}

at::Tensor roll(const at::Tensor & self, at::IntArrayRef shifts, at::IntArrayRef dims) {
return wrapper__roll(self, shifts, dims);
}

at::Tensor trunc(const at::Tensor & self) {
return wrapper_trunc(self);
}

at::Tensor & trunc_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_trunc_out_out(self, out);
}

at::Tensor & trunc_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_trunc_out_out(self, out);
}

at::Tensor & trunc_(at::Tensor & self) {
return wrapper_trunc_(self);
}

::std::tuple<at::Tensor,at::Tensor> _unique(const at::Tensor & self, bool sorted, bool return_inverse) {
return wrapper___unique(self, sorted, return_inverse);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> unique_dim(const at::Tensor & self, int64_t dim, bool sorted, bool return_inverse, bool return_counts) {
return wrapper__unique_dim(self, dim, sorted, return_inverse, return_counts);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> unique_consecutive(const at::Tensor & self, bool return_inverse, bool return_counts, c10::optional<int64_t> dim) {
return wrapper__unique_consecutive(self, return_inverse, return_counts, dim);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> unique_dim_consecutive(const at::Tensor & self, int64_t dim, bool return_inverse, bool return_counts) {
return wrapper__unique_dim_consecutive(self, dim, return_inverse, return_counts);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> _unique2(const at::Tensor & self, bool sorted, bool return_inverse, bool return_counts) {
return wrapper___unique2(self, sorted, return_inverse, return_counts);
}

at::Tensor unsqueeze(const at::Tensor & self, int64_t dim) {
return wrapper__unsqueeze(self, dim);
}

at::Tensor var(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
return wrapper_correction_var_correction(self, dim, correction, keepdim);
}

at::Tensor & var_out(at::Tensor & out, const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
return wrapper_correction_out_var_out_correction_out(self, dim, correction, keepdim, out);
}

at::Tensor & var_outf(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim, at::Tensor & out) {
return wrapper_correction_out_var_out_correction_out(self, dim, correction, keepdim, out);
}

::std::tuple<at::Tensor,at::Tensor> var_mean(const at::Tensor & self, c10::optional<at::IntArrayRef> dim, c10::optional<int64_t> correction, bool keepdim) {
return wrapper_correction_var_mean_correction(self, dim, correction, keepdim);
}

at::Tensor _s_where(const at::Tensor & condition, const at::Tensor & self, const at::Tensor & other) {
return wrapper___s_where(condition, self, other);
}

::std::tuple<at::Tensor,at::Tensor> _weight_norm_cuda_interface(const at::Tensor & v, const at::Tensor & g, int64_t dim) {
return wrapper___weight_norm_cuda_interface(v, g, dim);
}

::std::tuple<at::Tensor,at::Tensor> _weight_norm_cuda_interface_backward(const at::Tensor & grad_w, const at::Tensor & saved_v, const at::Tensor & saved_g, const at::Tensor & saved_norms, int64_t dim) {
return wrapper___weight_norm_cuda_interface_backward(grad_w, saved_v, saved_g, saved_norms, dim);
}

at::Tensor _efficientzerotensor(at::IntArrayRef size, at::TensorOptions options) {
return wrapper___efficientzerotensor(size, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor _efficientzerotensor(at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper___efficientzerotensor(size, dtype, layout, device, pin_memory);
}

at::Tensor _standard_gamma_grad(const at::Tensor & self, const at::Tensor & output) {
return wrapper___standard_gamma_grad(self, output);
}

at::Tensor _standard_gamma(const at::Tensor & self, c10::optional<at::Generator> generator) {
return wrapper___standard_gamma(self, generator);
}

at::Tensor _dirichlet_grad(const at::Tensor & x, const at::Tensor & alpha, const at::Tensor & total) {
return wrapper___dirichlet_grad(x, alpha, total);
}

at::Tensor _sample_dirichlet(const at::Tensor & self, c10::optional<at::Generator> generator) {
return wrapper___sample_dirichlet(self, generator);
}

at::Tensor poisson(const at::Tensor & self, c10::optional<at::Generator> generator) {
return wrapper__poisson(self, generator);
}

at::Tensor binomial(const at::Tensor & count, const at::Tensor & prob, c10::optional<at::Generator> generator) {
return wrapper__binomial(count, prob, generator);
}

at::Tensor norm(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype) {
return wrapper_norm_ScalarOpt_dim_dtype(self, p, dim, keepdim, dtype);
}

at::Tensor & norm_out(at::Tensor & out, const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype) {
return wrapper_norm_out_dtype_out(self, p, dim, keepdim, dtype, out);
}

at::Tensor & norm_outf(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype, at::Tensor & out) {
return wrapper_norm_out_dtype_out(self, p, dim, keepdim, dtype, out);
}

at::Tensor norm(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim) {
return wrapper_norm_ScalarOpt_dim(self, p, dim, keepdim);
}

at::Tensor & norm_out(at::Tensor & out, const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim) {
return wrapper_norm_out_out(self, p, dim, keepdim, out);
}

at::Tensor & norm_outf(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::Tensor & out) {
return wrapper_norm_out_out(self, p, dim, keepdim, out);
}

::std::tuple<at::Tensor &,at::Tensor &> frexp_out(at::Tensor & mantissa, at::Tensor & exponent, const at::Tensor & self) {
return wrapper_Tensor_out_frexp_out_Tensor_out(self, mantissa, exponent);
}

::std::tuple<at::Tensor &,at::Tensor &> frexp_outf(const at::Tensor & self, at::Tensor & mantissa, at::Tensor & exponent) {
return wrapper_Tensor_out_frexp_out_Tensor_out(self, mantissa, exponent);
}

at::Tensor & zero_(at::Tensor & self) {
return wrapper__zero_(self);
}

at::Tensor sub(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_sub_Tensor(self, other, alpha);
}

at::Tensor & sub_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_sub_out_out(self, other, alpha, out);
}

at::Tensor & sub_outf(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_sub_out_out(self, other, alpha, out);
}

at::Tensor & sub_(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_sub__Tensor(self, other, alpha);
}

at::Tensor rsub(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_Tensor_rsub_Tensor(self, other, alpha);
}

at::Tensor heaviside(const at::Tensor & self, const at::Tensor & values) {
return wrapper_heaviside(self, values);
}

at::Tensor & heaviside_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & values) {
return wrapper_heaviside_out_out(self, values, out);
}

at::Tensor & heaviside_outf(const at::Tensor & self, const at::Tensor & values, at::Tensor & out) {
return wrapper_heaviside_out_out(self, values, out);
}

at::Tensor & heaviside_(at::Tensor & self, const at::Tensor & values) {
return wrapper_heaviside_(self, values);
}

at::Tensor addmm(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_addmm(self, mat1, mat2, beta, alpha);
}

at::Tensor & addmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_addmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor & addmm_outf(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_addmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor & addmm_(at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_addmm_(self, mat1, mat2, beta, alpha);
}

at::Tensor to_sparse(const at::Tensor & self, int64_t sparse_dim) {
return wrapper_sparse_dim_to_sparse_sparse_dim(self, sparse_dim);
}

at::Tensor to_sparse(const at::Tensor & self) {
return wrapper__to_sparse(self);
}

at::Tensor quantize_per_tensor_dynamic(const at::Tensor & self, at::ScalarType dtype, bool reduce_range) {
return wrapper__quantize_per_tensor_dynamic(self, dtype, reduce_range);
}

at::Tensor quantize_per_tensor(const at::Tensor & self, double scale, int64_t zero_point, at::ScalarType dtype) {
return wrapper__quantize_per_tensor(self, scale, zero_point, dtype);
}

at::Tensor quantize_per_tensor(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, at::ScalarType dtype) {
return wrapper_tensor_qparams_quantize_per_tensor_tensor_qparams(self, scale, zero_point, dtype);
}

at::Tensor quantize_per_channel(const at::Tensor & self, const at::Tensor & scales, const at::Tensor & zero_points, int64_t axis, at::ScalarType dtype) {
return wrapper__quantize_per_channel(self, scales, zero_points, axis, dtype);
}

at::Tensor dequantize(const at::Tensor & self) {
return wrapper_self_dequantize_self(self);
}

at::Tensor _make_per_tensor_quantized_tensor(const at::Tensor & self, double scale, int64_t zero_point) {
return wrapper___make_per_tensor_quantized_tensor(self, scale, zero_point);
}

at::Tensor _make_per_channel_quantized_tensor(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t axis) {
return wrapper___make_per_channel_quantized_tensor(self, scale, zero_point, axis);
}

::std::tuple<at::Tensor,at::Tensor> fake_quantize_per_tensor_affine_cachemask(const at::Tensor & self, double scale, int64_t zero_point, int64_t quant_min, int64_t quant_max) {
return wrapper__fake_quantize_per_tensor_affine_cachemask(self, scale, zero_point, quant_min, quant_max);
}

::std::tuple<at::Tensor,at::Tensor> _fake_quantize_per_tensor_affine_cachemask_tensor_qparams(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, const at::Tensor & fake_quant_enabled, int64_t quant_min, int64_t quant_max) {
return wrapper___fake_quantize_per_tensor_affine_cachemask_tensor_qparams(self, scale, zero_point, fake_quant_enabled, quant_min, quant_max);
}

at::Tensor _fake_quantize_learnable_per_tensor_affine(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t quant_min, int64_t quant_max, double grad_factor) {
return wrapper___fake_quantize_learnable_per_tensor_affine(self, scale, zero_point, quant_min, quant_max, grad_factor);
}

::std::tuple<at::Tensor,at::Tensor> fake_quantize_per_channel_affine_cachemask(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t axis, int64_t quant_min, int64_t quant_max) {
return wrapper__fake_quantize_per_channel_affine_cachemask(self, scale, zero_point, axis, quant_min, quant_max);
}

at::Tensor _fake_quantize_learnable_per_channel_affine(const at::Tensor & self, const at::Tensor & scale, const at::Tensor & zero_point, int64_t axis, int64_t quant_min, int64_t quant_max, double grad_factor) {
return wrapper___fake_quantize_learnable_per_channel_affine(self, scale, zero_point, axis, quant_min, quant_max, grad_factor);
}

::std::tuple<at::Tensor,at::Tensor> _fused_moving_avg_obs_fq_helper(const at::Tensor & self, const at::Tensor & observer_on, const at::Tensor & fake_quant_on, at::Tensor & running_min, at::Tensor & running_max, at::Tensor & scale, at::Tensor & zero_point, double averaging_const, int64_t quant_min, int64_t quant_max, int64_t ch_axis, bool per_row_fake_quant, bool symmetric_quant) {
return wrapper___fused_moving_avg_obs_fq_helper(self, observer_on, fake_quant_on, running_min, running_max, scale, zero_point, averaging_const, quant_min, quant_max, ch_axis, per_row_fake_quant, symmetric_quant);
}

at::Scalar _local_scalar_dense(const at::Tensor & self) {
return wrapper___local_scalar_dense(self);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> _thnn_fused_lstm_cell(const at::Tensor & input_gates, const at::Tensor & hidden_gates, const at::Tensor & cx, const c10::optional<at::Tensor> & input_bias, const c10::optional<at::Tensor> & hidden_bias) {
return wrapper___thnn_fused_lstm_cell(input_gates, hidden_gates, cx, input_bias, hidden_bias);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> _thnn_fused_lstm_cell_backward(const c10::optional<at::Tensor> & grad_hy, const c10::optional<at::Tensor> & grad_cy, const at::Tensor & cx, const at::Tensor & cy, const at::Tensor & workspace, bool has_bias) {
return wrapper___thnn_fused_lstm_cell_backward(grad_hy, grad_cy, cx, cy, workspace, has_bias);
}

::std::tuple<at::Tensor,at::Tensor> _thnn_fused_gru_cell(const at::Tensor & input_gates, const at::Tensor & hidden_gates, const at::Tensor & hx, const c10::optional<at::Tensor> & input_bias, const c10::optional<at::Tensor> & hidden_bias) {
return wrapper___thnn_fused_gru_cell(input_gates, hidden_gates, hx, input_bias, hidden_bias);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor,at::Tensor,at::Tensor> _thnn_fused_gru_cell_backward(const at::Tensor & grad_hy, const at::Tensor & workspace, bool has_bias) {
return wrapper___thnn_fused_gru_cell_backward(grad_hy, workspace, has_bias);
}

at::Tensor & set_(at::Tensor & self, at::Storage source) {
return wrapper_source_Storage_set__source_Storage(self, source);
}

at::Tensor & set_(at::Tensor & self, at::Storage source, int64_t storage_offset, at::IntArrayRef size, at::IntArrayRef stride) {
return wrapper_source_Storage_storage_offset_set__source_Storage_storage_offset(self, source, storage_offset, size, stride);
}

at::Tensor & set_(at::Tensor & self, const at::Tensor & source) {
return wrapper_source_Tensor_set__source_Tensor(self, source);
}

at::Tensor & set_(at::Tensor & self) {
return wrapper__set_(self);
}

bool is_set_to(const at::Tensor & self, const at::Tensor & tensor) {
return wrapper__is_set_to(self, tensor);
}

at::Tensor & masked_fill_(at::Tensor & self, const at::Tensor & mask, const at::Scalar & value) {
return wrapper_Scalar_masked_fill__Scalar(self, mask, value);
}

at::Tensor & masked_fill_(at::Tensor & self, const at::Tensor & mask, const at::Tensor & value) {
return wrapper_Tensor_masked_fill__Tensor(self, mask, value);
}

at::Tensor & masked_scatter_(at::Tensor & self, const at::Tensor & mask, const at::Tensor & source) {
return wrapper__masked_scatter_(self, mask, source);
}

at::Tensor _masked_softmax(const at::Tensor & self, const at::Tensor & mask) {
return wrapper___masked_softmax(self, mask);
}

at::Tensor view(const at::Tensor & self, at::IntArrayRef size) {
return wrapper__view(self, size);
}

at::Tensor & put_(at::Tensor & self, const at::Tensor & index, const at::Tensor & source, bool accumulate) {
return wrapper__put_(self, index, source, accumulate);
}

at::Tensor index_add(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha) {
return wrapper_index_add(self, dim, index, source, alpha);
}

at::Tensor & index_add_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha) {
return wrapper_index_add_out_out(self, dim, index, source, alpha, out);
}

at::Tensor & index_add_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_index_add_out_out(self, dim, index, source, alpha, out);
}

at::Tensor & index_add_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & source, const at::Scalar & alpha) {
return wrapper_index_add_(self, dim, index, source, alpha);
}

at::Tensor & index_fill_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
return wrapper_int_Scalar_index_fill__int_Scalar(self, dim, index, value);
}

at::Tensor & index_fill_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & value) {
return wrapper_int_Tensor_index_fill__int_Tensor(self, dim, index, value);
}

at::Tensor scatter(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
return wrapper_scatter_src(self, dim, index, src);
}

at::Tensor & scatter_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
return wrapper_scatter_out_src_out(self, dim, index, src, out);
}

at::Tensor & scatter_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, at::Tensor & out) {
return wrapper_scatter_out_src_out(self, dim, index, src, out);
}

at::Tensor & scatter_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
return wrapper_scatter__src(self, dim, index, src);
}

at::Tensor scatter(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
return wrapper_scatter_value(self, dim, index, value);
}

at::Tensor & scatter_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
return wrapper_scatter_out_value_out(self, dim, index, value, out);
}

at::Tensor & scatter_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, at::Tensor & out) {
return wrapper_scatter_out_value_out(self, dim, index, value, out);
}

at::Tensor & scatter_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value) {
return wrapper_scatter__value(self, dim, index, value);
}

at::Tensor scatter(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce) {
return wrapper_scatter_reduce(self, dim, index, src, reduce);
}

at::Tensor & scatter_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce) {
return wrapper_scatter_out_reduce_out(self, dim, index, src, reduce, out);
}

at::Tensor & scatter_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce, at::Tensor & out) {
return wrapper_scatter_out_reduce_out(self, dim, index, src, reduce, out);
}

at::Tensor & scatter_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, c10::string_view reduce) {
return wrapper_scatter__reduce(self, dim, index, src, reduce);
}

at::Tensor scatter(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce) {
return wrapper_scatter_value_reduce(self, dim, index, value, reduce);
}

at::Tensor & scatter_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce) {
return wrapper_scatter_out_value_reduce_out(self, dim, index, value, reduce, out);
}

at::Tensor & scatter_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce, at::Tensor & out) {
return wrapper_scatter_out_value_reduce_out(self, dim, index, value, reduce, out);
}

at::Tensor & scatter_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Scalar & value, c10::string_view reduce) {
return wrapper_scatter__value_reduce(self, dim, index, value, reduce);
}

at::Tensor scatter_add(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
return wrapper_scatter_add(self, dim, index, src);
}

at::Tensor & scatter_add_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
return wrapper_scatter_add_out_out(self, dim, index, src, out);
}

at::Tensor & scatter_add_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src, at::Tensor & out) {
return wrapper_scatter_add_out_out(self, dim, index, src, out);
}

at::Tensor & scatter_add_(at::Tensor & self, int64_t dim, const at::Tensor & index, const at::Tensor & src) {
return wrapper_scatter_add_(self, dim, index, src);
}

at::Tensor eq(const at::Tensor & self, const at::Scalar & other) {
return wrapper_eq_Scalar(self, other);
}

at::Tensor & eq_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_eq_out_Scalar_out(self, other, out);
}

at::Tensor & eq_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_eq_out_Scalar_out(self, other, out);
}

at::Tensor & eq_(at::Tensor & self, const at::Scalar & other) {
return wrapper_eq__Scalar(self, other);
}

at::Tensor eq(const at::Tensor & self, const at::Tensor & other) {
return wrapper_eq_Tensor(self, other);
}

at::Tensor & eq_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_eq_out_Tensor_out(self, other, out);
}

at::Tensor & eq_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_eq_out_Tensor_out(self, other, out);
}

at::Tensor & eq_(at::Tensor & self, const at::Tensor & other) {
return wrapper_eq__Tensor(self, other);
}

at::Tensor bitwise_and(const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_and_Tensor(self, other);
}

at::Tensor & bitwise_and_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_and_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_and_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_bitwise_and_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_and_(at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_and__Tensor(self, other);
}

at::Tensor bitwise_or(const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_or_Tensor(self, other);
}

at::Tensor & bitwise_or_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_or_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_or_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_bitwise_or_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_or_(at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_or__Tensor(self, other);
}

at::Tensor bitwise_xor(const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_xor_Tensor(self, other);
}

at::Tensor & bitwise_xor_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_xor_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_xor_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_bitwise_xor_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_xor_(at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_xor__Tensor(self, other);
}

at::Tensor __lshift__(const at::Tensor & self, const at::Scalar & other) {
return wrapper_Scalar___lshift___Scalar(self, other);
}

at::Tensor & __ilshift__(at::Tensor & self, const at::Scalar & other) {
return wrapper_Scalar___ilshift___Scalar(self, other);
}

at::Tensor __lshift__(const at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor___lshift___Tensor(self, other);
}

at::Tensor & __ilshift__(at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor___ilshift___Tensor(self, other);
}

at::Tensor bitwise_left_shift(const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_left_shift_Tensor(self, other);
}

at::Tensor & bitwise_left_shift_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_left_shift_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_left_shift_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_bitwise_left_shift_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_left_shift_(at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_left_shift__Tensor(self, other);
}

at::Tensor bitwise_left_shift(const at::Tensor & self, const at::Scalar & other) {
return wrapper_Tensor_Scalar_bitwise_left_shift_Tensor_Scalar(self, other);
}

at::Tensor & bitwise_left_shift_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_Tensor_Scalar_out_bitwise_left_shift_out_Tensor_Scalar_out(self, other, out);
}

at::Tensor & bitwise_left_shift_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_Tensor_Scalar_out_bitwise_left_shift_out_Tensor_Scalar_out(self, other, out);
}

at::Tensor & bitwise_left_shift_(at::Tensor & self, const at::Scalar & other) {
return wrapper_Tensor_Scalar_bitwise_left_shift__Tensor_Scalar(self, other);
}

at::Tensor bitwise_left_shift(const at::Scalar & self, const at::Tensor & other) {
return wrapper_Scalar_Tensor_bitwise_left_shift_Scalar_Tensor(self, other);
}

at::Tensor __rshift__(const at::Tensor & self, const at::Scalar & other) {
return wrapper_Scalar___rshift___Scalar(self, other);
}

at::Tensor & __irshift__(at::Tensor & self, const at::Scalar & other) {
return wrapper_Scalar___irshift___Scalar(self, other);
}

at::Tensor __rshift__(const at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor___rshift___Tensor(self, other);
}

at::Tensor & __irshift__(at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor___irshift___Tensor(self, other);
}

at::Tensor bitwise_right_shift(const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_right_shift_Tensor(self, other);
}

at::Tensor & bitwise_right_shift_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_right_shift_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_right_shift_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_bitwise_right_shift_out_Tensor_out(self, other, out);
}

at::Tensor & bitwise_right_shift_(at::Tensor & self, const at::Tensor & other) {
return wrapper_bitwise_right_shift__Tensor(self, other);
}

at::Tensor bitwise_right_shift(const at::Tensor & self, const at::Scalar & other) {
return wrapper_Tensor_Scalar_bitwise_right_shift_Tensor_Scalar(self, other);
}

at::Tensor & bitwise_right_shift_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_Tensor_Scalar_out_bitwise_right_shift_out_Tensor_Scalar_out(self, other, out);
}

at::Tensor & bitwise_right_shift_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_Tensor_Scalar_out_bitwise_right_shift_out_Tensor_Scalar_out(self, other, out);
}

at::Tensor & bitwise_right_shift_(at::Tensor & self, const at::Scalar & other) {
return wrapper_Tensor_Scalar_bitwise_right_shift__Tensor_Scalar(self, other);
}

at::Tensor bitwise_right_shift(const at::Scalar & self, const at::Tensor & other) {
return wrapper_Scalar_Tensor_bitwise_right_shift_Scalar_Tensor(self, other);
}

at::Tensor tril(const at::Tensor & self, int64_t diagonal) {
return wrapper_tril(self, diagonal);
}

at::Tensor & tril_out(at::Tensor & out, const at::Tensor & self, int64_t diagonal) {
return wrapper_tril_out_out(self, diagonal, out);
}

at::Tensor & tril_outf(const at::Tensor & self, int64_t diagonal, at::Tensor & out) {
return wrapper_tril_out_out(self, diagonal, out);
}

at::Tensor & tril_(at::Tensor & self, int64_t diagonal) {
return wrapper_tril_(self, diagonal);
}

at::Tensor triu(const at::Tensor & self, int64_t diagonal) {
return wrapper_triu(self, diagonal);
}

at::Tensor & triu_out(at::Tensor & out, const at::Tensor & self, int64_t diagonal) {
return wrapper_triu_out_out(self, diagonal, out);
}

at::Tensor & triu_outf(const at::Tensor & self, int64_t diagonal, at::Tensor & out) {
return wrapper_triu_out_out(self, diagonal, out);
}

at::Tensor & triu_(at::Tensor & self, int64_t diagonal) {
return wrapper_triu_(self, diagonal);
}

at::Tensor digamma(const at::Tensor & self) {
return wrapper_digamma(self);
}

at::Tensor & digamma_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_digamma_out_out(self, out);
}

at::Tensor & digamma_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_digamma_out_out(self, out);
}

at::Tensor & digamma_(at::Tensor & self) {
return wrapper_digamma_(self);
}

at::Tensor lerp(const at::Tensor & self, const at::Tensor & end, const at::Scalar & weight) {
return wrapper_lerp_Scalar(self, end, weight);
}

at::Tensor & lerp_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & end, const at::Scalar & weight) {
return wrapper_lerp_out_Scalar_out(self, end, weight, out);
}

at::Tensor & lerp_outf(const at::Tensor & self, const at::Tensor & end, const at::Scalar & weight, at::Tensor & out) {
return wrapper_lerp_out_Scalar_out(self, end, weight, out);
}

at::Tensor & lerp_(at::Tensor & self, const at::Tensor & end, const at::Scalar & weight) {
return wrapper_lerp__Scalar(self, end, weight);
}

at::Tensor lerp(const at::Tensor & self, const at::Tensor & end, const at::Tensor & weight) {
return wrapper_lerp_Tensor(self, end, weight);
}

at::Tensor & lerp_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & end, const at::Tensor & weight) {
return wrapper_lerp_out_Tensor_out(self, end, weight, out);
}

at::Tensor & lerp_outf(const at::Tensor & self, const at::Tensor & end, const at::Tensor & weight, at::Tensor & out) {
return wrapper_lerp_out_Tensor_out(self, end, weight, out);
}

at::Tensor & lerp_(at::Tensor & self, const at::Tensor & end, const at::Tensor & weight) {
return wrapper_lerp__Tensor(self, end, weight);
}

at::Tensor addbmm(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper__addbmm(self, batch1, batch2, beta, alpha);
}

at::Tensor & addbmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_out_addbmm_out_out(self, batch1, batch2, beta, alpha, out);
}

at::Tensor & addbmm_outf(const at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_addbmm_out_out(self, batch1, batch2, beta, alpha, out);
}

at::Tensor & addbmm_(at::Tensor & self, const at::Tensor & batch1, const at::Tensor & batch2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper__addbmm_(self, batch1, batch2, beta, alpha);
}

at::Tensor & random_(at::Tensor & self, int64_t from, c10::optional<int64_t> to, c10::optional<at::Generator> generator) {
return wrapper_from_random__from(self, from, to, generator);
}

at::Tensor & random_(at::Tensor & self, int64_t to, c10::optional<at::Generator> generator) {
return wrapper_to_random__to(self, to, generator);
}

at::Tensor & random_(at::Tensor & self, c10::optional<at::Generator> generator) {
return wrapper__random_(self, generator);
}

at::Tensor & uniform_(at::Tensor & self, double from, double to, c10::optional<at::Generator> generator) {
return wrapper__uniform_(self, from, to, generator);
}

at::Tensor & cauchy_(at::Tensor & self, double median, double sigma, c10::optional<at::Generator> generator) {
return wrapper__cauchy_(self, median, sigma, generator);
}

at::Tensor & log_normal_(at::Tensor & self, double mean, double std, c10::optional<at::Generator> generator) {
return wrapper__log_normal_(self, mean, std, generator);
}

at::Tensor & exponential_(at::Tensor & self, double lambd, c10::optional<at::Generator> generator) {
return wrapper__exponential_(self, lambd, generator);
}

at::Tensor & geometric_(at::Tensor & self, double p, c10::optional<at::Generator> generator) {
return wrapper__geometric_(self, p, generator);
}

at::Tensor & diag_out(at::Tensor & out, const at::Tensor & self, int64_t diagonal) {
return wrapper_out_diag_out_out(self, diagonal, out);
}

at::Tensor & diag_outf(const at::Tensor & self, int64_t diagonal, at::Tensor & out) {
return wrapper_out_diag_out_out(self, diagonal, out);
}

at::Tensor tril_indices(int64_t row, int64_t col, int64_t offset, at::TensorOptions options) {
return wrapper__tril_indices(row, col, offset, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor tril_indices(int64_t row, int64_t col, int64_t offset, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper__tril_indices(row, col, offset, dtype, layout, device, pin_memory);
}

at::Tensor triu_indices(int64_t row, int64_t col, int64_t offset, at::TensorOptions options) {
return wrapper__triu_indices(row, col, offset, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor triu_indices(int64_t row, int64_t col, int64_t offset, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper__triu_indices(row, col, offset, dtype, layout, device, pin_memory);
}

at::Tensor trace(const at::Tensor & self) {
return wrapper__trace(self);
}

at::Tensor ne(const at::Tensor & self, const at::Scalar & other) {
return wrapper_ne_Scalar(self, other);
}

at::Tensor & ne_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_ne_out_Scalar_out(self, other, out);
}

at::Tensor & ne_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_ne_out_Scalar_out(self, other, out);
}

at::Tensor & ne_(at::Tensor & self, const at::Scalar & other) {
return wrapper_ne__Scalar(self, other);
}

at::Tensor ne(const at::Tensor & self, const at::Tensor & other) {
return wrapper_ne_Tensor(self, other);
}

at::Tensor & ne_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_ne_out_Tensor_out(self, other, out);
}

at::Tensor & ne_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_ne_out_Tensor_out(self, other, out);
}

at::Tensor & ne_(at::Tensor & self, const at::Tensor & other) {
return wrapper_ne__Tensor(self, other);
}

at::Tensor ge(const at::Tensor & self, const at::Scalar & other) {
return wrapper_ge_Scalar(self, other);
}

at::Tensor & ge_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_ge_out_Scalar_out(self, other, out);
}

at::Tensor & ge_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_ge_out_Scalar_out(self, other, out);
}

at::Tensor & ge_(at::Tensor & self, const at::Scalar & other) {
return wrapper_ge__Scalar(self, other);
}

at::Tensor ge(const at::Tensor & self, const at::Tensor & other) {
return wrapper_ge_Tensor(self, other);
}

at::Tensor & ge_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_ge_out_Tensor_out(self, other, out);
}

at::Tensor & ge_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_ge_out_Tensor_out(self, other, out);
}

at::Tensor & ge_(at::Tensor & self, const at::Tensor & other) {
return wrapper_ge__Tensor(self, other);
}

at::Tensor le(const at::Tensor & self, const at::Scalar & other) {
return wrapper_le_Scalar(self, other);
}

at::Tensor & le_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_le_out_Scalar_out(self, other, out);
}

at::Tensor & le_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_le_out_Scalar_out(self, other, out);
}

at::Tensor & le_(at::Tensor & self, const at::Scalar & other) {
return wrapper_le__Scalar(self, other);
}

at::Tensor le(const at::Tensor & self, const at::Tensor & other) {
return wrapper_le_Tensor(self, other);
}

at::Tensor & le_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_le_out_Tensor_out(self, other, out);
}

at::Tensor & le_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_le_out_Tensor_out(self, other, out);
}

at::Tensor & le_(at::Tensor & self, const at::Tensor & other) {
return wrapper_le__Tensor(self, other);
}

at::Tensor gt(const at::Tensor & self, const at::Scalar & other) {
return wrapper_gt_Scalar(self, other);
}

at::Tensor & gt_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_gt_out_Scalar_out(self, other, out);
}

at::Tensor & gt_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_gt_out_Scalar_out(self, other, out);
}

at::Tensor & gt_(at::Tensor & self, const at::Scalar & other) {
return wrapper_gt__Scalar(self, other);
}

at::Tensor gt(const at::Tensor & self, const at::Tensor & other) {
return wrapper_gt_Tensor(self, other);
}

at::Tensor & gt_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_gt_out_Tensor_out(self, other, out);
}

at::Tensor & gt_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_gt_out_Tensor_out(self, other, out);
}

at::Tensor & gt_(at::Tensor & self, const at::Tensor & other) {
return wrapper_gt__Tensor(self, other);
}

at::Tensor lt(const at::Tensor & self, const at::Scalar & other) {
return wrapper_lt_Scalar(self, other);
}

at::Tensor & lt_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & other) {
return wrapper_lt_out_Scalar_out(self, other, out);
}

at::Tensor & lt_outf(const at::Tensor & self, const at::Scalar & other, at::Tensor & out) {
return wrapper_lt_out_Scalar_out(self, other, out);
}

at::Tensor & lt_(at::Tensor & self, const at::Scalar & other) {
return wrapper_lt__Scalar(self, other);
}

at::Tensor lt(const at::Tensor & self, const at::Tensor & other) {
return wrapper_lt_Tensor(self, other);
}

at::Tensor & lt_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_lt_out_Tensor_out(self, other, out);
}

at::Tensor & lt_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_lt_out_Tensor_out(self, other, out);
}

at::Tensor & lt_(at::Tensor & self, const at::Tensor & other) {
return wrapper_lt__Tensor(self, other);
}

at::Tensor take(const at::Tensor & self, const at::Tensor & index) {
return wrapper__take(self, index);
}

at::Tensor & take_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & index) {
return wrapper_out_take_out_out(self, index, out);
}

at::Tensor & take_outf(const at::Tensor & self, const at::Tensor & index, at::Tensor & out) {
return wrapper_out_take_out_out(self, index, out);
}

at::Tensor index_select(const at::Tensor & self, int64_t dim, const at::Tensor & index) {
return wrapper__index_select(self, dim, index);
}

at::Tensor & index_select_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index) {
return wrapper_out_index_select_out_out(self, dim, index, out);
}

at::Tensor & index_select_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, at::Tensor & out) {
return wrapper_out_index_select_out_out(self, dim, index, out);
}

at::Tensor masked_select(const at::Tensor & self, const at::Tensor & mask) {
return wrapper__masked_select(self, mask);
}

at::Tensor & masked_select_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mask) {
return wrapper_out_masked_select_out_out(self, mask, out);
}

at::Tensor & masked_select_outf(const at::Tensor & self, const at::Tensor & mask, at::Tensor & out) {
return wrapper_out_masked_select_out_out(self, mask, out);
}

at::Tensor nonzero(const at::Tensor & self) {
return wrapper__nonzero(self);
}

at::Tensor & nonzero_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_nonzero_out_out(self, out);
}

at::Tensor & nonzero_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_nonzero_out_out(self, out);
}

at::Tensor gather(const at::Tensor & self, int64_t dim, const at::Tensor & index, bool sparse_grad) {
return wrapper_gather(self, dim, index, sparse_grad);
}

at::Tensor & gather_out(at::Tensor & out, const at::Tensor & self, int64_t dim, const at::Tensor & index, bool sparse_grad) {
return wrapper_gather_out_out(self, dim, index, sparse_grad, out);
}

at::Tensor & gather_outf(const at::Tensor & self, int64_t dim, const at::Tensor & index, bool sparse_grad, at::Tensor & out) {
return wrapper_gather_out_out(self, dim, index, sparse_grad, out);
}

at::Tensor addcmul(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
return wrapper_addcmul(self, tensor1, tensor2, value);
}

at::Tensor & addcmul_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
return wrapper_addcmul_out_out(self, tensor1, tensor2, value, out);
}

at::Tensor & addcmul_outf(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value, at::Tensor & out) {
return wrapper_addcmul_out_out(self, tensor1, tensor2, value, out);
}

at::Tensor & addcmul_(at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
return wrapper_addcmul_(self, tensor1, tensor2, value);
}

at::Tensor addcdiv(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
return wrapper_addcdiv(self, tensor1, tensor2, value);
}

at::Tensor & addcdiv_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
return wrapper_addcdiv_out_out(self, tensor1, tensor2, value, out);
}

at::Tensor & addcdiv_outf(const at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value, at::Tensor & out) {
return wrapper_addcdiv_out_out(self, tensor1, tensor2, value, out);
}

at::Tensor & addcdiv_(at::Tensor & self, const at::Tensor & tensor1, const at::Tensor & tensor2, const at::Scalar & value) {
return wrapper_addcdiv_(self, tensor1, tensor2, value);
}

::std::tuple<at::Tensor,at::Tensor> lstsq(const at::Tensor & self, const at::Tensor & A) {
return wrapper__lstsq(self, A);
}

::std::tuple<at::Tensor &,at::Tensor &> lstsq_out(at::Tensor & X, at::Tensor & qr, const at::Tensor & self, const at::Tensor & A) {
return wrapper_X_lstsq_out_X(self, A, X, qr);
}

::std::tuple<at::Tensor &,at::Tensor &> lstsq_outf(const at::Tensor & self, const at::Tensor & A, at::Tensor & X, at::Tensor & qr) {
return wrapper_X_lstsq_out_X(self, A, X, qr);
}

::std::tuple<at::Tensor,at::Tensor> triangular_solve(const at::Tensor & self, const at::Tensor & A, bool upper, bool transpose, bool unitriangular) {
return wrapper_triangular_solve(self, A, upper, transpose, unitriangular);
}

::std::tuple<at::Tensor &,at::Tensor &> triangular_solve_out(at::Tensor & X, at::Tensor & M, const at::Tensor & self, const at::Tensor & A, bool upper, bool transpose, bool unitriangular) {
return wrapper_triangular_solve_out_X(self, A, upper, transpose, unitriangular, X, M);
}

::std::tuple<at::Tensor &,at::Tensor &> triangular_solve_outf(const at::Tensor & self, const at::Tensor & A, bool upper, bool transpose, bool unitriangular, at::Tensor & X, at::Tensor & M) {
return wrapper_triangular_solve_out_X(self, A, upper, transpose, unitriangular, X, M);
}

at::Tensor linalg_solve_triangular(const at::Tensor & self, const at::Tensor & B, bool upper, bool left, bool unitriangular) {
return wrapper__linalg_solve_triangular(self, B, upper, left, unitriangular);
}

at::Tensor & linalg_solve_triangular_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & B, bool upper, bool left, bool unitriangular) {
return wrapper_out_linalg_solve_triangular_out_out(self, B, upper, left, unitriangular, out);
}

at::Tensor & linalg_solve_triangular_outf(const at::Tensor & self, const at::Tensor & B, bool upper, bool left, bool unitriangular, at::Tensor & out) {
return wrapper_out_linalg_solve_triangular_out_out(self, B, upper, left, unitriangular, out);
}

::std::tuple<at::Tensor,at::Tensor> _symeig_helper(const at::Tensor & self, bool eigenvectors, bool upper) {
return wrapper___symeig_helper(self, eigenvectors, upper);
}

at::Tensor cholesky(const at::Tensor & self, bool upper) {
return wrapper__cholesky(self, upper);
}

at::Tensor & cholesky_out(at::Tensor & out, const at::Tensor & self, bool upper) {
return wrapper_out_cholesky_out_out(self, upper, out);
}

at::Tensor & cholesky_outf(const at::Tensor & self, bool upper, at::Tensor & out) {
return wrapper_out_cholesky_out_out(self, upper, out);
}

at::Tensor _cholesky_solve_helper(const at::Tensor & self, const at::Tensor & A, bool upper) {
return wrapper___cholesky_solve_helper(self, A, upper);
}

::std::tuple<at::Tensor,at::Tensor> _solve_helper(const at::Tensor & self, const at::Tensor & A) {
return wrapper___solve_helper(self, A);
}

at::Tensor cholesky_inverse(const at::Tensor & self, bool upper) {
return wrapper__cholesky_inverse(self, upper);
}

at::Tensor & cholesky_inverse_out(at::Tensor & out, const at::Tensor & self, bool upper) {
return wrapper_out_cholesky_inverse_out_out(self, upper, out);
}

at::Tensor & cholesky_inverse_outf(const at::Tensor & self, bool upper, at::Tensor & out) {
return wrapper_out_cholesky_inverse_out_out(self, upper, out);
}

::std::tuple<at::Tensor,at::Tensor> geqrf(const at::Tensor & self) {
return wrapper__geqrf(self);
}

::std::tuple<at::Tensor &,at::Tensor &> geqrf_out(at::Tensor & a, at::Tensor & tau, const at::Tensor & self) {
return wrapper_a_geqrf_out_a(self, a, tau);
}

::std::tuple<at::Tensor &,at::Tensor &> geqrf_outf(const at::Tensor & self, at::Tensor & a, at::Tensor & tau) {
return wrapper_a_geqrf_out_a(self, a, tau);
}

at::Tensor ormqr(const at::Tensor & self, const at::Tensor & input2, const at::Tensor & input3, bool left, bool transpose) {
return wrapper__ormqr(self, input2, input3, left, transpose);
}

at::Tensor & ormqr_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & input2, const at::Tensor & input3, bool left, bool transpose) {
return wrapper_out_ormqr_out_out(self, input2, input3, left, transpose, out);
}

at::Tensor & ormqr_outf(const at::Tensor & self, const at::Tensor & input2, const at::Tensor & input3, bool left, bool transpose, at::Tensor & out) {
return wrapper_out_ormqr_out_out(self, input2, input3, left, transpose, out);
}

at::Tensor lu_solve(const at::Tensor & self, const at::Tensor & LU_data, const at::Tensor & LU_pivots) {
return wrapper__lu_solve(self, LU_data, LU_pivots);
}

at::Tensor & lu_solve_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & LU_data, const at::Tensor & LU_pivots) {
return wrapper_out_lu_solve_out_out(self, LU_data, LU_pivots, out);
}

at::Tensor & lu_solve_outf(const at::Tensor & self, const at::Tensor & LU_data, const at::Tensor & LU_pivots, at::Tensor & out) {
return wrapper_out_lu_solve_out_out(self, LU_data, LU_pivots, out);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> lu_unpack(const at::Tensor & LU_data, const at::Tensor & LU_pivots, bool unpack_data, bool unpack_pivots) {
return wrapper__lu_unpack(LU_data, LU_pivots, unpack_data, unpack_pivots);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> lu_unpack_out(at::Tensor & P, at::Tensor & L, at::Tensor & U, const at::Tensor & LU_data, const at::Tensor & LU_pivots, bool unpack_data, bool unpack_pivots) {
return wrapper_out_lu_unpack_out_out(LU_data, LU_pivots, unpack_data, unpack_pivots, P, L, U);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> lu_unpack_outf(const at::Tensor & LU_data, const at::Tensor & LU_pivots, bool unpack_data, bool unpack_pivots, at::Tensor & P, at::Tensor & L, at::Tensor & U) {
return wrapper_out_lu_unpack_out_out(LU_data, LU_pivots, unpack_data, unpack_pivots, P, L, U);
}

at::Tensor multinomial(const at::Tensor & self, int64_t num_samples, bool replacement, c10::optional<at::Generator> generator) {
return wrapper__multinomial(self, num_samples, replacement, generator);
}

at::Tensor & multinomial_out(at::Tensor & out, const at::Tensor & self, int64_t num_samples, bool replacement, c10::optional<at::Generator> generator) {
return wrapper_out_multinomial_out_out(self, num_samples, replacement, generator, out);
}

at::Tensor & multinomial_outf(const at::Tensor & self, int64_t num_samples, bool replacement, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_out_multinomial_out_out(self, num_samples, replacement, generator, out);
}

at::Tensor lgamma(const at::Tensor & self) {
return wrapper_lgamma(self);
}

at::Tensor & lgamma_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_lgamma_out_out(self, out);
}

at::Tensor & lgamma_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_lgamma_out_out(self, out);
}

at::Tensor & lgamma_(at::Tensor & self) {
return wrapper_lgamma_(self);
}

at::Tensor polygamma(int64_t n, const at::Tensor & self) {
return wrapper_polygamma(n, self);
}

at::Tensor & polygamma_out(at::Tensor & out, int64_t n, const at::Tensor & self) {
return wrapper_polygamma_out_out(n, self, out);
}

at::Tensor & polygamma_outf(int64_t n, const at::Tensor & self, at::Tensor & out) {
return wrapper_polygamma_out_out(n, self, out);
}

at::Tensor erfinv(const at::Tensor & self) {
return wrapper_erfinv(self);
}

at::Tensor & erfinv_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_erfinv_out_out(self, out);
}

at::Tensor & erfinv_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_erfinv_out_out(self, out);
}

at::Tensor & erfinv_(at::Tensor & self) {
return wrapper_erfinv_(self);
}

at::Tensor i0(const at::Tensor & self) {
return wrapper_i0(self);
}

at::Tensor & i0_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_i0_out_out(self, out);
}

at::Tensor & i0_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_i0_out_out(self, out);
}

at::Tensor & i0_(at::Tensor & self) {
return wrapper_i0_(self);
}

at::Tensor sign(const at::Tensor & self) {
return wrapper_sign(self);
}

at::Tensor & sign_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_sign_out_out(self, out);
}

at::Tensor & sign_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_sign_out_out(self, out);
}

at::Tensor & sign_(at::Tensor & self) {
return wrapper_sign_(self);
}

at::Tensor signbit(const at::Tensor & self) {
return wrapper_signbit(self);
}

at::Tensor & signbit_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_signbit_out_out(self, out);
}

at::Tensor & signbit_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_signbit_out_out(self, out);
}

at::Tensor atan2(const at::Tensor & self, const at::Tensor & other) {
return wrapper_atan2(self, other);
}

at::Tensor & atan2_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_atan2_out_out(self, other, out);
}

at::Tensor & atan2_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_atan2_out_out(self, other, out);
}

at::Tensor & atan2_(at::Tensor & self, const at::Tensor & other) {
return wrapper_atan2_(self, other);
}

at::Tensor histc(const at::Tensor & self, int64_t bins, const at::Scalar & min, const at::Scalar & max) {
return wrapper__histc(self, bins, min, max);
}

at::Tensor & histc_out(at::Tensor & out, const at::Tensor & self, int64_t bins, const at::Scalar & min, const at::Scalar & max) {
return wrapper_out_histc_out_out(self, bins, min, max, out);
}

at::Tensor & histc_outf(const at::Tensor & self, int64_t bins, const at::Scalar & min, const at::Scalar & max, at::Tensor & out) {
return wrapper_out_histc_out_out(self, bins, min, max, out);
}

at::Tensor fmod(const at::Tensor & self, const at::Tensor & other) {
return wrapper_fmod_Tensor(self, other);
}

at::Tensor & fmod_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_fmod_out_Tensor_out(self, other, out);
}

at::Tensor & fmod_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_fmod_out_Tensor_out(self, other, out);
}

at::Tensor & fmod_(at::Tensor & self, const at::Tensor & other) {
return wrapper_fmod__Tensor(self, other);
}

at::Tensor hypot(const at::Tensor & self, const at::Tensor & other) {
return wrapper_hypot(self, other);
}

at::Tensor & hypot_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_hypot_out_out(self, other, out);
}

at::Tensor & hypot_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_hypot_out_out(self, other, out);
}

at::Tensor & hypot_(at::Tensor & self, const at::Tensor & other) {
return wrapper_hypot_(self, other);
}

at::Tensor igamma(const at::Tensor & self, const at::Tensor & other) {
return wrapper_igamma(self, other);
}

at::Tensor & igamma_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_igamma_out_out(self, other, out);
}

at::Tensor & igamma_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_igamma_out_out(self, other, out);
}

at::Tensor & igamma_(at::Tensor & self, const at::Tensor & other) {
return wrapper_igamma_(self, other);
}

at::Tensor igammac(const at::Tensor & self, const at::Tensor & other) {
return wrapper_igammac(self, other);
}

at::Tensor & igammac_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_igammac_out_out(self, other, out);
}

at::Tensor & igammac_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_igammac_out_out(self, other, out);
}

at::Tensor & igammac_(at::Tensor & self, const at::Tensor & other) {
return wrapper_igammac_(self, other);
}

at::Tensor nextafter(const at::Tensor & self, const at::Tensor & other) {
return wrapper_nextafter(self, other);
}

at::Tensor & nextafter_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_nextafter_out_out(self, other, out);
}

at::Tensor & nextafter_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_nextafter_out_out(self, other, out);
}

at::Tensor & nextafter_(at::Tensor & self, const at::Tensor & other) {
return wrapper_nextafter_(self, other);
}

at::Tensor remainder(const at::Tensor & self, const at::Tensor & other) {
return wrapper_remainder_Tensor(self, other);
}

at::Tensor & remainder_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_remainder_out_Tensor_out(self, other, out);
}

at::Tensor & remainder_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_remainder_out_Tensor_out(self, other, out);
}

at::Tensor & remainder_(at::Tensor & self, const at::Tensor & other) {
return wrapper_remainder__Tensor(self, other);
}

at::Tensor remainder(const at::Scalar & self, const at::Tensor & other) {
return wrapper_Scalar_Tensor_remainder_Scalar_Tensor(self, other);
}

at::Tensor min(const at::Tensor & self) {
return wrapper__min(self);
}

at::Tensor fmin(const at::Tensor & self, const at::Tensor & other) {
return wrapper_fmin(self, other);
}

at::Tensor & fmin_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_fmin_out_out(self, other, out);
}

at::Tensor & fmin_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_fmin_out_out(self, other, out);
}

at::Tensor max(const at::Tensor & self) {
return wrapper__max(self);
}

at::Tensor fmax(const at::Tensor & self, const at::Tensor & other) {
return wrapper_fmax(self, other);
}

at::Tensor & fmax_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_fmax_out_out(self, other, out);
}

at::Tensor & fmax_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_fmax_out_out(self, other, out);
}

at::Tensor maximum(const at::Tensor & self, const at::Tensor & other) {
return wrapper_maximum(self, other);
}

at::Tensor & maximum_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_maximum_out_out(self, other, out);
}

at::Tensor & maximum_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_maximum_out_out(self, other, out);
}

at::Tensor minimum(const at::Tensor & self, const at::Tensor & other) {
return wrapper_minimum(self, other);
}

at::Tensor & minimum_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_minimum_out_out(self, other, out);
}

at::Tensor & minimum_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_minimum_out_out(self, other, out);
}

::std::tuple<at::Tensor,at::Tensor> sort(const at::Tensor & self, int64_t dim, bool descending) {
return wrapper__sort(self, dim, descending);
}

::std::tuple<at::Tensor &,at::Tensor &> sort_out(at::Tensor & values, at::Tensor & indices, const at::Tensor & self, int64_t dim, bool descending) {
return wrapper_values_sort_out_values(self, dim, descending, values, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> sort_outf(const at::Tensor & self, int64_t dim, bool descending, at::Tensor & values, at::Tensor & indices) {
return wrapper_values_sort_out_values(self, dim, descending, values, indices);
}

::std::tuple<at::Tensor,at::Tensor> sort(const at::Tensor & self, c10::optional<bool> stable, int64_t dim, bool descending) {
return wrapper_stable_sort_stable(self, stable, dim, descending);
}

::std::tuple<at::Tensor &,at::Tensor &> sort_out(at::Tensor & values, at::Tensor & indices, const at::Tensor & self, c10::optional<bool> stable, int64_t dim, bool descending) {
return wrapper_values_stable_sort_out_values_stable(self, stable, dim, descending, values, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> sort_outf(const at::Tensor & self, c10::optional<bool> stable, int64_t dim, bool descending, at::Tensor & values, at::Tensor & indices) {
return wrapper_values_stable_sort_out_values_stable(self, stable, dim, descending, values, indices);
}

::std::tuple<at::Tensor,at::Tensor> topk(const at::Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted) {
return wrapper_topk(self, k, dim, largest, sorted);
}

::std::tuple<at::Tensor &,at::Tensor &> topk_out(at::Tensor & values, at::Tensor & indices, const at::Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted) {
return wrapper_topk_out_values(self, k, dim, largest, sorted, values, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> topk_outf(const at::Tensor & self, int64_t k, int64_t dim, bool largest, bool sorted, at::Tensor & values, at::Tensor & indices) {
return wrapper_topk_out_values(self, k, dim, largest, sorted, values, indices);
}

at::Tensor all(const at::Tensor & self) {
return wrapper_all(self);
}

at::Tensor & all_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_all_out_all_out(self, out);
}

at::Tensor & all_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_all_out_all_out(self, out);
}

at::Tensor any(const at::Tensor & self) {
return wrapper_any(self);
}

at::Tensor & any_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_any_out_all_out(self, out);
}

at::Tensor & any_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_any_out_all_out(self, out);
}

at::Tensor renorm(const at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm) {
return wrapper_renorm(self, p, dim, maxnorm);
}

at::Tensor & renorm_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm) {
return wrapper_renorm_out_out(self, p, dim, maxnorm, out);
}

at::Tensor & renorm_outf(const at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm, at::Tensor & out) {
return wrapper_renorm_out_out(self, p, dim, maxnorm, out);
}

at::Tensor & renorm_(at::Tensor & self, const at::Scalar & p, int64_t dim, const at::Scalar & maxnorm) {
return wrapper_renorm_(self, p, dim, maxnorm);
}

at::Tensor unfold(const at::Tensor & self, int64_t dimension, int64_t size, int64_t step) {
return wrapper__unfold(self, dimension, size, step);
}

at::Tensor unfold_backward(const at::Tensor & grad_in, at::IntArrayRef input_sizes, int64_t dim, int64_t size, int64_t step) {
return wrapper__unfold_backward(grad_in, input_sizes, dim, size, step);
}

bool equal(const at::Tensor & self, const at::Tensor & other) {
return wrapper__equal(self, other);
}

at::Tensor pow(const at::Tensor & self, const at::Tensor & exponent) {
return wrapper_pow_Tensor_Tensor(self, exponent);
}

at::Tensor & pow_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & exponent) {
return wrapper_pow_out_Tensor_Tensor_out(self, exponent, out);
}

at::Tensor & pow_outf(const at::Tensor & self, const at::Tensor & exponent, at::Tensor & out) {
return wrapper_pow_out_Tensor_Tensor_out(self, exponent, out);
}

at::Tensor & pow_(at::Tensor & self, const at::Tensor & exponent) {
return wrapper_pow__Tensor(self, exponent);
}

at::Tensor pow(const at::Scalar & self, const at::Tensor & exponent) {
return wrapper_pow_Scalar(self, exponent);
}

at::Tensor & pow_out(at::Tensor & out, const at::Scalar & self, const at::Tensor & exponent) {
return wrapper_pow_out_Scalar_out(self, exponent, out);
}

at::Tensor & pow_outf(const at::Scalar & self, const at::Tensor & exponent, at::Tensor & out) {
return wrapper_pow_out_Scalar_out(self, exponent, out);
}

at::Tensor pow(const at::Tensor & self, const at::Scalar & exponent) {
return wrapper_pow_Tensor_Scalar(self, exponent);
}

at::Tensor & pow_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & exponent) {
return wrapper_pow_out_Tensor_Scalar_out(self, exponent, out);
}

at::Tensor & pow_outf(const at::Tensor & self, const at::Scalar & exponent, at::Tensor & out) {
return wrapper_pow_out_Tensor_Scalar_out(self, exponent, out);
}

at::Tensor & pow_(at::Tensor & self, const at::Scalar & exponent) {
return wrapper_pow__Scalar(self, exponent);
}

at::Tensor & normal_(at::Tensor & self, double mean, double std, c10::optional<at::Generator> generator) {
return wrapper__normal_(self, mean, std, generator);
}

at::Tensor normal(const at::Tensor & mean, double std, c10::optional<at::Generator> generator) {
return wrapper_Tensor_float_normal_Tensor_float(mean, std, generator);
}

at::Tensor & normal_out(at::Tensor & out, const at::Tensor & mean, double std, c10::optional<at::Generator> generator) {
return wrapper_Tensor_float_out_normal_out_Tensor_float_out(mean, std, generator, out);
}

at::Tensor & normal_outf(const at::Tensor & mean, double std, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_Tensor_float_out_normal_out_Tensor_float_out(mean, std, generator, out);
}

at::Tensor normal(double mean, const at::Tensor & std, c10::optional<at::Generator> generator) {
return wrapper_float_Tensor_normal_float_Tensor(mean, std, generator);
}

at::Tensor & normal_out(at::Tensor & out, double mean, const at::Tensor & std, c10::optional<at::Generator> generator) {
return wrapper_float_Tensor_out_normal_out_float_Tensor_out(mean, std, generator, out);
}

at::Tensor & normal_outf(double mean, const at::Tensor & std, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_float_Tensor_out_normal_out_float_Tensor_out(mean, std, generator, out);
}

at::Tensor normal(const at::Tensor & mean, const at::Tensor & std, c10::optional<at::Generator> generator) {
return wrapper_Tensor_Tensor_normal_Tensor_Tensor(mean, std, generator);
}

at::Tensor & normal_out(at::Tensor & out, const at::Tensor & mean, const at::Tensor & std, c10::optional<at::Generator> generator) {
return wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out(mean, std, generator, out);
}

at::Tensor & normal_outf(const at::Tensor & mean, const at::Tensor & std, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_Tensor_Tensor_out_normal_out_Tensor_Tensor_out(mean, std, generator, out);
}

void _amp_foreach_non_finite_check_and_unscale_(at::TensorList self, at::Tensor & found_inf, const at::Tensor & inv_scale) {
return wrapper___amp_foreach_non_finite_check_and_unscale_(self, found_inf, inv_scale);
}

at::Tensor & _amp_update_scale_(at::Tensor & self, at::Tensor & growth_tracker, const at::Tensor & found_inf, double scale_growth_factor, double scale_backoff_factor, int64_t growth_interval) {
return wrapper___amp_update_scale_(self, growth_tracker, found_inf, scale_growth_factor, scale_backoff_factor, growth_interval);
}

at::Tensor _cat(at::TensorList tensors, int64_t dim) {
return wrapper___cat(tensors, dim);
}

at::Tensor & _cat_out(at::Tensor & out, at::TensorList tensors, int64_t dim) {
return wrapper_out__cat_out_out(tensors, dim, out);
}

at::Tensor & _cat_outf(at::TensorList tensors, int64_t dim, at::Tensor & out) {
return wrapper_out__cat_out_out(tensors, dim, out);
}

::std::vector<at::Tensor> _foreach_add(at::TensorList tensors, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_add_Scalar(tensors, scalar);
}

void _foreach_add_(at::TensorList self, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_add__Scalar(self, scalar);
}

::std::vector<at::Tensor> _foreach_sub(at::TensorList tensors, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_sub_Scalar(tensors, scalar);
}

void _foreach_sub_(at::TensorList self, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_sub__Scalar(self, scalar);
}

::std::vector<at::Tensor> _foreach_mul(at::TensorList tensors, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_mul_Scalar(tensors, scalar);
}

void _foreach_mul_(at::TensorList self, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_mul__Scalar(self, scalar);
}

::std::vector<at::Tensor> _foreach_div(at::TensorList tensors, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_div_Scalar(tensors, scalar);
}

void _foreach_div_(at::TensorList self, const at::Scalar & scalar) {
return wrapper_Scalar__foreach_div__Scalar(self, scalar);
}

::std::vector<at::Tensor> _foreach_add(at::TensorList tensors1, at::TensorList tensors2, const at::Scalar & alpha) {
return wrapper_List__foreach_add_List(tensors1, tensors2, alpha);
}

void _foreach_add_(at::TensorList self, at::TensorList other, const at::Scalar & alpha) {
return wrapper_List__foreach_add__List(self, other, alpha);
}

::std::vector<at::Tensor> _foreach_sub(at::TensorList tensors1, at::TensorList tensors2, const at::Scalar & alpha) {
return wrapper_List__foreach_sub_List(tensors1, tensors2, alpha);
}

void _foreach_sub_(at::TensorList self, at::TensorList other, const at::Scalar & alpha) {
return wrapper_List__foreach_sub__List(self, other, alpha);
}

::std::vector<at::Tensor> _foreach_mul(at::TensorList tensors1, at::TensorList tensors2) {
return wrapper_List__foreach_mul_List(tensors1, tensors2);
}

void _foreach_mul_(at::TensorList self, at::TensorList other) {
return wrapper_List__foreach_mul__List(self, other);
}

::std::vector<at::Tensor> _foreach_div(at::TensorList tensors1, at::TensorList tensors2) {
return wrapper_List__foreach_div_List(tensors1, tensors2);
}

void _foreach_div_(at::TensorList self, at::TensorList other) {
return wrapper_List__foreach_div__List(self, other);
}

::std::vector<at::Tensor> _foreach_add(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_add_ScalarList(tensors, scalars);
}

void _foreach_add_(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_add__ScalarList(self, scalars);
}

::std::vector<at::Tensor> _foreach_sub(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_sub_ScalarList(tensors, scalars);
}

void _foreach_sub_(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_sub__ScalarList(self, scalars);
}

::std::vector<at::Tensor> _foreach_div(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_div_ScalarList(tensors, scalars);
}

void _foreach_div_(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_div__ScalarList(self, scalars);
}

::std::vector<at::Tensor> _foreach_mul(at::TensorList tensors, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_mul_ScalarList(tensors, scalars);
}

void _foreach_mul_(at::TensorList self, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_mul__ScalarList(self, scalars);
}

::std::vector<at::Tensor> _foreach_exp(at::TensorList tensors) {
return wrapper___foreach_exp(tensors);
}

void _foreach_zero_(at::TensorList self) {
return wrapper___foreach_zero_(self);
}

void _foreach_exp_(at::TensorList self) {
return wrapper___foreach_exp_(self);
}

::std::vector<at::Tensor> _foreach_sqrt(at::TensorList tensors) {
return wrapper___foreach_sqrt(tensors);
}

void _foreach_sqrt_(at::TensorList self) {
return wrapper___foreach_sqrt_(self);
}

::std::vector<at::Tensor> _foreach_abs(at::TensorList tensors) {
return wrapper___foreach_abs(tensors);
}

void _foreach_abs_(at::TensorList self) {
return wrapper___foreach_abs_(self);
}

::std::vector<at::Tensor> _foreach_acos(at::TensorList tensors) {
return wrapper___foreach_acos(tensors);
}

void _foreach_acos_(at::TensorList self) {
return wrapper___foreach_acos_(self);
}

::std::vector<at::Tensor> _foreach_asin(at::TensorList tensors) {
return wrapper___foreach_asin(tensors);
}

void _foreach_asin_(at::TensorList self) {
return wrapper___foreach_asin_(self);
}

::std::vector<at::Tensor> _foreach_atan(at::TensorList tensors) {
return wrapper___foreach_atan(tensors);
}

void _foreach_atan_(at::TensorList self) {
return wrapper___foreach_atan_(self);
}

::std::vector<at::Tensor> _foreach_ceil(at::TensorList tensors) {
return wrapper___foreach_ceil(tensors);
}

void _foreach_ceil_(at::TensorList self) {
return wrapper___foreach_ceil_(self);
}

::std::vector<at::Tensor> _foreach_cos(at::TensorList tensors) {
return wrapper___foreach_cos(tensors);
}

void _foreach_cos_(at::TensorList self) {
return wrapper___foreach_cos_(self);
}

::std::vector<at::Tensor> _foreach_cosh(at::TensorList tensors) {
return wrapper___foreach_cosh(tensors);
}

void _foreach_cosh_(at::TensorList self) {
return wrapper___foreach_cosh_(self);
}

::std::vector<at::Tensor> _foreach_erf(at::TensorList tensors) {
return wrapper___foreach_erf(tensors);
}

void _foreach_erf_(at::TensorList self) {
return wrapper___foreach_erf_(self);
}

::std::vector<at::Tensor> _foreach_erfc(at::TensorList tensors) {
return wrapper___foreach_erfc(tensors);
}

void _foreach_erfc_(at::TensorList self) {
return wrapper___foreach_erfc_(self);
}

::std::vector<at::Tensor> _foreach_expm1(at::TensorList tensors) {
return wrapper___foreach_expm1(tensors);
}

void _foreach_expm1_(at::TensorList self) {
return wrapper___foreach_expm1_(self);
}

::std::vector<at::Tensor> _foreach_floor(at::TensorList tensors) {
return wrapper___foreach_floor(tensors);
}

void _foreach_floor_(at::TensorList self) {
return wrapper___foreach_floor_(self);
}

::std::vector<at::Tensor> _foreach_log(at::TensorList tensors) {
return wrapper___foreach_log(tensors);
}

void _foreach_log_(at::TensorList self) {
return wrapper___foreach_log_(self);
}

::std::vector<at::Tensor> _foreach_log10(at::TensorList tensors) {
return wrapper___foreach_log10(tensors);
}

void _foreach_log10_(at::TensorList self) {
return wrapper___foreach_log10_(self);
}

::std::vector<at::Tensor> _foreach_log1p(at::TensorList tensors) {
return wrapper___foreach_log1p(tensors);
}

void _foreach_log1p_(at::TensorList self) {
return wrapper___foreach_log1p_(self);
}

::std::vector<at::Tensor> _foreach_log2(at::TensorList tensors) {
return wrapper___foreach_log2(tensors);
}

void _foreach_log2_(at::TensorList self) {
return wrapper___foreach_log2_(self);
}

::std::vector<at::Tensor> _foreach_neg(at::TensorList tensors) {
return wrapper___foreach_neg(tensors);
}

void _foreach_neg_(at::TensorList self) {
return wrapper___foreach_neg_(self);
}

::std::vector<at::Tensor> _foreach_tan(at::TensorList tensors) {
return wrapper___foreach_tan(tensors);
}

void _foreach_tan_(at::TensorList self) {
return wrapper___foreach_tan_(self);
}

::std::vector<at::Tensor> _foreach_tanh(at::TensorList tensors) {
return wrapper___foreach_tanh(tensors);
}

void _foreach_tanh_(at::TensorList self) {
return wrapper___foreach_tanh_(self);
}

::std::vector<at::Tensor> _foreach_sin(at::TensorList tensors) {
return wrapper___foreach_sin(tensors);
}

void _foreach_sin_(at::TensorList self) {
return wrapper___foreach_sin_(self);
}

::std::vector<at::Tensor> _foreach_sinh(at::TensorList tensors) {
return wrapper___foreach_sinh(tensors);
}

void _foreach_sinh_(at::TensorList self) {
return wrapper___foreach_sinh_(self);
}

::std::vector<at::Tensor> _foreach_round(at::TensorList tensors) {
return wrapper___foreach_round(tensors);
}

void _foreach_round_(at::TensorList self) {
return wrapper___foreach_round_(self);
}

::std::vector<at::Tensor> _foreach_lgamma(at::TensorList tensors) {
return wrapper___foreach_lgamma(tensors);
}

void _foreach_lgamma_(at::TensorList self) {
return wrapper___foreach_lgamma_(self);
}

::std::vector<at::Tensor> _foreach_frac(at::TensorList tensors) {
return wrapper___foreach_frac(tensors);
}

void _foreach_frac_(at::TensorList self) {
return wrapper___foreach_frac_(self);
}

::std::vector<at::Tensor> _foreach_reciprocal(at::TensorList tensors) {
return wrapper___foreach_reciprocal(tensors);
}

void _foreach_reciprocal_(at::TensorList self) {
return wrapper___foreach_reciprocal_(self);
}

::std::vector<at::Tensor> _foreach_sigmoid(at::TensorList tensors) {
return wrapper___foreach_sigmoid(tensors);
}

void _foreach_sigmoid_(at::TensorList self) {
return wrapper___foreach_sigmoid_(self);
}

::std::vector<at::Tensor> _foreach_trunc(at::TensorList tensors) {
return wrapper___foreach_trunc(tensors);
}

void _foreach_trunc_(at::TensorList self) {
return wrapper___foreach_trunc_(self);
}

void _foreach_addcdiv_(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
return wrapper_Scalar__foreach_addcdiv__Scalar(self, tensor1, tensor2, value);
}

void _foreach_addcmul_(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
return wrapper_Scalar__foreach_addcmul__Scalar(self, tensor1, tensor2, value);
}

void _foreach_addcdiv_(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_addcdiv__ScalarList(self, tensor1, tensor2, scalars);
}

void _foreach_addcmul_(at::TensorList self, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_addcmul__ScalarList(self, tensor1, tensor2, scalars);
}

::std::vector<at::Tensor> _foreach_addcdiv(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
return wrapper_Scalar__foreach_addcdiv_Scalar(input, tensor1, tensor2, value);
}

::std::vector<at::Tensor> _foreach_addcmul(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, const at::Scalar & value) {
return wrapper_Scalar__foreach_addcmul_Scalar(input, tensor1, tensor2, value);
}

::std::vector<at::Tensor> _foreach_addcdiv(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_addcdiv_ScalarList(input, tensor1, tensor2, scalars);
}

::std::vector<at::Tensor> _foreach_addcmul(at::TensorList input, at::TensorList tensor1, at::TensorList tensor2, at::ArrayRef<at::Scalar> scalars) {
return wrapper_ScalarList__foreach_addcmul_ScalarList(input, tensor1, tensor2, scalars);
}

::std::vector<at::Tensor> _foreach_maximum(at::TensorList tensors1, at::TensorList tensors2) {
return wrapper_List__foreach_maximum_List(tensors1, tensors2);
}

::std::vector<at::Tensor> _foreach_minimum(at::TensorList tensors1, at::TensorList tensors2) {
return wrapper_List__foreach_minimum_List(tensors1, tensors2);
}

::std::vector<at::Tensor> _foreach_norm(at::TensorList tensors, const at::Scalar & ord) {
return wrapper_Scalar__foreach_norm_Scalar(tensors, ord);
}

at::Tensor bucketize(const at::Tensor & self, const at::Tensor & boundaries, bool out_int32, bool right) {
return wrapper_Tensor_bucketize_Tensor(self, boundaries, out_int32, right);
}

at::Tensor & bucketize_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & boundaries, bool out_int32, bool right) {
return wrapper_Tensor_out_bucketize_out_Tensor_out(self, boundaries, out_int32, right, out);
}

at::Tensor & bucketize_outf(const at::Tensor & self, const at::Tensor & boundaries, bool out_int32, bool right, at::Tensor & out) {
return wrapper_Tensor_out_bucketize_out_Tensor_out(self, boundaries, out_int32, right, out);
}

at::Tensor bucketize(const at::Scalar & self, const at::Tensor & boundaries, bool out_int32, bool right) {
return wrapper_Scalar_bucketize_Scalar(self, boundaries, out_int32, right);
}

at::Tensor searchsorted(const at::Tensor & sorted_sequence, const at::Tensor & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter) {
return wrapper_Tensor_searchsorted_Tensor(sorted_sequence, self, out_int32, right, side, sorter);
}

at::Tensor & searchsorted_out(at::Tensor & out, const at::Tensor & sorted_sequence, const at::Tensor & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter) {
return wrapper_Tensor_out_searchsorted_out_Tensor_out(sorted_sequence, self, out_int32, right, side, sorter, out);
}

at::Tensor & searchsorted_outf(const at::Tensor & sorted_sequence, const at::Tensor & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter, at::Tensor & out) {
return wrapper_Tensor_out_searchsorted_out_Tensor_out(sorted_sequence, self, out_int32, right, side, sorter, out);
}

at::Tensor _torch_cuda_cu_linker_symbol_op(const at::Tensor & self) {
return wrapper___torch_cuda_cu_linker_symbol_op(self);
}

at::Tensor searchsorted(const at::Tensor & sorted_sequence, const at::Scalar & self, bool out_int32, bool right, c10::optional<c10::string_view> side, const c10::optional<at::Tensor> & sorter) {
return wrapper_Scalar_searchsorted_Scalar(sorted_sequence, self, out_int32, right, side, sorter);
}

at::Tensor _convert_indices_from_coo_to_csr(const at::Tensor & self, int64_t size, bool out_int32) {
return wrapper__convert_indices_from_coo_to_csr(self, size, out_int32);
}

at::Tensor & _convert_indices_from_coo_to_csr_out(at::Tensor & out, const at::Tensor & self, int64_t size, bool out_int32) {
return wrapper__convert_indices_from_coo_to_csr_out_out(self, size, out_int32, out);
}

at::Tensor & _convert_indices_from_coo_to_csr_outf(const at::Tensor & self, int64_t size, bool out_int32, at::Tensor & out) {
return wrapper__convert_indices_from_coo_to_csr_out_out(self, size, out_int32, out);
}

at::Tensor _convert_indices_from_csr_to_coo(const at::Tensor & crow_indices, const at::Tensor & col_indices, bool out_int32, bool transpose) {
return wrapper__convert_indices_from_csr_to_coo(crow_indices, col_indices, out_int32, transpose);
}

at::Tensor & _convert_indices_from_csr_to_coo_out(at::Tensor & out, const at::Tensor & crow_indices, const at::Tensor & col_indices, bool out_int32, bool transpose) {
return wrapper__convert_indices_from_csr_to_coo_out_out(crow_indices, col_indices, out_int32, transpose, out);
}

at::Tensor & _convert_indices_from_csr_to_coo_outf(const at::Tensor & crow_indices, const at::Tensor & col_indices, bool out_int32, bool transpose, at::Tensor & out) {
return wrapper__convert_indices_from_csr_to_coo_out_out(crow_indices, col_indices, out_int32, transpose, out);
}

at::Tensor mse_loss(const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper__mse_loss(self, target, reduction);
}

at::Tensor & mse_loss_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper_out_mse_loss_out_out(self, target, reduction, out);
}

at::Tensor & mse_loss_outf(const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & out) {
return wrapper_out_mse_loss_out_out(self, target, reduction, out);
}

at::Tensor mse_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper__mse_loss_backward(grad_output, self, target, reduction);
}

at::Tensor & mse_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper_grad_input_mse_loss_backward_out_grad_input(grad_output, self, target, reduction, grad_input);
}

at::Tensor & mse_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & grad_input) {
return wrapper_grad_input_mse_loss_backward_out_grad_input(grad_output, self, target, reduction, grad_input);
}

at::Tensor & l1_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper_grad_input_l1_loss_backward_out_grad_input(grad_output, self, target, reduction, grad_input);
}

at::Tensor & l1_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & grad_input) {
return wrapper_grad_input_l1_loss_backward_out_grad_input(grad_output, self, target, reduction, grad_input);
}

at::Tensor multi_margin_loss(const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper__multi_margin_loss(self, target, p, margin, weight, reduction);
}

at::Tensor & multi_margin_loss_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper_out_multi_margin_loss_out_out(self, target, p, margin, weight, reduction, out);
}

at::Tensor & multi_margin_loss_outf(const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & out) {
return wrapper_out_multi_margin_loss_out_out(self, target, p, margin, weight, reduction, out);
}

at::Tensor multi_margin_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper__multi_margin_loss_backward(grad_output, self, target, p, margin, weight, reduction);
}

at::Tensor & multi_margin_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction) {
return wrapper_grad_input_multi_margin_loss_backward_out_grad_input(grad_output, self, target, p, margin, weight, reduction, grad_input);
}

at::Tensor & multi_margin_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const at::Scalar & p, const at::Scalar & margin, const c10::optional<at::Tensor> & weight, int64_t reduction, at::Tensor & grad_input) {
return wrapper_grad_input_multi_margin_loss_backward_out_grad_input(grad_output, self, target, p, margin, weight, reduction, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> multilabel_margin_loss_forward(const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper__multilabel_margin_loss_forward(self, target, reduction);
}

::std::tuple<at::Tensor &,at::Tensor &> multilabel_margin_loss_forward_out(at::Tensor & output, at::Tensor & is_target, const at::Tensor & self, const at::Tensor & target, int64_t reduction) {
return wrapper_output_multilabel_margin_loss_forward_out_output(self, target, reduction, output, is_target);
}

::std::tuple<at::Tensor &,at::Tensor &> multilabel_margin_loss_forward_outf(const at::Tensor & self, const at::Tensor & target, int64_t reduction, at::Tensor & output, at::Tensor & is_target) {
return wrapper_output_multilabel_margin_loss_forward_out_output(self, target, reduction, output, is_target);
}

at::Tensor multilabel_margin_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, const at::Tensor & is_target) {
return wrapper__multilabel_margin_loss_backward(grad_output, self, target, reduction, is_target);
}

at::Tensor & multilabel_margin_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, const at::Tensor & is_target) {
return wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input(grad_output, self, target, reduction, is_target, grad_input);
}

at::Tensor & multilabel_margin_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, const at::Tensor & is_target, at::Tensor & grad_input) {
return wrapper_grad_input_multilabel_margin_loss_backward_out_grad_input(grad_output, self, target, reduction, is_target, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> nll_loss_forward(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index) {
return wrapper_nll_loss_forward(self, target, weight, reduction, ignore_index);
}

::std::tuple<at::Tensor &,at::Tensor &> nll_loss_forward_out(at::Tensor & output, at::Tensor & total_weight, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index) {
return wrapper_nll_loss_forward_out_output(self, target, weight, reduction, ignore_index, output, total_weight);
}

::std::tuple<at::Tensor &,at::Tensor &> nll_loss_forward_outf(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, at::Tensor & output, at::Tensor & total_weight) {
return wrapper_nll_loss_forward_out_output(self, target, weight, reduction, ignore_index, output, total_weight);
}

at::Tensor nll_loss_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight) {
return wrapper_nll_loss_backward(grad_output, self, target, weight, reduction, ignore_index, total_weight);
}

at::Tensor & nll_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight) {
return wrapper_nll_loss_backward_out_grad_input(grad_output, self, target, weight, reduction, ignore_index, total_weight, grad_input);
}

at::Tensor & nll_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight, at::Tensor & grad_input) {
return wrapper_nll_loss_backward_out_grad_input(grad_output, self, target, weight, reduction, ignore_index, total_weight, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> nll_loss2d_forward(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index) {
return wrapper__nll_loss2d_forward(self, target, weight, reduction, ignore_index);
}

::std::tuple<at::Tensor &,at::Tensor &> nll_loss2d_forward_out(at::Tensor & output, at::Tensor & total_weight, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index) {
return wrapper_output_nll_loss2d_forward_out_output(self, target, weight, reduction, ignore_index, output, total_weight);
}

::std::tuple<at::Tensor &,at::Tensor &> nll_loss2d_forward_outf(const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, at::Tensor & output, at::Tensor & total_weight) {
return wrapper_output_nll_loss2d_forward_out_output(self, target, weight, reduction, ignore_index, output, total_weight);
}

at::Tensor nll_loss2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight) {
return wrapper__nll_loss2d_backward(grad_output, self, target, weight, reduction, ignore_index, total_weight);
}

at::Tensor & nll_loss2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight) {
return wrapper_grad_input_nll_loss2d_backward_out_grad_input(grad_output, self, target, weight, reduction, ignore_index, total_weight, grad_input);
}

at::Tensor & nll_loss2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, const c10::optional<at::Tensor> & weight, int64_t reduction, int64_t ignore_index, const at::Tensor & total_weight, at::Tensor & grad_input) {
return wrapper_grad_input_nll_loss2d_backward_out_grad_input(grad_output, self, target, weight, reduction, ignore_index, total_weight, grad_input);
}

at::Tensor smooth_l1_loss(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta) {
return wrapper_smooth_l1_loss(self, target, reduction, beta);
}

at::Tensor & smooth_l1_loss_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta) {
return wrapper_smooth_l1_loss_out_out(self, target, reduction, beta, out);
}

at::Tensor & smooth_l1_loss_outf(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta, at::Tensor & out) {
return wrapper_smooth_l1_loss_out_out(self, target, reduction, beta, out);
}

at::Tensor & smooth_l1_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta) {
return wrapper_grad_input_smooth_l1_loss_backward_out_grad_input(grad_output, self, target, reduction, beta, grad_input);
}

at::Tensor & smooth_l1_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double beta, at::Tensor & grad_input) {
return wrapper_grad_input_smooth_l1_loss_backward_out_grad_input(grad_output, self, target, reduction, beta, grad_input);
}

at::Tensor huber_loss(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta) {
return wrapper__huber_loss(self, target, reduction, delta);
}

at::Tensor & huber_loss_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta) {
return wrapper_out_huber_loss_out_out(self, target, reduction, delta, out);
}

at::Tensor & huber_loss_outf(const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta, at::Tensor & out) {
return wrapper_out_huber_loss_out_out(self, target, reduction, delta, out);
}

at::Tensor & huber_loss_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta) {
return wrapper_out_huber_loss_backward_out_out(grad_output, self, target, reduction, delta, grad_input);
}

at::Tensor & huber_loss_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & target, int64_t reduction, double delta, at::Tensor & grad_input) {
return wrapper_out_huber_loss_backward_out_out(grad_output, self, target, reduction, delta, grad_input);
}

at::Tensor elu(const at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale) {
return wrapper_elu(self, alpha, scale, input_scale);
}

at::Tensor & elu_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale) {
return wrapper_elu_out_out(self, alpha, scale, input_scale, out);
}

at::Tensor & elu_outf(const at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, at::Tensor & out) {
return wrapper_elu_out_out(self, alpha, scale, input_scale, out);
}

at::Tensor & elu_(at::Tensor & self, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale) {
return wrapper_elu_(self, alpha, scale, input_scale);
}

at::Tensor elu_backward(const at::Tensor & grad_output, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, bool is_result, const at::Tensor & self_or_result) {
return wrapper_elu_backward(grad_output, alpha, scale, input_scale, is_result, self_or_result);
}

at::Tensor & elu_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, bool is_result, const at::Tensor & self_or_result) {
return wrapper_elu_backward_out_grad_input(grad_output, alpha, scale, input_scale, is_result, self_or_result, grad_input);
}

at::Tensor & elu_backward_outf(const at::Tensor & grad_output, const at::Scalar & alpha, const at::Scalar & scale, const at::Scalar & input_scale, bool is_result, const at::Tensor & self_or_result, at::Tensor & grad_input) {
return wrapper_elu_backward_out_grad_input(grad_output, alpha, scale, input_scale, is_result, self_or_result, grad_input);
}

at::Tensor glu(const at::Tensor & self, int64_t dim) {
return wrapper_glu(self, dim);
}

at::Tensor & glu_out(at::Tensor & out, const at::Tensor & self, int64_t dim) {
return wrapper_glu_out_out(self, dim, out);
}

at::Tensor & glu_outf(const at::Tensor & self, int64_t dim, at::Tensor & out) {
return wrapper_glu_out_out(self, dim, out);
}

at::Tensor glu_backward(const at::Tensor & grad_output, const at::Tensor & self, int64_t dim) {
return wrapper__glu_backward(grad_output, self, dim);
}

at::Tensor & glu_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, int64_t dim) {
return wrapper_grad_input_glu_backward_out_grad_input(grad_output, self, dim, grad_input);
}

at::Tensor & glu_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, int64_t dim, at::Tensor & grad_input) {
return wrapper_grad_input_glu_backward_out_grad_input(grad_output, self, dim, grad_input);
}

at::Tensor hardsigmoid(const at::Tensor & self) {
return wrapper_hardsigmoid(self);
}

at::Tensor & hardsigmoid_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_hardsigmoid_out_out(self, out);
}

at::Tensor & hardsigmoid_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_hardsigmoid_out_out(self, out);
}

at::Tensor & hardsigmoid_(at::Tensor & self) {
return wrapper_hardsigmoid_(self);
}

at::Tensor hardsigmoid_backward(const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper_hardsigmoid_backward(grad_output, self);
}

at::Tensor & hardsigmoid_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper_hardsigmoid_backward_out_grad_input(grad_output, self, grad_input);
}

at::Tensor & hardsigmoid_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::Tensor & grad_input) {
return wrapper_hardsigmoid_backward_out_grad_input(grad_output, self, grad_input);
}

at::Tensor hardtanh(const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
return wrapper__hardtanh(self, min_val, max_val);
}

at::Tensor & hardtanh_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
return wrapper_out_hardtanh_out_out(self, min_val, max_val, out);
}

at::Tensor & hardtanh_outf(const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val, at::Tensor & out) {
return wrapper_out_hardtanh_out_out(self, min_val, max_val, out);
}

at::Tensor & hardtanh_(at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
return wrapper__hardtanh_(self, min_val, max_val);
}

at::Tensor hardtanh_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
return wrapper__hardtanh_backward(grad_output, self, min_val, max_val);
}

at::Tensor & hardtanh_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val) {
return wrapper_grad_input_hardtanh_backward_out_grad_input(grad_output, self, min_val, max_val, grad_input);
}

at::Tensor & hardtanh_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & min_val, const at::Scalar & max_val, at::Tensor & grad_input) {
return wrapper_grad_input_hardtanh_backward_out_grad_input(grad_output, self, min_val, max_val, grad_input);
}

at::Tensor hardswish(const at::Tensor & self) {
return wrapper__hardswish(self);
}

at::Tensor & hardswish_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_hardswish_out_out(self, out);
}

at::Tensor & hardswish_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_hardswish_out_out(self, out);
}

at::Tensor & hardswish_(at::Tensor & self) {
return wrapper__hardswish_(self);
}

at::Tensor hardswish_backward(const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper__hardswish_backward(grad_output, self);
}

at::Tensor leaky_relu(const at::Tensor & self, const at::Scalar & negative_slope) {
return wrapper_leaky_relu(self, negative_slope);
}

at::Tensor & leaky_relu_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & negative_slope) {
return wrapper_leaky_relu_out_out(self, negative_slope, out);
}

at::Tensor & leaky_relu_outf(const at::Tensor & self, const at::Scalar & negative_slope, at::Tensor & out) {
return wrapper_leaky_relu_out_out(self, negative_slope, out);
}

at::Tensor & leaky_relu_(at::Tensor & self, const at::Scalar & negative_slope) {
return wrapper_leaky_relu_(self, negative_slope);
}

at::Tensor leaky_relu_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & negative_slope, bool self_is_result) {
return wrapper_leaky_relu_backward(grad_output, self, negative_slope, self_is_result);
}

at::Tensor & leaky_relu_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & negative_slope, bool self_is_result) {
return wrapper_leaky_relu_backward_out_grad_input(grad_output, self, negative_slope, self_is_result, grad_input);
}

at::Tensor & leaky_relu_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & negative_slope, bool self_is_result, at::Tensor & grad_input) {
return wrapper_leaky_relu_backward_out_grad_input(grad_output, self, negative_slope, self_is_result, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> log_sigmoid_forward(const at::Tensor & self) {
return wrapper__log_sigmoid_forward(self);
}

::std::tuple<at::Tensor &,at::Tensor &> log_sigmoid_forward_out(at::Tensor & output, at::Tensor & buffer, const at::Tensor & self) {
return wrapper_output_log_sigmoid_forward_out_output(self, output, buffer);
}

::std::tuple<at::Tensor &,at::Tensor &> log_sigmoid_forward_outf(const at::Tensor & self, at::Tensor & output, at::Tensor & buffer) {
return wrapper_output_log_sigmoid_forward_out_output(self, output, buffer);
}

at::Tensor log_sigmoid_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & buffer) {
return wrapper__log_sigmoid_backward(grad_output, self, buffer);
}

at::Tensor & log_sigmoid_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & buffer) {
return wrapper_grad_input_log_sigmoid_backward_out_grad_input(grad_output, self, buffer, grad_input);
}

at::Tensor & log_sigmoid_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & buffer, at::Tensor & grad_input) {
return wrapper_grad_input_log_sigmoid_backward_out_grad_input(grad_output, self, buffer, grad_input);
}

at::Tensor rrelu_with_noise(const at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator) {
return wrapper__rrelu_with_noise(self, noise, lower, upper, training, generator);
}

at::Tensor & rrelu_with_noise_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator) {
return wrapper_out_rrelu_with_noise_out_out(self, noise, lower, upper, training, generator, out);
}

at::Tensor & rrelu_with_noise_outf(const at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator, at::Tensor & out) {
return wrapper_out_rrelu_with_noise_out_out(self, noise, lower, upper, training, generator, out);
}

at::Tensor & rrelu_with_noise_(at::Tensor & self, const at::Tensor & noise, const at::Scalar & lower, const at::Scalar & upper, bool training, c10::optional<at::Generator> generator) {
return wrapper__rrelu_with_noise_(self, noise, lower, upper, training, generator);
}

at::Tensor softplus(const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold) {
return wrapper_softplus(self, beta, threshold);
}

at::Tensor & softplus_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold) {
return wrapper_softplus_out_out(self, beta, threshold, out);
}

at::Tensor & softplus_outf(const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold, at::Tensor & out) {
return wrapper_softplus_out_out(self, beta, threshold, out);
}

at::Tensor softplus_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold) {
return wrapper_softplus_backward(grad_output, self, beta, threshold);
}

at::Tensor & softplus_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold) {
return wrapper_softplus_backward_out_grad_input(grad_output, self, beta, threshold, grad_input);
}

at::Tensor & softplus_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & beta, const at::Scalar & threshold, at::Tensor & grad_input) {
return wrapper_softplus_backward_out_grad_input(grad_output, self, beta, threshold, grad_input);
}

at::Tensor softshrink(const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_softshrink(self, lambd);
}

at::Tensor & softshrink_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_softshrink_out_out(self, lambd, out);
}

at::Tensor & softshrink_outf(const at::Tensor & self, const at::Scalar & lambd, at::Tensor & out) {
return wrapper_softshrink_out_out(self, lambd, out);
}

at::Tensor softshrink_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_softshrink_backward(grad_output, self, lambd);
}

at::Tensor & softshrink_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & lambd) {
return wrapper_softshrink_backward_out_grad_input(grad_output, self, lambd, grad_input);
}

at::Tensor & softshrink_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Scalar & lambd, at::Tensor & grad_input) {
return wrapper_softshrink_backward_out_grad_input(grad_output, self, lambd, grad_input);
}

at::Tensor & adaptive_avg_pool2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper_out_adaptive_avg_pool2d_out_out(self, output_size, out);
}

at::Tensor & adaptive_avg_pool2d_outf(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out) {
return wrapper_out_adaptive_avg_pool2d_out_out(self, output_size, out);
}

at::Tensor _adaptive_avg_pool2d(const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper___adaptive_avg_pool2d(self, output_size);
}

at::Tensor _adaptive_avg_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper___adaptive_avg_pool2d_backward(grad_output, self);
}

at::Tensor & adaptive_avg_pool3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper_out_adaptive_avg_pool3d_out_out(self, output_size, out);
}

at::Tensor & adaptive_avg_pool3d_outf(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out) {
return wrapper_out_adaptive_avg_pool3d_out_out(self, output_size, out);
}

at::Tensor _adaptive_avg_pool3d(const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper___adaptive_avg_pool3d(self, output_size);
}

at::Tensor & adaptive_avg_pool3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input(grad_output, self, grad_input);
}

at::Tensor & adaptive_avg_pool3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::Tensor & grad_input) {
return wrapper_grad_input_adaptive_avg_pool3d_backward_out_grad_input(grad_output, self, grad_input);
}

at::Tensor _adaptive_avg_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self) {
return wrapper___adaptive_avg_pool3d_backward(grad_output, self);
}

::std::tuple<at::Tensor,at::Tensor> adaptive_max_pool2d(const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper_adaptive_max_pool2d(self, output_size);
}

::std::tuple<at::Tensor &,at::Tensor &> adaptive_max_pool2d_out(at::Tensor & out, at::Tensor & indices, const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper_adaptive_max_pool2d_out_out(self, output_size, out, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> adaptive_max_pool2d_outf(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out, at::Tensor & indices) {
return wrapper_adaptive_max_pool2d_out_out(self, output_size, out, indices);
}

at::Tensor adaptive_max_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices) {
return wrapper_adaptive_max_pool2d_backward(grad_output, self, indices);
}

at::Tensor & adaptive_max_pool2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices) {
return wrapper_adaptive_max_pool2d_backward_out_grad_input(grad_output, self, indices, grad_input);
}

at::Tensor & adaptive_max_pool2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::Tensor & grad_input) {
return wrapper_adaptive_max_pool2d_backward_out_grad_input(grad_output, self, indices, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> adaptive_max_pool3d(const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper_adaptive_max_pool3d(self, output_size);
}

::std::tuple<at::Tensor &,at::Tensor &> adaptive_max_pool3d_out(at::Tensor & out, at::Tensor & indices, const at::Tensor & self, at::IntArrayRef output_size) {
return wrapper_adaptive_max_pool3d_out_out(self, output_size, out, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> adaptive_max_pool3d_outf(const at::Tensor & self, at::IntArrayRef output_size, at::Tensor & out, at::Tensor & indices) {
return wrapper_adaptive_max_pool3d_out_out(self, output_size, out, indices);
}

at::Tensor adaptive_max_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices) {
return wrapper_adaptive_max_pool3d_backward(grad_output, self, indices);
}

at::Tensor & adaptive_max_pool3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices) {
return wrapper_adaptive_max_pool3d_backward_out_grad_input(grad_output, self, indices, grad_input);
}

at::Tensor & adaptive_max_pool3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::Tensor & grad_input) {
return wrapper_adaptive_max_pool3d_backward_out_grad_input(grad_output, self, indices, grad_input);
}

at::Tensor avg_pool2d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool2d(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
}

at::Tensor & avg_pool2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool2d_out_out(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, out);
}

at::Tensor & avg_pool2d_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & out) {
return wrapper_avg_pool2d_out_out(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, out);
}

at::Tensor avg_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool2d_backward(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
}

at::Tensor & avg_pool2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool2d_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, grad_input);
}

at::Tensor & avg_pool2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & grad_input) {
return wrapper_avg_pool2d_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, grad_input);
}

at::Tensor avg_pool3d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool3d(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
}

at::Tensor & avg_pool3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool3d_out_out(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, out);
}

at::Tensor & avg_pool3d_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & out) {
return wrapper_avg_pool3d_out_out(self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, out);
}

at::Tensor avg_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool3d_backward(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override);
}

at::Tensor & avg_pool3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override) {
return wrapper_avg_pool3d_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, grad_input);
}

at::Tensor & avg_pool3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, bool ceil_mode, bool count_include_pad, c10::optional<int64_t> divisor_override, at::Tensor & grad_input) {
return wrapper_avg_pool3d_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, ceil_mode, count_include_pad, divisor_override, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> fractional_max_pool2d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples) {
return wrapper_fractional_max_pool2d(self, kernel_size, output_size, random_samples);
}

::std::tuple<at::Tensor &,at::Tensor &> fractional_max_pool2d_out(at::Tensor & output, at::Tensor & indices, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples) {
return wrapper_fractional_max_pool2d_out_output(self, kernel_size, output_size, random_samples, output, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> fractional_max_pool2d_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples, at::Tensor & output, at::Tensor & indices) {
return wrapper_fractional_max_pool2d_out_output(self, kernel_size, output_size, random_samples, output, indices);
}

at::Tensor fractional_max_pool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices) {
return wrapper_fractional_max_pool2d_backward(grad_output, self, kernel_size, output_size, indices);
}

at::Tensor & fractional_max_pool2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices) {
return wrapper_fractional_max_pool2d_backward_out_grad_input(grad_output, self, kernel_size, output_size, indices, grad_input);
}

at::Tensor & fractional_max_pool2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices, at::Tensor & grad_input) {
return wrapper_fractional_max_pool2d_backward_out_grad_input(grad_output, self, kernel_size, output_size, indices, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> fractional_max_pool3d(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples) {
return wrapper_fractional_max_pool3d(self, kernel_size, output_size, random_samples);
}

::std::tuple<at::Tensor &,at::Tensor &> fractional_max_pool3d_out(at::Tensor & output, at::Tensor & indices, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples) {
return wrapper_fractional_max_pool3d_out_output(self, kernel_size, output_size, random_samples, output, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> fractional_max_pool3d_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & random_samples, at::Tensor & output, at::Tensor & indices) {
return wrapper_fractional_max_pool3d_out_output(self, kernel_size, output_size, random_samples, output, indices);
}

at::Tensor fractional_max_pool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices) {
return wrapper__fractional_max_pool3d_backward(grad_output, self, kernel_size, output_size, indices);
}

at::Tensor & fractional_max_pool3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices) {
return wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input(grad_output, self, kernel_size, output_size, indices, grad_input);
}

at::Tensor & fractional_max_pool3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef output_size, const at::Tensor & indices, at::Tensor & grad_input) {
return wrapper_grad_input_fractional_max_pool3d_backward_out_grad_input(grad_output, self, kernel_size, output_size, indices, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> max_pool2d_with_indices(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode) {
return wrapper_max_pool2d_with_indices(self, kernel_size, stride, padding, dilation, ceil_mode);
}

::std::tuple<at::Tensor &,at::Tensor &> max_pool2d_with_indices_out(at::Tensor & out, at::Tensor & indices, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode) {
return wrapper_max_pool2d_with_indices_out_out(self, kernel_size, stride, padding, dilation, ceil_mode, out, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> max_pool2d_with_indices_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, at::Tensor & out, at::Tensor & indices) {
return wrapper_max_pool2d_with_indices_out_out(self, kernel_size, stride, padding, dilation, ceil_mode, out, indices);
}

at::Tensor max_pool2d_with_indices_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices) {
return wrapper_max_pool2d_with_indices_backward(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices);
}

at::Tensor & max_pool2d_with_indices_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices) {
return wrapper_max_pool2d_with_indices_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, grad_input);
}

at::Tensor & max_pool2d_with_indices_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices, at::Tensor & grad_input) {
return wrapper_max_pool2d_with_indices_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, grad_input);
}

::std::tuple<at::Tensor,at::Tensor> max_pool3d_with_indices(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode) {
return wrapper__max_pool3d_with_indices(self, kernel_size, stride, padding, dilation, ceil_mode);
}

::std::tuple<at::Tensor &,at::Tensor &> max_pool3d_with_indices_out(at::Tensor & out, at::Tensor & indices, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode) {
return wrapper_out_max_pool3d_with_indices_out_out(self, kernel_size, stride, padding, dilation, ceil_mode, out, indices);
}

::std::tuple<at::Tensor &,at::Tensor &> max_pool3d_with_indices_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, at::Tensor & out, at::Tensor & indices) {
return wrapper_out_max_pool3d_with_indices_out_out(self, kernel_size, stride, padding, dilation, ceil_mode, out, indices);
}

at::Tensor max_pool3d_with_indices_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices) {
return wrapper__max_pool3d_with_indices_backward(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices);
}

at::Tensor & max_pool3d_with_indices_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices) {
return wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, grad_input);
}

at::Tensor & max_pool3d_with_indices_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, bool ceil_mode, const at::Tensor & indices, at::Tensor & grad_input) {
return wrapper_grad_input_max_pool3d_with_indices_backward_out_grad_input(grad_output, self, kernel_size, stride, padding, dilation, ceil_mode, indices, grad_input);
}

at::Tensor max_unpool2d(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size) {
return wrapper__max_unpool2d(self, indices, output_size);
}

at::Tensor & max_unpool2d_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size) {
return wrapper_out_max_unpool2d_out_out(self, indices, output_size, out);
}

at::Tensor & max_unpool2d_outf(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::Tensor & out) {
return wrapper_out_max_unpool2d_out_out(self, indices, output_size, out);
}

at::Tensor max_unpool2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size) {
return wrapper__max_unpool2d_backward(grad_output, self, indices, output_size);
}

at::Tensor & max_unpool2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size) {
return wrapper_grad_input_max_unpool2d_backward_out_grad_input(grad_output, self, indices, output_size, grad_input);
}

at::Tensor & max_unpool2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::Tensor & grad_input) {
return wrapper_grad_input_max_unpool2d_backward_out_grad_input(grad_output, self, indices, output_size, grad_input);
}

at::Tensor max_unpool3d(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper__max_unpool3d(self, indices, output_size, stride, padding);
}

at::Tensor & max_unpool3d_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper_out_max_unpool3d_out_out(self, indices, output_size, stride, padding, out);
}

at::Tensor & max_unpool3d_outf(const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_out_max_unpool3d_out_out(self, indices, output_size, stride, padding, out);
}

at::Tensor max_unpool3d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper__max_unpool3d_backward(grad_output, self, indices, output_size, stride, padding);
}

at::Tensor & max_unpool3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper_grad_input_max_unpool3d_backward_out_grad_input(grad_output, self, indices, output_size, stride, padding, grad_input);
}

at::Tensor & max_unpool3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & indices, at::IntArrayRef output_size, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_grad_input_max_unpool3d_backward_out_grad_input(grad_output, self, indices, output_size, stride, padding, grad_input);
}

at::Tensor reflection_pad1d(const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad1d(self, padding);
}

at::Tensor & reflection_pad1d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad1d_out_out(self, padding, out);
}

at::Tensor & reflection_pad1d_outf(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_reflection_pad1d_out_out(self, padding, out);
}

at::Tensor reflection_pad1d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad1d_backward(grad_output, self, padding);
}

at::Tensor & reflection_pad1d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad1d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor & reflection_pad1d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_reflection_pad1d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor reflection_pad2d(const at::Tensor & self, at::IntArrayRef padding) {
return wrapper__reflection_pad2d(self, padding);
}

at::Tensor & reflection_pad2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_out_reflection_pad2d_out_out(self, padding, out);
}

at::Tensor & reflection_pad2d_outf(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_out_reflection_pad2d_out_out(self, padding, out);
}

at::Tensor reflection_pad2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper__reflection_pad2d_backward(grad_output, self, padding);
}

at::Tensor & reflection_pad2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_grad_input_reflection_pad2d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor & reflection_pad2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_grad_input_reflection_pad2d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor reflection_pad3d(const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad3d(self, padding);
}

at::Tensor & reflection_pad3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad3d_out_out(self, padding, out);
}

at::Tensor & reflection_pad3d_outf(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_reflection_pad3d_out_out(self, padding, out);
}

at::Tensor reflection_pad3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad3d_backward(grad_output, self, padding);
}

at::Tensor & reflection_pad3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_reflection_pad3d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor & reflection_pad3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_reflection_pad3d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor replication_pad1d(const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad1d(self, padding);
}

at::Tensor & replication_pad1d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad1d_out_out(self, padding, out);
}

at::Tensor & replication_pad1d_outf(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_replication_pad1d_out_out(self, padding, out);
}

at::Tensor replication_pad1d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad1d_backward(grad_output, self, padding);
}

at::Tensor & replication_pad1d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad1d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor & replication_pad1d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_replication_pad1d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor replication_pad2d(const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad2d(self, padding);
}

at::Tensor & replication_pad2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad2d_out_out(self, padding, out);
}

at::Tensor & replication_pad2d_outf(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_replication_pad2d_out_out(self, padding, out);
}

at::Tensor replication_pad2d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper__replication_pad2d_backward(grad_output, self, padding);
}

at::Tensor & replication_pad2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_grad_input_replication_pad2d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor & replication_pad2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_grad_input_replication_pad2d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor replication_pad3d(const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad3d(self, padding);
}

at::Tensor & replication_pad3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_replication_pad3d_out_out(self, padding, out);
}

at::Tensor & replication_pad3d_outf(const at::Tensor & self, at::IntArrayRef padding, at::Tensor & out) {
return wrapper_replication_pad3d_out_out(self, padding, out);
}

at::Tensor replication_pad3d_backward(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper__replication_pad3d_backward(grad_output, self, padding);
}

at::Tensor & replication_pad3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding) {
return wrapper_grad_input_replication_pad3d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor & replication_pad3d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, at::IntArrayRef padding, at::Tensor & grad_input) {
return wrapper_grad_input_replication_pad3d_backward_out_grad_input(grad_output, self, padding, grad_input);
}

at::Tensor upsample_nearest3d(const at::Tensor & input, c10::optional<at::IntArrayRef> output_size, c10::optional<at::ArrayRef<double>> scale_factors) {
return wrapper_vec_upsample_nearest3d_vec(input, output_size, scale_factors);
}

at::Tensor _upsample_nearest_exact3d(const at::Tensor & input, c10::optional<at::IntArrayRef> output_size, c10::optional<at::ArrayRef<double>> scale_factors) {
return wrapper_vec__upsample_nearest_exact3d_vec(input, output_size, scale_factors);
}

at::Tensor upsample_nearest3d_backward(const at::Tensor & grad_output, c10::optional<at::IntArrayRef> output_size, at::IntArrayRef input_size, c10::optional<at::ArrayRef<double>> scale_factors) {
return wrapper_vec_upsample_nearest3d_backward_vec(grad_output, output_size, input_size, scale_factors);
}

at::Tensor _upsample_nearest_exact3d_backward(const at::Tensor & grad_output, c10::optional<at::IntArrayRef> output_size, at::IntArrayRef input_size, c10::optional<at::ArrayRef<double>> scale_factors) {
return wrapper_vec__upsample_nearest_exact3d_backward_vec(grad_output, output_size, input_size, scale_factors);
}

at::Tensor upsample_linear1d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales) {
return wrapper_upsample_linear1d(self, output_size, align_corners, scales);
}

at::Tensor & upsample_linear1d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales) {
return wrapper_upsample_linear1d_out_out(self, output_size, align_corners, scales, out);
}

at::Tensor & upsample_linear1d_outf(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales, at::Tensor & out) {
return wrapper_upsample_linear1d_out_out(self, output_size, align_corners, scales, out);
}

at::Tensor upsample_linear1d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales) {
return wrapper_upsample_linear1d_backward(grad_output, output_size, input_size, align_corners, scales);
}

at::Tensor & upsample_linear1d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales) {
return wrapper_upsample_linear1d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales, grad_input);
}

at::Tensor & upsample_linear1d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales, at::Tensor & grad_input) {
return wrapper_upsample_linear1d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales, grad_input);
}

at::Tensor upsample_bilinear2d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bilinear2d(self, output_size, align_corners, scales_h, scales_w);
}

at::Tensor & upsample_bilinear2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bilinear2d_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor & upsample_bilinear2d_outf(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper_upsample_bilinear2d_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor upsample_bilinear2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bilinear2d_backward(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
}

at::Tensor & upsample_bilinear2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bilinear2d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor & upsample_bilinear2d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper_upsample_bilinear2d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor _upsample_bilinear2d_aa(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bilinear2d_aa(self, output_size, align_corners, scales_h, scales_w);
}

at::Tensor & _upsample_bilinear2d_aa_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bilinear2d_aa_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor & _upsample_bilinear2d_aa_outf(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper__upsample_bilinear2d_aa_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor _upsample_bilinear2d_aa_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bilinear2d_aa_backward(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
}

at::Tensor & _upsample_bilinear2d_aa_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bilinear2d_aa_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor & _upsample_bilinear2d_aa_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper__upsample_bilinear2d_aa_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor upsample_bicubic2d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bicubic2d(self, output_size, align_corners, scales_h, scales_w);
}

at::Tensor & upsample_bicubic2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bicubic2d_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor & upsample_bicubic2d_outf(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper_upsample_bicubic2d_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor upsample_bicubic2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bicubic2d_backward(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
}

at::Tensor & upsample_bicubic2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_bicubic2d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor & upsample_bicubic2d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper_upsample_bicubic2d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor _upsample_bicubic2d_aa(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bicubic2d_aa(self, output_size, align_corners, scales_h, scales_w);
}

at::Tensor & _upsample_bicubic2d_aa_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bicubic2d_aa_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor & _upsample_bicubic2d_aa_outf(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper__upsample_bicubic2d_aa_out_out(self, output_size, align_corners, scales_h, scales_w, out);
}

at::Tensor _upsample_bicubic2d_aa_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bicubic2d_aa_backward(grad_output, output_size, input_size, align_corners, scales_h, scales_w);
}

at::Tensor & _upsample_bicubic2d_aa_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_bicubic2d_aa_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor & _upsample_bicubic2d_aa_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper__upsample_bicubic2d_aa_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_h, scales_w, grad_input);
}

at::Tensor upsample_trilinear3d(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_trilinear3d(self, output_size, align_corners, scales_d, scales_h, scales_w);
}

at::Tensor & upsample_trilinear3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_trilinear3d_out_out(self, output_size, align_corners, scales_d, scales_h, scales_w, out);
}

at::Tensor & upsample_trilinear3d_outf(const at::Tensor & self, at::IntArrayRef output_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper_upsample_trilinear3d_out_out(self, output_size, align_corners, scales_d, scales_h, scales_w, out);
}

at::Tensor upsample_trilinear3d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_trilinear3d_backward(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w);
}

at::Tensor & upsample_trilinear3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_trilinear3d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w, grad_input);
}

at::Tensor & upsample_trilinear3d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, bool align_corners, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper_upsample_trilinear3d_backward_out_grad_input(grad_output, output_size, input_size, align_corners, scales_d, scales_h, scales_w, grad_input);
}

at::Tensor upsample_nearest1d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales) {
return wrapper_upsample_nearest1d(self, output_size, scales);
}

at::Tensor & upsample_nearest1d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales) {
return wrapper_upsample_nearest1d_out_out(self, output_size, scales, out);
}

at::Tensor & upsample_nearest1d_outf(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales, at::Tensor & out) {
return wrapper_upsample_nearest1d_out_out(self, output_size, scales, out);
}

at::Tensor _upsample_nearest_exact1d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales) {
return wrapper__upsample_nearest_exact1d(self, output_size, scales);
}

at::Tensor & _upsample_nearest_exact1d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales) {
return wrapper__upsample_nearest_exact1d_out_out(self, output_size, scales, out);
}

at::Tensor & _upsample_nearest_exact1d_outf(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales, at::Tensor & out) {
return wrapper__upsample_nearest_exact1d_out_out(self, output_size, scales, out);
}

at::Tensor upsample_nearest1d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales) {
return wrapper_upsample_nearest1d_backward(grad_output, output_size, input_size, scales);
}

at::Tensor & upsample_nearest1d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales) {
return wrapper_upsample_nearest1d_backward_out_grad_input(grad_output, output_size, input_size, scales, grad_input);
}

at::Tensor & upsample_nearest1d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales, at::Tensor & grad_input) {
return wrapper_upsample_nearest1d_backward_out_grad_input(grad_output, output_size, input_size, scales, grad_input);
}

at::Tensor _upsample_nearest_exact1d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales) {
return wrapper__upsample_nearest_exact1d_backward(grad_output, output_size, input_size, scales);
}

at::Tensor & _upsample_nearest_exact1d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales) {
return wrapper__upsample_nearest_exact1d_backward_out_grad_input(grad_output, output_size, input_size, scales, grad_input);
}

at::Tensor & _upsample_nearest_exact1d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales, at::Tensor & grad_input) {
return wrapper__upsample_nearest_exact1d_backward_out_grad_input(grad_output, output_size, input_size, scales, grad_input);
}

at::Tensor upsample_nearest2d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest2d(self, output_size, scales_h, scales_w);
}

at::Tensor & upsample_nearest2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest2d_out_out(self, output_size, scales_h, scales_w, out);
}

at::Tensor & upsample_nearest2d_outf(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper_upsample_nearest2d_out_out(self, output_size, scales_h, scales_w, out);
}

at::Tensor _upsample_nearest_exact2d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact2d(self, output_size, scales_h, scales_w);
}

at::Tensor & _upsample_nearest_exact2d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact2d_out_out(self, output_size, scales_h, scales_w, out);
}

at::Tensor & _upsample_nearest_exact2d_outf(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper__upsample_nearest_exact2d_out_out(self, output_size, scales_h, scales_w, out);
}

at::Tensor upsample_nearest2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest2d_backward(grad_output, output_size, input_size, scales_h, scales_w);
}

at::Tensor & upsample_nearest2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest2d_backward_out_grad_input(grad_output, output_size, input_size, scales_h, scales_w, grad_input);
}

at::Tensor & upsample_nearest2d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper_upsample_nearest2d_backward_out_grad_input(grad_output, output_size, input_size, scales_h, scales_w, grad_input);
}

at::Tensor _upsample_nearest_exact2d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact2d_backward(grad_output, output_size, input_size, scales_h, scales_w);
}

at::Tensor & _upsample_nearest_exact2d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact2d_backward_out_grad_input(grad_output, output_size, input_size, scales_h, scales_w, grad_input);
}

at::Tensor & _upsample_nearest_exact2d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper__upsample_nearest_exact2d_backward_out_grad_input(grad_output, output_size, input_size, scales_h, scales_w, grad_input);
}

at::Tensor upsample_nearest3d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest3d(self, output_size, scales_d, scales_h, scales_w);
}

at::Tensor & upsample_nearest3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest3d_out_out(self, output_size, scales_d, scales_h, scales_w, out);
}

at::Tensor & upsample_nearest3d_outf(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper_upsample_nearest3d_out_out(self, output_size, scales_d, scales_h, scales_w, out);
}

at::Tensor _upsample_nearest_exact3d(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact3d(self, output_size, scales_d, scales_h, scales_w);
}

at::Tensor & _upsample_nearest_exact3d_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact3d_out_out(self, output_size, scales_d, scales_h, scales_w, out);
}

at::Tensor & _upsample_nearest_exact3d_outf(const at::Tensor & self, at::IntArrayRef output_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & out) {
return wrapper__upsample_nearest_exact3d_out_out(self, output_size, scales_d, scales_h, scales_w, out);
}

at::Tensor upsample_nearest3d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest3d_backward(grad_output, output_size, input_size, scales_d, scales_h, scales_w);
}

at::Tensor & upsample_nearest3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper_upsample_nearest3d_backward_out_grad_input(grad_output, output_size, input_size, scales_d, scales_h, scales_w, grad_input);
}

at::Tensor & upsample_nearest3d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper_upsample_nearest3d_backward_out_grad_input(grad_output, output_size, input_size, scales_d, scales_h, scales_w, grad_input);
}

at::Tensor _upsample_nearest_exact3d_backward(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact3d_backward(grad_output, output_size, input_size, scales_d, scales_h, scales_w);
}

at::Tensor & _upsample_nearest_exact3d_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w) {
return wrapper__upsample_nearest_exact3d_backward_out_grad_input(grad_output, output_size, input_size, scales_d, scales_h, scales_w, grad_input);
}

at::Tensor & _upsample_nearest_exact3d_backward_outf(const at::Tensor & grad_output, at::IntArrayRef output_size, at::IntArrayRef input_size, c10::optional<double> scales_d, c10::optional<double> scales_h, c10::optional<double> scales_w, at::Tensor & grad_input) {
return wrapper__upsample_nearest_exact3d_backward_out_grad_input(grad_output, output_size, input_size, scales_d, scales_h, scales_w, grad_input);
}

at::Tensor sigmoid_backward(const at::Tensor & grad_output, const at::Tensor & output) {
return wrapper_sigmoid_backward(grad_output, output);
}

at::Tensor & sigmoid_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & output) {
return wrapper_sigmoid_backward_out_grad_input(grad_output, output, grad_input);
}

at::Tensor & sigmoid_backward_outf(const at::Tensor & grad_output, const at::Tensor & output, at::Tensor & grad_input) {
return wrapper_sigmoid_backward_out_grad_input(grad_output, output, grad_input);
}

at::Tensor logit_backward(const at::Tensor & grad_output, const at::Tensor & self, c10::optional<double> eps) {
return wrapper_logit_backward(grad_output, self, eps);
}

at::Tensor & logit_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & self, c10::optional<double> eps) {
return wrapper_logit_backward_out_grad_input(grad_output, self, eps, grad_input);
}

at::Tensor & logit_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, c10::optional<double> eps, at::Tensor & grad_input) {
return wrapper_logit_backward_out_grad_input(grad_output, self, eps, grad_input);
}

at::Tensor tanh_backward(const at::Tensor & grad_output, const at::Tensor & output) {
return wrapper_tanh_backward(grad_output, output);
}

at::Tensor & tanh_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, const at::Tensor & output) {
return wrapper_tanh_backward_out_grad_input(grad_output, output, grad_input);
}

at::Tensor & tanh_backward_outf(const at::Tensor & grad_output, const at::Tensor & output, at::Tensor & grad_input) {
return wrapper_tanh_backward_out_grad_input(grad_output, output, grad_input);
}

at::Tensor slow_conv_transpose2d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation) {
return wrapper_slow_conv_transpose2d(self, weight, kernel_size, bias, stride, padding, output_padding, dilation);
}

at::Tensor & slow_conv_transpose2d_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation) {
return wrapper_slow_conv_transpose2d_out_out(self, weight, kernel_size, bias, stride, padding, output_padding, dilation, out);
}

at::Tensor & slow_conv_transpose2d_outf(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation, at::Tensor & out) {
return wrapper_slow_conv_transpose2d_out_out(self, weight, kernel_size, bias, stride, padding, output_padding, dilation, out);
}

at::Tensor slow_conv_transpose3d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation) {
return wrapper__slow_conv_transpose3d(self, weight, kernel_size, bias, stride, padding, output_padding, dilation);
}

at::Tensor & slow_conv_transpose3d_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation) {
return wrapper_out_slow_conv_transpose3d_out_out(self, weight, kernel_size, bias, stride, padding, output_padding, dilation, out);
}

at::Tensor & slow_conv_transpose3d_outf(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef output_padding, at::IntArrayRef dilation, at::Tensor & out) {
return wrapper_out_slow_conv_transpose3d_out_out(self, weight, kernel_size, bias, stride, padding, output_padding, dilation, out);
}

at::Tensor _slow_conv2d_forward(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper___slow_conv2d_forward(self, weight, kernel_size, bias, stride, padding);
}

at::Tensor & _slow_conv2d_forward_out(at::Tensor & output, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper_output__slow_conv2d_forward_out_output(self, weight, kernel_size, bias, stride, padding, output);
}

at::Tensor & _slow_conv2d_forward_outf(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & output) {
return wrapper_output__slow_conv2d_forward_out_output(self, weight, kernel_size, bias, stride, padding, output);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> _slow_conv2d_backward_out(at::Tensor & grad_input, at::Tensor & grad_weight, at::Tensor & grad_bias, const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding) {
return wrapper_grad_input__slow_conv2d_backward_out_grad_input(grad_output, self, weight, kernel_size, stride, padding, grad_input, grad_weight, grad_bias);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> _slow_conv2d_backward_outf(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, at::Tensor & grad_input, at::Tensor & grad_weight, at::Tensor & grad_bias) {
return wrapper_grad_input__slow_conv2d_backward_out_grad_input(grad_output, self, weight, kernel_size, stride, padding, grad_input, grad_weight, grad_bias);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> _slow_conv2d_backward(const at::Tensor & grad_output, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, at::IntArrayRef stride, at::IntArrayRef padding, ::std::array<bool,3> output_mask) {
return wrapper_output_mask__slow_conv2d_backward_output_mask(grad_output, self, weight, kernel_size, stride, padding, output_mask);
}

at::Tensor _conv_depthwise2d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
return wrapper___conv_depthwise2d(self, weight, kernel_size, bias, stride, padding, dilation);
}

const at::Tensor & _conv_depthwise2d_out(const at::Tensor & out, const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
return wrapper_out__conv_depthwise2d_out_out(self, weight, kernel_size, bias, stride, padding, dilation, out);
}

const at::Tensor & _conv_depthwise2d_outf(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation, const at::Tensor & out) {
return wrapper_out__conv_depthwise2d_out_out(self, weight, kernel_size, bias, stride, padding, dilation, out);
}

at::Tensor conv_depthwise3d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
return wrapper__conv_depthwise3d(self, weight, kernel_size, bias, stride, padding, dilation);
}

at::Tensor slow_conv_dilated2d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
return wrapper__slow_conv_dilated2d(self, weight, kernel_size, bias, stride, padding, dilation);
}

at::Tensor slow_conv_dilated3d(const at::Tensor & self, const at::Tensor & weight, at::IntArrayRef kernel_size, const c10::optional<at::Tensor> & bias, at::IntArrayRef stride, at::IntArrayRef padding, at::IntArrayRef dilation) {
return wrapper__slow_conv_dilated3d(self, weight, kernel_size, bias, stride, padding, dilation);
}

at::Tensor col2im(const at::Tensor & self, at::IntArrayRef output_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper__col2im(self, output_size, kernel_size, dilation, padding, stride);
}

at::Tensor & col2im_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef output_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper_out_col2im_out_out(self, output_size, kernel_size, dilation, padding, stride, out);
}

at::Tensor & col2im_outf(const at::Tensor & self, at::IntArrayRef output_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & out) {
return wrapper_out_col2im_out_out(self, output_size, kernel_size, dilation, padding, stride, out);
}

at::Tensor col2im_backward(const at::Tensor & grad_output, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper__col2im_backward(grad_output, kernel_size, dilation, padding, stride);
}

at::Tensor & col2im_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper_grad_input_col2im_backward_out_grad_input(grad_output, kernel_size, dilation, padding, stride, grad_input);
}

at::Tensor & col2im_backward_outf(const at::Tensor & grad_output, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & grad_input) {
return wrapper_grad_input_col2im_backward_out_grad_input(grad_output, kernel_size, dilation, padding, stride, grad_input);
}

at::Tensor im2col(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper__im2col(self, kernel_size, dilation, padding, stride);
}

at::Tensor & im2col_out(at::Tensor & out, const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper_out_im2col_out_out(self, kernel_size, dilation, padding, stride, out);
}

at::Tensor & im2col_outf(const at::Tensor & self, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & out) {
return wrapper_out_im2col_out_out(self, kernel_size, dilation, padding, stride, out);
}

at::Tensor im2col_backward(const at::Tensor & grad_output, at::IntArrayRef input_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper__im2col_backward(grad_output, input_size, kernel_size, dilation, padding, stride);
}

at::Tensor & im2col_backward_out(at::Tensor & grad_input, const at::Tensor & grad_output, at::IntArrayRef input_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride) {
return wrapper_grad_input_im2col_backward_out_grad_input(grad_output, input_size, kernel_size, dilation, padding, stride, grad_input);
}

at::Tensor & im2col_backward_outf(const at::Tensor & grad_output, at::IntArrayRef input_size, at::IntArrayRef kernel_size, at::IntArrayRef dilation, at::IntArrayRef padding, at::IntArrayRef stride, at::Tensor & grad_input) {
return wrapper_grad_input_im2col_backward_out_grad_input(grad_output, input_size, kernel_size, dilation, padding, stride, grad_input);
}

void record_stream(at::Tensor & self, at::Stream s) {
return wrapper__record_stream(self, s);
}

at::Tensor isposinf(const at::Tensor & self) {
return wrapper_isposinf(self);
}

at::Tensor & isposinf_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_isposinf_out_out(self, out);
}

at::Tensor & isposinf_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_isposinf_out_out(self, out);
}

at::Tensor isneginf(const at::Tensor & self) {
return wrapper_isneginf(self);
}

at::Tensor & isneginf_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_isneginf_out_out(self, out);
}

at::Tensor & isneginf_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_isneginf_out_out(self, out);
}

at::Tensor special_entr(const at::Tensor & self) {
return wrapper_special_entr(self);
}

at::Tensor & special_entr_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_special_entr_out_out(self, out);
}

at::Tensor & special_entr_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_special_entr_out_out(self, out);
}

at::Tensor special_ndtri(const at::Tensor & self) {
return wrapper_special_ndtri(self);
}

at::Tensor & special_ndtri_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_special_ndtri_out_out(self, out);
}

at::Tensor & special_ndtri_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_special_ndtri_out_out(self, out);
}

at::Tensor special_erfcx(const at::Tensor & self) {
return wrapper_special_erfcx(self);
}

at::Tensor & special_erfcx_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_special_erfcx_out_out(self, out);
}

at::Tensor & special_erfcx_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_special_erfcx_out_out(self, out);
}

at::Tensor special_xlog1py(const at::Tensor & self, const at::Tensor & other) {
return wrapper_special_xlog1py(self, other);
}

at::Tensor & special_xlog1py_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_special_xlog1py_out_out(self, other, out);
}

at::Tensor & special_xlog1py_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_special_xlog1py_out_out(self, other, out);
}

at::Tensor special_zeta(const at::Tensor & self, const at::Tensor & other) {
return wrapper_special_zeta(self, other);
}

at::Tensor & special_zeta_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_special_zeta_out_out(self, other, out);
}

at::Tensor & special_zeta_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_special_zeta_out_out(self, other, out);
}

at::Tensor special_i0e(const at::Tensor & self) {
return wrapper_special_i0e(self);
}

at::Tensor & special_i0e_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_special_i0e_out_out(self, out);
}

at::Tensor & special_i0e_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_special_i0e_out_out(self, out);
}

at::Tensor special_i1(const at::Tensor & self) {
return wrapper_special_i1(self);
}

at::Tensor & special_i1_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_special_i1_out_out(self, out);
}

at::Tensor & special_i1_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_special_i1_out_out(self, out);
}

at::Tensor special_i1e(const at::Tensor & self) {
return wrapper_special_i1e(self);
}

at::Tensor & special_i1e_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_special_i1e_out_out(self, out);
}

at::Tensor & special_i1e_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_special_i1e_out_out(self, out);
}

::std::tuple<at::Tensor,at::Tensor> linalg_cholesky_ex(const at::Tensor & self, bool upper, bool check_errors) {
return wrapper__linalg_cholesky_ex(self, upper, check_errors);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_cholesky_ex_out(at::Tensor & L, at::Tensor & info, const at::Tensor & self, bool upper, bool check_errors) {
return wrapper_L_linalg_cholesky_ex_out_L(self, upper, check_errors, L, info);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_cholesky_ex_outf(const at::Tensor & self, bool upper, bool check_errors, at::Tensor & L, at::Tensor & info) {
return wrapper_L_linalg_cholesky_ex_out_L(self, upper, check_errors, L, info);
}

at::Tensor linalg_cross(const at::Tensor & self, const at::Tensor & other, int64_t dim) {
return wrapper_linalg_cross(self, other, dim);
}

at::Tensor & linalg_cross_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, int64_t dim) {
return wrapper_linalg_cross_out_out(self, other, dim, out);
}

at::Tensor & linalg_cross_outf(const at::Tensor & self, const at::Tensor & other, int64_t dim, at::Tensor & out) {
return wrapper_linalg_cross_out_out(self, other, dim, out);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> linalg_lu_factor_ex(const at::Tensor & A, bool pivot, bool check_errors) {
return wrapper_linalg_lu_factor_ex(A, pivot, check_errors);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> linalg_lu_factor_ex_out(at::Tensor & LU, at::Tensor & pivots, at::Tensor & info, const at::Tensor & A, bool pivot, bool check_errors) {
return wrapper_linalg_lu_factor_ex_out_out(A, pivot, check_errors, LU, pivots, info);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> linalg_lu_factor_ex_outf(const at::Tensor & A, bool pivot, bool check_errors, at::Tensor & LU, at::Tensor & pivots, at::Tensor & info) {
return wrapper_linalg_lu_factor_ex_out_out(A, pivot, check_errors, LU, pivots, info);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> _det_lu_based_helper(const at::Tensor & self) {
return wrapper___det_lu_based_helper(self);
}

at::Tensor _det_lu_based_helper_backward_helper(const at::Tensor & det_grad, const at::Tensor & det, const at::Tensor & self, const at::Tensor & lu, const at::Tensor & pivs) {
return wrapper___det_lu_based_helper_backward_helper(det_grad, det, self, lu, pivs);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &,at::Tensor &> linalg_lstsq_out(at::Tensor & solution, at::Tensor & residuals, at::Tensor & rank, at::Tensor & singular_values, const at::Tensor & self, const at::Tensor & b, c10::optional<double> rcond, c10::optional<c10::string_view> driver) {
return wrapper_out_linalg_lstsq_out_out(self, b, rcond, driver, solution, residuals, rank, singular_values);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &,at::Tensor &> linalg_lstsq_outf(const at::Tensor & self, const at::Tensor & b, c10::optional<double> rcond, c10::optional<c10::string_view> driver, at::Tensor & solution, at::Tensor & residuals, at::Tensor & rank, at::Tensor & singular_values) {
return wrapper_out_linalg_lstsq_out_out(self, b, rcond, driver, solution, residuals, rank, singular_values);
}

at::Tensor linalg_matrix_exp(const at::Tensor & self) {
return wrapper__linalg_matrix_exp(self);
}

::std::tuple<at::Tensor,at::Tensor> linalg_slogdet(const at::Tensor & self) {
return wrapper__linalg_slogdet(self);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_slogdet_out(at::Tensor & sign, at::Tensor & logabsdet, const at::Tensor & self) {
return wrapper_out_linalg_slogdet_out_out(self, sign, logabsdet);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_slogdet_outf(const at::Tensor & self, at::Tensor & sign, at::Tensor & logabsdet) {
return wrapper_out_linalg_slogdet_out_out(self, sign, logabsdet);
}

::std::tuple<at::Tensor,at::Tensor> linalg_eig(const at::Tensor & self) {
return wrapper__linalg_eig(self);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_eig_out(at::Tensor & eigenvalues, at::Tensor & eigenvectors, const at::Tensor & self) {
return wrapper_out_linalg_eig_out_out(self, eigenvalues, eigenvectors);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_eig_outf(const at::Tensor & self, at::Tensor & eigenvalues, at::Tensor & eigenvectors) {
return wrapper_out_linalg_eig_out_out(self, eigenvalues, eigenvectors);
}

::std::tuple<at::Tensor,at::Tensor> linalg_eigh(const at::Tensor & self, c10::string_view UPLO) {
return wrapper__linalg_eigh(self, UPLO);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_eigh_out(at::Tensor & eigvals, at::Tensor & eigvecs, const at::Tensor & self, c10::string_view UPLO) {
return wrapper_eigvals_linalg_eigh_out_eigvals(self, UPLO, eigvals, eigvecs);
}

::std::tuple<at::Tensor &,at::Tensor &> linalg_eigh_outf(const at::Tensor & self, c10::string_view UPLO, at::Tensor & eigvals, at::Tensor & eigvecs) {
return wrapper_eigvals_linalg_eigh_out_eigvals(self, UPLO, eigvals, eigvecs);
}

at::Tensor & linalg_eigvalsh_out(at::Tensor & out, const at::Tensor & self, c10::string_view UPLO) {
return wrapper_out_linalg_eigvalsh_out_out(self, UPLO, out);
}

at::Tensor & linalg_eigvalsh_outf(const at::Tensor & self, c10::string_view UPLO, at::Tensor & out) {
return wrapper_out_linalg_eigvalsh_out_out(self, UPLO, out);
}

at::Tensor linalg_householder_product(const at::Tensor & input, const at::Tensor & tau) {
return wrapper__linalg_householder_product(input, tau);
}

at::Tensor & linalg_householder_product_out(at::Tensor & out, const at::Tensor & input, const at::Tensor & tau) {
return wrapper_out_linalg_householder_product_out_out(input, tau, out);
}

at::Tensor & linalg_householder_product_outf(const at::Tensor & input, const at::Tensor & tau, at::Tensor & out) {
return wrapper_out_linalg_householder_product_out_out(input, tau, out);
}

at::Tensor & _linalg_inv_out_helper_(at::Tensor & self, at::Tensor & infos_lu, at::Tensor & infos_getri) {
return wrapper___linalg_inv_out_helper_(self, infos_lu, infos_getri);
}

at::Tensor linalg_vector_norm(const at::Tensor & self, const at::Scalar & ord, c10::optional<at::IntArrayRef> dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper__linalg_vector_norm(self, ord, dim, keepdim, dtype);
}

at::Tensor & linalg_vector_norm_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & ord, c10::optional<at::IntArrayRef> dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_out_linalg_vector_norm_out_out(self, ord, dim, keepdim, dtype, out);
}

at::Tensor & linalg_vector_norm_outf(const at::Tensor & self, const at::Scalar & ord, c10::optional<at::IntArrayRef> dim, bool keepdim, c10::optional<at::ScalarType> dtype, at::Tensor & out) {
return wrapper_out_linalg_vector_norm_out_out(self, ord, dim, keepdim, dtype, out);
}

::std::tuple<at::Tensor,at::Tensor,at::Tensor> _linalg_svd(const at::Tensor & A, bool full_matrices, bool compute_uv) {
return wrapper__linalg_svd(A, full_matrices, compute_uv);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> _linalg_svd_out(at::Tensor & U, at::Tensor & S, at::Tensor & Vh, const at::Tensor & A, bool full_matrices, bool compute_uv) {
return wrapper__linalg_svd_out_U(A, full_matrices, compute_uv, U, S, Vh);
}

::std::tuple<at::Tensor &,at::Tensor &,at::Tensor &> _linalg_svd_outf(const at::Tensor & A, bool full_matrices, bool compute_uv, at::Tensor & U, at::Tensor & S, at::Tensor & Vh) {
return wrapper__linalg_svd_out_U(A, full_matrices, compute_uv, U, S, Vh);
}

at::Tensor linalg_solve(const at::Tensor & input, const at::Tensor & other) {
return wrapper__linalg_solve(input, other);
}

at::Tensor & linalg_solve_out(at::Tensor & out, const at::Tensor & input, const at::Tensor & other) {
return wrapper_out_linalg_solve_out_out(input, other, out);
}

at::Tensor & linalg_solve_outf(const at::Tensor & input, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_linalg_solve_out_out(input, other, out);
}

::std::tuple<at::Tensor,at::Tensor> _linalg_qr_helper(const at::Tensor & self, c10::string_view mode) {
return wrapper___linalg_qr_helper(self, mode);
}

at::Tensor segment_reduce(const at::Tensor & data, c10::string_view reduce, const c10::optional<at::Tensor> & lengths, const c10::optional<at::Tensor> & indices, int64_t axis, bool unsafe, const c10::optional<at::Scalar> & initial) {
return wrapper__segment_reduce(data, reduce, lengths, indices, axis, unsafe, initial);
}

at::Tensor _segment_reduce_backward(const at::Tensor & grad, const at::Tensor & output, const at::Tensor & data, c10::string_view reduce, const c10::optional<at::Tensor> & lengths, int64_t axis) {
return wrapper___segment_reduce_backward(grad, output, data, reduce, lengths, axis);
}

} // namespace cuda

} // namespace at
